#include <cstring>
#include <iostream>
#include <stdlib.h>
#include <ctime>

#include "sbutils.h"

#include "sbstringlist.h"
#include "sbwincertstorage.h"

using namespace SecureBlackbox;

int main(int argc, char **argv) {

	try
	{
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
SetLicenseKey("<put the key here>");
	}
	catch (SBException E)
	{
		std::cout << "Failed to set license key:" << std::endl;
		std::cout << E.what() << std::endl;
		return 0;
	}

	std::string paramStorage = "MY";

	if (argc < 2)
	{
		std::cout << "Usage:" << std::endl;
		std::cout << "windowsstorage -list -storage <storage_name>" << std::endl;
		return 0;
	}

	int i = 1;
	while (i < argc - 1)
	{
		char *arg = argv[i];
		if (!strcmp(arg, "-storage"))
			paramStorage.assign(argv[++i]);

		i++;
	}

	try
	{
		std::cout << "Certificates from " << paramStorage << " windows storage:" << std::endl;
		TElWinCertStorage WinCertStorage(NULL);
		WinCertStorage.get_SystemStores()->set_Text(paramStorage);
		for (int i = 0; i < WinCertStorage.get_Count(); i++)
		{
			TElX509Certificate *pCert = WinCertStorage.get_Certificates(i);
			TName name;
			pCert->get_SubjectName(name);
			std::cout << (i + 1) << "\tSubject: ";
			if (name.CommonName != NULL)
				std::cout << (char *)name.CommonName;
			else
				std::cout << (char *)name.Organization;

			std::cout << std::endl;
			pCert->get_IssuerName(name);
			std::cout << "\tIssuer: ";
			if (name.CommonName != NULL)
				std::cout << (char *)name.CommonName;
			else
				std::cout << (char *)name.Organization;

			std::cout << std::endl;
			std::vector<uint8_t> SerialNumber;
			pCert->get_SerialNumber(SerialNumber);
			std::string s;
			BinaryToString(SerialNumber, s);
			BeautifyBinaryString(s, ':', s);
			std::cout << "\tSerial number: " << s << std::endl;

			time_t t;
			t = (time_t)pCert->get_ValidFrom();
			char* dt = ctime(&t);
			if (dt != NULL)
				std::cout << "\tValid from: " << dt;

			t = (time_t)pCert->get_ValidTo();
			dt = ctime(&t);
			if (dt != NULL)
				std::cout << "\tValid to: " << dt;

			std::cout << "\tPrivate key: ";
			if (pCert->get_PrivateKeyExists())
				std::cout << "YES";
			else
				std::cout << "NO";

			std::cout << std::endl;
		}
	}
	catch (SBException E)
	{
		std::cout << "Error: " << E.what() << std::endl;
	}

	return 0;
}
