#ifndef __INC_SBOFFICERESOURCES
#define __INC_SBOFFICERESOURCES

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbcore.h"
#include "sbsystem.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
#define SB_SFOfficeIndexOutOfBounds 	"Index out of bounds (%d)"
#define SB_SFOfficeInvalidLogicalItemSuffixName 	"Invalid suffix name for a logical item (%s)"
#define SB_SFOfficeCannotCreatePartExists 	"Cannot create part (%s) the part {%s} already exists"
#define SB_SFOfficeStreamExists 	"The stream already exists (%s)"
#define SB_SFOfficeDuplicatePart 	"Duplicate part (%s)"
#define SB_SFOfficePackagePartNotFound 	"Package part not found (%s)"
#define SB_SFOfficeUnsupportedAlgorithmInt 	"Unsupported algorithm (%d)"
#define SB_SFOfficeUnsupportedAlgorithmStr 	"Unsupported algorithm (%s)"
#define SB_SFOfficeUnsupportedHashAlgorithmInt 	"Unsupported hash algorithm (%d)"
#define SB_SFOfficeUnsupportedHashAlgorithmStr 	"Unsupported hash algorithm (%s)"
#define SB_SFOfficePackageEntryNotFound 	"Package entry not found (%s)"
#define SB_SFOfficeCertificateLoadFailedFromAsyncState 	"Failed to load certificate from async state: %d"
#define SB_SOfficeNotImplemented 	"Not implemented"
#define SB_SOfficeNoStreamAvailable 	"No Stream Available"
#define SB_SOfficeNoXMLElementAvailable 	"No XML element available"
#define SB_SOfficeInvalidXMLElement 	"Invalid XML element"
#define SB_SOfficeNoXMLDocumentAvailable 	"No XML document available"
#define SB_SOfficeNoPackagePartAvailable 	"No package part available"
#define SB_SOfficeNoSignedPartAvailable 	"No signed part available"
#define SB_SOfficeNoSignedEntryAvailable 	"No signed entry available"
#define SB_SOfficeNoSignatureDefinitionAvailable 	"No signature definition available"
#define SB_SOfficeNoCertificate 	"No certificate"
#define SB_SOfficeNoKeyData 	"No key data"
#define SB_SOfficeInvalidKeyEncryptorXMLElement 	"Invalid key encryptor XML element"
#define SB_SOfficeVersionStringTooLong 	"Version string is too long"
#define SB_SOfficeSignatureCommentsStringTooLong 	"Signature comments string is too long"
#define SB_SOfficeSignatureProviderURLStringTooLong 	"Signature provider url string is too long"
#define SB_SOfficeSignatureTextStringTooLong 	"Signature text string is too long"
#define SB_SOfficePositiveIntegerExpected 	"A positive integer is expected"
#define SB_SOfficeSecurityHandlerAlreadyRegistered 	"Security handler already registered"
#define SB_SOfficeSecurityHandlerNotFound 	"Security handler not found"
#define SB_SOfficeDocumentNotOpened 	"Document is not opened"
#define SB_SOfficeDocumentNotEncrypted 	"Document is not encrypted"
#define SB_SOfficeCannotEncryptSignedDocument 	"Cannot encrypt signed document"
#define SB_SOfficeCannotSignEncryptedDocument 	"Cannot sign encrypted document"
#define SB_SOfficeCannotEncryptEncryptedDocument 	"Cannot encrypt encrypted document"
#define SB_SOfficeEncryptionHandlerCannotEncryptDocument 	"Cannot encrypt document using this encryption handler"
#define SB_SOfficeInvalidEncryptionHandler 	"Invalid encryption handler"
#define SB_SOfficeInvalidSignatureHandler 	"Invalid signature handler"
#define SB_SOfficeInvalidDocumentFormat 	"Invalid document format"
#define SB_SOfficeInvalidDocumentType 	"Invalid document type"
#define SB_SOfficeUnsupportedOperationDocumentFormat 	"Operation is not supported for this document format"
#define SB_SOfficeCannotChangeEncryptionHandler 	"Cannot change encryption handler"
#define SB_SOfficeCannotSignSharedWorkbook 	"Cannot sign shared workbook"
#define SB_SOfficeCannotSignProtectedDocument 	"Cannot sign protected document"
#define SB_SOfficeNothingToSign 	"Nothing to sign"
#define SB_SOfficeEncryptedPackageEntryNotFound 	"EncryptedPackage stream entry not found"
#define SB_SOfficeDataSpacesVersionEntryNotFound 	"DataSpaces\\Version stream entry not found"
#define SB_SOfficeDataSpaceMapEntryNotFound 	"DataSpaceMap stream entry not found"
#define SB_SOfficeDataSpaceInfoEntryNotFound 	"DataSpaceInfo storage entry not found"
#define SB_SOfficeStrongEncryptionDataSpaceEntryNotFound 	"StrongEncryptionDataSpace stream entry not found"
#define SB_SOfficeInvalidDataSpaceDefinitionTransformReferenceEntry 	"Invalid DataSpaceDefinition TransformReference entry"
#define SB_SOfficeDataSpacesTransformInfoEntryNotFound 	"DataSpaces\\TransformInfo storage entry not found"
#define SB_SOfficeDataSpacesStrongEncryptionTransformNotFound 	"DataSpaces\\TransformInfo\\StrongEncryptionTransform storage entry not found"
#define SB_SOfficeDataSpacesStrongEncryptionTransformPrimaryNotFound 	"DataSpaces\\TransformInfo\\StrongEncryptionTransform\\Primary stream entry not found"
#define SB_SOfficeInvalidTransformInfoHeader 	"Invalid TransformInfoHeader"
#define SB_SOfficeEncryptionInfoEntryNotFound 	"EncryptionInfo stream entry not found"
#define SB_SOfficeFailedToCreatePartReadOnly 	"Failed to create part (package is read-only)"
#define SB_SOfficeFailedToDeletePartReadOnly 	"Failed to delete part (package is read-only)"
#define SB_SOfficeFailedToCreatePartStreamReadOnly 	"Failed to create part stream (package is read-only)"
#define SB_SOfficeFailedToDeletePartStreamReadOnly 	"Failed to delete part stream (package is read-only)"
#define SB_SOfficeFailedToOpenStreamForWriting 	"Failed to open part stream for writing"
#define SB_SOfficeContentTypesStreamNotFound 	"Content Types stream not found"
#define SB_SOfficePackageDirectoryNotExists 	"The package directory does not exists"
#define SB_SOfficeInvalidPackagePartContentType 	"Invalid package part content type"
#define SB_SOfficeFailedToGetInterleavedPartStream 	"Failed to get interleaved part stream"
#define SB_SOfficeFailedToReadData 	"Failed to read data"
#define SB_SOfficeFailedToReadValue 	"Failed to read value"
#define SB_SOfficeFailedToWriteValue 	"Failed to write value"
#define SB_SOfficeInvalidDataSpacesFeatureIdentifier 	"Invalid DataSpaces feature identifier"
#define SB_SOfficeInvalidDataSpacesReaderVersion 	"Invalid DataSpaces reader version"
#define SB_SOfficeInvalidDataSpaceMapHeaderLength 	"Invalid DataSpacesMap header length"
#define SB_SOfficeInvalidDataSpaceMapEntryLength 	"Invalid DataSpacesMapEntry length"
#define SB_SOfficeInvalidDataSpaceDefinitionHeaderLength 	"Invalid DataSpacesDefinition header length"
#define SB_SOfficeInvalidTransformInfoHeaderTransformLength 	"Invalid TransformInfoHeader transform length"
#define SB_SOfficeInvalidReservedValue 	"Invalid reserved value"
#define SB_SOfficeInvalidEncryptionHeaderSizeExtra 	"Invalid EncryptionHeader size extra value"
#define SB_SOfficeInvalidEncryptionVerifierSaltSize 	"Invalid EncryptionVerifier salt size"
#define SB_SOfficeInvalidEncryptionHeaderLength 	"Invalid EncryptionHeader length"
#define SB_SOfficeInvalidCertificateInfoSize 	"Invalid CertificateInfo size"
#define SB_SOfficeInvalidCertificateInfoVersion 	"Invalid CertificateInfo version"
#define SB_SOfficeInvalidCertificateInfoSignerNameLength 	"Invalid CertificateInfo signer name length"
#define SB_SOfficeInvalidCertificateInfoIssuerNameLength 	"Invalid CertificateInfo issuer name length"
#define SB_SOfficeInvalidDocSigSerializedCertStoreVersion 	"Invalid DocSigSerializedCertStore version"
#define SB_SOfficeInvalidDocSigSerializedCertStoreFileType 	"Invalid DocSigSerializedCertStore file type"
#define SB_SOfficeInvalidCertStoreCertificateGroupSize 	"Invalid CertStoreCertificateGroup size"
#define SB_SOfficeInvalidEndElementMarkerEntry 	"Invalid EndElementMarkerEntry"
#define SB_SOfficeInvalidIntermediateCertificatesStoreSize 	"Invalid IntermediateCertificatesStore size"
#define SB_SOfficeInvalidPersistDirectoryEntry 	"Invalid PersistDirectoryEntry"
#define SB_SOfficeInvalidRecordSize 	"Invalid record size"
#define SB_SOfficeInvalidOfficeArtBStoreContainerFileBlock 	"Invalid OfficeArtBStoreContainerFileBlock"
#define SB_SOfficeUnsupportedOfficeArtBStoreContainerFileBlock 	"Unsupported OfficeArtBStoreContainerFileBlock"
#define SB_SOfficeInvalidUserEditAtom 	"Invalid UserEditAtom"
#define SB_SOfficeInvalidPersistDirectoryAtom 	"Invalid PersistDirectoryAtom"
#define SB_SOfficeWorkbookBOFRecordNotFound 	"Workbook BOF record not found"
#define SB_SOfficeInvalidCurrentUserStreamSize 	"Invalid Current User stream size"
#define SB_SOfficeInvalidEncryptedStreamNameLength 	"Invalid encrypted stream name length"
#define SB_SOfficeUnsupportedAutoIncrementParameterValue 	"Unsupported auto increment parameter value"
#define SB_SOfficeInvalidPassword 	"Invalid password"
#define SB_SOfficePasswordTooShort 	"Password is too short"
#define SB_SOfficePasswordTooLong 	"Password is too long"
#define SB_SOfficeInvalidCipherMode 	"Invalid cipher mode"
#define SB_SOfficeInvalidEncryptionStream 	"Invalid encryption stream"
#define SB_SOfficeFailedToReadDataSizeEncryptedPackage 	"Failed to read data size from EncryptedPackage"
#define SB_SOfficeFailedToWriteDataSizeEncryptedPackage 	"Failed to write data size to EncryptedPackage"
#define SB_SOfficeInvalidEncryptedPackageStreamSizeValue 	"Invalid EncryptedPackage stream size value"
#define SB_SOfficeInvalidEncryptionHeaderFlags 	"Invalid EncryptionHeader flags"
#define SB_SOfficeInvalidEncryptionAlgorithm 	"Invalid encryption algorithm"
#define SB_SOfficeInvalidHashAlgorithm 	"Invalid hash algorithm"
#define SB_SOfficeInvalidEncryptionAlgorithmKeySize 	"Invalid encryption algorithm key size"
#define SB_SOfficeInvalidSaltSize 	"Invalid salt size"
#define SB_SOfficeInvalidBlockSize 	"Invalid block size"
#define SB_SOfficeInvalidHashSize 	"Invalid hash size"
#define SB_SOfficeInvalidSpinCount 	"Invalid spin count"
#define SB_SOfficeInvalidVerifierHashSize 	"Invalid verifier hash size"
#define SB_SOfficeInvalidKeyLength 	"Invalid key length"
#define SB_SOfficeInvalidHMACKeySize 	"Invalid HMAC key size"
#define SB_SOfficeInvalidChecksum 	"Invalid checksum"
#define SB_SOfficeCannotAttachSignature 	"Cannot attach (signature already attached)"
#define SB_SOfficeCannotAttachSignatureCalculated 	"Cannot attach (signature already calculated)"
#define SB_SOfficeCannotDetachSignatureCalculated 	"Cannot detach (signature already calculated)"
#define SB_SOfficeCannotSignSignatureCalculated 	"Cannot sign (signature already calculated)"
#define SB_SOfficeCannotCompleteAsyncSignNoSignature 	"Cannot complete async sign (no signature)"
#define SB_SOfficeCannotValidateSignatureNotCalculated 	"Cannot validate (signature is not calculated)"
#define SB_SOfficeCannotModifySignedParts 	"Cannot modify signed parts (signature already calculated)"
#define SB_SOfficeCannotModifySignatureProperties 	"Cannot modify signature properties (signature already calculated)"
#define SB_SOfficeSignatureHandlerNotAttached 	"The signature handler is not attached to a document"
#define SB_SOfficeSignedPartNotAttached 	"The signed part is not attached to a signature handler"
#define SB_SOfficeSignedPartExists 	"Signed part already exists"
#define SB_SOfficeSignedRelPartExists 	"Signed relationship part already exists"
#define SB_SOfficeCannotModifyEncryptionHandlerProperties 	"Cannot modify encryption handler properties (document already encrypted)"
#define SB_SOfficeCannotModifyKeyEncryptors 	"Cannot modify key encryptors (document already encrypted)"
#define SB_SOfficeDataIntegrityError 	"Data integrity error"
#define SB_SOfficeInsufficientData 	"Insufficient data"
#define SB_SOfficePackageObjectElementNotFound 	"The package-specific Object element not found"
#define SB_SOfficeInvalidPackageObjectElement 	"Invalid package-specific Object element"
#define SB_SOfficeInvalidTransformInPackageManifestElement 	"Invalid transform in package-specific Manifest element"
#define SB_SOfficeUnsupportedCertificatePublicKeyAlg 	"Unsupported certificate public key algorithm"
#define SB_SOfficeUnsupportedCanonicalizationMethod 	"Unsupported canonicalization method"
#define SB_SOfficeNoRelationships 	"No relationsips"
#define SB_SOfficeOriginPartNotFound 	"Digital Signature Origin part not found"
#define SB_SOfficePackageSignatureCorrupted 	"Package signature corrupted"
#define SB_SOfficeFixedDocumentPartNotFound 	"Fixed Document part not found"
#define SB_SOfficeFixedDocumentSequencePartNotFound 	"Fixed Document Sequence part not found"
#define SB_SOfficeInvalidSignatureDefinitionPart 	"Invalid Signature Definitions part"
#define SB_SOfficeSignatureInfoV1RequiredElementMissing 	"Required element is missing (in SignatureInfoV1 element)"
#define SB_SOfficeBadAsyncState 	"Bad asynchronous operation state"
#define SB_SOfficeCannotEmbedCertificateIntoSignedPartAfterSigning 	"Cannot embed certificate into a signed part after signing"
#define SB_SOfficeManifestStreamNotFound 	"Manifest stream not found"
#define SB_SOfficeMimetypeStreamNotFound 	"MIME Media Type stream not found"
#define SB_SOfficeFileEntryNotEncrypted 	"File entry is not encrypted"
#define SB_SOfficeInvalidFileEntrySizeValue 	"Invalid file entry size value"
#define SB_SOfficeSignedEntryExists 	"Signed entry already exists"
#define SB_SOfficeCannotModifySignedEntries 	"Cannot modify signed entries (signature already calculated)"

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBOFFICERESOURCES */

