#ifndef __INC_SBDEFS
#define __INC_SBDEFS

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000


#ifdef _WIN64
#  ifndef CPU64
#    define CPU64
#  endif
#elif _WIN32
  // default
#elif __APPLE__
#  include "TargetConditionals.h"
#  if TARGET_OS_IPHONE | TARGET_IPHONE_SIMULATOR
#    ifndef MACOS
#      define MACOS
#    endif
#    ifndef SB_IOS
#      define SB_IOS
#    endif
#    ifdef __LP64__
#      ifndef CPU64
#        define CPU64
#      endif
#    endif
#  elif TARGET_OS_MAC
#    ifndef MACOS
#      define MACOS 
#    endif
#    ifdef TARGET_RT_64_BIT
#      ifndef CPU64
#        define CPU64
#      endif
#    endif
#  else
     // Unsupported platform
#  endif
#elif __linux__
#  ifndef LINUX
#    define LINUX
#  endif
#  if defined(__LP64__) || defined(_LP64) || (__SIZEOF_POINTER__ == 8)
#    ifndef CPU64
#      define CPU64
#    endif
#  endif
#else
   // Unsupported platform
#endif

#if defined(MACOS) && defined(LINUX)
error: defines MACOS and LINUX are enabled
#endif

#ifndef LINUX
#ifndef MACOS
#ifndef SB_IOS
#  define SB_WINDOWS
#endif
#endif
#endif

#ifdef CPU64
#  define SB_CPU64_OR_IOS
#endif

#ifdef SB_IOS
#  define SB_CPU64_OR_IOS
#endif

#ifndef CPU64
#  define SB_NOT_CPU64_OR_IOS
#endif

#ifdef SB_IOS
#  define SB_NOT_CPU64_OR_IOS
#endif

#ifdef CPU64
#  define SB_CPU64_OR_NOT_IOS
#endif

#ifndef SB_IOS
#  define SB_CPU64_OR_NOT_IOS
#endif

#ifndef CPU64
#  define SB_NOT_CPU64_OR_NOT_IOS
#endif

#ifndef SB_IOS
#  define SB_NOT_CPU64_OR_NOT_IOS
#endif

#ifndef CPU64
#  define SB_NOT_CPU64_OR_WINDOWS
#endif

#ifdef SB_WINDOWS
#  define SB_NOT_CPU64_OR_WINDOWS
#endif

#ifdef CPU64
#  define SB_CPU64_OR_NOT_WINDOWS
#endif

#ifndef SB_WINDOWS
#  define SB_CPU64_OR_NOT_WINDOWS
#endif

#ifndef CPU64
#  define SB_NOT_CPU64_OR_NOT_WINDOWS
#endif

#ifndef SB_WINDOWS
#  define SB_NOT_CPU64_OR_NOT_WINDOWS
#endif

#ifdef WINCE
#  define SB_WINCE_OR_LINUX
#endif

#ifdef LINUX
#  define SB_WINCE_OR_LINUX
#endif

#ifdef WINCE
#  define SB_WINCE_OR_NOT_WINDOWS
#endif

#ifndef SB_WINDOWS
#  define SB_WINCE_OR_NOT_WINDOWS
#endif

#ifdef LINUX
#  define SB_LINUX_OR_IOS
#endif

#ifdef SB_IOS
#  define SB_LINUX_OR_IOS
#endif

#ifndef MACOS
#  define SB_NOT_MACOS_OR_IOS
#endif

#ifdef SB_IOS
#  define SB_NOT_MACOS_OR_IOS
#endif

#ifndef CPU64
#  define SB_NOT_CPU64_OR_IOS_OR_WINDOWS
#endif

#ifdef SB_IOS
#  define SB_NOT_CPU64_OR_IOS_OR_WINDOWS
#endif

#ifdef SB_WINDOWS
#  define SB_NOT_CPU64_OR_IOS_OR_WINDOWS
#endif


#include "sbcustom.h"

#ifdef SB_USE_ALL_UNITS
#  define SB_USE_UNIT_SYSTEM
#  define SB_USE_UNIT_AES
#  define SB_USE_UNIT_ALGORITHMIDENTIFIER
#ifdef MACOS
#  define SB_USE_UNIT_APPLECERTSTORAGE
#  define SB_USE_UNIT_APPLECOMMON
#endif
#  define SB_USE_UNIT_BZIP2
#  define SB_USE_UNIT_BZIP2COMMON
#  define SB_USE_UNIT_BZIP2TYPES
#  define SB_USE_UNIT_BZIP2UTILS
#  define SB_USE_UNIT_BZLIB
#  define SB_USE_UNIT_CHACHA20
#  define SB_USE_UNIT_CONSTANTS
#  define SB_USE_UNIT_CUSTOMCRYPTO
#  define SB_USE_UNIT_DES
#  define SB_USE_UNIT_DSA
#  define SB_USE_UNIT_ASN1
#  define SB_USE_UNIT_ASN1TREE
#  define SB_USE_UNIT_HASHFUNCTION
#  define SB_USE_UNIT_HMAC
#  define SB_USE_UNIT_MATH
#  define SB_USE_UNIT_MSKEYBLOB
#  define SB_USE_UNIT_MD
#  define SB_USE_UNIT_PEM
#  define SB_USE_UNIT_POLY1305
#  define SB_USE_UNIT_RANDOM
#  define SB_USE_UNIT_RC2
#  define SB_USE_UNIT_RC4
#  define SB_USE_UNIT_RIPEMD
#  define SB_USE_UNIT_RSA
#  define SB_USE_UNIT_SHA
#  define SB_USE_UNIT_SHA2
#  define SB_USE_UNIT_TYPES
#  define SB_USE_UNIT_UTILS
#  define SB_USE_UNIT_STRUTILS
#  define SB_USE_UNIT_STREAMS
#  define SB_USE_UNIT_ENCODING
#  define SB_USE_UNIT_BLOWFISH
#  define SB_USE_UNIT_ELGAMAL
#  define SB_USE_UNIT_CAMELLIA
#  define SB_USE_UNIT_CAST128
#  define SB_USE_UNIT_CRC
#  define SB_USE_UNIT_LICENSEMANAGER
#  define SB_USE_UNIT_SEED
#  define SB_USE_UNIT_RABBIT
#  define SB_USE_UNIT_SERPENT
#  define SB_USE_UNIT_SHAREDRESOURCE
#  define SB_USE_UNIT_SOCKET
#  define SB_USE_UNIT_PORTKNOCK
#  define SB_USE_UNIT_STRINGLIST
#  define SB_USE_UNIT_TIMER
#  define SB_USE_UNIT_TWOFISH
#  define SB_USE_UNIT_ZUNCOMPRESSUNIT
#  define SB_USE_UNIT_ZLIB
#  define SB_USE_UNIT_ZCOMMONUNIT
#  define SB_USE_UNIT_ZCOMPRESSUNIT
#  define SB_USE_UNIT_CRYPTOPROV
#  define SB_USE_UNIT_CRYPTOPROVUTILS
#  define SB_USE_UNIT_CRYPTOPROVDEFAULT
#  define SB_USE_UNIT_CRYPTOPROVBUILTIN
#  define SB_USE_UNIT_CRYPTOPROVBUILTINHASH
#  define SB_USE_UNIT_CRYPTOPROVBUILTINPKI
#  define SB_USE_UNIT_CRYPTOPROVBUILTINSYM
#ifdef SB_WINDOWS
#  define SB_USE_UNIT_CRYPTOPROVWIN32
#endif
#  define SB_USE_UNIT_CRYPTOPROVMANAGER
#  define SB_USE_UNIT_X509
#  define SB_USE_UNIT_X509EXT
#  define SB_USE_UNIT_CRL
#  define SB_USE_UNIT_CRLSTORAGE
#  define SB_USE_UNIT_CERTRETRIEVER
#  define SB_USE_UNIT_CERTVALIDATOR
#  define SB_USE_UNIT_RDN
#  define SB_USE_UNIT_CUSTOMCERTSTORAGE
#  define SB_USE_UNIT_MESSAGES
#  define SB_USE_UNIT_PKCS5
#  define SB_USE_UNIT_PKCS7
#  define SB_USE_UNIT_PKCS7UTILS
#  define SB_USE_UNIT_PKCS8
#  define SB_USE_UNIT_PKCS12
#  define SB_USE_UNIT_JKS
#ifdef SB_WINDOWS
#  define SB_USE_UNIT_WINCERTSTORAGE
#  define SB_USE_UNIT_WINCRYPT
#endif
#  define SB_USE_UNIT_SMIMESIGNATURES
#  define SB_USE_UNIT_OCSPCOMMON
#  define SB_USE_UNIT_OCSPCLIENT
#  define SB_USE_UNIT_OCSPSTORAGE
#  define SB_USE_UNIT_PUBLICKEYCRYPTO
#  define SB_USE_UNIT_SRP
#  define SB_USE_UNIT_SYMMETRICCRYPTO
#  define SB_USE_UNIT_PKIASYNC
#  define SB_USE_UNIT_TSPCOMMON
#  define SB_USE_UNIT_TSPCLIENT
#  define SB_USE_UNIT_SOCKETTSPCLIENT
#  define SB_USE_UNIT_TAR
#  define SB_USE_UNIT_UMAC
#  define SB_USE_UNIT_ECCOMMON
#  define SB_USE_UNIT_ECMATH
#  define SB_USE_UNIT_ECDSA
#  define SB_USE_UNIT_GOSTCOMMON
#  define SB_USE_UNIT_GOST341194
#  define SB_USE_UNIT_GOST341094
#  define SB_USE_UNIT_GOST341001
#  define SB_USE_UNIT_GOST2814789
#  define SB_USE_UNIT_GSSAPI
#  define SB_USE_UNIT_GSSAPIBASE
#ifdef SB_WINDOWS
#  define SB_USE_UNIT_GSSWINAUTH
#  define SB_USE_UNIT_SSPI
#endif
#  define SB_USE_UNIT_DNSSEC
#  define SB_USE_UNIT_DNSSECTYPES
#  define SB_USE_UNIT_DNSSECUTILS
#  define SB_USE_UNIT_CUSTOMFSADAPTER
#  define SB_USE_UNIT_DISKFSADAPTER
#  define SB_USE_UNIT_PUNYCODE
#  define SB_USE_UNIT_HTTPAUTH
#  define SB_USE_UNIT_SASL
#  define SB_USE_UNIT_COMPRSTREAM
#  define SB_USE_UNIT_DC
#  define SB_USE_UNIT_DCDEF
#  define SB_USE_UNIT_DCENC
#  define SB_USE_UNIT_CSARMSCII_8
#  define SB_USE_UNIT_CSATARIST
#  define SB_USE_UNIT_CSBIGFIVE
#  define SB_USE_UNIT_CSCNS_11643_1
#  define SB_USE_UNIT_CSCNS_11643_2
#  define SB_USE_UNIT_CSCNS_11643_3
#  define SB_USE_UNIT_CSCNS_11643_4
#  define SB_USE_UNIT_CSCNS_11643_5
#  define SB_USE_UNIT_CSCNS_11643_6
#  define SB_USE_UNIT_CSCNS_11643_7
#  define SB_USE_UNIT_CSCNS_11643_F
#  define SB_USE_UNIT_CSCP1006
#  define SB_USE_UNIT_CSCP1131
#  define SB_USE_UNIT_CSCP1133
#  define SB_USE_UNIT_CSCP1250
#  define SB_USE_UNIT_CSCP1251
#  define SB_USE_UNIT_CSCP1252
#  define SB_USE_UNIT_CSCP1253
#  define SB_USE_UNIT_CSCP1254
#  define SB_USE_UNIT_CSCP1255
#  define SB_USE_UNIT_CSCP1256
#  define SB_USE_UNIT_CSCP1257
#  define SB_USE_UNIT_CSCP1258
#  define SB_USE_UNIT_CSCP037
#  define SB_USE_UNIT_CSCP424
#  define SB_USE_UNIT_CSCP437
#  define SB_USE_UNIT_CSCP500
#  define SB_USE_UNIT_CSCP737
#  define SB_USE_UNIT_CSCP775
#  define SB_USE_UNIT_CSCP850
#  define SB_USE_UNIT_CSCP852
#  define SB_USE_UNIT_CSCP853
#  define SB_USE_UNIT_CSCP855
#  define SB_USE_UNIT_CSCP856
#  define SB_USE_UNIT_CSCP857
#  define SB_USE_UNIT_CSCP860
#  define SB_USE_UNIT_CSCP861
#  define SB_USE_UNIT_CSCP862
#  define SB_USE_UNIT_CSCP863
#  define SB_USE_UNIT_CSCP864
#  define SB_USE_UNIT_CSCP865
#  define SB_USE_UNIT_CSCP866
#  define SB_USE_UNIT_CSCP869
#  define SB_USE_UNIT_CSCP874
#  define SB_USE_UNIT_CSCP875
#  define SB_USE_UNIT_CSCP950DATA
#  define SB_USE_UNIT_CSGB_18030
#  define SB_USE_UNIT_CSGB_2312
#  define SB_USE_UNIT_CSGBK
#  define SB_USE_UNIT_CSGEORGIANACADEMY
#  define SB_USE_UNIT_CSGEORGIANPS
#  define SB_USE_UNIT_CSGEOSTD8
#  define SB_USE_UNIT_CSHKSCS
#  define SB_USE_UNIT_CSHPROMAN8
#  define SB_USE_UNIT_CSISO_8859_10
#  define SB_USE_UNIT_CSISO_8859_11
#  define SB_USE_UNIT_CSISO_8859_13
#  define SB_USE_UNIT_CSISO_8859_14
#  define SB_USE_UNIT_CSISO_8859_15
#  define SB_USE_UNIT_CSISO_8859_16
#  define SB_USE_UNIT_CSISO_8859_2
#  define SB_USE_UNIT_CSISO_8859_3
#  define SB_USE_UNIT_CSISO_8859_4
#  define SB_USE_UNIT_CSISO_8859_5
#  define SB_USE_UNIT_CSISO_8859_6
#  define SB_USE_UNIT_CSISO_8859_7
#  define SB_USE_UNIT_CSISO_8859_8
#  define SB_USE_UNIT_CSISO_8859_8I
#  define SB_USE_UNIT_CSISO_8859_9
#  define SB_USE_UNIT_CSISO_IR_165
#  define SB_USE_UNIT_CSJIS_0201
#  define SB_USE_UNIT_CSJIS_0208
#  define SB_USE_UNIT_CSJIS_0212
#  define SB_USE_UNIT_CSKOI8R
#  define SB_USE_UNIT_CSKOI8RU
#  define SB_USE_UNIT_CSKOI8T
#  define SB_USE_UNIT_CSKOI8U
#  define SB_USE_UNIT_CSKS_X_1001
#  define SB_USE_UNIT_CSMACCELTIC
#  define SB_USE_UNIT_CSMACCENTRALEUROPEAN
#  define SB_USE_UNIT_CSMACCROATIAN
#  define SB_USE_UNIT_CSMACCYRILLIC
#  define SB_USE_UNIT_CSMACGAELIC
#  define SB_USE_UNIT_CSMACGREEK
#  define SB_USE_UNIT_CSMACHEBREW
#  define SB_USE_UNIT_CSMACICELANDIC
#  define SB_USE_UNIT_CSMACROMAN
#  define SB_USE_UNIT_CSMACROMANIAN
#  define SB_USE_UNIT_CSMACTHAI
#  define SB_USE_UNIT_CSMACTURKISH
#  define SB_USE_UNIT_CSNEXTSTEP
#  define SB_USE_UNIT_CSSHIFTJIS
#  define SB_USE_UNIT_CSUHC
#  define SB_USE_UNIT_CSVISCII
#  define SB_USE_UNIT_CHSCJK
#  define SB_USE_UNIT_CHSCONV
#  define SB_USE_UNIT_CHSCONVBASE
#  define SB_USE_UNIT_CHSUNICODE
#  define SB_USE_UNIT_UNICODE
#  define SB_USE_UNIT_IDEA
#  define SB_USE_UNIT_CRYPTOPROVBUILTINEX
#  define SB_USE_UNIT_JSON
#  define SB_USE_UNIT_BCRYPT
#  define SB_USE_UNIT_WHIRLPOOL
#  define SB_USE_UNIT_DICTIONARY
#  define SB_USE_UNIT_USERS
#  define SB_USE_UNIT_DATASTORAGE
#  define SB_USE_UNIT_AWSDATASTORAGE
#  define SB_USE_UNIT_FILEDATASTORAGE
#  define SB_USE_UNIT_ENCSTREAM
#  define SB_USE_UNIT_AUTHDATASTREAM
#  define SB_USE_UNIT_WINAZUREDATASTORAGE
#  define SB_USE_UNIT_GOOGLEDATASTORAGE
#  define SB_USE_UNIT_GOOGLEDRIVEDATASTORAGE
#  define SB_USE_UNIT_ONEDRIVEDATASTORAGE
#  define SB_USE_UNIT_DROPBOXDATASTORAGE
#  define SB_USE_UNIT_DATASTORAGEENCODINGS
#  define SB_USE_UNIT_DATASTORAGEUTILS
#  define SB_USE_UNIT_BOXDATASTORAGE
#  define SB_USE_UNIT_HTTPSWEBDAVCLIENT
#  define SB_USE_UNIT_WEBDAVCLIENT
#  define SB_USE_UNIT_WEBDAVCOMMON
#  define SB_USE_UNIT_VCARD
#  define SB_USE_UNIT_WEBDAVSERVER
#  define SB_USE_UNIT_DCXMLENC
#  define SB_USE_UNIT_DCPKI
#  define SB_USE_UNIT_DCSERVER
#  define SB_USE_UNIT_AS2
#  define SB_USE_UNIT_AS3
#  define SB_USE_UNIT_ASCOMMON
#  define SB_USE_UNIT_ASUTILS
#  define SB_USE_UNIT_SIMPLEFTPS
#  define SB_USE_UNIT_FTPSCOMMON
#  define SB_USE_UNIT_FTPSSERVER
#  define SB_USE_UNIT_SIMPLEFTPSSERVER
#  define SB_USE_UNIT_HTTPSCOMMON
#  define SB_USE_UNIT_HTTPSCLIENT
#  define SB_USE_UNIT_HTTPTSPCLIENT
#  define SB_USE_UNIT_HTTPOCSPCLIENT
#  define SB_USE_UNIT_HTTPCERTRETRIEVER
#  define SB_USE_UNIT_HTTPCRL
#  define SB_USE_UNIT_OAUTH2
#  define SB_USE_UNIT_COOKIEMGR
#  define SB_USE_UNIT_WEBSOCKETCOMMON
#  define SB_USE_UNIT_WEBSOCKETCLIENT
#  define SB_USE_UNIT_RESTCLIENT
#  define SB_USE_UNIT_HTTPSSERVER
#  define SB_USE_UNIT_WEBSOCKETSERVER
#  define SB_USE_UNIT_LDAPCERTSTORAGE
#  define SB_USE_UNIT_LDAPCERTRETRIEVER
#  define SB_USE_UNIT_LDAPCRL
#  define SB_USE_UNIT_LDAPSCLIENT
#  define SB_USE_UNIT_LDAPSCORE
#  define SB_USE_UNIT_SMTPCLIENT
#  define SB_USE_UNIT_POP3CLIENT
#  define SB_USE_UNIT_IMAPCLIENT
#  define SB_USE_UNIT_IMAPUTILS
#  define SB_USE_UNIT_DOMAINKEYS
#  define SB_USE_UNIT_MIME
#  define SB_USE_UNIT_MIMEENC
#  define SB_USE_UNIT_MIMESTREAM
#  define SB_USE_UNIT_SIMPLEMIME
#  define SB_USE_UNIT_COMPOUNDFILE
#  define SB_USE_UNIT_OFFICE
#  define SB_USE_UNIT_OFFICEBINARYCORE
#  define SB_USE_UNIT_OFFICEPACKAGE
#  define SB_USE_UNIT_OFFICESECURITY
#  define SB_USE_UNIT_OFFICEXMLCORE
#  define SB_USE_UNIT_PDF
#  define SB_USE_UNIT_PDFCORE
#  define SB_USE_UNIT_PDFSECURITY
#  define SB_USE_UNIT_PDFUTILS
#  define SB_USE_UNIT_PADES
#  define SB_USE_UNIT_PGP
#  define SB_USE_UNIT_PGPENTITIES
#  define SB_USE_UNIT_PGPKEYS
#  define SB_USE_UNIT_PGPMD
#  define SB_USE_UNIT_PGPSTREAMS
#  define SB_USE_UNIT_PGPUTILS
#ifndef SB_WINCE_OR_NOT_WINDOWS
#  define SB_USE_UNIT_PGPSFX
#endif
#  define SB_USE_UNIT_LDAPSKEYSERVERCLIENT
#  define SB_USE_UNIT_PGPMIME
#  define SB_USE_UNIT_PGPSSH
#  define SB_USE_UNIT_PGPTLS
#  define SB_USE_UNIT_CMS
#  define SB_USE_UNIT_CRYPTOPROVPKCS11
#  define SB_USE_UNIT_PKCS11BASE
#  define SB_USE_UNIT_PKCS11MANAGER
#  define SB_USE_UNIT_PKCS11CERTSTORAGE
#  define SB_USE_UNIT_PKCS10
#  define SB_USE_UNIT_OCSPSERVER
#  define SB_USE_UNIT_TSPSERVER
#  define SB_USE_UNIT_AUTHENTICODE
#  define SB_USE_UNIT_CRLEX
#  define SB_USE_UNIT_X509EX
#  define SB_USE_UNIT_SSHPKCS11KEYSTORAGE
#  define SB_USE_UNIT_CADES
#  define SB_USE_UNIT_CMC
#  define SB_USE_UNIT_OTPCOMMON
#  define SB_USE_UNIT_OTPCLIENT
#  define SB_USE_UNIT_OTPSERVER
#  define SB_USE_UNIT_ECIESCRYPTO
#  define SB_USE_UNIT_SFTP
#  define SB_USE_UNIT_SFTPCOMMON
#  define SB_USE_UNIT_SIMPLESFTP
#  define SB_USE_UNIT_SFTPHANDLER
#  define SB_USE_UNIT_SFTPSERVER
#  define SB_USE_UNIT_SIMPLESFTPSERVER
#  define SB_USE_UNIT_SMIMECORE
#  define SB_USE_UNIT_SMIMECADES
#  define SB_USE_UNIT_SSHCONSTANTS
#  define SB_USE_UNIT_SSHKEYSTORAGE
#  define SB_USE_UNIT_SSHTERM
#  define SB_USE_UNIT_SSHUTILS
#  define SB_USE_UNIT_SSHCLIENT
#  define SB_USE_UNIT_SSHCOMMON
#  define SB_USE_UNIT_SIMPLESSH
#  define SB_USE_UNIT_SSHFORWARDING
#  define SB_USE_UNIT_SSHPUBKEYCOMMON
#  define SB_USE_UNIT_SSHPUBKEYCLIENT
#ifndef WINCE
#  define SB_USE_UNIT_SSHAUTHAGENT
#endif
#  define SB_USE_UNIT_SSHSERVER
#  define SB_USE_UNIT_SSHHANDLERS
#  define SB_USE_UNIT_SSHCONNECTIONHANDLER
#  define SB_USE_UNIT_SSHPUBKEYSERVER
#  define SB_USE_UNIT_SSHPUBKEYHANDLER
#  define SB_USE_UNIT_SIMPLESSHSERVER
#  define SB_USE_UNIT_SSHFORWARDINGHANDLERS
#  define SB_USE_UNIT_SSLCLIENT
#  define SB_USE_UNIT_SIMPLESSL
#  define SB_USE_UNIT_SSLCOMMON
#  define SB_USE_UNIT_CMDSSLCLIENT
#  define SB_USE_UNIT_DTLSCLIENT
#  define SB_USE_UNIT_SSLSERVER
#  define SB_USE_UNIT_SESSIONPOOL
#  define SB_USE_UNIT_DTLSSERVER
#  define SB_USE_UNIT_XMLCHARSETS
#  define SB_USE_UNIT_XMLCORE
#  define SB_USE_UNIT_XMLDEFS
#  define SB_USE_UNIT_XMLPATH
#  define SB_USE_UNIT_XMLUTILS
#  define SB_USE_UNIT_XMLADES
#  define SB_USE_UNIT_XMLADESINTF
#  define SB_USE_UNIT_XMLENC
#  define SB_USE_UNIT_XMLSEC
#  define SB_USE_UNIT_XMLSIG
#  define SB_USE_UNIT_XMLTRANSFORM
#  define SB_USE_UNIT_XMLSOAPCORE
#  define SB_USE_UNIT_XMLWSSCORE
#  define SB_USE_UNIT_XMLSOAP
#  define SB_USE_UNIT_XMLSOAPSECURITY
#  define SB_USE_UNIT_XMLSOAPCLIENT
#  define SB_USE_UNIT_ARCBASE
#  define SB_USE_UNIT_ARCZIP
#  define SB_USE_UNIT_ZIPENTITIES
#  define SB_USE_UNIT_ZIPUTILS
#  define SB_USE_UNIT_ARCTAR
#  define SB_USE_UNIT_TARENTITIES
#  define SB_USE_UNIT_TARUTILS
#  define SB_USE_UNIT_ARCGZIP
#  define SB_USE_UNIT_ARCBZIP2
#ifndef SB_WINCE_OR_NOT_WINDOWS
#  define SB_USE_UNIT_ZIPSFX
#endif
#ifdef SB_WINDOWS
#  define SB_USE_UNIT_ZIPSFXMAKER
#endif
#  define SB_USE_UNIT_XMLSAMLBIND
#  define SB_USE_UNIT_XMLSAMLCOMMON
#  define SB_USE_UNIT_XMLSAMLCORE
#  define SB_USE_UNIT_XMLSAMLMETADATA
#  define SB_USE_UNIT_XMLSAMLPROTOCOL
#  define SB_USE_UNIT_SAMLIDENTITYPROVIDER
#  define SB_USE_UNIT_SAMLSERVICEPROVIDER
#  define SB_USE_UNIT_DCCMS
#endif /* SB_USE_ALL_UNITS */

#ifdef SB_USE_PACKAGE_BASE
#  define SB_USE_UNIT_AES
#  define SB_USE_UNIT_ALGORITHMIDENTIFIER
#  define SB_USE_UNIT_APPLECERTSTORAGE
#  define SB_USE_UNIT_APPLECOMMON
#  define SB_USE_UNIT_BZIP2
#  define SB_USE_UNIT_BZIP2BASETYPES
#  define SB_USE_UNIT_BZIP2COMMON
#  define SB_USE_UNIT_BZIP2TYPES
#  define SB_USE_UNIT_BZIP2UTILS
#  define SB_USE_UNIT_BZLIB
#  define SB_USE_UNIT_CHACHA20
#  define SB_USE_UNIT_CONSTANTS
#  define SB_USE_UNIT_CUSTOMCRYPTO
#  define SB_USE_UNIT_DES
#  define SB_USE_UNIT_DSA
#  define SB_USE_UNIT_ASN1
#  define SB_USE_UNIT_ASN1TREE
#  define SB_USE_UNIT_HASHFUNCTION
#  define SB_USE_UNIT_HMAC
#  define SB_USE_UNIT_MATH
#  define SB_USE_UNIT_MSKEYBLOB
#  define SB_USE_UNIT_MD
#  define SB_USE_UNIT_PEM
#  define SB_USE_UNIT_POLY1305
#  define SB_USE_UNIT_RANDOM
#  define SB_USE_UNIT_RC2
#  define SB_USE_UNIT_RC4
#  define SB_USE_UNIT_RIPEMD
#  define SB_USE_UNIT_RSA
#  define SB_USE_UNIT_SHA
#  define SB_USE_UNIT_SHA2
#  define SB_USE_UNIT_TYPES
#  define SB_USE_UNIT_UTILS
#  define SB_USE_UNIT_STRUTILS
#  define SB_USE_UNIT_STREAMS
#  define SB_USE_UNIT_ENCODING
#  define SB_USE_UNIT_BLOWFISH
#  define SB_USE_UNIT_ELGAMAL
#  define SB_USE_UNIT_CAMELLIA
#  define SB_USE_UNIT_CAST128
#  define SB_USE_UNIT_CRC
#  define SB_USE_UNIT_LICENSEMANAGER
#  define SB_USE_UNIT_SEED
#  define SB_USE_UNIT_RABBIT
#  define SB_USE_UNIT_SERPENT
#  define SB_USE_UNIT_SHAREDRESOURCE
#  define SB_USE_UNIT_SOCKET
#  define SB_USE_UNIT_PORTKNOCK
#  define SB_USE_UNIT_STRINGLIST
#  define SB_USE_UNIT_TIMER
#  define SB_USE_UNIT_TWOFISH
#  define SB_USE_UNIT_ZUNCOMPRESSUNIT
#  define SB_USE_UNIT_ZLIB
#  define SB_USE_UNIT_ZCOMMONUNIT
#  define SB_USE_UNIT_ZCOMPRESSUNIT
#  define SB_USE_UNIT_CMSUTILS
#  define SB_USE_UNIT_CRYPTOPROV
#  define SB_USE_UNIT_CRYPTOPROVRS
#  define SB_USE_UNIT_CRYPTOPROVUTILS
#  define SB_USE_UNIT_CRYPTOPROVDEFAULT
#  define SB_USE_UNIT_CRYPTOPROVBUILTIN
#  define SB_USE_UNIT_CRYPTOPROVBUILTINHASH
#  define SB_USE_UNIT_CRYPTOPROVBUILTINPKI
#  define SB_USE_UNIT_CRYPTOPROVBUILTINSYM
#  define SB_USE_UNIT_CRYPTOPROVWIN32
#  define SB_USE_UNIT_CRYPTOPROVMANAGER
#  define SB_USE_UNIT_X509
#  define SB_USE_UNIT_X509EXT
#  define SB_USE_UNIT_CRL
#  define SB_USE_UNIT_CRLSTORAGE
#  define SB_USE_UNIT_CERTRETRIEVER
#  define SB_USE_UNIT_CERTVALIDATOR
#  define SB_USE_UNIT_RDN
#  define SB_USE_UNIT_CUSTOMCERTSTORAGE
#  define SB_USE_UNIT_MESSAGES
#  define SB_USE_UNIT_PKCS5
#  define SB_USE_UNIT_PKCS7
#  define SB_USE_UNIT_PKCS7UTILS
#  define SB_USE_UNIT_PKCS8
#  define SB_USE_UNIT_PKCS12
#  define SB_USE_UNIT_JKS
#  define SB_USE_UNIT_WINCERTSTORAGE
#  define SB_USE_UNIT_WINCRYPT
#  define SB_USE_UNIT_SMIMESIGNATURES
#  define SB_USE_UNIT_OCSPCOMMON
#  define SB_USE_UNIT_OCSPCLIENT
#  define SB_USE_UNIT_OCSPSTORAGE
#  define SB_USE_UNIT_PUBLICKEYCRYPTO
#  define SB_USE_UNIT_SRP
#  define SB_USE_UNIT_SYMMETRICCRYPTO
#  define SB_USE_UNIT_PKIASYNC
#  define SB_USE_UNIT_PKICOMMON
#  define SB_USE_UNIT_TSPCOMMON
#  define SB_USE_UNIT_TSPCLIENT
#  define SB_USE_UNIT_SOCKETTSPCLIENT
#  define SB_USE_UNIT_TAR
#  define SB_USE_UNIT_UMAC
#  define SB_USE_UNIT_ECCOMMON
#  define SB_USE_UNIT_ECMATH
#  define SB_USE_UNIT_ECDSA
#  define SB_USE_UNIT_GOSTCOMMON
#  define SB_USE_UNIT_GOST341194
#  define SB_USE_UNIT_GOST341094
#  define SB_USE_UNIT_GOST341001
#  define SB_USE_UNIT_GOST2814789
#  define SB_USE_UNIT_GSSAPI
#  define SB_USE_UNIT_GSSAPIBASE
#  define SB_USE_UNIT_GSSWINAUTH
#  define SB_USE_UNIT_SSPI
#  define SB_USE_UNIT_DNSSEC
#  define SB_USE_UNIT_DNSSECTYPES
#  define SB_USE_UNIT_DNSSECCONSTS
#  define SB_USE_UNIT_DNSSECUTILS
#  define SB_USE_UNIT_CUSTOMFSADAPTER
#  define SB_USE_UNIT_DISKFSADAPTER
#  define SB_USE_UNIT_PUNYCODE
#  define SB_USE_UNIT_HTTPAUTH
#  define SB_USE_UNIT_HTTPSCONSTANTS
#  define SB_USE_UNIT_SASL
#  define SB_USE_UNIT_COMPRSTREAM
#  define SB_USE_UNIT_DC
#  define SB_USE_UNIT_DCDEF
#  define SB_USE_UNIT_DCENC
#  define SB_USE_UNIT_DCPKICONSTANTS
#  define SB_USE_UNIT_SOCKETHANDLER
#  define SB_USE_UNIT_CSARMSCII_8
#  define SB_USE_UNIT_CSATARIST
#  define SB_USE_UNIT_CSBIGFIVE
#  define SB_USE_UNIT_CSCNS_11643_1
#  define SB_USE_UNIT_CSCNS_11643_2
#  define SB_USE_UNIT_CSCNS_11643_3
#  define SB_USE_UNIT_CSCNS_11643_4
#  define SB_USE_UNIT_CSCNS_11643_5
#  define SB_USE_UNIT_CSCNS_11643_6
#  define SB_USE_UNIT_CSCNS_11643_7
#  define SB_USE_UNIT_CSCNS_11643_F
#  define SB_USE_UNIT_CSCP1006
#  define SB_USE_UNIT_CSCP1131
#  define SB_USE_UNIT_CSCP1133
#  define SB_USE_UNIT_CSCP1250
#  define SB_USE_UNIT_CSCP1251
#  define SB_USE_UNIT_CSCP1252
#  define SB_USE_UNIT_CSCP1253
#  define SB_USE_UNIT_CSCP1254
#  define SB_USE_UNIT_CSCP1255
#  define SB_USE_UNIT_CSCP1256
#  define SB_USE_UNIT_CSCP1257
#  define SB_USE_UNIT_CSCP1258
#  define SB_USE_UNIT_CSCP037
#  define SB_USE_UNIT_CSCP424
#  define SB_USE_UNIT_CSCP437
#  define SB_USE_UNIT_CSCP500
#  define SB_USE_UNIT_CSCP737
#  define SB_USE_UNIT_CSCP775
#  define SB_USE_UNIT_CSCP850
#  define SB_USE_UNIT_CSCP852
#  define SB_USE_UNIT_CSCP853
#  define SB_USE_UNIT_CSCP855
#  define SB_USE_UNIT_CSCP856
#  define SB_USE_UNIT_CSCP857
#  define SB_USE_UNIT_CSCP860
#  define SB_USE_UNIT_CSCP861
#  define SB_USE_UNIT_CSCP862
#  define SB_USE_UNIT_CSCP863
#  define SB_USE_UNIT_CSCP864
#  define SB_USE_UNIT_CSCP865
#  define SB_USE_UNIT_CSCP866
#  define SB_USE_UNIT_CSCP869
#  define SB_USE_UNIT_CSCP874
#  define SB_USE_UNIT_CSCP875
#  define SB_USE_UNIT_CSCP950DATA
#  define SB_USE_UNIT_CSGB_18030
#  define SB_USE_UNIT_CSGB_2312
#  define SB_USE_UNIT_CSGBK
#  define SB_USE_UNIT_CSGEORGIANACADEMY
#  define SB_USE_UNIT_CSGEORGIANPS
#  define SB_USE_UNIT_CSGEOSTD8
#  define SB_USE_UNIT_CSHKSCS
#  define SB_USE_UNIT_CSHPROMAN8
#  define SB_USE_UNIT_CSISO_8859_10
#  define SB_USE_UNIT_CSISO_8859_11
#  define SB_USE_UNIT_CSISO_8859_13
#  define SB_USE_UNIT_CSISO_8859_14
#  define SB_USE_UNIT_CSISO_8859_15
#  define SB_USE_UNIT_CSISO_8859_16
#  define SB_USE_UNIT_CSISO_8859_2
#  define SB_USE_UNIT_CSISO_8859_3
#  define SB_USE_UNIT_CSISO_8859_4
#  define SB_USE_UNIT_CSISO_8859_5
#  define SB_USE_UNIT_CSISO_8859_6
#  define SB_USE_UNIT_CSISO_8859_7
#  define SB_USE_UNIT_CSISO_8859_8
#  define SB_USE_UNIT_CSISO_8859_8I
#  define SB_USE_UNIT_CSISO_8859_9
#  define SB_USE_UNIT_CSISO_IR_165
#  define SB_USE_UNIT_CSJIS_0201
#  define SB_USE_UNIT_CSJIS_0208
#  define SB_USE_UNIT_CSJIS_0212
#  define SB_USE_UNIT_CSKOI8R
#  define SB_USE_UNIT_CSKOI8RU
#  define SB_USE_UNIT_CSKOI8T
#  define SB_USE_UNIT_CSKOI8U
#  define SB_USE_UNIT_CSKS_X_1001
#  define SB_USE_UNIT_CSMACCELTIC
#  define SB_USE_UNIT_CSMACCENTRALEUROPEAN
#  define SB_USE_UNIT_CSMACCROATIAN
#  define SB_USE_UNIT_CSMACCYRILLIC
#  define SB_USE_UNIT_CSMACGAELIC
#  define SB_USE_UNIT_CSMACGREEK
#  define SB_USE_UNIT_CSMACHEBREW
#  define SB_USE_UNIT_CSMACICELANDIC
#  define SB_USE_UNIT_CSMACROMAN
#  define SB_USE_UNIT_CSMACROMANIAN
#  define SB_USE_UNIT_CSMACTHAI
#  define SB_USE_UNIT_CSMACTURKISH
#  define SB_USE_UNIT_CSNEXTSTEP
#  define SB_USE_UNIT_CSSHIFTJIS
#  define SB_USE_UNIT_CSUHC
#  define SB_USE_UNIT_CSVISCII
#  define SB_USE_UNIT_CHSCJK
#  define SB_USE_UNIT_CHSCJKCONSTS
#  define SB_USE_UNIT_CHSCONV
#  define SB_USE_UNIT_CHSCONVBASE
#  define SB_USE_UNIT_CHSCONVCHARSETS
#  define SB_USE_UNIT_CHSCONVCONSTS
#  define SB_USE_UNIT_CHSUNICODE
#  define SB_USE_UNIT_UNICODE
#  define SB_USE_UNIT_IDEA
#  define SB_USE_UNIT_CRYPTOPROVBUILTINEX
#  define SB_USE_UNIT_JSON
#  define SB_USE_UNIT_BCRYPT
#  define SB_USE_UNIT_WHIRLPOOL
#  define SB_USE_UNIT_DICTIONARY
#  define SB_USE_UNIT_USERS
#endif /* SB_USE_PACKAGE_BASE */

#ifdef SB_USE_PACKAGE_CLOUD
#  define SB_USE_UNIT_DATASTORAGE
#  define SB_USE_UNIT_AWSDATASTORAGE
#  define SB_USE_UNIT_FILEDATASTORAGE
#  define SB_USE_UNIT_ENCSTREAM
#  define SB_USE_UNIT_AUTHDATASTREAM
#  define SB_USE_UNIT_WINAZUREDATASTORAGE
#  define SB_USE_UNIT_GOOGLEDATASTORAGE
#  define SB_USE_UNIT_GOOGLEDRIVEDATASTORAGE
#  define SB_USE_UNIT_ONEDRIVEDATASTORAGE
#  define SB_USE_UNIT_DROPBOXDATASTORAGE
#  define SB_USE_UNIT_DATASTORAGEENCODINGS
#  define SB_USE_UNIT_DATASTORAGEUTILS
#  define SB_USE_UNIT_BOXDATASTORAGE
#endif /* SB_USE_PACKAGE_CLOUD */

#ifdef SB_USE_PACKAGE_DAVCLI
#  define SB_USE_UNIT_HTTPSWEBDAVCLIENT
#  define SB_USE_UNIT_WEBDAVCLIENT
#  define SB_USE_UNIT_WEBDAVCOMMON
#  define SB_USE_UNIT_VCARD
#endif /* SB_USE_PACKAGE_DAVCLI */

#ifdef SB_USE_PACKAGE_DAVSRV
#  define SB_USE_UNIT_WEBDAVSERVER
#endif /* SB_USE_PACKAGE_DAVSRV */

#ifdef SB_USE_PACKAGE_DC
#  define SB_USE_UNIT_DCXMLENC
#  define SB_USE_UNIT_DCPKI
#  define SB_USE_UNIT_DCSERVER
#endif /* SB_USE_PACKAGE_DC */

#ifdef SB_USE_PACKAGE_EDI
#  define SB_USE_UNIT_AS2
#  define SB_USE_UNIT_AS3
#  define SB_USE_UNIT_ASCOMMON
#  define SB_USE_UNIT_ASCONSTANTS
#  define SB_USE_UNIT_ASRESOURCES
#  define SB_USE_UNIT_ASUTILS
#endif /* SB_USE_PACKAGE_EDI */

#ifdef SB_USE_PACKAGE_FTPSCLI
#  define SB_USE_UNIT_SIMPLEFTPS
#endif /* SB_USE_PACKAGE_FTPSCLI */

#ifdef SB_USE_PACKAGE_FTPSSRV
#  define SB_USE_UNIT_FTPSCOMMON
#  define SB_USE_UNIT_FTPSSERVER
#  define SB_USE_UNIT_SIMPLEFTPSSERVER
#endif /* SB_USE_PACKAGE_FTPSSRV */

#ifdef SB_USE_PACKAGE_HTTPCLI
#  define SB_USE_UNIT_HTTPSCOMMON
#  define SB_USE_UNIT_HTTPSCLIENT
#  define SB_USE_UNIT_HTTPTSPCLIENT
#  define SB_USE_UNIT_HTTPOCSPCLIENT
#  define SB_USE_UNIT_HTTPCERTRETRIEVER
#  define SB_USE_UNIT_HTTPCRL
#  define SB_USE_UNIT_OAUTH2
#  define SB_USE_UNIT_COOKIEMGR
#  define SB_USE_UNIT_WEBSOCKETCOMMON
#  define SB_USE_UNIT_WEBSOCKETCLIENT
#  define SB_USE_UNIT_RESTCLIENT
#endif /* SB_USE_PACKAGE_HTTPCLI */

#ifdef SB_USE_PACKAGE_HTTPSRV
#  define SB_USE_UNIT_HTTPSSERVER
#  define SB_USE_UNIT_WEBSOCKETSERVER
#endif /* SB_USE_PACKAGE_HTTPSRV */

#ifdef SB_USE_PACKAGE_LDAP
#  define SB_USE_UNIT_LDAPCERTSTORAGE
#  define SB_USE_UNIT_LDAPCERTRETRIEVER
#  define SB_USE_UNIT_LDAPCRL
#  define SB_USE_UNIT_LDAPSCLIENT
#  define SB_USE_UNIT_LDAPSCORE
#endif /* SB_USE_PACKAGE_LDAP */

#ifdef SB_USE_PACKAGE_MAIL
#  define SB_USE_UNIT_SMTPCLIENT
#  define SB_USE_UNIT_POP3CLIENT
#  define SB_USE_UNIT_IMAPCLIENT
#  define SB_USE_UNIT_IMAPUTILS
#endif /* SB_USE_PACKAGE_MAIL */

#ifdef SB_USE_PACKAGE_MIME
#  define SB_USE_UNIT_DOMAINKEYS
#  define SB_USE_UNIT_MIME
#  define SB_USE_UNIT_MIMEENC
#  define SB_USE_UNIT_MIMESTREAM
#  define SB_USE_UNIT_SIMPLEMIME
#endif /* SB_USE_PACKAGE_MIME */

#ifdef SB_USE_PACKAGE_OFFICE
#  define SB_USE_UNIT_COMPOUNDFILE
#  define SB_USE_UNIT_COMPOUNDFILEBASE
#  define SB_USE_UNIT_COMPOUNDFILERESOURCES
#  define SB_USE_UNIT_OFFICE
#  define SB_USE_UNIT_OFFICEBINARYCORE
#  define SB_USE_UNIT_OFFICECOMMON
#  define SB_USE_UNIT_OFFICECONSTANTS
#  define SB_USE_UNIT_OFFICEPACKAGE
#  define SB_USE_UNIT_OFFICERESOURCES
#  define SB_USE_UNIT_OFFICESECURITY
#  define SB_USE_UNIT_OFFICEXMLCORE
#endif /* SB_USE_PACKAGE_OFFICE */

#ifdef SB_USE_PACKAGE_PDF
#  define SB_USE_UNIT_PDF
#  define SB_USE_UNIT_PDFCORE
#  define SB_USE_UNIT_PDFSECURITY
#  define SB_USE_UNIT_PDFUTILS
#  define SB_USE_UNIT_PADES
#endif /* SB_USE_PACKAGE_PDF */

#ifdef SB_USE_PACKAGE_PGP
#  define SB_USE_UNIT_PGP
#  define SB_USE_UNIT_PGPCONSTANTS
#  define SB_USE_UNIT_PGPENTITIES
#  define SB_USE_UNIT_PGPEXCEPTIONS
#  define SB_USE_UNIT_PGPKEYS
#  define SB_USE_UNIT_PGPMD
#  define SB_USE_UNIT_PGPRESOURCESTRINGS
#  define SB_USE_UNIT_PGPSTREAMS
#  define SB_USE_UNIT_PGPUTILS
#  define SB_USE_UNIT_PGPSFX
#endif /* SB_USE_PACKAGE_PGP */

#ifdef SB_USE_PACKAGE_PGPLDAP
#  define SB_USE_UNIT_LDAPSKEYSERVERCLIENT
#endif /* SB_USE_PACKAGE_PGPLDAP */

#ifdef SB_USE_PACKAGE_PGPMIME
#  define SB_USE_UNIT_PGPMIME
#endif /* SB_USE_PACKAGE_PGPMIME */

#ifdef SB_USE_PACKAGE_PGPSSH
#  define SB_USE_UNIT_PGPSSH
#endif /* SB_USE_PACKAGE_PGPSSH */

#ifdef SB_USE_PACKAGE_PGPTLS
#  define SB_USE_UNIT_PGPTLS
#endif /* SB_USE_PACKAGE_PGPTLS */

#ifdef SB_USE_PACKAGE_PKI
#  define SB_USE_UNIT_CMS
#  define SB_USE_UNIT_CRYPTOPROVPKCS11
#  define SB_USE_UNIT_PKCS11COMMON
#  define SB_USE_UNIT_PKCS11BASE
#  define SB_USE_UNIT_PKCS11MANAGER
#  define SB_USE_UNIT_PKCS11CERTSTORAGE
#  define SB_USE_UNIT_PKCS10
#  define SB_USE_UNIT_OCSPSERVER
#  define SB_USE_UNIT_TSPSERVER
#  define SB_USE_UNIT_AUTHENTICODE
#  define SB_USE_UNIT_CRLEX
#  define SB_USE_UNIT_X509EX
#  define SB_USE_UNIT_SSHPKCS11KEYSTORAGE
#  define SB_USE_UNIT_CADES
#  define SB_USE_UNIT_CMC
#  define SB_USE_UNIT_OTPCOMMON
#  define SB_USE_UNIT_OTPCLIENT
#  define SB_USE_UNIT_OTPSERVER
#  define SB_USE_UNIT_ECIESCRYPTO
#endif /* SB_USE_PACKAGE_PKI */

#ifdef SB_USE_PACKAGE_SFTPCLI
#  define SB_USE_UNIT_SFTP
#  define SB_USE_UNIT_SFTPCOMMON
#  define SB_USE_UNIT_SIMPLESFTP
#endif /* SB_USE_PACKAGE_SFTPCLI */

#ifdef SB_USE_PACKAGE_SFTPSRV
#  define SB_USE_UNIT_SFTPHANDLER
#  define SB_USE_UNIT_SFTPSERVER
#  define SB_USE_UNIT_SIMPLESFTPSERVER
#endif /* SB_USE_PACKAGE_SFTPSRV */

#ifdef SB_USE_PACKAGE_SMIME
#  define SB_USE_UNIT_SMIMECORE
#  define SB_USE_UNIT_SMIMECADES
#endif /* SB_USE_PACKAGE_SMIME */

#ifdef SB_USE_PACKAGE_SSHCLI
#  define SB_USE_UNIT_SSHCONSTANTS
#  define SB_USE_UNIT_SSHKEYSTORAGE
#  define SB_USE_UNIT_SSHTERM
#  define SB_USE_UNIT_SSHUTILS
#  define SB_USE_UNIT_SSHCLIENT
#  define SB_USE_UNIT_SSHCOMMON
#  define SB_USE_UNIT_SIMPLESSH
#  define SB_USE_UNIT_SSHFORWARDING
#  define SB_USE_UNIT_SSHPUBKEYCOMMON
#  define SB_USE_UNIT_SSHPUBKEYCLIENT
#  define SB_USE_UNIT_SSHAUTHAGENT
#endif /* SB_USE_PACKAGE_SSHCLI */

#ifdef SB_USE_PACKAGE_SSHSRV
#  define SB_USE_UNIT_SSHSERVER
#  define SB_USE_UNIT_SSHHANDLERS
#  define SB_USE_UNIT_SSHCONNECTIONHANDLER
#  define SB_USE_UNIT_SSHPUBKEYSERVER
#  define SB_USE_UNIT_SSHPUBKEYHANDLER
#  define SB_USE_UNIT_SIMPLESSHSERVER
#  define SB_USE_UNIT_SSHFORWARDINGHANDLERS
#endif /* SB_USE_PACKAGE_SSHSRV */

#ifdef SB_USE_PACKAGE_SSLCLI
#  define SB_USE_UNIT_SSLCLIENT
#  define SB_USE_UNIT_SIMPLESSL
#  define SB_USE_UNIT_SSLCOMMON
#  define SB_USE_UNIT_SSLCONSTANTS
#  define SB_USE_UNIT_CMDSSLCLIENT
#  define SB_USE_UNIT_DTLSCLIENT
#endif /* SB_USE_PACKAGE_SSLCLI */

#ifdef SB_USE_PACKAGE_SSLSRV
#  define SB_USE_UNIT_SSLSERVER
#  define SB_USE_UNIT_SESSIONPOOL
#  define SB_USE_UNIT_DTLSSERVER
#endif /* SB_USE_PACKAGE_SSLSRV */

#ifdef SB_USE_PACKAGE_XML
#  define SB_USE_UNIT_XMLCHARSETS
#  define SB_USE_UNIT_XMLCORE
#  define SB_USE_UNIT_XMLDEFS
#  define SB_USE_UNIT_XMLPATH
#  define SB_USE_UNIT_XMLUTILS
#endif /* SB_USE_PACKAGE_XML */

#ifdef SB_USE_PACKAGE_XMLSEC
#  define SB_USE_UNIT_XMLADES
#  define SB_USE_UNIT_XMLADESINTF
#  define SB_USE_UNIT_XMLENC
#  define SB_USE_UNIT_XMLSEC
#  define SB_USE_UNIT_XMLSIG
#  define SB_USE_UNIT_XMLTRANSFORM
#  define SB_USE_UNIT_XMLSOAPCORE
#  define SB_USE_UNIT_XMLWSSCORE
#  define SB_USE_UNIT_XMLSOAP
#  define SB_USE_UNIT_XMLSOAPSECURITY
#endif /* SB_USE_PACKAGE_XMLSEC */

#ifdef SB_USE_PACKAGE_SOAPCLI
#  define SB_USE_UNIT_XMLSOAPCLIENT
#endif /* SB_USE_PACKAGE_SOAPCLI */

#ifdef SB_USE_PACKAGE_ZIP
#  define SB_USE_UNIT_ARCBASE
#  define SB_USE_UNIT_ARCZIP
#  define SB_USE_UNIT_ZIPENTITIES
#  define SB_USE_UNIT_ZIPUTILS
#  define SB_USE_UNIT_ARCTAR
#  define SB_USE_UNIT_TARENTITIES
#  define SB_USE_UNIT_TARUTILS
#  define SB_USE_UNIT_ARCGZIP
#  define SB_USE_UNIT_ARCBZIP2
#  define SB_USE_UNIT_ZIPSFX
#  define SB_USE_UNIT_ZIPSFXMAKER
#endif /* SB_USE_PACKAGE_ZIP */

#ifdef SB_USE_PACKAGE_SAML
#  define SB_USE_UNIT_XMLSAMLBIND
#  define SB_USE_UNIT_XMLSAMLCOMMON
#  define SB_USE_UNIT_XMLSAMLCORE
#  define SB_USE_UNIT_XMLSAMLMETADATA
#  define SB_USE_UNIT_XMLSAMLPROTOCOL
#  define SB_USE_UNIT_SAMLIDENTITYPROVIDER
#  define SB_USE_UNIT_SAMLSERVICEPROVIDER
#endif /* SB_USE_PACKAGE_SAML */

#ifdef SB_USE_PACKAGE_DCPKI
#  define SB_USE_UNIT_DCCMS
#endif /* SB_USE_PACKAGE_DCPKI */

#ifdef SB_USE_UNIT_SYSTEM
#  define SB_USE_CLASS_TOBJECT
#  define SB_USE_CLASS_TBITS
#  define SB_USE_CLASS_TPERSISTENT
#  define SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASS_THANDLESTREAM
#  define SB_USE_CLASS_TFILESTREAM
#  define SB_USE_CLASS_TINTERFACEDOBJECT
#  define SB_USE_CLASS_TINTERFACEDPERSISTENT
#  define SB_USE_CLASS_TLIST
#  define SB_USE_CLASS_TCUSTOMMEMORYSTREAM
#  define SB_USE_CLASS_TCOMPONENT
#  define SB_USE_CLASS_TMEMORYSTREAM
#  define SB_USE_CLASS_TSTRINGS
#  define SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASS_TTHREAD
#endif /* SB_USE_UNIT_SYSTEM */

#ifdef SB_USE_UNIT_AES
#  define SB_USE_GLOBAL_PROCS_AES
#endif /* SB_USE_UNIT_AES */

#ifdef SB_USE_UNIT_ALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELRSAALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELRSAPSSALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELRSAOAEPALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELDSAALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELDHALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELECALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELECDSAALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELGOST3411ALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELGOST3410ALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELGOST3411WITHGOST3410ALGORITHMIDENTIFIER
#endif /* SB_USE_UNIT_ALGORITHMIDENTIFIER */

#ifdef MACOS
#ifdef SB_USE_UNIT_APPLECERTSTORAGE
#  define SB_USE_GLOBAL_PROCS_APPLECERTSTORAGE
#  define SB_USE_CLASS_TELAPPLECERTSTORAGE
#endif /* SB_USE_UNIT_APPLECERTSTORAGE */

#ifdef SB_USE_UNIT_APPLECOMMON
#  define SB_USE_GLOBAL_PROCS_APPLECOMMON
#endif /* SB_USE_UNIT_APPLECOMMON */
#endif

#ifdef SB_USE_UNIT_BZIP2
#  define SB_USE_GLOBAL_PROCS_BZIP2
#endif /* SB_USE_UNIT_BZIP2 */

#ifdef SB_USE_UNIT_BZIP2COMMON
#  define SB_USE_GLOBAL_PROCS_BZIP2COMMON
#endif /* SB_USE_UNIT_BZIP2COMMON */

#ifdef SB_USE_UNIT_BZIP2TYPES
#  define SB_USE_CLASS_ESTATE
#  define SB_USE_CLASS_DSTATE
#  define SB_USE_CLASS_BZ_STREAM
#endif /* SB_USE_UNIT_BZIP2TYPES */

#ifdef SB_USE_UNIT_BZIP2UTILS
#  define SB_USE_GLOBAL_PROCS_BZIP2UTILS
#  define SB_USE_CLASS_TSBDATAARRAY
#  define SB_USE_CLASS_TSBBYTEDATAARRAY
#  define SB_USE_CLASS_TSBBYTEARRAY
#  define SB_USE_CLASS_TSBINT16ARRAY
#  define SB_USE_CLASS_TSBUINT16ARRAY
#  define SB_USE_CLASS_TSBINT32ARRAY
#  define SB_USE_CLASS_TSBUINT32ARRAY
#  define SB_USE_CLASS_TSBUINT16ONBYTEARRAY
#  define SB_USE_CLASS_TSBBYTEONUINT32ARRAY
#  define SB_USE_CLASS_TSBUINT16ONUINT32ARRAY
#  define SB_USE_CLASS_TSBARRAYPOINTER
#  define SB_USE_CLASS_TSBINT32ARRAYPOINTER
#  define SB_USE_CLASS_TSBUINT32ARRAYPOINTER
#  define SB_USE_CLASS_TSBBYTEARRAYPOINTER
#endif /* SB_USE_UNIT_BZIP2UTILS */

#ifdef SB_USE_UNIT_BZLIB
#  define SB_USE_GLOBAL_PROCS_BZLIB
#endif /* SB_USE_UNIT_BZLIB */

#ifdef SB_USE_UNIT_CHACHA20
#  define SB_USE_GLOBAL_PROCS_CHACHA20
#endif /* SB_USE_UNIT_CHACHA20 */

#ifdef SB_USE_UNIT_CONSTANTS
#  define SB_USE_GLOBAL_PROCS_CONSTANTS
#endif /* SB_USE_UNIT_CONSTANTS */

#ifdef SB_USE_UNIT_CUSTOMCRYPTO
#  define SB_USE_CLASS_TELKEYMATERIAL
#  define SB_USE_CLASS_TELCUSTOMCRYPTO
#  define SB_USE_CLASS_TELKEYMATERIALSTORAGE
#endif /* SB_USE_UNIT_CUSTOMCRYPTO */

#ifdef SB_USE_UNIT_DES
#  define SB_USE_GLOBAL_PROCS_DES
#endif /* SB_USE_UNIT_DES */

#ifdef SB_USE_UNIT_DSA
#  define SB_USE_GLOBAL_PROCS_DSA
#endif /* SB_USE_UNIT_DSA */

#ifdef SB_USE_UNIT_ASN1
#  define SB_USE_GLOBAL_PROCS_ASN1
#  define SB_USE_CLASS_TELASN1PARSER
#endif /* SB_USE_UNIT_ASN1 */

#ifdef SB_USE_UNIT_ASN1TREE
#  define SB_USE_GLOBAL_PROCS_ASN1TREE
#  define SB_USE_CLASS_TELASN1CUSTOMTAG
#  define SB_USE_CLASS_TELASN1DATASOURCE
#  define SB_USE_CLASS_TELASN1SIMPLETAG
#  define SB_USE_CLASS_TELASN1CONSTRAINEDTAG
#endif /* SB_USE_UNIT_ASN1TREE */

#ifdef SB_USE_UNIT_HASHFUNCTION
#  define SB_USE_CLASS_TELHMACKEYMATERIAL
#  define SB_USE_CLASS_TELHASHFUNCTION
#endif /* SB_USE_UNIT_HASHFUNCTION */

#ifdef SB_USE_UNIT_HMAC
#  define SB_USE_GLOBAL_PROCS_HMAC
#endif /* SB_USE_UNIT_HMAC */

#ifdef SB_USE_UNIT_MATH
#  define SB_USE_GLOBAL_PROCS_MATH
#endif /* SB_USE_UNIT_MATH */

#ifdef SB_USE_UNIT_MSKEYBLOB
#  define SB_USE_GLOBAL_PROCS_MSKEYBLOB
#endif /* SB_USE_UNIT_MSKEYBLOB */

#ifdef SB_USE_UNIT_MD
#  define SB_USE_GLOBAL_PROCS_MD
#endif /* SB_USE_UNIT_MD */

#ifdef SB_USE_UNIT_PEM
#  define SB_USE_GLOBAL_PROCS_PEM
#  define SB_USE_CLASS_TELPEMPROCESSOR
#endif /* SB_USE_UNIT_PEM */

#ifdef SB_USE_UNIT_POLY1305
#  define SB_USE_GLOBAL_PROCS_POLY1305
#endif /* SB_USE_UNIT_POLY1305 */

#ifdef SB_USE_UNIT_RANDOM
#  define SB_USE_GLOBAL_PROCS_RANDOM
#  define SB_USE_CLASS_TELRANDOM
#endif /* SB_USE_UNIT_RANDOM */

#ifdef SB_USE_UNIT_RC2
#  define SB_USE_GLOBAL_PROCS_RC2
#endif /* SB_USE_UNIT_RC2 */

#ifdef SB_USE_UNIT_RC4
#  define SB_USE_GLOBAL_PROCS_RC4
#endif /* SB_USE_UNIT_RC4 */

#ifdef SB_USE_UNIT_RIPEMD
#  define SB_USE_GLOBAL_PROCS_RIPEMD
#endif /* SB_USE_UNIT_RIPEMD */

#ifdef SB_USE_UNIT_RSA
#  define SB_USE_GLOBAL_PROCS_RSA
#  define SB_USE_CLASS_TELRSAANTITIMINGPARAMS
#endif /* SB_USE_UNIT_RSA */

#ifdef SB_USE_UNIT_SHA
#  define SB_USE_GLOBAL_PROCS_SHA
#endif /* SB_USE_UNIT_SHA */

#ifdef SB_USE_UNIT_SHA2
#  define SB_USE_GLOBAL_PROCS_SHA2
#endif /* SB_USE_UNIT_SHA2 */

#ifdef SB_USE_UNIT_TYPES
#  define SB_USE_CLASS_TELSTRINGHOLDER
#  define SB_USE_CLASS_TELBYTEARRAYHOLDER
#endif /* SB_USE_UNIT_TYPES */

#ifdef SB_USE_UNIT_UTILS
#  define SB_USE_GLOBAL_PROCS_UTILS
#ifndef SB_WINDOWS
#  define SB_USE_CLASS_TELSTRINGLIST
#endif
#  define SB_USE_CLASS_TELBYTEARRAYLIST
#  define SB_USE_CLASS_TSBOBJECTLIST
#  define SB_USE_CLASS_TELCUSTOMEXCEPTIONHANDLER
#  define SB_USE_CLASS_TELSTANDARDEXCEPTIONHANDLER
#  define SB_USE_CLASS_TELDEBUGEXCEPTIONHANDLER
#endif /* SB_USE_UNIT_UTILS */

#ifdef SB_USE_UNIT_STRUTILS
#  define SB_USE_GLOBAL_PROCS_STRUTILS
#  define SB_USE_CLASS_TELSTRINGCONVERTER
#ifdef SB_WINDOWS
#  define SB_USE_CLASS_TELPLATFORMSTRINGCONVERTER
#endif
#endif /* SB_USE_UNIT_STRUTILS */

#ifdef SB_USE_UNIT_STREAMS
#  define SB_USE_GLOBAL_PROCS_STREAMS
#  define SB_USE_CLASS_TELFILESTREAM
#  define SB_USE_CLASS_TELDATASTREAM
#  define SB_USE_CLASS_TELMULTISTREAM
#  define SB_USE_CLASS_TELREADCACHINGSTREAM
#  define SB_USE_CLASS_TELWRITECACHINGSTREAM
#endif /* SB_USE_UNIT_STREAMS */

#ifdef SB_USE_UNIT_ENCODING
#  define SB_USE_GLOBAL_PROCS_ENCODING
#endif /* SB_USE_UNIT_ENCODING */

#ifdef SB_USE_UNIT_BLOWFISH
#  define SB_USE_GLOBAL_PROCS_BLOWFISH
#endif /* SB_USE_UNIT_BLOWFISH */

#ifdef SB_USE_UNIT_ELGAMAL
#  define SB_USE_GLOBAL_PROCS_ELGAMAL
#endif /* SB_USE_UNIT_ELGAMAL */

#ifdef SB_USE_UNIT_CAMELLIA
#  define SB_USE_GLOBAL_PROCS_CAMELLIA
#endif /* SB_USE_UNIT_CAMELLIA */

#ifdef SB_USE_UNIT_CAST128
#  define SB_USE_GLOBAL_PROCS_CAST128
#endif /* SB_USE_UNIT_CAST128 */

#ifdef SB_USE_UNIT_CRC
#  define SB_USE_GLOBAL_PROCS_CRC
#endif /* SB_USE_UNIT_CRC */

#ifdef SB_USE_UNIT_LICENSEMANAGER
#  define SB_USE_GLOBAL_PROCS_LICENSEMANAGER
#  define SB_USE_CLASS_TELSBLICENSEMANAGER
#endif /* SB_USE_UNIT_LICENSEMANAGER */

#ifdef SB_USE_UNIT_SEED
#  define SB_USE_GLOBAL_PROCS_SEED
#endif /* SB_USE_UNIT_SEED */

#ifdef SB_USE_UNIT_RABBIT
#  define SB_USE_GLOBAL_PROCS_RABBIT
#endif /* SB_USE_UNIT_RABBIT */

#ifdef SB_USE_UNIT_SERPENT
#  define SB_USE_GLOBAL_PROCS_SERPENT
#endif /* SB_USE_UNIT_SERPENT */

#ifdef SB_USE_UNIT_SHAREDRESOURCE
#ifndef SB_WINDOWS
#  define SB_USE_CLASS_TELSEMAPHORE
#endif
#  define SB_USE_CLASS_TELSHAREDRESOURCE
#endif /* SB_USE_UNIT_SHAREDRESOURCE */

#ifdef SB_USE_UNIT_SOCKET
#  define SB_USE_GLOBAL_PROCS_SOCKET
#  define SB_USE_CLASS_TELSOCKET
#  define SB_USE_CLASS_TELCUSTOMSOCKETBINDING
#  define SB_USE_CLASS_TELCLIENTSOCKETBINDING
#ifndef SB_WINCE_OR_NOT_WINDOWS
#  define SB_USE_CLASS_TELDNSSETTINGS
#endif
#  define SB_USE_CLASS_TELSOCKETSETTINGS
#endif /* SB_USE_UNIT_SOCKET */

#ifdef SB_USE_UNIT_PORTKNOCK
#  define SB_USE_GLOBAL_PROCS_PORTKNOCK
#  define SB_USE_CLASS_TELPORTKNOCKENTRY
#  define SB_USE_CLASS_TELPORTKNOCK
#endif /* SB_USE_UNIT_PORTKNOCK */

#ifdef SB_USE_UNIT_STRINGLIST
#  define SB_USE_CLASS_TELSTRINGTOKENIZER
#endif /* SB_USE_UNIT_STRINGLIST */

#ifdef SB_USE_UNIT_TIMER
#  define SB_USE_CLASS_TTIMERTHREAD
#  define SB_USE_CLASS_TELTIMER
#endif /* SB_USE_UNIT_TIMER */

#ifdef SB_USE_UNIT_TWOFISH
#  define SB_USE_GLOBAL_PROCS_TWOFISH
#endif /* SB_USE_UNIT_TWOFISH */

#ifdef SB_USE_UNIT_ZUNCOMPRESSUNIT
#  define SB_USE_GLOBAL_PROCS_ZUNCOMPRESSUNIT
#endif /* SB_USE_UNIT_ZUNCOMPRESSUNIT */

#ifdef SB_USE_UNIT_ZLIB
#  define SB_USE_GLOBAL_PROCS_ZLIB
#endif /* SB_USE_UNIT_ZLIB */

#ifdef SB_USE_UNIT_ZCOMMONUNIT
#  define SB_USE_GLOBAL_PROCS_ZCOMMONUNIT
#endif /* SB_USE_UNIT_ZCOMMONUNIT */

#ifdef SB_USE_UNIT_ZCOMPRESSUNIT
#  define SB_USE_GLOBAL_PROCS_ZCOMPRESSUNIT
#endif /* SB_USE_UNIT_ZCOMPRESSUNIT */

#ifdef SB_USE_UNIT_CRYPTOPROV
#  define SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#  define SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER
#  define SB_USE_CLASS_TELCUSTOMCRYPTOKEYSTORAGE
#  define SB_USE_CLASS_TELCUSTOMCRYPTOKEY
#  define SB_USE_CLASS_TELCUSTOMCRYPTOCONTEXT
#  define SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDEROPTIONS
#  define SB_USE_CLASS_TELBLACKBOXCRYPTOPROVIDER
#  define SB_USE_CLASS_TELEXTERNALCRYPTOPROVIDER
#endif /* SB_USE_UNIT_CRYPTOPROV */

#ifdef SB_USE_UNIT_CRYPTOPROVUTILS
#  define SB_USE_GLOBAL_PROCS_CRYPTOPROVUTILS
#endif /* SB_USE_UNIT_CRYPTOPROVUTILS */

#ifdef SB_USE_UNIT_CRYPTOPROVDEFAULT
#  define SB_USE_GLOBAL_PROCS_CRYPTOPROVDEFAULT
#endif /* SB_USE_UNIT_CRYPTOPROVDEFAULT */

#ifdef SB_USE_UNIT_CRYPTOPROVBUILTIN
#  define SB_USE_GLOBAL_PROCS_CRYPTOPROVBUILTIN
#  define SB_USE_CLASS_TELBUILTINCRYPTOPROVIDEROPTIONS
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOPROVIDER
#endif /* SB_USE_UNIT_CRYPTOPROVBUILTIN */

#ifdef SB_USE_UNIT_CRYPTOPROVBUILTINHASH
#  define SB_USE_CLASS_TELBUILTINHASHFUNCTION
#  define SB_USE_CLASS_TELBUILTINMACKEY
#endif /* SB_USE_UNIT_CRYPTOPROVBUILTINHASH */

#ifdef SB_USE_UNIT_CRYPTOPROVBUILTINPKI
#  define SB_USE_CLASS_TELBUILTINRSACRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINDSACRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINELGAMALCRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINDHCRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINECCRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINGOST341094CRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINGOST34102001CRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINRSAPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINDSAPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINELGAMALPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINDHPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINECDSAPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINECDHPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINGOST94PUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINGOST2001PUBLICKEYCRYPTO
#endif /* SB_USE_UNIT_CRYPTOPROVBUILTINPKI */

#ifdef SB_USE_UNIT_CRYPTOPROVBUILTINSYM
#  define SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTOFACTORY
#  define SB_USE_CLASS_TELBUILTINIDENTITYSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBUILTINRC4SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBUILTINGOST28147SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBUILTINCHACHA20SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBUILTINAEADCHACHA20POLY1305SYMMETRICCRYPTO
#endif /* SB_USE_UNIT_CRYPTOPROVBUILTINSYM */

#ifdef SB_WINDOWS
#ifdef SB_USE_UNIT_CRYPTOPROVWIN32
#  define SB_USE_GLOBAL_PROCS_CRYPTOPROVWIN32
#  define SB_USE_CLASS_TELWIN32CRYPTOPROVIDEROPTIONS
#  define SB_USE_CLASS_TELWIN32CRYPTOPROVIDER
#  define SB_USE_CLASS_TELCNGCRYPTOPROVIDERHANDLEINFO
#  define SB_USE_CLASS_TELCNGCRYPTOPROVIDERHANDLEMANAGER
#endif /* SB_USE_UNIT_CRYPTOPROVWIN32 */
#endif

#ifdef SB_USE_UNIT_CRYPTOPROVMANAGER
#  define SB_USE_GLOBAL_PROCS_CRYPTOPROVMANAGER
#  define SB_USE_CLASS_TELBUILTINCRYPTOPROVIDERMANAGER
#  define SB_USE_CLASS_TELFIPSCOMPLIANTCRYPTOPROVIDERMANAGER
#endif /* SB_USE_UNIT_CRYPTOPROVMANAGER */

#ifdef SB_USE_UNIT_X509
#  define SB_USE_GLOBAL_PROCS_X509
#  define SB_USE_CLASS_TELSUBJECTPUBLICKEYINFO
#  define SB_USE_CLASS_TELTBSCERTIFICATE
#  define SB_USE_CLASS_TELX509CERTIFICATECHAIN
#  define SB_USE_CLASS_TELX509CERTIFICATE
#  define SB_USE_CLASS_TELBASECERTSTORAGE
#endif /* SB_USE_UNIT_X509 */

#ifdef SB_USE_UNIT_X509EXT
#  define SB_USE_GLOBAL_PROCS_X509EXT
#  define SB_USE_CLASS_TELEDIPARTYNAME
#  define SB_USE_CLASS_TELOTHERNAME
#  define SB_USE_CLASS_TELPERMANENTIDENTIFIER
#  define SB_USE_CLASS_TELGENERALNAME
#  define SB_USE_CLASS_TELGENERALNAMES
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#  define SB_USE_CLASS_TELAUTHORITYKEYIDENTIFIEREXTENSION
#  define SB_USE_CLASS_TELSUBJECTKEYIDENTIFIEREXTENSION
#  define SB_USE_CLASS_TELKEYUSAGEEXTENSION
#  define SB_USE_CLASS_TELPRIVATEKEYUSAGEPERIODEXTENSION
#  define SB_USE_CLASS_TELNETSCAPECERTTYPEEXTENSION
#  define SB_USE_CLASS_TELNETSCAPESTRING
#  define SB_USE_CLASS_TELNETSCAPEBASEURL
#  define SB_USE_CLASS_TELNETSCAPEREVOKEURL
#  define SB_USE_CLASS_TELNETSCAPECAREVOKEURL
#  define SB_USE_CLASS_TELNETSCAPERENEWALURL
#  define SB_USE_CLASS_TELNETSCAPECAPOLICY
#  define SB_USE_CLASS_TELNETSCAPESERVERNAME
#  define SB_USE_CLASS_TELNETSCAPECOMMENT
#  define SB_USE_CLASS_TELCOMMONNAME
#  define SB_USE_CLASS_TELUSERNOTICE
#  define SB_USE_CLASS_TELSINGLEPOLICYQUALIFIER
#  define SB_USE_CLASS_TELSINGLEPOLICYINFORMATION
#  define SB_USE_CLASS_TELCERTIFICATEPOLICIESEXTENSION
#  define SB_USE_CLASS_TELPOLICYMAPPING
#  define SB_USE_CLASS_TELPOLICYMAPPINGSEXTENSION
#  define SB_USE_CLASS_TELALTERNATIVENAMEEXTENSION
#  define SB_USE_CLASS_TELBASICCONSTRAINTSEXTENSION
#  define SB_USE_CLASS_TELNAMECONSTRAINT
#  define SB_USE_CLASS_TELNAMECONSTRAINTSEXTENSION
#  define SB_USE_CLASS_TELPOLICYCONSTRAINTSEXTENSION
#  define SB_USE_CLASS_TELEXTENDEDKEYUSAGEEXTENSION
#  define SB_USE_CLASS_TELDISTRIBUTIONPOINT
#  define SB_USE_CLASS_TELCRLDISTRIBUTIONPOINTSEXTENSION
#  define SB_USE_CLASS_TELACCESSDESCRIPTION
#  define SB_USE_CLASS_TELAUTHORITYINFORMATIONACCESSEXTENSION
#  define SB_USE_CLASS_TELSUBJECTDIRECTORYATTRIBUTESEXTENSION
#  define SB_USE_CLASS_TELCERTIFICATEEXTENSIONS
#  define SB_USE_CLASS_TELEXTENSIONWRITER
#  define SB_USE_CLASS_TELEXTENSIONREADER
#endif /* SB_USE_UNIT_X509EXT */

#ifdef SB_USE_UNIT_CRL
#  define SB_USE_GLOBAL_PROCS_CRL
#  define SB_USE_CLASS_TELAUTHORITYKEYIDENTIFIERCRLEXTENSION
#  define SB_USE_CLASS_TELCRLNUMBERCRLEXTENSION
#  define SB_USE_CLASS_TELDELTACRLINDICATORCRLEXTENSION
#  define SB_USE_CLASS_TELREASONCODECRLEXTENSION
#  define SB_USE_CLASS_TELHOLDINSTRUCTIONCODECRLEXTENSION
#  define SB_USE_CLASS_TELINVALIDITYDATECRLEXTENSION
#  define SB_USE_CLASS_TELCERTIFICATEISSUERCRLEXTENSION
#  define SB_USE_CLASS_TELISSUINGDISTRIBUTIONPOINTCRLEXTENSION
#  define SB_USE_CLASS_TELCRLEXTENSIONS
#  define SB_USE_CLASS_TELCRLENTRYEXTENSIONS
#  define SB_USE_CLASS_TELREVOCATIONITEM
#  define SB_USE_CLASS_TELCERTIFICATEREVOCATIONLIST
#endif /* SB_USE_UNIT_CRL */

#ifdef SB_USE_UNIT_CRLSTORAGE
#  define SB_USE_GLOBAL_PROCS_CRLSTORAGE
#  define SB_USE_CLASS_TELCUSTOMCRLSTORAGE
#  define SB_USE_CLASS_TELCRLLOOKUP
#  define SB_USE_CLASS_TELMEMORYCRLSTORAGE
#  define SB_USE_CLASS_TELCRLCACHESTORAGE
#  define SB_USE_CLASS_TELCUSTOMCRLRETRIEVER
#  define SB_USE_CLASS_TELCUSTOMCRLRETRIEVERFACTORY
#  define SB_USE_CLASS_TELCRLMANAGER
#endif /* SB_USE_UNIT_CRLSTORAGE */

#ifdef SB_USE_UNIT_CERTRETRIEVER
#  define SB_USE_GLOBAL_PROCS_CERTRETRIEVER
#  define SB_USE_CLASS_TELCUSTOMCERTIFICATERETRIEVER
#  define SB_USE_CLASS_TELFILECERTIFICATERETRIEVER
#  define SB_USE_CLASS_TELCUSTOMCERTIFICATERETRIEVERFACTORY
#  define SB_USE_CLASS_TELCERTIFICATERETRIEVERMANAGER
#endif /* SB_USE_UNIT_CERTRETRIEVER */

#ifdef SB_USE_UNIT_CERTVALIDATOR
#  define SB_USE_GLOBAL_PROCS_CERTVALIDATOR
#  define SB_USE_CLASS_TELX509CERTIFICATEVALIDATOR
#  define SB_USE_CLASS_TELX509CERTIFICATEVALIDATORLOGGER
#  define SB_USE_CLASS_TELX509CERTIFICATEVALIDATIONRESULT
#  define SB_USE_CLASS_TELX509CACHEDCERTIFICATE
#  define SB_USE_CLASS_TELCACHECERTSTORAGE
#endif /* SB_USE_UNIT_CERTVALIDATOR */

#ifdef SB_USE_UNIT_RDN
#  define SB_USE_GLOBAL_PROCS_RDN
#  define SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME
#  define SB_USE_CLASS_TELRDNCONVERTER
#endif /* SB_USE_UNIT_RDN */

#ifdef SB_USE_UNIT_CUSTOMCERTSTORAGE
#  define SB_USE_GLOBAL_PROCS_CUSTOMCERTSTORAGE
#  define SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#  define SB_USE_CLASS_TELCERTIFICATELOOKUP
#  define SB_USE_CLASS_TELMEMORYCERTSTORAGE
#  define SB_USE_CLASS_TELFILECERTSTORAGE
#endif /* SB_USE_UNIT_CUSTOMCERTSTORAGE */

#ifdef SB_USE_UNIT_MESSAGES
#  define SB_USE_GLOBAL_PROCS_MESSAGES
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#  define SB_USE_CLASS_TELMESSAGEENCRYPTOR
#  define SB_USE_CLASS_TELMESSAGEDECRYPTOR
#  define SB_USE_CLASS_TELMESSAGEVERIFIER
#  define SB_USE_CLASS_TELMESSAGESIGNER
#  define SB_USE_CLASS_TELMESSAGEDECOMPRESSOR
#  define SB_USE_CLASS_TELMESSAGECOMPRESSOR
#  define SB_USE_CLASS_TELMESSAGETIMESTAMPER
#  define SB_USE_CLASS_TELMESSAGETIMESTAMPVERIFIER
#endif /* SB_USE_UNIT_MESSAGES */

#ifdef SB_USE_UNIT_PKCS5
#  define SB_USE_GLOBAL_PROCS_PKCS5
#  define SB_USE_CLASS_TELPKCS5PBE
#endif /* SB_USE_UNIT_PKCS5 */

#ifdef SB_USE_UNIT_PKCS7
#  define SB_USE_GLOBAL_PROCS_PKCS7
#  define SB_USE_CLASS_TELPKCS7RECIPIENT
#  define SB_USE_CLASS_TELPKCS7CONTENTPART
#  define SB_USE_CLASS_TELPKCS7ENCRYPTEDCONTENT
#  define SB_USE_CLASS_TELPKCS7MESSAGE
#  define SB_USE_CLASS_TELPKCS7ENVELOPEDDATA
#  define SB_USE_CLASS_TELPKCS7COMPRESSEDDATA
#  define SB_USE_CLASS_TELPKCS7SIGNER
#  define SB_USE_CLASS_TELPKCS7SIGNEDDATA
#  define SB_USE_CLASS_TELPKCS7DIGESTEDDATA
#  define SB_USE_CLASS_TELPKCS7ENCRYPTEDDATA
#  define SB_USE_CLASS_TELPKCS7SIGNEDANDENVELOPEDDATA
#  define SB_USE_CLASS_TELPKCS7AUTHENTICATEDDATA
#  define SB_USE_CLASS_TELPKCS7TIMESTAMPANDCRL
#  define SB_USE_CLASS_TELPKCS7TIMESTAMPEDDATA
#endif /* SB_USE_UNIT_PKCS7 */

#ifdef SB_USE_UNIT_PKCS7UTILS
#  define SB_USE_GLOBAL_PROCS_PKCS7UTILS
#  define SB_USE_CLASS_TELPKCS7ATTRIBUTES
#  define SB_USE_CLASS_TELPKCS7ISSUER
#endif /* SB_USE_UNIT_PKCS7UTILS */

#ifdef SB_USE_UNIT_PKCS8
#  define SB_USE_GLOBAL_PROCS_PKCS8
#  define SB_USE_CLASS_TELPKCS8ENCRYPTEDPRIVATEKEYINFO
#  define SB_USE_CLASS_TELPKCS8PRIVATEKEYINFO
#  define SB_USE_CLASS_TELPKCS8PRIVATEKEY
#endif /* SB_USE_UNIT_PKCS8 */

#ifdef SB_USE_UNIT_PKCS12
#  define SB_USE_GLOBAL_PROCS_PKCS12
#  define SB_USE_CLASS_TELPKCS12MESSAGE
#endif /* SB_USE_UNIT_PKCS12 */

#ifdef SB_USE_UNIT_JKS
#  define SB_USE_CLASS_TELJKS
#endif /* SB_USE_UNIT_JKS */

#ifdef SB_WINDOWS
#ifdef SB_USE_UNIT_WINCERTSTORAGE
#  define SB_USE_GLOBAL_PROCS_WINCERTSTORAGE
#  define SB_USE_CLASS_TELWINCERTSTORAGE
#endif /* SB_USE_UNIT_WINCERTSTORAGE */

#ifdef SB_USE_UNIT_WINCRYPT
#  define SB_USE_GLOBAL_PROCS_WINCRYPT
#endif /* SB_USE_UNIT_WINCRYPT */
#endif

#ifdef SB_USE_UNIT_SMIMESIGNATURES
#  define SB_USE_CLASS_TELSMIMEMESSAGESIGNER
#  define SB_USE_CLASS_TELSMIMEMESSAGEVERIFIER
#endif /* SB_USE_UNIT_SMIMESIGNATURES */

#ifdef SB_USE_UNIT_OCSPCOMMON
#  define SB_USE_GLOBAL_PROCS_OCSPCOMMON
#  define SB_USE_CLASS_TELOCSPCLASS
#endif /* SB_USE_UNIT_OCSPCOMMON */

#ifdef SB_USE_UNIT_OCSPCLIENT
#  define SB_USE_GLOBAL_PROCS_OCSPCLIENT
#  define SB_USE_CLASS_TELOCSPCLIENT
#  define SB_USE_CLASS_TELOCSPRESPONDERID
#  define SB_USE_CLASS_TELOCSPSINGLERESPONSE
#  define SB_USE_CLASS_TELOCSPRESPONSE
#  define SB_USE_CLASS_TELFILEOCSPCLIENT
#  define SB_USE_CLASS_TELCUSTOMOCSPCLIENTFACTORY
#  define SB_USE_CLASS_TELOCSPCLIENTMANAGER
#endif /* SB_USE_UNIT_OCSPCLIENT */

#ifdef SB_USE_UNIT_OCSPSTORAGE
#  define SB_USE_CLASS_TELOCSPRESPONSESTORAGE
#endif /* SB_USE_UNIT_OCSPSTORAGE */

#ifdef SB_USE_UNIT_PUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELPUBLICKEYMATERIAL
#  define SB_USE_CLASS_TELPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELRSAKEYMATERIAL
#  define SB_USE_CLASS_TELRSAPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELDSAKEYMATERIAL
#  define SB_USE_CLASS_TELDSAPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELECKEYMATERIAL
#  define SB_USE_CLASS_TELECDSAPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELECDHPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELDHKEYMATERIAL
#  define SB_USE_CLASS_TELDHPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELELGAMALKEYMATERIAL
#  define SB_USE_CLASS_TELELGAMALPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELSRPKEYMATERIAL
#  define SB_USE_CLASS_TELSRPPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELGOST94KEYMATERIAL
#  define SB_USE_CLASS_TELGOST94PUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELGOST2001KEYMATERIAL
#  define SB_USE_CLASS_TELGOST2001PUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELPUBLICKEYCRYPTOFACTORY
#  define SB_USE_CLASS_TELREMOTESIGNINGPARAMS
#endif /* SB_USE_UNIT_PUBLICKEYCRYPTO */

#ifdef SB_USE_UNIT_SRP
#  define SB_USE_GLOBAL_PROCS_SRP
#  define SB_USE_CLASS_TELSRPCREDENTIAL
#  define SB_USE_CLASS_TELSRPCREDENTIALSTORE
#endif /* SB_USE_UNIT_SRP */

#ifdef SB_USE_UNIT_SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICKEYMATERIAL
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTOFACTORY
#  define SB_USE_CLASS_TELAESSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBLOWFISHSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELTWOFISHSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELIDEASYMMETRICCRYPTO
#  define SB_USE_CLASS_TELCAST128SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELRC2SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELRC4SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELDESSYMMETRICCRYPTO
#  define SB_USE_CLASS_TEL3DESSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELCAMELLIASYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSERPENTSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSEEDSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELRABBITSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELGOST28147SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELIDENTITYSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELCHACHA20SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELAEADCHACHA20POLY1305SYMMETRICCRYPTO
#endif /* SB_USE_UNIT_SYMMETRICCRYPTO */

#ifdef SB_USE_UNIT_PKIASYNC
#  define SB_USE_GLOBAL_PROCS_PKIASYNC
#  define SB_USE_CLASS_TELPUBLICKEYASYNCCALCULATOR
#  define SB_USE_CLASS_TELPUBLICKEYCOMPUTATIONTOKEN
#endif /* SB_USE_UNIT_PKIASYNC */

#ifdef SB_USE_UNIT_TSPCOMMON
#  define SB_USE_CLASS_TELTSPINFO
#  define SB_USE_CLASS_TELTSPCLASS
#endif /* SB_USE_UNIT_TSPCOMMON */

#ifdef SB_USE_UNIT_TSPCLIENT
#  define SB_USE_GLOBAL_PROCS_TSPCLIENT
#  define SB_USE_CLASS_TELCLIENTTSPINFO
#  define SB_USE_CLASS_TELCUSTOMTSPCLIENT
#  define SB_USE_CLASS_TELFILETSPCLIENT
#endif /* SB_USE_UNIT_TSPCLIENT */

#ifdef SB_USE_UNIT_SOCKETTSPCLIENT
#  define SB_USE_GLOBAL_PROCS_SOCKETTSPCLIENT
#  define SB_USE_CLASS_TELSOCKETTSPCLIENT
#endif /* SB_USE_UNIT_SOCKETTSPCLIENT */

#ifdef SB_USE_UNIT_TAR
#  define SB_USE_CLASS_TELTARREADERLOW
#  define SB_USE_CLASS_TELTARWRITERLOW
#endif /* SB_USE_UNIT_TAR */

#ifdef SB_USE_UNIT_UMAC
#  define SB_USE_CLASS_TELUMAC
#endif /* SB_USE_UNIT_UMAC */

#ifdef SB_USE_UNIT_ECCOMMON
#  define SB_USE_GLOBAL_PROCS_ECCOMMON
#  define SB_USE_CLASS_TELECDOMAINPARAMETERS
#endif /* SB_USE_UNIT_ECCOMMON */

#ifdef SB_USE_UNIT_ECMATH
#  define SB_USE_GLOBAL_PROCS_ECMATH
#endif /* SB_USE_UNIT_ECMATH */

#ifdef SB_USE_UNIT_ECDSA
#  define SB_USE_GLOBAL_PROCS_ECDSA
#endif /* SB_USE_UNIT_ECDSA */

#ifdef SB_USE_UNIT_GOSTCOMMON
#  define SB_USE_CLASS_TELGOSTBASE
#endif /* SB_USE_UNIT_GOSTCOMMON */

#ifdef SB_USE_UNIT_GOST341194
#  define SB_USE_CLASS_TELGOSTMD
#endif /* SB_USE_UNIT_GOST341194 */

#ifdef SB_USE_UNIT_GOST341094
#  define SB_USE_CLASS_TELGOSTSIGNERBASE
#  define SB_USE_CLASS_TELGOSTSIGNER
#endif /* SB_USE_UNIT_GOST341094 */

#ifdef SB_USE_UNIT_GOST341001
#  define SB_USE_GLOBAL_PROCS_GOST341001
#endif /* SB_USE_UNIT_GOST341001 */

#ifdef SB_USE_UNIT_GOST2814789
#  define SB_USE_GLOBAL_PROCS_GOST2814789
#  define SB_USE_CLASS_TELGOST
#endif /* SB_USE_UNIT_GOST2814789 */

#ifdef SB_USE_UNIT_GSSAPI
#  define SB_USE_CLASS_TELGSSCUSTOMCONTEXT
#  define SB_USE_CLASS_TELGSSCUSTOMNAME
#  define SB_USE_CLASS_TELGSSBASEMECHANISM
#  define SB_USE_CLASS_TELGSSAPICONTEXT
#  define SB_USE_CLASS_TELGSSAPINAME
#  define SB_USE_CLASS_TELGSSAPIMECHANISM
#  define SB_USE_CLASS_TELGSSMECHANISMCOLLECTION
#endif /* SB_USE_UNIT_GSSAPI */

#ifdef SB_USE_UNIT_GSSAPIBASE
#  define SB_USE_GLOBAL_PROCS_GSSAPIBASE
#endif /* SB_USE_UNIT_GSSAPIBASE */

#ifdef SB_WINDOWS
#ifdef SB_USE_UNIT_GSSWINAUTH
#  define SB_USE_CLASS_TELGSSWINCONTEXT
#  define SB_USE_CLASS_TELGSSWINNAME
#  define SB_USE_CLASS_TELGSSWINAUTHMECHANISM
#endif /* SB_USE_UNIT_GSSWINAUTH */

#ifdef SB_USE_UNIT_SSPI
#  define SB_USE_GLOBAL_PROCS_SSPI
#endif /* SB_USE_UNIT_SSPI */
#endif

#ifdef SB_USE_UNIT_DNSSEC
#  define SB_USE_GLOBAL_PROCS_DNSSEC
#  define SB_USE_CLASS_TELDNSQUESTION
#  define SB_USE_CLASS_TELDNSQUESTIONLIST
#  define SB_USE_CLASS_TELDNSCACHE
#  define SB_USE_CLASS_TELDNSMESSAGEEXTENSIONS
#  define SB_USE_CLASS_TELDNSMESSAGE
#  define SB_USE_CLASS_TELDNSCLIENT
#  define SB_USE_CLASS_TELDNSRESOLVER
#endif /* SB_USE_UNIT_DNSSEC */

#ifdef SB_USE_UNIT_DNSSECTYPES
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#  define SB_USE_CLASS_TELDNSIPV4ADDRESSRECORD
#  define SB_USE_CLASS_TELDNSNAMESERVERRECORD
#  define SB_USE_CLASS_TELDNSCANONICALNAMERECORD
#  define SB_USE_CLASS_TELDNSSTARTOFAUTHORITYRECORD
#  define SB_USE_CLASS_TELDNSWELLKNOWNSERVICERECORD
#  define SB_USE_CLASS_TELDNSDOMAINNAMEPOINTERRECORD
#  define SB_USE_CLASS_TELDNSHOSTINFORECORD
#  define SB_USE_CLASS_TELDNSMAILINFORECORD
#  define SB_USE_CLASS_TELDNSMAILEXCHANGERECORD
#  define SB_USE_CLASS_TELDNSTEXTSTRINGSRECORD
#  define SB_USE_CLASS_TELDNSIPV6ADDRESSRECORD
#  define SB_USE_CLASS_TELDNSSERVICELOCATIONRECORD
#  define SB_USE_CLASS_TELDNSEXTENSIONSRECORD
#  define SB_USE_CLASS_TELDNSPUBLICKEYRECORD
#  define SB_USE_CLASS_TELDNSDELEGATIONSIGNERRECORD
#  define SB_USE_CLASS_TELDNSSIGNATURERECORD
#  define SB_USE_CLASS_TELDNSNEXTSECURERECORD
#  define SB_USE_CLASS_TELDNSNEXTSECURE3RECORD
#  define SB_USE_CLASS_TELDNSNEXTSECURE3PARAMRECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORDSET
#endif /* SB_USE_UNIT_DNSSECTYPES */

#ifdef SB_USE_UNIT_DNSSECUTILS
#  define SB_USE_GLOBAL_PROCS_DNSSECUTILS
#endif /* SB_USE_UNIT_DNSSECUTILS */

#ifdef SB_USE_UNIT_CUSTOMFSADAPTER
#  define SB_USE_GLOBAL_PROCS_CUSTOMFSADAPTER
#  define SB_USE_CLASS_TELVFSENTRYINFORMATION
#  define SB_USE_CLASS_TELVFSENTRYINFORMATIONLIST
#  define SB_USE_CLASS_TELCUSTOMFILESYSTEMADAPTER
#endif /* SB_USE_UNIT_CUSTOMFSADAPTER */

#ifdef SB_USE_UNIT_DISKFSADAPTER
#  define SB_USE_CLASS_TELDISKFILESYSTEMADAPTER
#endif /* SB_USE_UNIT_DISKFSADAPTER */

#ifdef SB_USE_UNIT_PUNYCODE
#  define SB_USE_GLOBAL_PROCS_PUNYCODE
#endif /* SB_USE_UNIT_PUNYCODE */

#ifdef SB_USE_UNIT_HTTPAUTH
#  define SB_USE_GLOBAL_PROCS_HTTPAUTH
#endif /* SB_USE_UNIT_HTTPAUTH */

#ifdef SB_USE_UNIT_SASL
#  define SB_USE_GLOBAL_PROCS_SASL
#  define SB_USE_CLASS_TELSASLCLIENT
#  define SB_USE_CLASS_TELSASLPLAINCLIENT
#  define SB_USE_CLASS_TELSASLLOGINCLIENT
#  define SB_USE_CLASS_TELSASLCRAMMD5CLIENT
#  define SB_USE_CLASS_TELSASLANONYMOUSCLIENT
#  define SB_USE_CLASS_TELSASLEXTERNALCLIENT
#  define SB_USE_CLASS_TELSASLDIGESTMD5CLIENT
#ifndef SB_WINCE_OR_NOT_WINDOWS
#  define SB_USE_CLASS_TELSASLNTLMCLIENT
#endif
#  define SB_USE_CLASS_TELSASLXOAUTH2CLIENT
#endif /* SB_USE_UNIT_SASL */

#ifdef SB_USE_UNIT_COMPRSTREAM
#  define SB_USE_CLASS_TELCUSTOMCOMPRESSINGSTREAM
#  define SB_USE_CLASS_TELCUSTOMDECOMPRESSINGSTREAM
#  define SB_USE_CLASS_TELZLIBCOMPRESSINGSTREAM
#  define SB_USE_CLASS_TELZLIBDECOMPRESSINGSTREAM
#endif /* SB_USE_UNIT_COMPRSTREAM */

#ifdef SB_USE_UNIT_DC
#  define SB_USE_GLOBAL_PROCS_DC
#  define SB_USE_CLASS_TELDCBASEMESSAGE
#  define SB_USE_CLASS_TELDCUNSUPPORTEDMESSAGE
#  define SB_USE_CLASS_TELDCERRORMESSAGE
#  define SB_USE_CLASS_TELDCOPERATIONREQUESTMESSAGE
#  define SB_USE_CLASS_TELDCOPERATIONRESPONSEMESSAGE
#  define SB_USE_CLASS_TELDCBATCHMESSAGE
#  define SB_USE_CLASS_TELDCMESSAGEFACTORY
#  define SB_USE_CLASS_TELDCASYNCSTATE
#  define SB_USE_CLASS_TELDCASYNCSTATECOLLECTION
#endif /* SB_USE_UNIT_DC */

#ifdef SB_USE_UNIT_DCDEF
#  define SB_USE_GLOBAL_PROCS_DCDEF
#  define SB_USE_CLASS_TELDCPKCS7SIGNPARAMETERS
#  define SB_USE_CLASS_TELDCDEFAULTREQUESTFACTORY
#endif /* SB_USE_UNIT_DCDEF */

#ifdef SB_USE_UNIT_DCENC
#  define SB_USE_GLOBAL_PROCS_DCENC
#  define SB_USE_CLASS_TELDCENCODING
#  define SB_USE_CLASS_TELDCNODE
#endif /* SB_USE_UNIT_DCENC */

#ifdef SB_USE_UNIT_CSARMSCII_8
#  define SB_USE_CLASS_TPLARMSCII_8
#endif /* SB_USE_UNIT_CSARMSCII_8 */

#ifdef SB_USE_UNIT_CSATARIST
#  define SB_USE_CLASS_TPLATARIST
#endif /* SB_USE_UNIT_CSATARIST */

#ifdef SB_USE_UNIT_CSBIGFIVE
#  define SB_USE_CLASS_TPLBIGFIVE
#endif /* SB_USE_UNIT_CSBIGFIVE */

#ifdef SB_USE_UNIT_CSCNS_11643_1
#  define SB_USE_CLASS_TPLCNS_11643_1
#endif /* SB_USE_UNIT_CSCNS_11643_1 */

#ifdef SB_USE_UNIT_CSCNS_11643_2
#  define SB_USE_CLASS_TPLCNS_11643_2
#endif /* SB_USE_UNIT_CSCNS_11643_2 */

#ifdef SB_USE_UNIT_CSCNS_11643_3
#  define SB_USE_CLASS_TPLCNS_11643_3
#endif /* SB_USE_UNIT_CSCNS_11643_3 */

#ifdef SB_USE_UNIT_CSCNS_11643_4
#  define SB_USE_CLASS_TPLCNS_11643_4
#endif /* SB_USE_UNIT_CSCNS_11643_4 */

#ifdef SB_USE_UNIT_CSCNS_11643_5
#  define SB_USE_CLASS_TPLCNS_11643_5
#endif /* SB_USE_UNIT_CSCNS_11643_5 */

#ifdef SB_USE_UNIT_CSCNS_11643_6
#  define SB_USE_CLASS_TPLCNS_11643_6
#endif /* SB_USE_UNIT_CSCNS_11643_6 */

#ifdef SB_USE_UNIT_CSCNS_11643_7
#  define SB_USE_CLASS_TPLCNS_11643_7
#endif /* SB_USE_UNIT_CSCNS_11643_7 */

#ifdef SB_USE_UNIT_CSCNS_11643_F
#  define SB_USE_CLASS_TPLCNS_11643_F
#endif /* SB_USE_UNIT_CSCNS_11643_F */

#ifdef SB_USE_UNIT_CSCP1006
#  define SB_USE_CLASS_TPLCP1006
#endif /* SB_USE_UNIT_CSCP1006 */

#ifdef SB_USE_UNIT_CSCP1131
#  define SB_USE_CLASS_TPLCP1131
#endif /* SB_USE_UNIT_CSCP1131 */

#ifdef SB_USE_UNIT_CSCP1133
#  define SB_USE_CLASS_TPLCP1133
#endif /* SB_USE_UNIT_CSCP1133 */

#ifdef SB_USE_UNIT_CSCP1250
#  define SB_USE_CLASS_TPLCP1250
#endif /* SB_USE_UNIT_CSCP1250 */

#ifdef SB_USE_UNIT_CSCP1251
#  define SB_USE_CLASS_TPLCP1251
#endif /* SB_USE_UNIT_CSCP1251 */

#ifdef SB_USE_UNIT_CSCP1252
#  define SB_USE_CLASS_TPLCP1252
#endif /* SB_USE_UNIT_CSCP1252 */

#ifdef SB_USE_UNIT_CSCP1253
#  define SB_USE_CLASS_TPLCP1253
#endif /* SB_USE_UNIT_CSCP1253 */

#ifdef SB_USE_UNIT_CSCP1254
#  define SB_USE_CLASS_TPLCP1254
#endif /* SB_USE_UNIT_CSCP1254 */

#ifdef SB_USE_UNIT_CSCP1255
#  define SB_USE_CLASS_TPLCP1255
#endif /* SB_USE_UNIT_CSCP1255 */

#ifdef SB_USE_UNIT_CSCP1256
#  define SB_USE_CLASS_TPLCP1256
#endif /* SB_USE_UNIT_CSCP1256 */

#ifdef SB_USE_UNIT_CSCP1257
#  define SB_USE_CLASS_TPLCP1257
#endif /* SB_USE_UNIT_CSCP1257 */

#ifdef SB_USE_UNIT_CSCP1258
#  define SB_USE_CLASS_TPLCP1258
#endif /* SB_USE_UNIT_CSCP1258 */

#ifdef SB_USE_UNIT_CSCP037
#  define SB_USE_CLASS_TPLCP037
#endif /* SB_USE_UNIT_CSCP037 */

#ifdef SB_USE_UNIT_CSCP424
#  define SB_USE_CLASS_TPLCP424
#endif /* SB_USE_UNIT_CSCP424 */

#ifdef SB_USE_UNIT_CSCP437
#  define SB_USE_CLASS_TPLCP437
#endif /* SB_USE_UNIT_CSCP437 */

#ifdef SB_USE_UNIT_CSCP500
#  define SB_USE_CLASS_TPLCP500
#endif /* SB_USE_UNIT_CSCP500 */

#ifdef SB_USE_UNIT_CSCP737
#  define SB_USE_CLASS_TPLCP737
#endif /* SB_USE_UNIT_CSCP737 */

#ifdef SB_USE_UNIT_CSCP775
#  define SB_USE_CLASS_TPLCP775
#endif /* SB_USE_UNIT_CSCP775 */

#ifdef SB_USE_UNIT_CSCP850
#  define SB_USE_CLASS_TPLCP850
#endif /* SB_USE_UNIT_CSCP850 */

#ifdef SB_USE_UNIT_CSCP852
#  define SB_USE_CLASS_TPLCP852
#endif /* SB_USE_UNIT_CSCP852 */

#ifdef SB_USE_UNIT_CSCP853
#  define SB_USE_CLASS_TPLCP853
#endif /* SB_USE_UNIT_CSCP853 */

#ifdef SB_USE_UNIT_CSCP855
#  define SB_USE_CLASS_TPLCP855
#endif /* SB_USE_UNIT_CSCP855 */

#ifdef SB_USE_UNIT_CSCP856
#  define SB_USE_CLASS_TPLCP856
#endif /* SB_USE_UNIT_CSCP856 */

#ifdef SB_USE_UNIT_CSCP857
#  define SB_USE_CLASS_TPLCP857
#endif /* SB_USE_UNIT_CSCP857 */

#ifdef SB_USE_UNIT_CSCP860
#  define SB_USE_CLASS_TPLCP860
#endif /* SB_USE_UNIT_CSCP860 */

#ifdef SB_USE_UNIT_CSCP861
#  define SB_USE_CLASS_TPLCP861
#endif /* SB_USE_UNIT_CSCP861 */

#ifdef SB_USE_UNIT_CSCP862
#  define SB_USE_CLASS_TPLCP862
#endif /* SB_USE_UNIT_CSCP862 */

#ifdef SB_USE_UNIT_CSCP863
#  define SB_USE_CLASS_TPLCP863
#endif /* SB_USE_UNIT_CSCP863 */

#ifdef SB_USE_UNIT_CSCP864
#  define SB_USE_CLASS_TPLCP864
#endif /* SB_USE_UNIT_CSCP864 */

#ifdef SB_USE_UNIT_CSCP865
#  define SB_USE_CLASS_TPLCP865
#endif /* SB_USE_UNIT_CSCP865 */

#ifdef SB_USE_UNIT_CSCP866
#  define SB_USE_CLASS_TPLCP866
#endif /* SB_USE_UNIT_CSCP866 */

#ifdef SB_USE_UNIT_CSCP869
#  define SB_USE_CLASS_TPLCP869
#endif /* SB_USE_UNIT_CSCP869 */

#ifdef SB_USE_UNIT_CSCP874
#  define SB_USE_CLASS_TPLCP874
#endif /* SB_USE_UNIT_CSCP874 */

#ifdef SB_USE_UNIT_CSCP875
#  define SB_USE_CLASS_TPLCP875
#endif /* SB_USE_UNIT_CSCP875 */

#ifdef SB_USE_UNIT_CSCP950DATA
#  define SB_USE_CLASS_TPLCP950DATA
#endif /* SB_USE_UNIT_CSCP950DATA */

#ifdef SB_USE_UNIT_CSGB_18030
#  define SB_USE_CLASS_TPLGB_18030DATA
#endif /* SB_USE_UNIT_CSGB_18030 */

#ifdef SB_USE_UNIT_CSGB_2312
#  define SB_USE_CLASS_TPLGB_2312
#endif /* SB_USE_UNIT_CSGB_2312 */

#ifdef SB_USE_UNIT_CSGBK
#  define SB_USE_CLASS_TPLGBKDATA
#endif /* SB_USE_UNIT_CSGBK */

#ifdef SB_USE_UNIT_CSGEORGIANACADEMY
#  define SB_USE_CLASS_TPLGEORGIANACADEMY
#endif /* SB_USE_UNIT_CSGEORGIANACADEMY */

#ifdef SB_USE_UNIT_CSGEORGIANPS
#  define SB_USE_CLASS_TPLGEORGIANPS
#endif /* SB_USE_UNIT_CSGEORGIANPS */

#ifdef SB_USE_UNIT_CSGEOSTD8
#  define SB_USE_CLASS_TPLGEOSTD8
#endif /* SB_USE_UNIT_CSGEOSTD8 */

#ifdef SB_USE_UNIT_CSHKSCS
#  define SB_USE_CLASS_TPLHKSCSDATA
#endif /* SB_USE_UNIT_CSHKSCS */

#ifdef SB_USE_UNIT_CSHPROMAN8
#  define SB_USE_CLASS_TPLHPROMAN8
#endif /* SB_USE_UNIT_CSHPROMAN8 */

#ifdef SB_USE_UNIT_CSISO_8859_10
#  define SB_USE_CLASS_TPLISO_8859_10
#endif /* SB_USE_UNIT_CSISO_8859_10 */

#ifdef SB_USE_UNIT_CSISO_8859_11
#  define SB_USE_CLASS_TPLISO_8859_11
#endif /* SB_USE_UNIT_CSISO_8859_11 */

#ifdef SB_USE_UNIT_CSISO_8859_13
#  define SB_USE_CLASS_TPLISO_8859_13
#endif /* SB_USE_UNIT_CSISO_8859_13 */

#ifdef SB_USE_UNIT_CSISO_8859_14
#  define SB_USE_CLASS_TPLISO_8859_14
#endif /* SB_USE_UNIT_CSISO_8859_14 */

#ifdef SB_USE_UNIT_CSISO_8859_15
#  define SB_USE_CLASS_TPLISO_8859_15
#endif /* SB_USE_UNIT_CSISO_8859_15 */

#ifdef SB_USE_UNIT_CSISO_8859_16
#  define SB_USE_CLASS_TPLISO_8859_16
#endif /* SB_USE_UNIT_CSISO_8859_16 */

#ifdef SB_USE_UNIT_CSISO_8859_2
#  define SB_USE_CLASS_TPLISO_8859_2
#endif /* SB_USE_UNIT_CSISO_8859_2 */

#ifdef SB_USE_UNIT_CSISO_8859_3
#  define SB_USE_CLASS_TPLISO_8859_3
#endif /* SB_USE_UNIT_CSISO_8859_3 */

#ifdef SB_USE_UNIT_CSISO_8859_4
#  define SB_USE_CLASS_TPLISO_8859_4
#endif /* SB_USE_UNIT_CSISO_8859_4 */

#ifdef SB_USE_UNIT_CSISO_8859_5
#  define SB_USE_CLASS_TPLISO_8859_5
#endif /* SB_USE_UNIT_CSISO_8859_5 */

#ifdef SB_USE_UNIT_CSISO_8859_6
#  define SB_USE_CLASS_TPLISO_8859_6
#endif /* SB_USE_UNIT_CSISO_8859_6 */

#ifdef SB_USE_UNIT_CSISO_8859_7
#  define SB_USE_CLASS_TPLISO_8859_7
#endif /* SB_USE_UNIT_CSISO_8859_7 */

#ifdef SB_USE_UNIT_CSISO_8859_8
#  define SB_USE_CLASS_TPLISO_8859_8
#endif /* SB_USE_UNIT_CSISO_8859_8 */

#ifdef SB_USE_UNIT_CSISO_8859_8I
#  define SB_USE_CLASS_TPLISO_8859_8I
#endif /* SB_USE_UNIT_CSISO_8859_8I */

#ifdef SB_USE_UNIT_CSISO_8859_9
#  define SB_USE_CLASS_TPLISO_8859_9
#endif /* SB_USE_UNIT_CSISO_8859_9 */

#ifdef SB_USE_UNIT_CSISO_IR_165
#  define SB_USE_CLASS_TPLISO_IR_165DATA
#endif /* SB_USE_UNIT_CSISO_IR_165 */

#ifdef SB_USE_UNIT_CSJIS_0201
#  define SB_USE_CLASS_TPLJIS_0201
#endif /* SB_USE_UNIT_CSJIS_0201 */

#ifdef SB_USE_UNIT_CSJIS_0208
#  define SB_USE_CLASS_TPLJIS_0208
#endif /* SB_USE_UNIT_CSJIS_0208 */

#ifdef SB_USE_UNIT_CSJIS_0212
#  define SB_USE_CLASS_TPLJIS_0212
#endif /* SB_USE_UNIT_CSJIS_0212 */

#ifdef SB_USE_UNIT_CSKOI8R
#  define SB_USE_CLASS_TPLKOI8R
#endif /* SB_USE_UNIT_CSKOI8R */

#ifdef SB_USE_UNIT_CSKOI8RU
#  define SB_USE_CLASS_TPLKOI8RU
#endif /* SB_USE_UNIT_CSKOI8RU */

#ifdef SB_USE_UNIT_CSKOI8T
#  define SB_USE_CLASS_TPLKOI8T
#endif /* SB_USE_UNIT_CSKOI8T */

#ifdef SB_USE_UNIT_CSKOI8U
#  define SB_USE_CLASS_TPLKOI8U
#endif /* SB_USE_UNIT_CSKOI8U */

#ifdef SB_USE_UNIT_CSKS_X_1001
#  define SB_USE_CLASS_TPLKS_X_1001
#endif /* SB_USE_UNIT_CSKS_X_1001 */

#ifdef SB_USE_UNIT_CSMACCELTIC
#  define SB_USE_CLASS_TPLMACCELTIC
#endif /* SB_USE_UNIT_CSMACCELTIC */

#ifdef SB_USE_UNIT_CSMACCENTRALEUROPEAN
#  define SB_USE_CLASS_TPLMACCENTRALEUROPEAN
#endif /* SB_USE_UNIT_CSMACCENTRALEUROPEAN */

#ifdef SB_USE_UNIT_CSMACCROATIAN
#  define SB_USE_CLASS_TPLMACCROATIAN
#endif /* SB_USE_UNIT_CSMACCROATIAN */

#ifdef SB_USE_UNIT_CSMACCYRILLIC
#  define SB_USE_CLASS_TPLMACCYRILLIC
#endif /* SB_USE_UNIT_CSMACCYRILLIC */

#ifdef SB_USE_UNIT_CSMACGAELIC
#  define SB_USE_CLASS_TPLMACGAELIC
#endif /* SB_USE_UNIT_CSMACGAELIC */

#ifdef SB_USE_UNIT_CSMACGREEK
#  define SB_USE_CLASS_TPLMACGREEK
#endif /* SB_USE_UNIT_CSMACGREEK */

#ifdef SB_USE_UNIT_CSMACHEBREW
#  define SB_USE_CLASS_TPLMACHEBREW
#endif /* SB_USE_UNIT_CSMACHEBREW */

#ifdef SB_USE_UNIT_CSMACICELANDIC
#  define SB_USE_CLASS_TPLMACICELANDIC
#endif /* SB_USE_UNIT_CSMACICELANDIC */

#ifdef SB_USE_UNIT_CSMACROMAN
#  define SB_USE_CLASS_TPLMACROMAN
#endif /* SB_USE_UNIT_CSMACROMAN */

#ifdef SB_USE_UNIT_CSMACROMANIAN
#  define SB_USE_CLASS_TPLMACROMANIAN
#endif /* SB_USE_UNIT_CSMACROMANIAN */

#ifdef SB_USE_UNIT_CSMACTHAI
#  define SB_USE_CLASS_TPLMACTHAI
#endif /* SB_USE_UNIT_CSMACTHAI */

#ifdef SB_USE_UNIT_CSMACTURKISH
#  define SB_USE_CLASS_TPLMACTURKISH
#endif /* SB_USE_UNIT_CSMACTURKISH */

#ifdef SB_USE_UNIT_CSNEXTSTEP
#  define SB_USE_CLASS_TPLNEXTSTEP
#endif /* SB_USE_UNIT_CSNEXTSTEP */

#ifdef SB_USE_UNIT_CSSHIFTJIS
#  define SB_USE_CLASS_TPLSHIFTJISDATA
#endif /* SB_USE_UNIT_CSSHIFTJIS */

#ifdef SB_USE_UNIT_CSUHC
#  define SB_USE_CLASS_TPLUHC
#endif /* SB_USE_UNIT_CSUHC */

#ifdef SB_USE_UNIT_CSVISCII
#  define SB_USE_CLASS_TPLVISCII
#endif /* SB_USE_UNIT_CSVISCII */

#ifdef SB_USE_UNIT_CHSCJK
#  define SB_USE_CLASS_TPLCUSTOMEUCCHARSET
#  define SB_USE_CLASS_TPLCUSTOMISO_2022CHARSET
#  define SB_USE_CLASS_TPLSHIFTJISCODE
#  define SB_USE_CLASS_TPLSHIFTJIS
#  define SB_USE_CLASS_TPLEUC_JP
#  define SB_USE_CLASS_TPLISO_2022_JP
#  define SB_USE_CLASS_TPLISO_2022_JP_1
#  define SB_USE_CLASS_TPLISO_2022_JP_2
#  define SB_USE_CLASS_TPLGBK
#  define SB_USE_CLASS_TPLHZ_GB_2312
#  define SB_USE_CLASS_TPLGB_18030CODE
#  define SB_USE_CLASS_TPLGB_18030
#  define SB_USE_CLASS_TPLISO_2022_CN
#  define SB_USE_CLASS_TPLISO_2022_CN_EXT
#  define SB_USE_CLASS_TPLBIGFIVEHKSCS
#  define SB_USE_CLASS_TPLCP950
#  define SB_USE_CLASS_TPLCNS_11643
#  define SB_USE_CLASS_TPLEUC_TW
#  define SB_USE_CLASS_TPLCP949
#  define SB_USE_CLASS_TPLJOHABHANGUL
#  define SB_USE_CLASS_TPLJOHABNONHANGUL
#  define SB_USE_CLASS_TPLJOHAB
#  define SB_USE_CLASS_TPLEUC_KR
#  define SB_USE_CLASS_TPLISO_2022_KR
#endif /* SB_USE_UNIT_CHSCJK */

#ifdef SB_USE_UNIT_CHSCONV
#  define SB_USE_GLOBAL_PROCS_CHSCONV
#  define SB_USE_CLASS_TPLCONVERTER
#  define SB_USE_CLASS_TPLCUSTOMUTF
#  define SB_USE_CLASS_TPLUTF32
#  define SB_USE_CLASS_TPLUTF32BE
#  define SB_USE_CLASS_TPLUTF16
#  define SB_USE_CLASS_TPLUTF16BE
#  define SB_USE_CLASS_TPLUTF8
#  define SB_USE_CLASS_TPLCUSTOMUTF7
#  define SB_USE_CLASS_TPLUTF7
#  define SB_USE_CLASS_TPLUTF7_IMAP
#  define SB_USE_CLASS_TPLCONVBUFFER
#  define SB_USE_CLASS_TPLCUSTOMSTRINGSTREAM
#  define SB_USE_CLASS_TPLANSISTRINGSTREAM
#  define SB_USE_CLASS_TPLWIDESTRINGSTREAM
#  define SB_USE_CLASS_TPLBYTEARRAYSTREAM
#  define SB_USE_CLASS_TPLCUSTOMSTRINGSTREAMPOOL
#  define SB_USE_CLASS_TPLANSISTRINGSTREAMPOOL
#  define SB_USE_CLASS_TPLWIDESTRINGSTREAMPOOL
#endif /* SB_USE_UNIT_CHSCONV */

#ifdef SB_USE_UNIT_CHSCONVBASE
#  define SB_USE_GLOBAL_PROCS_CHSCONVBASE
#  define SB_USE_CLASS_TPLCHARSET
#  define SB_USE_CLASS_TPLTABLECHARSET
#  define SB_USE_CLASS_TPLMIXEDCHARSET
#  define SB_USE_CLASS_TPLCONVERTINGCHARSET
#  define SB_USE_CLASS_TPLASCII
#  define SB_USE_CLASS_TPLISO_8859_1
#endif /* SB_USE_UNIT_CHSCONVBASE */

#ifdef SB_USE_UNIT_CHSUNICODE
#  define SB_USE_GLOBAL_PROCS_CHSUNICODE
#endif /* SB_USE_UNIT_CHSUNICODE */

#ifdef SB_USE_UNIT_UNICODE
#  define SB_USE_GLOBAL_PROCS_UNICODE
#  define SB_USE_CLASS_TELUNICODECONVERTER
#endif /* SB_USE_UNIT_UNICODE */

#ifdef SB_USE_UNIT_IDEA
#  define SB_USE_GLOBAL_PROCS_IDEA
#endif /* SB_USE_UNIT_IDEA */

#ifdef SB_USE_UNIT_CRYPTOPROVBUILTINEX
#  define SB_USE_GLOBAL_PROCS_CRYPTOPROVBUILTINEX
#  define SB_USE_CLASS_TELBUILTINEXTENDEDCRYPTOPROVIDER
#  define SB_USE_CLASS_TELBUILTINEXTENDEDSYMMETRICCRYPTOFACTORY
#  define SB_USE_CLASS_TELBUILTINIDEASYMMETRICCRYPTO
#endif /* SB_USE_UNIT_CRYPTOPROVBUILTINEX */

#ifdef SB_USE_UNIT_JSON
#  define SB_USE_GLOBAL_PROCS_JSON
#  define SB_USE_CLASS_TELJSONENTITY
#  define SB_USE_CLASS_TELJSONARRAY
#  define SB_USE_CLASS_TELJSONOBJECT
#  define SB_USE_CLASS_TELJSONVALUE
#endif /* SB_USE_UNIT_JSON */

#ifdef SB_USE_UNIT_BCRYPT
#  define SB_USE_CLASS_TELBCRYPT
#endif /* SB_USE_UNIT_BCRYPT */

#ifdef SB_USE_UNIT_WHIRLPOOL
#  define SB_USE_GLOBAL_PROCS_WHIRLPOOL
#endif /* SB_USE_UNIT_WHIRLPOOL */

#ifdef SB_USE_UNIT_DICTIONARY
#  define SB_USE_CLASS_TELDICTIONARYENTRY
#  define SB_USE_CLASS_TELDICTIONARY
#endif /* SB_USE_UNIT_DICTIONARY */

#ifdef SB_USE_UNIT_USERS
#  define SB_USE_GLOBAL_PROCS_USERS
#  define SB_USE_CLASS_TELUSERS
#  define SB_USE_CLASS_TELCUSTOMUSER
#endif /* SB_USE_UNIT_USERS */

#ifdef SB_USE_UNIT_DATASTORAGE
#  define SB_USE_GLOBAL_PROCS_DATASTORAGE
#  define SB_USE_CLASS_TELDSCUSTOMKEYPROTECTIONHANDLER
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGEENCODINGHANDLER
#  define SB_USE_CLASS_TELDSENVELOPEDDATAKEYPROTECTIONHANDLER
#  define SB_USE_CLASS_TELDSENCRYPTEDDATAKEYPROTECTIONHANDLER
#  define SB_USE_CLASS_TELDSPLAINKEYPROTECTIONHANDLER
#  define SB_USE_CLASS_TELDSKEYPROTECTIONHANDLERSFACTORY
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#  define SB_USE_CLASS_TELDATASTORAGEOBJECTLIST
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGE
#  define SB_USE_CLASS_TELDEFAULTDATASTORAGESECURITYHANDLER
#  define SB_USE_CLASS_TELDATASTORAGESECURITYHANDLERSFACTORY
#  define SB_USE_CLASS_TELDATASTORAGEENCODINGHANDLERSFACTORY
#endif /* SB_USE_UNIT_DATASTORAGE */

#ifdef SB_USE_UNIT_AWSDATASTORAGE
#  define SB_USE_GLOBAL_PROCS_AWSDATASTORAGE
#  define SB_USE_CLASS_TELAWSS3DATASTORAGE
#  define SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT
#  define SB_USE_CLASS_TELAWSS3DATASTORAGELISTSTATE
#  define SB_USE_CLASS_TELAWSS3ACCESSCONTROLGRANT
#  define SB_USE_CLASS_TELAWSS3ACCESSCONTROLPOLICY
#  define SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKET
#  define SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKETLIST
#endif /* SB_USE_UNIT_AWSDATASTORAGE */

#ifdef SB_USE_UNIT_FILEDATASTORAGE
#  define SB_USE_GLOBAL_PROCS_FILEDATASTORAGE
#  define SB_USE_CLASS_TELFILEDATASTORAGEOBJECT
#  define SB_USE_CLASS_TELFILEDATASTORAGE
#endif /* SB_USE_UNIT_FILEDATASTORAGE */

#ifdef SB_USE_UNIT_ENCSTREAM
#  define SB_USE_CLASS_TELCHUNKEDENCRYPTINGSTREAM
#  define SB_USE_CLASS_TELCHUNKEDDECRYPTINGSTREAM
#endif /* SB_USE_UNIT_ENCSTREAM */

#ifdef SB_USE_UNIT_AUTHDATASTREAM
#  define SB_USE_CLASS_TELAUTHENTICATEDDATAWRITESTREAM
#  define SB_USE_CLASS_TELAUTHENTICATEDDATAREADSTREAM
#endif /* SB_USE_UNIT_AUTHDATASTREAM */

#ifdef SB_USE_UNIT_WINAZUREDATASTORAGE
#  define SB_USE_GLOBAL_PROCS_WINAZUREDATASTORAGE
#  define SB_USE_CLASS_TELWINAZUREDATASTORAGE
#  define SB_USE_CLASS_TELWINAZUREDATASTORAGELISTSTATE
#  define SB_USE_CLASS_TELWINAZURESINGLEACCESSPOLICY
#  define SB_USE_CLASS_TELWINAZUREACCESSPOLICY
#  define SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT
#  define SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER
#  define SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINERLIST
#endif /* SB_USE_UNIT_WINAZUREDATASTORAGE */

#ifdef SB_USE_UNIT_GOOGLEDATASTORAGE
#  define SB_USE_GLOBAL_PROCS_GOOGLEDATASTORAGE
#  define SB_USE_CLASS_TELGOOGLEDATASTORAGE
#  define SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECTCATEGORIES
#  define SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECTLINKS
#  define SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECT
#  define SB_USE_CLASS_TELGOOGLEPREFIXEDPOSTFIXEDUPLOADSTREAM
#  define SB_USE_CLASS_TELGOOGLEBASE64ENCODINGSTREAM
#  define SB_USE_CLASS_TELGOOGLEBASE64DECODINGSTREAM
#  define SB_USE_CLASS_TELGOOGLEPREFIXEDMETADATAPROCESSINGSTREAM
#endif /* SB_USE_UNIT_GOOGLEDATASTORAGE */

#ifdef SB_USE_UNIT_GOOGLEDRIVEDATASTORAGE
#  define SB_USE_GLOBAL_PROCS_GOOGLEDRIVEDATASTORAGE
#  define SB_USE_CLASS_TELGOOGLEDRIVEDATASTORAGE
#  define SB_USE_CLASS_TELGOOGLEDRIVEDATASTORAGEOBJECT
#  define SB_USE_CLASS_TELGOOGLEDRIVEFOLDER
#  define SB_USE_CLASS_TELGOOGLEDRIVEPROPERTIES
#  define SB_USE_CLASS_TELGOOGLEDRIVECOMMENT
#  define SB_USE_CLASS_TELGOOGLEDRIVEREPLIES
#  define SB_USE_CLASS_TELGOOGLEDRIVEUSER
#  define SB_USE_CLASS_TELGOOGLEDRIVEACCOUNTINFO
#  define SB_USE_CLASS_TELGOOGLEDRIVECOMMENTS
#  define SB_USE_CLASS_TELGOOGLEDRIVEREPLY
#  define SB_USE_CLASS_TELGOOGLEDRIVEPROPERTY
#  define SB_USE_CLASS_TELGOOGLEDRIVEPERMISSION
#  define SB_USE_CLASS_TELGOOGLEDRIVEPERMISSIONS
#  define SB_USE_CLASS_TELGOOGLEDRIVECUSTOMFILE
#  define SB_USE_CLASS_TELGOOGLEDRIVEFILE
#  define SB_USE_CLASS_TELGOOGLEDOCUMENT
#endif /* SB_USE_UNIT_GOOGLEDRIVEDATASTORAGE */

#ifdef SB_USE_UNIT_ONEDRIVEDATASTORAGE
#  define SB_USE_GLOBAL_PROCS_ONEDRIVEDATASTORAGE
#  define SB_USE_CLASS_TELONEDRIVEDATASTORAGE
#  define SB_USE_CLASS_TELONEDRIVEDATASTORAGEOBJECT
#  define SB_USE_CLASS_TELONEDRIVEFOLDER
#  define SB_USE_CLASS_TELONEDRIVECOMMENTS
#  define SB_USE_CLASS_TELONEDRIVETAGS
#  define SB_USE_CLASS_TELONEDRIVEFILE
#  define SB_USE_CLASS_TELONEDRIVEFRIEND
#  define SB_USE_CLASS_TELONEDRIVECOMMENT
#  define SB_USE_CLASS_TELONEDRIVETAGGEDOBJECT
#  define SB_USE_CLASS_TELONEDRIVETAG
#  define SB_USE_CLASS_TELONEDRIVENOTEBOOK
#  define SB_USE_CLASS_TELONEDRIVEAUDIO
#  define SB_USE_CLASS_TELONEDRIVEPHOTO
#  define SB_USE_CLASS_TELONEDRIVEPHOTOIMAGE
#  define SB_USE_CLASS_TELONEDRIVEPHOTOIMAGES
#  define SB_USE_CLASS_TELONEDRIVEVIDEO
#  define SB_USE_CLASS_TELONEDRIVEALBUM
#  define SB_USE_CLASS_TELONEDRIVEUSERINFO
#endif /* SB_USE_UNIT_ONEDRIVEDATASTORAGE */

#ifdef SB_USE_UNIT_DROPBOXDATASTORAGE
#  define SB_USE_GLOBAL_PROCS_DROPBOXDATASTORAGE
#  define SB_USE_CLASS_TELDROPBOXDATASTORAGE
#  define SB_USE_CLASS_TELDROPBOXDATASTORAGEOBJECT
#  define SB_USE_CLASS_TELDROPBOXACCOUNTINFO
#endif /* SB_USE_UNIT_DROPBOXDATASTORAGE */

#ifdef SB_USE_UNIT_DATASTORAGEENCODINGS
#  define SB_USE_CLASS_TELZLIBDATASTORAGEENCODINGHANDLER
#endif /* SB_USE_UNIT_DATASTORAGEENCODINGS */

#ifdef SB_USE_UNIT_DATASTORAGEUTILS
#  define SB_USE_GLOBAL_PROCS_DATASTORAGEUTILS
#  define SB_USE_CLASS_TELPROXYSTREAM
#  define SB_USE_CLASS_TELMETADATACACHE
#  define SB_USE_CLASS_TELPROTECTEDOBJECTUPLOADSTREAM
#  define SB_USE_CLASS_TELPROTECTEDOBJECTREADER
#  define SB_USE_CLASS_TELPROTECTEDOBJECTDOWNLOADSTREAM
#endif /* SB_USE_UNIT_DATASTORAGEUTILS */

#ifdef SB_USE_UNIT_BOXDATASTORAGE
#  define SB_USE_GLOBAL_PROCS_BOXDATASTORAGE
#  define SB_USE_CLASS_TELBOXDATASTORAGE
#  define SB_USE_CLASS_TELBOXDATASTORAGEOBJECT
#  define SB_USE_CLASS_TELBOXFILE
#  define SB_USE_CLASS_TELBOXFOLDER
#  define SB_USE_CLASS_TELBOXGROUPINFO
#  define SB_USE_CLASS_TELBOXUSERINFO
#  define SB_USE_CLASS_TELBOXENTERPRISE
#  define SB_USE_CLASS_TELBOXUSEREMAILALIAS
#  define SB_USE_CLASS_TELBOXUSEREMAILALIASES
#  define SB_USE_CLASS_TELBOXGROUPMEMBERSHIP
#  define SB_USE_CLASS_TELBOXGROUPMEMBERSHIPS
#  define SB_USE_CLASS_TELBOXUSER
#  define SB_USE_CLASS_TELBOXUSERS
#  define SB_USE_CLASS_TELBOXGROUPMEMBER
#  define SB_USE_CLASS_TELBOXGROUPMEMBERS
#  define SB_USE_CLASS_TELBOXGROUP
#  define SB_USE_CLASS_TELBOXGROUPS
#  define SB_USE_CLASS_TELBOXSHAREDLINK
#  define SB_USE_CLASS_TELBOXSHAREDLINKPERMISSIONS
#  define SB_USE_CLASS_TELBOXCOLLABORATION
#  define SB_USE_CLASS_TELBOXCOLLABORATIONS
#  define SB_USE_CLASS_TELBOXDATASTORAGEOBJECTPERMISSIONS
#  define SB_USE_CLASS_TELBOXCOMMENT
#  define SB_USE_CLASS_TELBOXCOMMENTS
#endif /* SB_USE_UNIT_BOXDATASTORAGE */

#ifdef SB_USE_UNIT_HTTPSWEBDAVCLIENT
#  define SB_USE_GLOBAL_PROCS_HTTPSWEBDAVCLIENT
#  define SB_USE_CLASS_TELHTTPSWEBDAVCLIENT
#endif /* SB_USE_UNIT_HTTPSWEBDAVCLIENT */

#ifdef SB_USE_UNIT_WEBDAVCLIENT
#  define SB_USE_GLOBAL_PROCS_WEBDAVCLIENT
#  define SB_USE_CLASS_TELWEBDAVCLIENT
#  define SB_USE_CLASS_TELWEBDAVLOCKLIST
#  define SB_USE_CLASS_TELWEBDAVMULTISTATUSRESPONSE
#  define SB_USE_CLASS_TELWEBDAVERROR
#  define SB_USE_CLASS_TELWEBDAVPRIVILEGESET
#  define SB_USE_CLASS_TELWEBDAVSUPPORTEDPRIVILEGE
#  define SB_USE_CLASS_TELWEBDAVSUPPORTEDPRIVILEGESET
#  define SB_USE_CLASS_TELWEBDAVPRINCIPALSEARCHPROPERTYSETRESPONSE
#  define SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT
#  define SB_USE_CLASS_TELWEBDAVERRORRESPONSE
#  define SB_USE_CLASS_TELWEBDAVOBJECTLIST
#  define SB_USE_CLASS_TELWEBDAVERRORLIST
#  define SB_USE_CLASS_SBWEBDAVCLIENT_TELWEBDAVPRINCIPAL
#  define SB_USE_CLASS_TELWEBDAVPRINCIPALLIST
#  define SB_USE_CLASS_TELCARDDAVSUPPORTEDADDRESSDATA
#  define SB_USE_CLASS_TELCARDDAVADDRESSBOOKINFO
#  define SB_USE_CLASS_TELCARDDAVREPORTCONTEXT
#endif /* SB_USE_UNIT_WEBDAVCLIENT */

#ifdef SB_USE_UNIT_WEBDAVCOMMON
#  define SB_USE_GLOBAL_PROCS_WEBDAVCOMMON
#  define SB_USE_CLASS_TELWEBDAVPROPERTYINFO
#  define SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST
#  define SB_USE_CLASS_TELWEBDAVNAMESPACEPREFIXMAP
#  define SB_USE_CLASS_TELWEBDAVLOCK
#  define SB_USE_CLASS_TELWEBDAVFILTER
#  define SB_USE_CLASS_TELWEBDAVTEXTMATCHFILTER
#  define SB_USE_CLASS_TELCARDDAVTEXTMATCHFILTER
#  define SB_USE_CLASS_TELCARDDAVPROPFILTER
#  define SB_USE_CLASS_TELCARDDAVFILTER
#  define SB_USE_CLASS_TELCARDDAVPARAMFILTER
#  define SB_USE_CLASS_TELWEBDAVACE
#  define SB_USE_CLASS_TELWEBDAVACL
#  define SB_USE_CLASS_TELWEBDAVACLRESTRICTIONS
#endif /* SB_USE_UNIT_WEBDAVCOMMON */

#ifdef SB_USE_UNIT_VCARD
#  define SB_USE_CLASS_TELDIRINFOATTRIBUTE
#  define SB_USE_CLASS_TELDIRINFOPROPERTY
#  define SB_USE_CLASS_TELDIRINFOPROPERTIESLIST
#  define SB_USE_CLASS_TELDIRINFO
#  define SB_USE_CLASS_TELVCARD
#  define SB_USE_CLASS_TELVCALENDAR
#endif /* SB_USE_UNIT_VCARD */

#ifdef SB_USE_UNIT_WEBDAVSERVER
#  define SB_USE_GLOBAL_PROCS_WEBDAVSERVER
#  define SB_USE_CLASS_TELWEBDAVSERVER
#  define SB_USE_CLASS_SBWEBDAVSERVER_TELWEBDAVPRINCIPAL
#  define SB_USE_CLASS_TELWEBDAVINMEMORYPRINCIPAL
#  define SB_USE_CLASS_TELWEBDAVPRINCIPALBACKEND
#  define SB_USE_CLASS_TELWEBDAVPRINCIPALMEMORYBACKEND
#  define SB_USE_CLASS_TELCALDAVTEXTMATCHFILTER
#  define SB_USE_CLASS_TELCALDAVPARAMFILTER
#  define SB_USE_CLASS_TELWEBDAVTIMERANGEBASE
#  define SB_USE_CLASS_TELWEBDAVTIMERANGE
#  define SB_USE_CLASS_TELCALDAVPROPFILTER
#  define SB_USE_CLASS_TELCALDAVCOMPFILTER
#  define SB_USE_CLASS_TELWEBDAVEXTENDEDREQUEST
#  define SB_USE_CLASS_TELWEBDAVADDRESSBOOKREQUEST
#  define SB_USE_CLASS_TELWEBDAVLIMITRECURRENCESET
#  define SB_USE_CLASS_TELWEBDAVEXPAND
#  define SB_USE_CLASS_TELWEBDAVLIMITFREEBUSYSET
#  define SB_USE_CLASS_TELWEBDAVCOMP
#  define SB_USE_CLASS_TELWEBDAVCALENDARREQUEST
#  define SB_USE_CLASS_TELWEBDAVPROPERTY
#  define SB_USE_CLASS_TELWEBDAVIFSTATE
#  define SB_USE_CLASS_TELWEBDAVIFRESOURCE
#  define SB_USE_CLASS_TELWEBDAVIFHEADER
#  define SB_USE_CLASS_TELWEBDAVCUSTOMLOCKLIST
#  define SB_USE_CLASS_TELWEBDAVFINDMEMORYLOCKHANDLE
#  define SB_USE_CLASS_TELWEBDAVMEMORYLOCKLIST
#  define SB_USE_CLASS_TELWEBDAVACLOPTIONS
#  define SB_USE_CLASS_TELCARDDAVOPTIONS
#  define SB_USE_CLASS_TELCALDAVOPTIONS
#  define SB_USE_CLASS_TELWEBDAVCOLLATION
#  define SB_USE_CLASS_TELWEBDAVUNICODECOLLATION
#  define SB_USE_CLASS_TELWEBDAVASCIICOLLATION
#  define SB_USE_CLASS_TELWEBDAVOCTETCOLLATION
#endif /* SB_USE_UNIT_WEBDAVSERVER */

#ifdef SB_USE_UNIT_DCXMLENC
#  define SB_USE_GLOBAL_PROCS_DCXMLENC
#  define SB_USE_CLASS_TELDCXMLENCODING
#endif /* SB_USE_UNIT_DCXMLENC */

#ifdef SB_USE_UNIT_DCPKI
#  define SB_USE_CLASS_TELDCX509SIGNOPERATIONHANDLER
#endif /* SB_USE_UNIT_DCPKI */

#ifdef SB_USE_UNIT_DCSERVER
#  define SB_USE_CLASS_TELDCOPERATIONHANDLER
#  define SB_USE_CLASS_TELDCSIGNOPERATIONHANDLER
#  define SB_USE_CLASS_TELDCGENERICSIGNOPERATIONHANDLER
#  define SB_USE_CLASS_TELDCSTANDARDSERVER
#endif /* SB_USE_UNIT_DCSERVER */

#ifdef SB_USE_UNIT_AS2
#  define SB_USE_GLOBAL_PROCS_AS2
#  define SB_USE_CLASS_TELAS2RECEIPTREQUEST
#  define SB_USE_CLASS_TELAS2ENCRYPTION
#  define SB_USE_CLASS_TELAS2SIGNATURE
#  define SB_USE_CLASS_TELAS2COMPRESSION
#  define SB_USE_CLASS_TELAS2RECEIPT
#  define SB_USE_CLASS_TELAS2MESSAGE
#  define SB_USE_CLASS_TELAS2HTTPOPTIONS
#  define SB_USE_CLASS_TELAS2PROXYOPTIONS
#  define SB_USE_CLASS_TELAS2SOCKETOPTIONS
#  define SB_USE_CLASS_TELAS2SOCKSOPTIONS
#  define SB_USE_CLASS_TELAS2SSLOPTIONS
#  define SB_USE_CLASS_TELAS2WEBTUNNELOPTIONS
#  define SB_USE_CLASS_TELAS2CLIENT
#endif /* SB_USE_UNIT_AS2 */

#ifdef SB_USE_UNIT_AS3
#  define SB_USE_GLOBAL_PROCS_AS3
#  define SB_USE_CLASS_TELAS3RECEIPTREQUEST
#  define SB_USE_CLASS_TELAS3ENCRYPTION
#  define SB_USE_CLASS_TELAS3SIGNATURE
#  define SB_USE_CLASS_TELAS3COMPRESSION
#  define SB_USE_CLASS_TELAS3RECEIPT
#  define SB_USE_CLASS_TELAS3MESSAGE
#  define SB_USE_CLASS_TELAS3SOCKSOPTIONS
#  define SB_USE_CLASS_TELAS3SSLOPTIONS
#  define SB_USE_CLASS_TELAS3WEBTUNNELOPTIONS
#  define SB_USE_CLASS_TELAS3FTPOPTIONS
#  define SB_USE_CLASS_TELAS3PROXYOPTIONS
#  define SB_USE_CLASS_TELAS3SOCKETOPTIONS
#  define SB_USE_CLASS_TELAS3CLIENT
#endif /* SB_USE_UNIT_AS3 */

#ifdef SB_USE_UNIT_ASCOMMON
#  define SB_USE_CLASS_TELASRECEIPTREQUEST
#  define SB_USE_CLASS_TELASMESSAGEDECRYPTOR
#  define SB_USE_CLASS_TELASMESSAGEENCRYPTOR
#  define SB_USE_CLASS_TELASENCRYPTION
#  define SB_USE_CLASS_TELASSMIMEMESSAGEDECRYPTOR
#  define SB_USE_CLASS_TELASSMIMEMESSAGEENCRYPTOR
#  define SB_USE_CLASS_TELASSMIMEENCRYPTION
#  define SB_USE_CLASS_TELASMESSAGESIGNER
#  define SB_USE_CLASS_TELASMESSAGEVERIFIER
#  define SB_USE_CLASS_TELASSIGNATURE
#  define SB_USE_CLASS_TELASSMIMEMESSAGESIGNER
#  define SB_USE_CLASS_TELASSMIMEMESSAGEVERIFIER
#  define SB_USE_CLASS_TELASSMIMESIGNATURE
#  define SB_USE_CLASS_TELASCOMPRESSION
#  define SB_USE_CLASS_TELASSMIMECOMPRESSION
#  define SB_USE_CLASS_TELASMESSAGEERROR
#  define SB_USE_CLASS_TELASMESSAGEERRORLIST
#  define SB_USE_CLASS_TELASMESSAGECONTENTDIGESTS
#  define SB_USE_CLASS_TELASRECEIPT
#  define SB_USE_CLASS_TELASMESSAGE
#endif /* SB_USE_UNIT_ASCOMMON */

#ifdef SB_USE_UNIT_ASUTILS
#  define SB_USE_GLOBAL_PROCS_ASUTILS
#endif /* SB_USE_UNIT_ASUTILS */

#ifdef SB_USE_UNIT_SIMPLEFTPS
#  define SB_USE_GLOBAL_PROCS_SIMPLEFTPS
#  define SB_USE_CLASS_TELSIMPLEFTPSCLIENT
#  define SB_USE_CLASS_TELFTPFILEINFO
#  define SB_USE_CLASS_TELFTPPROXYSETTINGS
#  define SB_USE_CLASS_TELFTPSTRANSFERMANAGER
#  define SB_USE_CLASS_TELMULTIPARTSTREAMACCESS
#  define SB_USE_CLASS_TELFTPSTRANSFERCHUNK
#  define SB_USE_CLASS_TELMULTIPARTSTREAMPART
#endif /* SB_USE_UNIT_SIMPLEFTPS */

#ifdef SB_USE_UNIT_FTPSCOMMON
#  define SB_USE_GLOBAL_PROCS_FTPSCOMMON
#endif /* SB_USE_UNIT_FTPSCOMMON */

#ifdef SB_USE_UNIT_FTPSSERVER
#  define SB_USE_GLOBAL_PROCS_FTPSSERVER
#  define SB_USE_CLASS_TELFTPSSERVERFILEINFO
#  define SB_USE_CLASS_TELFTPSSERVERMESSAGETABLE
#  define SB_USE_CLASS_TELFTPSUSER
#  define SB_USE_CLASS_TELFTPSSERVER
#endif /* SB_USE_UNIT_FTPSSERVER */

#ifdef SB_USE_UNIT_SIMPLEFTPSSERVER
#  define SB_USE_GLOBAL_PROCS_SIMPLEFTPSSERVER
#  define SB_USE_CLASS_TELSIMPLEFTPSSERVERSESSIONTHREAD
#  define SB_USE_CLASS_TELSIMPLEFTPSSERVER
#  define SB_USE_CLASS_TELSIMPLEFTPSSERVERLISTENINGTHREAD
#  define SB_USE_CLASS_TELFTPSUSERS
#endif /* SB_USE_UNIT_SIMPLEFTPSSERVER */

#ifdef SB_USE_UNIT_HTTPSCOMMON
#  define SB_USE_GLOBAL_PROCS_HTTPSCOMMON
#  define SB_USE_CLASS_TELHTTPSCLIENTPARAMS
#  define SB_USE_CLASS_TELCUSTOMSAMLADAPTER
#  define SB_USE_CLASS_TELHTTPRANGES
#  define SB_USE_CLASS_TELHTTPPARAMS
#  define SB_USE_CLASS_TELHTTPCUSTOMREQUESTPARAMS
#  define SB_USE_CLASS_TELHTTPMULTIPARTPART
#  define SB_USE_CLASS_TELHTTPMULTIPARTLIST
#  define SB_USE_CLASS_TELHTTPENCODINGPROCESSOR
#  define SB_USE_CLASS_TELHTTPCHUNKEDPROCESSOR
#  define SB_USE_CLASS_TELHTTPCOMPRESSEDPROCESSOR
#  define SB_USE_CLASS_TELHTTPUTILS
#endif /* SB_USE_UNIT_HTTPSCOMMON */

#ifdef SB_USE_UNIT_HTTPSCLIENT
#  define SB_USE_GLOBAL_PROCS_HTTPSCLIENT
#  define SB_USE_CLASS_TELHTTPREQUESTPARAMS
#  define SB_USE_CLASS_TELHTTPSCLIENT
#  define SB_USE_CLASS_SBHTTPSCLIENT_TELSTRINGVALUE
#endif /* SB_USE_UNIT_HTTPSCLIENT */

#ifdef SB_USE_UNIT_HTTPTSPCLIENT
#  define SB_USE_GLOBAL_PROCS_HTTPTSPCLIENT
#  define SB_USE_CLASS_TELHTTPTSPCLIENT
#endif /* SB_USE_UNIT_HTTPTSPCLIENT */

#ifdef SB_USE_UNIT_HTTPOCSPCLIENT
#  define SB_USE_GLOBAL_PROCS_HTTPOCSPCLIENT
#  define SB_USE_CLASS_TELHTTPOCSPCLIENT
#  define SB_USE_CLASS_TELHTTPOCSPCLIENTFACTORY
#endif /* SB_USE_UNIT_HTTPOCSPCLIENT */

#ifdef SB_USE_UNIT_HTTPCERTRETRIEVER
#  define SB_USE_GLOBAL_PROCS_HTTPCERTRETRIEVER
#  define SB_USE_CLASS_TELHTTPCERTIFICATERETRIEVER
#  define SB_USE_CLASS_TELHTTPCERTIFICATERETRIEVERFACTORY
#endif /* SB_USE_UNIT_HTTPCERTRETRIEVER */

#ifdef SB_USE_UNIT_HTTPCRL
#  define SB_USE_GLOBAL_PROCS_HTTPCRL
#  define SB_USE_CLASS_TELHTTPCRLRETRIEVER
#  define SB_USE_CLASS_TELHTTPCRLRETRIEVERFACTORY
#endif /* SB_USE_UNIT_HTTPCRL */

#ifdef SB_USE_UNIT_OAUTH2
#  define SB_USE_GLOBAL_PROCS_OAUTH2
#  define SB_USE_CLASS_TELOAUTH2SETTINGS
#  define SB_USE_CLASS_TELOAUTH2REQUEST
#  define SB_USE_CLASS_TELOAUTH2CLIENT
#  define SB_USE_CLASS_TELOAUTH2REDIRECTRECEIVER
#endif /* SB_USE_UNIT_OAUTH2 */

#ifdef SB_USE_UNIT_COOKIEMGR
#  define SB_USE_GLOBAL_PROCS_COOKIEMGR
#  define SB_USE_CLASS_TELCOOKIE
#  define SB_USE_CLASS_TELCOOKIEDOMAIN
#  define SB_USE_CLASS_TELCOOKIEMANAGER
#endif /* SB_USE_UNIT_COOKIEMGR */

#ifdef SB_USE_UNIT_WEBSOCKETCOMMON
#  define SB_USE_CLASS_TELWEBSOCKETMESSAGE
#  define SB_USE_CLASS_TELWEBSOCKETOPTION
#  define SB_USE_CLASS_TELWEBSOCKETEXTENSION
#  define SB_USE_CLASS_TELWEBSOCKETBASE
#  define SB_USE_CLASS_TELWEBSOCKETSUBPROTOCOL
#  define SB_USE_CLASS_TELWEBSOCKETEXTENSIONS
#  define SB_USE_CLASS_TELWEBSOCKETSUBPROTOCOLS
#endif /* SB_USE_UNIT_WEBSOCKETCOMMON */

#ifdef SB_USE_UNIT_WEBSOCKETCLIENT
#  define SB_USE_CLASS_TELWEBSOCKETCLIENT
#endif /* SB_USE_UNIT_WEBSOCKETCLIENT */

#ifdef SB_USE_UNIT_RESTCLIENT
#  define SB_USE_GLOBAL_PROCS_RESTCLIENT
#  define SB_USE_CLASS_TELRESTCLIENT
#endif /* SB_USE_UNIT_RESTCLIENT */

#ifdef SB_USE_UNIT_HTTPSSERVER
#  define SB_USE_GLOBAL_PROCS_HTTPSSERVER
#  define SB_USE_CLASS_TELHTTPSERVERREQUESTPARAMS
#  define SB_USE_CLASS_TELHTTPSERVERRESPONSEPARAMS
#  define SB_USE_CLASS_TELMULTIPARTFORMDATA
#  define SB_USE_CLASS_TELMULTIPARTFORMLIST
#  define SB_USE_CLASS_TELHTTPSSERVER
#  define SB_USE_CLASS_TELDIGESTAUTH
#endif /* SB_USE_UNIT_HTTPSSERVER */

#ifdef SB_USE_UNIT_WEBSOCKETSERVER
#  define SB_USE_CLASS_TELWEBSOCKETSERVER
#endif /* SB_USE_UNIT_WEBSOCKETSERVER */

#ifdef SB_USE_UNIT_LDAPCERTSTORAGE
#  define SB_USE_GLOBAL_PROCS_LDAPCERTSTORAGE
#  define SB_USE_CLASS_TELLDAPCERTSTORAGE
#endif /* SB_USE_UNIT_LDAPCERTSTORAGE */

#ifdef SB_USE_UNIT_LDAPCERTRETRIEVER
#  define SB_USE_GLOBAL_PROCS_LDAPCERTRETRIEVER
#  define SB_USE_CLASS_TELLDAPCERTIFICATERETRIEVER
#  define SB_USE_CLASS_TELLDAPCERTIFICATERETRIEVERFACTORY
#endif /* SB_USE_UNIT_LDAPCERTRETRIEVER */

#ifdef SB_USE_UNIT_LDAPCRL
#  define SB_USE_GLOBAL_PROCS_LDAPCRL
#  define SB_USE_CLASS_TELLDAPCRLRETRIEVER
#  define SB_USE_CLASS_TELLDAPCRLRETRIEVERFACTORY
#endif /* SB_USE_UNIT_LDAPCRL */

#ifdef SB_USE_UNIT_LDAPSCLIENT
#  define SB_USE_GLOBAL_PROCS_LDAPSCLIENT
#  define SB_USE_CLASS_TELLDAPSSEARCHFILTER
#  define SB_USE_CLASS_TELLDAPRESPONSE
#  define SB_USE_CLASS_TELLDAPURL
#  define SB_USE_CLASS_TELLDAPSCLIENT
#endif /* SB_USE_UNIT_LDAPSCLIENT */

#ifdef SB_USE_UNIT_LDAPSCORE
#  define SB_USE_GLOBAL_PROCS_LDAPSCORE
#  define SB_USE_CLASS_TELLDAPMESSAGE
#  define SB_USE_CLASS_TELLDAPSIMPLEBINDMESSAGE
#  define SB_USE_CLASS_TELLDAPSASLBINDMESSAGE
#  define SB_USE_CLASS_TELLDAPUNBINDMESSAGE
#  define SB_USE_CLASS_TELLDAPRESULT
#  define SB_USE_CLASS_TELLDAPRESULTMESSAGE
#  define SB_USE_CLASS_TELLDAPBINDRESPONSEMESSAGE
#  define SB_USE_CLASS_TELLDAPSEARCHMESSAGE
#  define SB_USE_CLASS_TELLDAPATTRIBUTEVALUE
#  define SB_USE_CLASS_TELLDAPPARTIALATTRIBUTE
#  define SB_USE_CLASS_TELLDAPSEARCHENTRYMESSAGE
#  define SB_USE_CLASS_TELLDAPSEARCHREFERENCEMESSAGE
#  define SB_USE_CLASS_TELLDAPDELETEMESSAGE
#  define SB_USE_CLASS_TELLDAPMODIFYMESSAGE
#endif /* SB_USE_UNIT_LDAPSCORE */

#ifdef SB_USE_UNIT_SMTPCLIENT
#  define SB_USE_GLOBAL_PROCS_SMTPCLIENT
#  define SB_USE_CLASS_TELSMTPCLIENT
#endif /* SB_USE_UNIT_SMTPCLIENT */

#ifdef SB_USE_UNIT_POP3CLIENT
#  define SB_USE_GLOBAL_PROCS_POP3CLIENT
#  define SB_USE_CLASS_TELPOP3CLIENT
#endif /* SB_USE_UNIT_POP3CLIENT */

#ifdef SB_USE_UNIT_IMAPCLIENT
#  define SB_USE_GLOBAL_PROCS_IMAPCLIENT
#  define SB_USE_CLASS_TELIMAPLITERALCONTEXT
#  define SB_USE_CLASS_TELIMAPMAILBOXSTATE
#  define SB_USE_CLASS_TELIMAPMAILBOXINFO
#  define SB_USE_CLASS_TELIMAPMAILBOXESLIST
#  define SB_USE_CLASS_TELIMAPFETCHRESPONSEITEM
#  define SB_USE_CLASS_TELIMAPFETCHRESPONSELINE
#  define SB_USE_CLASS_TELIMAPFETCHRESPONSE
#  define SB_USE_CLASS_TELIMAPIDLEUPDATE
#  define SB_USE_CLASS_TELIMAPIDLETHREAD
#  define SB_USE_CLASS_TELIMAPTIMEOUTTHREAD
#  define SB_USE_CLASS_TELIMAPCLIENT
#endif /* SB_USE_UNIT_IMAPCLIENT */

#ifdef SB_USE_UNIT_IMAPUTILS
#  define SB_USE_GLOBAL_PROCS_IMAPUTILS
#  define SB_USE_CLASS_TELIMAPPARSER
#endif /* SB_USE_UNIT_IMAPUTILS */

#ifdef SB_USE_UNIT_DOMAINKEYS
#  define SB_USE_CLASS_TELDKPUBLICKEY
#  define SB_USE_CLASS_TELDKRSAPUBLICKEY
#  define SB_USE_CLASS_TELDKDNSRECORD
#  define SB_USE_CLASS_TELDOMAINKEYSCLASS
#  define SB_USE_CLASS_TELDOMAINKEYSSIGNER
#  define SB_USE_CLASS_TELDOMAINKEYSVERIFIER
#  define SB_USE_CLASS_TELDKSIGNATURE
#endif /* SB_USE_UNIT_DOMAINKEYS */

#ifdef SB_USE_UNIT_MIME
#  define SB_USE_GLOBAL_PROCS_MIME
#  define SB_USE_CLASS_TELMESSAGE
#  define SB_USE_CLASS_TELMESSAGEHEADER
#  define SB_USE_CLASS_TELMESSAGEHEADERFIELD
#  define SB_USE_CLASS_TELMAILADDRESSGROUP
#  define SB_USE_CLASS_TELMAILADDRESSLIST
#  define SB_USE_CLASS_TELMAILADDRESS
#  define SB_USE_CLASS_TELMESSAGEPART
#  define SB_USE_CLASS_TELMULTIPARTLIST
#  define SB_USE_CLASS_TELPLAINTEXTPART
#  define SB_USE_CLASS_TELMESSAGEPARTHANDLER
#  define SB_USE_CLASS_TELCONVERTER
#  define SB_USE_CLASS_TELREGISTEREDMESSAGEPARTHANDLERS
#  define SB_USE_CLASS_TELXMLPART
#endif /* SB_USE_UNIT_MIME */

#ifdef SB_USE_UNIT_MIMEENC
#  define SB_USE_GLOBAL_PROCS_MIMEENC
#  define SB_USE_CLASS_TELMIMEENCODINGSTREAM
#  define SB_USE_CLASS_TELBASE64STREAM
#  define SB_USE_CLASS_TELQUOTEDPRINTABLESTREAM
#  define SB_USE_CLASS_TEL7BITSTREAM
#  define SB_USE_CLASS_TEL8BITSTREAM
#  define SB_USE_CLASS_TELBINARYSTREAM
#endif /* SB_USE_UNIT_MIMEENC */

#ifdef SB_USE_UNIT_MIMESTREAM
#  define SB_USE_GLOBAL_PROCS_MIMESTREAM
#  define SB_USE_CLASS_TELCUSTOMMIMESTREAM
#  define SB_USE_CLASS_TNULLMIMESTREAM
#  define SB_USE_CLASS_TELCUSTOMMEMORYMIMESTREAM
#  define SB_USE_CLASS_TELMEMORYMIMESTREAM
#  define SB_USE_CLASS_TANSISTRINGMIMESTREAM
#  define SB_USE_CLASS_TWIDESTRINGMIMESTREAM
#endif /* SB_USE_UNIT_MIMESTREAM */

#ifdef SB_USE_UNIT_SIMPLEMIME
#  define SB_USE_CLASS_TELSIMPLEMIMEATTACHMENT
#  define SB_USE_CLASS_TELSIMPLEMIMEMESSAGE
#endif /* SB_USE_UNIT_SIMPLEMIME */

#ifdef SB_USE_UNIT_COMPOUNDFILE
#  define SB_USE_GLOBAL_PROCS_COMPOUNDFILE
#  define SB_USE_CLASS_TELCOMPOUNDFILESTORAGE
#  define SB_USE_CLASS_TELCOMPOUNDFILECUSTOMENTRY
#  define SB_USE_CLASS_TELCOMPOUNDFILESTORAGEENTRY
#  define SB_USE_CLASS_TELCOMPOUNDFILEVIRTUALSTREAM
#  define SB_USE_CLASS_TELCOMPOUNDFILETABLESTREAM
#  define SB_USE_CLASS_TELCOMPOUNDFILEDIRECTORYSTREAM
#  define SB_USE_CLASS_TELCOMPOUNDFILESTREAMENTRY
#endif /* SB_USE_UNIT_COMPOUNDFILE */

#ifdef SB_USE_UNIT_OFFICE
#  define SB_USE_GLOBAL_PROCS_OFFICE
#  define SB_USE_CLASS_TELOFFICEOPENXMLSIGNATUREVIEW
#  define SB_USE_CLASS_TELOFFICECUSTOMSECURITYHANDLER
#  define SB_USE_CLASS_TELOFFICECUSTOMENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOFFICEBINARYCUSTOMENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOPENOFFICECUSTOMENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOFFICECUSTOMSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEBINARYCUSTOMSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEBINARYUNSUPPORTEDSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEBINARYINVALIDSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEOPENXMLUNSUPPORTEDSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEOPENXMLINVALIDSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOPENOFFICECUSTOMSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOPENOFFICEUNSUPPORTEDSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOPENOFFICEINVALIDSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEBINARYDOCUMENT
#  define SB_USE_CLASS_TELOFFICEOPENXMLPACKAGE
#  define SB_USE_CLASS_TELOFFICEOPENXMLSIGNATURELINE
#  define SB_USE_CLASS_TELOFFICEOPENXMLDOCUMENT
#  define SB_USE_CLASS_TELOFFICEOPENXPSSIGNATUREDEFINITION
#  define SB_USE_CLASS_TELOFFICEOPENXPSPAGECONTENT
#  define SB_USE_CLASS_TELOFFICEOPENXPSFIXEDDOCUMENT
#  define SB_USE_CLASS_TELOFFICEOPENXPSDOCUMENT
#  define SB_USE_CLASS_TELOPENOFFICEDOCUMENT
#  define SB_USE_CLASS_TELOFFICEDOCUMENT
#endif /* SB_USE_UNIT_OFFICE */

#ifdef SB_USE_UNIT_OFFICEBINARYCORE
#  define SB_USE_GLOBAL_PROCS_OFFICEBINARYCORE
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#  define SB_USE_CLASS_TELOFFICEDATASPACEVERSIONINFO
#  define SB_USE_CLASS_TELOFFICEDATASPACEREFERENCECOMPONENT
#  define SB_USE_CLASS_TELOFFICEDATASPACEMAPENTRY
#  define SB_USE_CLASS_TELOFFICEDATASPACEMAP
#  define SB_USE_CLASS_TELOFFICEDATASPACEDEFINITION
#  define SB_USE_CLASS_TELOFFICETRANSFORMINFOHEADER
#  define SB_USE_CLASS_TELOFFICEENCRYPTIONTRANSFORMINFO
#  define SB_USE_CLASS_TELOFFICEEXTENSIBILITYHEADER
#  define SB_USE_CLASS_TELOFFICEIRMDSTRANSFORMINFO
#  define SB_USE_CLASS_TELOFFICEENDUSERLICENSEHEADER
#  define SB_USE_CLASS_TELOFFICEENCRYPTIONHEADER
#  define SB_USE_CLASS_TELOFFICEENCRYPTIONVERIFIER
#  define SB_USE_CLASS_TELOFFICEENCRYPTIONINFO
#  define SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV1
#  define SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV2
#  define SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV3
#  define SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV4
#  define SB_USE_CLASS_TELOFFICEXOROBFUSCATION
#  define SB_USE_CLASS_TELOFFICEENCRYPTEDSTREAMDESCRIPTOR
#  define SB_USE_CLASS_TELOFFICECERTIFICATEINFO
#  define SB_USE_CLASS_TELOFFICECERTSTORECERTIFICATEGROUP
#  define SB_USE_CLASS_TELOFFICEDOCSIGSERIALIZEDCERTSTORE
#  define SB_USE_CLASS_TELOFFICECRYPTOAPIDIGITALSIGNATURE
#  define SB_USE_CLASS_TELOFFICEWORDFIBBASE
#  define SB_USE_CLASS_TELOFFICEWORDFIBRGFCLCB
#  define SB_USE_CLASS_TELOFFICEWORDFIB
#  define SB_USE_CLASS_TELOFFICEWORKBOOKRECORDINFO
#  define SB_USE_CLASS_TELOFFICEWORKBOOKBOF
#  define SB_USE_CLASS_TELOFFICEWORKBOOKFILEPASS
#  define SB_USE_CLASS_TELOFFICEPOWERPOINTRECORDHEADER
#  define SB_USE_CLASS_TELOFFICEPOWERPOINTUSEREDITATOM
#  define SB_USE_CLASS_TELOFFICEPOWERPOINTPERSISTDIRECTORYENTRY
#  define SB_USE_CLASS_TELOFFICEPOWERPOINTPERSISTDIRECTORYATOM
#endif /* SB_USE_UNIT_OFFICEBINARYCORE */

#ifdef SB_USE_UNIT_OFFICECOMMON
#endif /* SB_USE_UNIT_OFFICECOMMON */

#ifdef SB_USE_UNIT_OFFICEPACKAGE
#  define SB_USE_CLASS_TELOFFICEPACKAGEPART
#  define SB_USE_CLASS_TELOFFICEPACKAGE
#  define SB_USE_CLASS_TELOFFICEZIPPACKAGE
#  define SB_USE_CLASS_TELOPENOFFICEPACKAGE
#endif /* SB_USE_UNIT_OFFICEPACKAGE */

#ifdef SB_USE_UNIT_OFFICESECURITY
#  define SB_USE_GLOBAL_PROCS_OFFICESECURITY
#  define SB_USE_CLASS_TELOFFICEOPENXMLSTANDARDENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOFFICEOPENXMLAGILEENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOFFICEOPENXMLKEYENCRYPTOR
#  define SB_USE_CLASS_TELOFFICEOPENXMLPASSWORDKEYENCRYPTOR
#  define SB_USE_CLASS_TELOPENOFFICEENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOFFICEBINARYRC4ENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOFFICEBINARYRC4CRYPTOAPIENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOFFICEBINARYCRYPTOAPISIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEBINARYSIGNEDENTRY
#  define SB_USE_CLASS_TELOFFICEBINARYXMLSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEOPENXMLSIGNEDPART
#  define SB_USE_CLASS_TELOFFICEOPENXMLSIGNEDRELATIONSHIPPART
#  define SB_USE_CLASS_TELOFFICEOPENXMLBASESIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEOPENXMLSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEOPENXPSSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOPENOFFICESIGNEDENTRY
#  define SB_USE_CLASS_TELOPENOFFICESIGNATUREHANDLER
#endif /* SB_USE_UNIT_OFFICESECURITY */

#ifdef SB_USE_UNIT_OFFICEXMLCORE
#  define SB_USE_GLOBAL_PROCS_OFFICEXMLCORE
#  define SB_USE_CLASS_TELOFFICEOPENXMLELEMENT
#  define SB_USE_CLASS_TELOFFICEOPENXMLRELATIONSHIP
#  define SB_USE_CLASS_TELOFFICEOPENXMLRELATIONSHIPS
#  define SB_USE_CLASS_TELOFFICEOPENXMLDEFAULT
#  define SB_USE_CLASS_TELOFFICEOPENXMLDEFAULTLIST
#  define SB_USE_CLASS_TELOFFICEOPENXMLOVERRIDE
#  define SB_USE_CLASS_TELOFFICEOPENXMLOVERRIDELIST
#  define SB_USE_CLASS_TELOFFICEOPENXMLCONTENTTYPES
#  define SB_USE_CLASS_TELOFFICEXMLDCSIMPLELITERAL
#  define SB_USE_CLASS_TELOFFICEXMLDCDATE
#  define SB_USE_CLASS_TELOFFICEOPENXMLCOREPROPERTIES
#  define SB_USE_CLASS_TELOFFICEXMLKEYDATA
#  define SB_USE_CLASS_TELOFFICEXMLDATAINTEGRITY
#  define SB_USE_CLASS_TELOFFICEXMLKEYENCRYPTOR
#  define SB_USE_CLASS_TELOFFICEXMLKEYENCRYPTORS
#  define SB_USE_CLASS_TELOFFICEXMLPASSWORDKEYENCRYPTOR
#  define SB_USE_CLASS_TELOFFICEXMLENCRYPTION
#  define SB_USE_CLASS_TELOFFICEXMLSIGNATURETIME
#  define SB_USE_CLASS_TELOFFICEOPENXMLRELATIONSHIPTRANSFORM
#  define SB_USE_CLASS_TELOFFICEXMLSIGNATUREINFOV1
#  define SB_USE_CLASS_TELOFFICEXMLSPOTLOCATION
#  define SB_USE_CLASS_TELOFFICEXMLSIGNATUREDEFINITION
#  define SB_USE_CLASS_TELOFFICEXMLFIXEDDOCUMENTSEQUENCE
#  define SB_USE_CLASS_TELOFFICEXMLPAGECONTENT
#  define SB_USE_CLASS_TELOFFICEXMLFIXEDDOCUMENT
#  define SB_USE_CLASS_TELOPENOFFICEXMLMANIFESTALGORITHM
#  define SB_USE_CLASS_TELOPENOFFICEXMLMANIFESTKEYDERIVATION
#  define SB_USE_CLASS_TELOPENOFFICEXMLMANIFESTSTARTKEYGENERATION
#  define SB_USE_CLASS_TELOPENOFFICEXMLMANIFESTENCRYPTIONDATA
#  define SB_USE_CLASS_TELOPENOFFICEXMLMANIFESTFILEENTRY
#  define SB_USE_CLASS_TELOPENOFFICEXMLMANIFEST
#endif /* SB_USE_UNIT_OFFICEXMLCORE */

#ifdef SB_USE_UNIT_PDF
#  define SB_USE_GLOBAL_PROCS_PDF
#  define SB_USE_CLASS_TELPDFDOCUMENT
#  define SB_USE_CLASS_TELPDFURPROPERTIES
#  define SB_USE_CLASS_TELPDFSIGREFENTRY
#  define SB_USE_CLASS_TELPDFSECURITYHANDLER
#  define SB_USE_CLASS_TELPDFBYTERANGE
#  define SB_USE_CLASS_TELPDFIMAGE
#  define SB_USE_CLASS_TELPDFCUSTOMFONTOBJECT
#  define SB_USE_CLASS_TELPDFENCODING
#  define SB_USE_CLASS_TELPDFFONTDESCRIPTOR
#  define SB_USE_CLASS_TELPDFCIDFONTDESCRIPTOR
#  define SB_USE_CLASS_TELPDFCIDSYSTEMINFO
#  define SB_USE_CLASS_TELPDFCUSTOMFONT
#  define SB_USE_CLASS_TELPDFSIMPLEFONT
#  define SB_USE_CLASS_TELPDFCOMPOSITEFONT
#  define SB_USE_CLASS_TELPDFMETRICW
#  define SB_USE_CLASS_TELPDFMETRICW2
#  define SB_USE_CLASS_TELPDFCIDFONT
#  define SB_USE_CLASS_TELPDFSIGNATUREWIDGETTEXT
#  define SB_USE_CLASS_TELPDFSIGNATUREWIDGETTEXTLIST
#  define SB_USE_CLASS_TELPDFSIGNATUREWIDGETPROPS
#  define SB_USE_CLASS_TELPDFSIGNATURE
#  define SB_USE_CLASS_TELPDFSIGNATUREINFO
#  define SB_USE_CLASS_TELPDFENCODINGHANDLER
#  define SB_USE_CLASS_TELPDFREQUIREMENTHANDLER
#  define SB_USE_CLASS_TELPDFREQUIREMENT
#  define SB_USE_CLASS_TELPDFPAGEINFO
#  define SB_USE_CLASS_TELPDFFILEATTACHMENT
#  define SB_USE_CLASS_TELPDFLEGALCONTENTATTESTATION
#endif /* SB_USE_UNIT_PDF */

#ifdef SB_USE_UNIT_PDFCORE
#  define SB_USE_GLOBAL_PROCS_PDFCORE
#  define SB_USE_CLASS_TELPDFOBJECT
#  define SB_USE_CLASS_TELPDFFILE
#  define SB_USE_CLASS_TELPDFNULL
#  define SB_USE_CLASS_TELPDFBOOLEAN
#  define SB_USE_CLASS_TELPDFREAL
#  define SB_USE_CLASS_TELPDFSTRING
#  define SB_USE_CLASS_TELPDFCOMMENT
#  define SB_USE_CLASS_TELPDFNAME
#  define SB_USE_CLASS_TELPDFCPXOBJ
#  define SB_USE_CLASS_TELPDFARRAY
#  define SB_USE_CLASS_TELPDFDICTIONARY
#  define SB_USE_CLASS_TELPDFSTREAM
#  define SB_USE_CLASS_TELPDFINDIRECT
#  define SB_USE_CLASS_TELPDFREF
#  define SB_USE_CLASS_TELPDFXREF
#  define SB_USE_CLASS_TELPDFXREFENTRY
#  define SB_USE_CLASS_TELPDFXREFS
#endif /* SB_USE_UNIT_PDFCORE */

#ifdef SB_USE_UNIT_PDFSECURITY
#  define SB_USE_GLOBAL_PROCS_PDFSECURITY
#  define SB_USE_CLASS_TELPDFPASSWORDSECURITYHANDLER
#  define SB_USE_CLASS_TELPDFPUBLICKEYSECURITYHANDLER
#  define SB_USE_CLASS_TELPDFPUBLICKEYRECIPIENTGROUP
#  define SB_USE_CLASS_TELPDFPUBLICKEYREVOCATIONINFO
#endif /* SB_USE_UNIT_PDFSECURITY */

#ifdef SB_USE_UNIT_PDFUTILS
#  define SB_USE_GLOBAL_PROCS_PDFUTILS
#  define SB_USE_CLASS_TELPDFPERMISSIONS
#endif /* SB_USE_UNIT_PDFUTILS */

#ifdef SB_USE_UNIT_PADES
#  define SB_USE_GLOBAL_PROCS_PADES
#  define SB_USE_CLASS_TELPDFADVANCEDPUBLICKEYSECURITYHANDLER
#endif /* SB_USE_UNIT_PADES */

#ifdef SB_USE_UNIT_PGP
#  define SB_USE_GLOBAL_PROCS_PGP
#  define SB_USE_CLASS_TELPGPWRITER
#  define SB_USE_CLASS_TELPGPPROCESSINGUNIT
#  define SB_USE_CLASS_TELPGPREADER
#endif /* SB_USE_UNIT_PGP */

#ifdef SB_USE_UNIT_PGPENTITIES
#  define SB_USE_GLOBAL_PROCS_PGPENTITIES
#  define SB_USE_CLASS_TELPGPENTITY
#  define SB_USE_CLASS_TELPGPPUBLICKEYENTITY
#  define SB_USE_CLASS_TELPGPS2K
#  define SB_USE_CLASS_TELPGPUSERIDENTITY
#  define SB_USE_CLASS_TELPGPUSERATTRSUBPACKET
#  define SB_USE_CLASS_TELPGPUSERATTRIMAGESUBPACKET
#  define SB_USE_CLASS_TELPGPUSERATTRENTITY
#  define SB_USE_CLASS_TELPGPSIGNATUREENTITY
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPCREATIONTIMESIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPEXPIRATIONTIMESIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPEMBEDDEDSIGNATURESIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPEXPORTABLECERTIFICATIONSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPTRUSTSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPREGULAREXPRESSIONSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPREVOCABLESIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPKEYEXPIRATIONTIMESIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPPREFERREDSYMMETRICALGORITHMSSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPREVOCATIONKEYSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPISSUERKEYIDSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPNOTATIONDATASIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPPREFERREDHASHALGORITHMSSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPPREFERREDCOMPRESSIONALGORITHMSSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPKEYSERVERPREFERENCESSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPPREFERREDKEYSERVERSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPPRIMARYUSERIDSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPPOLICYURLSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPKEYFLAGSSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNERSUSERIDSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPREASONFORREVOCATIONSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPFEATURESSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPTARGETSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPX509SIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKETS
#  define SB_USE_CLASS_TELPGPTRUSTENTITY
#  define SB_USE_CLASS_TELPGPPUBLICKEYENCRYPTEDSESSIONKEYENTITY
#  define SB_USE_CLASS_TELPGPSYMMETRICKEYENCRYPTEDSESSIONKEYENTITY
#  define SB_USE_CLASS_TELPGPONEPASSSIGNATUREENTITY
#  define SB_USE_CLASS_TELPGPSECRETKEYENTITY
#  define SB_USE_CLASS_TELPGPSTREAMINGENTITY
#  define SB_USE_CLASS_TELPGPLITERAL
#  define SB_USE_CLASS_TELPGPSYMMETRICALLYENCRYPTED
#  define SB_USE_CLASS_TELPGPCOMPRESSED
#  define SB_USE_CLASS_TELPGPSTREAMPROCESSOR
#  define SB_USE_CLASS_TELPGPSTUBENTITY
#  define SB_USE_CLASS_TELPGPSTREAMIO
#endif /* SB_USE_UNIT_PGPENTITIES */

#ifdef SB_USE_UNIT_PGPEXCEPTIONS
#endif /* SB_USE_UNIT_PGPEXCEPTIONS */

#ifdef SB_USE_UNIT_PGPKEYS
#  define SB_USE_GLOBAL_PROCS_PGPKEYS
#  define SB_USE_CLASS_TELPGPCUSTOMPUBLICKEY
#  define SB_USE_CLASS_TELPGPPUBLICSUBKEY
#  define SB_USE_CLASS_TELPGPPUBLICKEY
#  define SB_USE_CLASS_TELPGPCUSTOMSECRETKEY
#  define SB_USE_CLASS_TELPGPSECRETSUBKEY
#  define SB_USE_CLASS_TELPGPSECRETKEY
#  define SB_USE_CLASS_TELPGPTRUST
#  define SB_USE_CLASS_TELPGPSIGNATURE
#  define SB_USE_CLASS_TELPGPCUSTOMUSER
#  define SB_USE_CLASS_TELPGPUSERID
#  define SB_USE_CLASS_TELPGPUSERATTR
#  define SB_USE_CLASS_TELPGPKEYRING
#  define SB_USE_CLASS_TELPGPJPEGIMAGE
#endif /* SB_USE_UNIT_PGPKEYS */

#ifdef SB_USE_UNIT_PGPMD
#  define SB_USE_GLOBAL_PROCS_PGPMD
#  define SB_USE_CLASS_TELPGPHASHINGPOOL
#endif /* SB_USE_UNIT_PGPMD */

#ifdef SB_USE_UNIT_PGPSTREAMS
#  define SB_USE_CLASS_TELPGPSTREAM
#  define SB_USE_CLASS_TELPGPARMORINGSTREAM
#  define SB_USE_CLASS_TELPGPDEARMORINGSTREAM
#  define SB_USE_CLASS_TELPGPENVELOPINGSTREAM
#  define SB_USE_CLASS_TELPGPUNENVELOPINGSTREAM
#  define SB_USE_CLASS_TELPGPENCRYPTINGSTREAM
#  define SB_USE_CLASS_TELPGPDECRYPTINGSTREAM
#  define SB_USE_CLASS_TELPGPCOMPRESSINGSTREAM
#  define SB_USE_CLASS_TELPGPDECOMPRESSINGSTREAM
#  define SB_USE_CLASS_TELPGPSIGNINGSTREAM
#  define SB_USE_CLASS_TELPGPCLEARTEXTVERIFYINGSTREAM
#  define SB_USE_CLASS_TELPGPENTITYSTREAM
#endif /* SB_USE_UNIT_PGPSTREAMS */

#ifdef SB_USE_UNIT_PGPUTILS
#  define SB_USE_GLOBAL_PROCS_PGPUTILS
#endif /* SB_USE_UNIT_PGPUTILS */

#ifndef SB_WINCE_OR_NOT_WINDOWS
#ifdef SB_USE_UNIT_PGPSFX
#  define SB_USE_GLOBAL_PROCS_PGPSFX
#  define SB_USE_CLASS_TELPGPSFXSTUB
#  define SB_USE_CLASS_TELPGPSFXMAKER
#endif /* SB_USE_UNIT_PGPSFX */
#endif

#ifdef SB_USE_UNIT_LDAPSKEYSERVERCLIENT
#  define SB_USE_GLOBAL_PROCS_LDAPSKEYSERVERCLIENT
#  define SB_USE_CLASS_TELLDAPSKEYSERVERSEARCHFILTER
#  define SB_USE_CLASS_TELLDAPSKEYSERVERCLIENT
#endif /* SB_USE_UNIT_LDAPSKEYSERVERCLIENT */

#ifdef SB_USE_UNIT_PGPMIME
#  define SB_USE_GLOBAL_PROCS_PGPMIME
#  define SB_USE_CLASS_TELMESSAGEPARTHANDLERPGPMIME
#  define SB_USE_CLASS_TELMESSAGEPARTHANDLERPGPKEYS
#  define SB_USE_CLASS_TELSIMPLEPGPMIMEOPTIONS
#  define SB_USE_CLASS_TELSIMPLEPGPMIMEMESSAGE
#endif /* SB_USE_UNIT_PGPMIME */

#ifdef SB_USE_UNIT_PGPSSH
#  define SB_USE_CLASS_TELSSHPGPKEY
#  define SB_USE_CLASS_TELSSHPGPAUTHHANDLER
#endif /* SB_USE_UNIT_PGPSSH */

#ifdef SB_USE_UNIT_PGPTLS
#  define SB_USE_CLASS_TELSSLPGPCERTIFICATETYPEHANDLER
#  define SB_USE_CLASS_TELSSLCLIENTPGPCERTIFICATETYPEHANDLER
#  define SB_USE_CLASS_TELSSLSERVERPGPCERTIFICATETYPEHANDLER
#endif /* SB_USE_UNIT_PGPTLS */

#ifdef SB_USE_UNIT_CMS
#  define SB_USE_GLOBAL_PROCS_CMS
#  define SB_USE_CLASS_TELASN1DIRECTORYSTRING
#  define SB_USE_CLASS_TELCMSPROPERTY
#  define SB_USE_CLASS_TELCMSHASH
#  define SB_USE_CLASS_TELCMSSIGNERIDENTIFIER
#  define SB_USE_CLASS_TELCMSCERTIFICATEREFS
#  define SB_USE_CLASS_TELCMSCRLIDENTIFIER
#  define SB_USE_CLASS_TELCMSCRLVALIDATEDID
#  define SB_USE_CLASS_TELCMSOCSPIDENTIFIER
#  define SB_USE_CLASS_TELCMSOCSPRESPONSESID
#  define SB_USE_CLASS_TELCMSREVOCATIONREF
#  define SB_USE_CLASS_TELCMSREVOCATIONREFS
#  define SB_USE_CLASS_TELCMSREVOCATIONVALUES
#  define SB_USE_CLASS_TELCMSCONTENT
#  define SB_USE_CLASS_TELCMSSIGPOLICYQUALIFIER
#  define SB_USE_CLASS_TELCMSSIGNATUREPOLICY
#  define SB_USE_CLASS_TELCMSCONTENTHINTS
#  define SB_USE_CLASS_TELCMSCONTENTREFERENCE
#  define SB_USE_CLASS_TELCMSCOMMITMENTTYPEINDICATION
#  define SB_USE_CLASS_TELCMSSIGNERLOCATION
#  define SB_USE_CLASS_TELCMSSIGNINGCERTIFICATE
#  define SB_USE_CLASS_TELCMSSIGNERATTRIBUTES
#  define SB_USE_CLASS_TELCMSSIGNATUREPOLICYSTORE
#  define SB_USE_CLASS_TELCMSSIGNATURE
#  define SB_USE_CLASS_TELCMSTIMESTAMP
#  define SB_USE_CLASS_TELATSHASHINDEXPROCESSOR
#  define SB_USE_CLASS_TELCMSMESSAGE
#  define SB_USE_CLASS_TELCMSCONTENTHASH
#  define SB_USE_CLASS_TELSIGNEDCMSMESSAGE
#  define SB_USE_CLASS_TELSIGNEDANDENVELOPEDCMSMESSAGE
#endif /* SB_USE_UNIT_CMS */

#ifdef SB_USE_UNIT_CRYPTOPROVPKCS11
#  define SB_USE_GLOBAL_PROCS_CRYPTOPROVPKCS11
#  define SB_USE_CLASS_TELPKCS11CRYPTOPROVIDEROPTIONS
#  define SB_USE_CLASS_TELPKCS11CRYPTOPROVIDER
#  define SB_USE_CLASS_TELPKCS11CRYPTOKEY
#  define SB_USE_CLASS_TELPKCS11CRYPTOCONTEXT
#  define SB_USE_CLASS_TELPKCS11ECPARAMSDIRECTORY
#endif /* SB_USE_UNIT_CRYPTOPROVPKCS11 */

#ifdef SB_USE_UNIT_PKCS11BASE
#  define SB_USE_GLOBAL_PROCS_PKCS11BASE
#  define SB_USE_CLASS_TELPKCS11MODULE
#  define SB_USE_CLASS_TELPKCS11SLOTINFO
#  define SB_USE_CLASS_TELPKCS11SESSIONINFO
#ifdef SB_IOS
#  define SB_USE_CLASS_TELPKCS11FUNCTIONSMANAGER
#endif
#  define SB_USE_CLASS_TELPKCS11CONSUMER
#  define SB_USE_CLASS_TELPKCS11ATTRIBUTELIST
#  define SB_USE_CLASS_TELPKCS11OBJECT
#  define SB_USE_CLASS_TELPKCS11DATAOBJECT
#  define SB_USE_CLASS_TELPKCS11CERTIFICATEOBJECT
#  define SB_USE_CLASS_TELPKCS11X509CERTIFICATEOBJECT
#  define SB_USE_CLASS_TELPKCS11WTLSCERTIFICATEOBJECT
#  define SB_USE_CLASS_TELPKCS11X509ATTRIBUTECERTIFICATEOBJECT
#  define SB_USE_CLASS_TELPKCS11KEYOBJECT
#  define SB_USE_CLASS_TELPKCS11PUBLICKEYOBJECT
#  define SB_USE_CLASS_TELPKCS11PRIVATEKEYOBJECT
#  define SB_USE_CLASS_TELPKCS11SECRETKEYOBJECT
#  define SB_USE_CLASS_TELPKCS11DOMAINPARAMETERSOBJECT
#  define SB_USE_CLASS_TELPKCS11UTILS
#  define SB_USE_CLASS_TELPKCS11NSSPARAMS
#  define SB_USE_CLASS_TELPKCS11MODULELIST
#  define SB_USE_CLASS_TELPKCS11ALGORITHMINFO
#  define SB_USE_CLASS_TELPKCS11ALGORITHMCONVERTER
#  define SB_USE_CLASS_TELSLOTEVENTMONITORINGTHREAD
#endif /* SB_USE_UNIT_PKCS11BASE */

#ifdef SB_USE_UNIT_PKCS11MANAGER
#  define SB_USE_GLOBAL_PROCS_PKCS11MANAGER
#  define SB_USE_CLASS_TELPKCS11MANAGER
#  define SB_USE_CLASS_TELPKCS11MANAGEROBJECT
#  define SB_USE_CLASS_TELPKCS11MANAGERDATAOBJECT
#  define SB_USE_CLASS_TELPKCS11MANAGERCERTIFICATEOBJECT
#  define SB_USE_CLASS_TELPKCS11MANAGERKEYOBJECT
#  define SB_USE_CLASS_TELPKCS11MANAGERPUBLICKEYOBJECT
#  define SB_USE_CLASS_TELPKCS11MANAGERPRIVATEKEYOBJECT
#  define SB_USE_CLASS_TELPKCS11MANAGERSECRETKEYOBJECT
#  define SB_USE_CLASS_TELPKCS11CONSUMERMANAGER
#endif /* SB_USE_UNIT_PKCS11MANAGER */

#ifdef SB_USE_UNIT_PKCS11CERTSTORAGE
#  define SB_USE_GLOBAL_PROCS_PKCS11CERTSTORAGE
#  define SB_USE_CLASS_TELPKCS11CERTSTORAGE
#  define SB_USE_CLASS_TELPKCS11STGCTX
#  define SB_USE_CLASS_TELPKCS11CONSUMERCERTSTORAGE
#endif /* SB_USE_UNIT_PKCS11CERTSTORAGE */

#ifdef SB_USE_UNIT_PKCS10
#  define SB_USE_GLOBAL_PROCS_PKCS10
#  define SB_USE_CLASS_TELCERTIFICATEREQUEST
#endif /* SB_USE_UNIT_PKCS10 */

#ifdef SB_USE_UNIT_OCSPSERVER
#  define SB_USE_GLOBAL_PROCS_OCSPSERVER
#  define SB_USE_CLASS_TELOCSPSERVER
#endif /* SB_USE_UNIT_OCSPSERVER */

#ifdef SB_USE_UNIT_TSPSERVER
#  define SB_USE_GLOBAL_PROCS_TSPSERVER
#  define SB_USE_CLASS_TELSERVERTSPINFO
#  define SB_USE_CLASS_TELCUSTOMTSPSERVER
#  define SB_USE_CLASS_TELFILETSPSERVER
#endif /* SB_USE_UNIT_TSPSERVER */

#ifdef SB_USE_UNIT_AUTHENTICODE
#  define SB_USE_GLOBAL_PROCS_AUTHENTICODE
#  define SB_USE_CLASS_TELAUTHENTICODEPROCESSOR
#  define SB_USE_CLASS_TELAUTHENTICODESIGNER
#  define SB_USE_CLASS_TELAUTHENTICODEVERIFIER
#endif /* SB_USE_UNIT_AUTHENTICODE */

#ifdef SB_USE_UNIT_CRLEX
#  define SB_USE_CLASS_TELCERTIFICATEREVOCATIONLISTEX
#endif /* SB_USE_UNIT_CRLEX */

#ifdef SB_USE_UNIT_X509EX
#  define SB_USE_GLOBAL_PROCS_X509EX
#  define SB_USE_CLASS_TELX509CERTIFICATEEX
#endif /* SB_USE_UNIT_X509EX */

#ifdef SB_USE_UNIT_SSHPKCS11KEYSTORAGE
#  define SB_USE_GLOBAL_PROCS_SSHPKCS11KEYSTORAGE
#  define SB_USE_CLASS_TELSSHPKCS11KEYSTORAGE
#  define SB_USE_CLASS_TELSSHPKCS11CONSUMERKEYSTORAGE
#  define SB_USE_CLASS_TELPKCS11SSHKEY
#endif /* SB_USE_UNIT_SSHPKCS11KEYSTORAGE */

#ifdef SB_USE_UNIT_CADES
#  define SB_USE_CLASS_TELCADESREVOCATIONINFO
#  define SB_USE_CLASS_TELCADESSIGNATUREPROCESSOR
#endif /* SB_USE_UNIT_CADES */

#ifdef SB_USE_UNIT_CMC
#  define SB_USE_CLASS_TELATTRIBUTEVALUE
#  define SB_USE_CLASS_TELTAGGEDATTRIBUTE
#  define SB_USE_CLASS_TELTAGGEDCERTIFICATIONREQUEST
#  define SB_USE_CLASS_TELEXTERNALLYDEFINEDCERTIFICATIONREQUEST
#  define SB_USE_CLASS_TELTAGGEDREQUEST
#  define SB_USE_CLASS_TELCONTENTINFO
#  define SB_USE_CLASS_TELTAGGEDCONTENTINFO
#  define SB_USE_CLASS_TELOTHERMSG
#  define SB_USE_CLASS_TELPKIDATA
#  define SB_USE_CLASS_TELPKIRESPONSE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#  define SB_USE_CLASS_TELIDENTIFICATIONATTRIBUTE
#  define SB_USE_CLASS_TELPENDINFO
#  define SB_USE_CLASS_TELCMCSTATUSINFOATTRIBUTE
#  define SB_USE_CLASS_TELBODYPARTREFERENCE
#  define SB_USE_CLASS_TELBODYPARTID
#  define SB_USE_CLASS_TELBODYPARTPATH
#  define SB_USE_CLASS_TELEXTENDEDFAILINFO
#  define SB_USE_CLASS_TELCMCSTATUSINFOV2ATTRIBUTE
#  define SB_USE_CLASS_TELADDEXTENSIONSATTRIBUTE
#  define SB_USE_CLASS_TELIDENTITYPROOFV2ATTRIBUTE
#  define SB_USE_CLASS_TELIDENTITYPROOFATTRIBUTE
#  define SB_USE_CLASS_TELPOPLINKWITNESSV2ATTRIBUTE
#  define SB_USE_CLASS_TELPOPLINKWITNESSATTRIBUTE
#  define SB_USE_CLASS_TELDATARETURNATTRIBUTE
#  define SB_USE_CLASS_TELTRANSACTIONIDENTIFIERATTRIBUTE
#  define SB_USE_CLASS_TELSENDERNONCEATTRIBUTE
#  define SB_USE_CLASS_TELRECIPIENTNONCEATTRIBUTE
#  define SB_USE_CLASS_TELENCRYPTEDPOPATTRIBUTE
#  define SB_USE_CLASS_TELDECRYPTEDPOPATTRIBUTE
#  define SB_USE_CLASS_TELLRAPOPWITNESSATTRIBUTE
#  define SB_USE_CLASS_TELGETCERTIFICATEATTRIBUTE
#  define SB_USE_CLASS_TELGETCRLATTRIBUTE
#  define SB_USE_CLASS_TELREVOCATIONREQUESTATTRIBUTE
#  define SB_USE_CLASS_TELREGISTRATIONINFORMATIONATTRIBUTE
#  define SB_USE_CLASS_TELRESPONSEINFORMATIONATTRIBUTE
#  define SB_USE_CLASS_TELQUERYPENDINGATTRIBUTE
#  define SB_USE_CLASS_TELCONFIRMCERTACCEPTANCEATTRIBUTE
#  define SB_USE_CLASS_TELPUBLISHTRUSTANCHORSATTRIBUTE
#  define SB_USE_CLASS_TELAUTHENTICATEDDATAATTRIBUTE
#  define SB_USE_CLASS_TELBATCHREQUESTSATTRIBUTE
#  define SB_USE_CLASS_TELBATCHRESPONSESATTRIBUTE
#  define SB_USE_CLASS_TELPOPLINKRANDOMATTRIBUTE
#  define SB_USE_CLASS_TELSINGLEPUBINFO
#  define SB_USE_CLASS_TELPKIPUBLICATIONINFO
#  define SB_USE_CLASS_TELPUBLICATIONINFORMATIONATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLPROCESSEDATTRIBUTE
#  define SB_USE_CLASS_TELOPTIONALVALIDITY
#  define SB_USE_CLASS_TELPUBLICKEYINFO
#  define SB_USE_CLASS_TELCERTTEMPLATE
#  define SB_USE_CLASS_TELMODCERTIFICATIONREQUESTATTRIBUTE
#  define SB_USE_CLASS_TELFULLPKIREQUEST
#  define SB_USE_CLASS_TELFULLPKIRESPONSE
#endif /* SB_USE_UNIT_CMC */

#ifdef SB_USE_UNIT_OTPCOMMON
#  define SB_USE_CLASS_TELOTPCLASS
#  define SB_USE_CLASS_TELHOTPPASSWORDGENERATOR
#  define SB_USE_CLASS_TELTOTPPASSWORDGENERATOR
#endif /* SB_USE_UNIT_OTPCOMMON */

#ifdef SB_USE_UNIT_OTPCLIENT
#  define SB_USE_CLASS_TELOTPCLIENT
#  define SB_USE_CLASS_TELHOTPCLIENT
#  define SB_USE_CLASS_TELTOTPCLIENT
#endif /* SB_USE_UNIT_OTPCLIENT */

#ifdef SB_USE_UNIT_OTPSERVER
#  define SB_USE_CLASS_TELOTPUSER
#  define SB_USE_CLASS_TELHOTPUSER
#  define SB_USE_CLASS_TELTOTPUSER
#  define SB_USE_CLASS_TELOTPUSERFACTORY
#  define SB_USE_CLASS_TELOTPUSERSTORAGE
#  define SB_USE_CLASS_TELOTPSERVER
#  define SB_USE_CLASS_TELHOTPSERVER
#  define SB_USE_CLASS_TELTOTPSERVER
#endif /* SB_USE_UNIT_OTPSERVER */

#ifdef SB_USE_UNIT_ECIESCRYPTO
#  define SB_USE_CLASS_TELECIESCRYPTO
#endif /* SB_USE_UNIT_ECIESCRYPTO */

#ifdef SB_USE_UNIT_SFTP
#  define SB_USE_GLOBAL_PROCS_SFTP
#  define SB_USE_CLASS_TELSFTPSTREAM
#  define SB_USE_CLASS_TELSFTPCLIENT
#endif /* SB_USE_UNIT_SFTP */

#ifdef SB_USE_UNIT_SFTPCOMMON
#  define SB_USE_GLOBAL_PROCS_SFTPCOMMON
#  define SB_USE_CLASS_TSBSFTPEXTENDEDATTRIBUTE
#  define SB_USE_CLASS_TELSFTPEXTENDEDREPLY
#  define SB_USE_CLASS_TELSFTPNEWLINEEXTENSION
#  define SB_USE_CLASS_TELSFTPVERSIONSEXTENSION
#  define SB_USE_CLASS_TELSFTPFILENAMETRANSLATIONEXTENSION
#  define SB_USE_CLASS_TELSFTPFILENAMECHARSETEXTENSION
#  define SB_USE_CLASS_TELSFTPVERSIONSELECTEXTENSION
#  define SB_USE_CLASS_TELSFTPSUPPORTEDEXTENSION
#  define SB_USE_CLASS_TELSFTPVENDORIDEXTENSION
#  define SB_USE_CLASS_TELSFTPCHECKFILEEXTENSION
#  define SB_USE_CLASS_TELSFTPSTATVFSEXTENSION
#  define SB_USE_CLASS_TELSFTPSPACEAVAILABLEEXTENSION
#  define SB_USE_CLASS_TELSFTPHOMEDIRECTORYEXTENSION
#  define SB_USE_CLASS_TELSFTPCOPYFILEEXTENSION
#  define SB_USE_CLASS_TELSFTPCOPYDATAEXTENSION
#  define SB_USE_CLASS_TELSFTPCHECKFILEREPLY
#  define SB_USE_CLASS_TELSFTPSPACEAVAILABLEREPLY
#  define SB_USE_CLASS_TELSFTPSTATVFSREPLY
#  define SB_USE_CLASS_TSBSFTPACE
#  define SB_USE_CLASS_TELSFTPEXTENDEDPROPERTIES
#  define SB_USE_CLASS_TELSFTPFILEATTRIBUTES
#  define SB_USE_CLASS_TELSFTPFILEINFO
#  define SB_USE_CLASS_TSBSFTPOPENREQUESTINFO
#  define SB_USE_CLASS_TSBSFTPTEXTHANDLEINFO
#  define SB_USE_CLASS_TELSFTPTRANSFERBLOCK
#  define SB_USE_CLASS_TELSFTPTRANSFERMANAGER
#  define SB_USE_CLASS_TELSFTPREMOVALTARGET
#  define SB_USE_CLASS_TELSFTPREMOVALMANAGER
#endif /* SB_USE_UNIT_SFTPCOMMON */

#ifdef SB_USE_UNIT_SIMPLESFTP
#  define SB_USE_GLOBAL_PROCS_SIMPLESFTP
#  define SB_USE_CLASS_TELSIMPLESFTPCLIENT
#endif /* SB_USE_UNIT_SIMPLESFTP */

#ifdef SB_USE_UNIT_SFTPHANDLER
#  define SB_USE_CLASS_TELSFTPSSHSUBSYSTEMHANDLER
#endif /* SB_USE_UNIT_SFTPHANDLER */

#ifdef SB_USE_UNIT_SFTPSERVER
#  define SB_USE_GLOBAL_PROCS_SFTPSERVER
#  define SB_USE_CLASS_TSBSFTPHANDLE
#  define SB_USE_CLASS_TELSFTPSERVER
#endif /* SB_USE_UNIT_SFTPSERVER */

#ifdef SB_USE_UNIT_SIMPLESFTPSERVER
#  define SB_USE_GLOBAL_PROCS_SIMPLESFTPSERVER
#  define SB_USE_CLASS_TELSIMPLESFTPSERVER
#  define SB_USE_CLASS_TELSIMPLESSHSFTPSEARCHREC
#  define SB_USE_CLASS_TELSIMPLESFTPSERVERSESSIONTHREAD
#endif /* SB_USE_UNIT_SIMPLESFTPSERVER */

#ifdef SB_USE_UNIT_SMIMECORE
#  define SB_USE_GLOBAL_PROCS_SMIMECORE
#  define SB_USE_CLASS_TELMESSAGEPARTHANDLERSMIME
#  define SB_USE_CLASS_TELSIMPLESMIMEMESSAGE
#  define SB_USE_CLASS_TELSIMPLESMIMEOPTIONS
#endif /* SB_USE_UNIT_SMIMECORE */

#ifdef SB_USE_UNIT_SMIMECADES
#  define SB_USE_CLASS_TELMESSAGEPARTHANDLERSMIMECADES
#endif /* SB_USE_UNIT_SMIMECADES */

#ifdef SB_USE_UNIT_SSHCONSTANTS
#  define SB_USE_GLOBAL_PROCS_SSHCONSTANTS
#endif /* SB_USE_UNIT_SSHCONSTANTS */

#ifdef SB_USE_UNIT_SSHKEYSTORAGE
#  define SB_USE_GLOBAL_PROCS_SSHKEYSTORAGE
#  define SB_USE_CLASS_TELSSHKEY
#  define SB_USE_CLASS_TELSSHCUSTOMKEYSTORAGE
#  define SB_USE_CLASS_TELSSHMEMORYKEYSTORAGE
#endif /* SB_USE_UNIT_SSHKEYSTORAGE */

#ifdef SB_USE_UNIT_SSHTERM
#  define SB_USE_GLOBAL_PROCS_SSHTERM
#  define SB_USE_CLASS_TELTERMINALINFO
#endif /* SB_USE_UNIT_SSHTERM */

#ifdef SB_USE_UNIT_SSHUTILS
#  define SB_USE_GLOBAL_PROCS_SSHUTILS
#endif /* SB_USE_UNIT_SSHUTILS */

#ifdef SB_USE_UNIT_SSHCLIENT
#  define SB_USE_GLOBAL_PROCS_SSHCLIENT
#  define SB_USE_CLASS_TELSSHCLIENT
#  define SB_USE_CLASS_TELSSHCLIENTTUNNELLIST
#  define SB_USE_CLASS_TELSSHCLIENTTUNNELCONNECTION
#endif /* SB_USE_UNIT_SSHCLIENT */

#ifdef SB_USE_UNIT_SSHCOMMON
#  define SB_USE_GLOBAL_PROCS_SSHCOMMON
#  define SB_USE_CLASS_TELSSHCLASS
#  define SB_USE_CLASS_TELSSHTUNNELLIST
#  define SB_USE_CLASS_TELCUSTOMSSHTUNNEL
#  define SB_USE_CLASS_TELSSHTUNNELCONNECTION
#  define SB_USE_CLASS_TELCUSTOMSSHTUNNELPARAMS
#  define SB_USE_CLASS_TELSHELLSSHTUNNEL
#  define SB_USE_CLASS_TELCOMMANDSSHTUNNEL
#  define SB_USE_CLASS_TELSUBSYSTEMSSHTUNNEL
#  define SB_USE_CLASS_TELREMOTEPORTFORWARDSSHTUNNEL
#  define SB_USE_CLASS_TELLOCALPORTFORWARDSSHTUNNEL
#  define SB_USE_CLASS_TELLOCALPORTFORWARDSSHTUNNELPARAMS
#  define SB_USE_CLASS_TELX11FORWARDSSHTUNNEL
#  define SB_USE_CLASS_TELAUTHENTICATIONAGENTSSHTUNNEL
#  define SB_USE_CLASS_TELSSHAUTHHANDLER
#endif /* SB_USE_UNIT_SSHCOMMON */

#ifdef SB_USE_UNIT_SIMPLESSH
#  define SB_USE_GLOBAL_PROCS_SIMPLESSH
#  define SB_USE_CLASS_TELSIMPLESSHCLIENT
#endif /* SB_USE_UNIT_SIMPLESSH */

#ifdef SB_USE_UNIT_SSHFORWARDING
#  define SB_USE_GLOBAL_PROCS_SSHFORWARDING
#  define SB_USE_CLASS_TELSSHFORWARDEDCONNECTION
#  define SB_USE_CLASS_TELSSHFORWARDINGTUNNEL
#  define SB_USE_CLASS_TELSSHFORWARDINGSESSION
#  define SB_USE_CLASS_TELSSHCUSTOMFORWARDING
#  define SB_USE_CLASS_TELSSHFORWARDINGINTERCEPT
#  define SB_USE_CLASS_TELSSHLOCALPORTFORWARDING
#  define SB_USE_CLASS_TELSSHREMOTEPORTFORWARDING
#  define SB_USE_CLASS_TELSSHTUNNELSTATE
#  define SB_USE_CLASS_TELSSHLPFLISTENINGTHREAD
#  define SB_USE_CLASS_TELSSHLOCALTUNNELSTATE
#  define SB_USE_CLASS_TELSSHREMOTETUNNELSTATE
#  define SB_USE_CLASS_TELSSHLOCALPORTFORWARDINGSESSION
#  define SB_USE_CLASS_TELSSHREMOTEPORTFORWARDINGSESSION
#  define SB_USE_CLASS_TELSSHSCHEDULEDSPECIALMESSAGE
#endif /* SB_USE_UNIT_SSHFORWARDING */

#ifdef SB_USE_UNIT_SSHPUBKEYCOMMON
#  define SB_USE_CLASS_TELSSHPUBLICKEYATTRIBUTES
#endif /* SB_USE_UNIT_SSHPUBKEYCOMMON */

#ifdef SB_USE_UNIT_SSHPUBKEYCLIENT
#  define SB_USE_GLOBAL_PROCS_SSHPUBKEYCLIENT
#  define SB_USE_CLASS_TELSSHPUBLICKEYCLIENT
#endif /* SB_USE_UNIT_SSHPUBKEYCLIENT */

#ifndef WINCE
#ifdef SB_USE_UNIT_SSHAUTHAGENT
#ifdef SB_WINDOWS
#  define SB_USE_GLOBAL_PROCS_SSHAUTHAGENT
#endif
#  define SB_USE_CLASS_TELSSHAUTHAGENT
#ifdef SB_WINDOWS
#  define SB_USE_CLASS_TELPAGEANTAUTHAGENT
#endif
#  define SB_USE_CLASS_TELOPENSSHAUTHAGENT
#endif /* SB_USE_UNIT_SSHAUTHAGENT */
#endif

#ifdef SB_USE_UNIT_SSHSERVER
#  define SB_USE_GLOBAL_PROCS_SSHSERVER
#  define SB_USE_CLASS_TELSSHUSER
#  define SB_USE_CLASS_TELSSHSERVERTUNNELCONNECTION
#  define SB_USE_CLASS_TELSSHSERVERADDITIONALSETTINGS
#  define SB_USE_CLASS_TELSSHSERVER
#endif /* SB_USE_UNIT_SSHSERVER */

#ifdef SB_USE_UNIT_SSHHANDLERS
#  define SB_USE_CLASS_TELCUSTOMSSHSUBSYSTEMHANDLER
#ifndef SB_WINCE_OR_NOT_WINDOWS
#  define SB_USE_CLASS_TELSHELLSSHSUBSYSTEMHANDLER
#endif
#  define SB_USE_CLASS_TELCUSTOMSOCKETFORWARDINGSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TELSSHSUBSYSTEMTHREAD
#endif /* SB_USE_UNIT_SSHHANDLERS */

#ifdef SB_USE_UNIT_SSHCONNECTIONHANDLER
#  define SB_USE_CLASS_TELSSHCONNECTIONHANDLER
#endif /* SB_USE_UNIT_SSHCONNECTIONHANDLER */

#ifdef SB_USE_UNIT_SSHPUBKEYSERVER
#  define SB_USE_GLOBAL_PROCS_SSHPUBKEYSERVER
#  define SB_USE_CLASS_TELSSHPUBLICKEYSERVER
#endif /* SB_USE_UNIT_SSHPUBKEYSERVER */

#ifdef SB_USE_UNIT_SSHPUBKEYHANDLER
#  define SB_USE_CLASS_TELPUBLICKEYSSHSUBSYSTEMHANDLER
#endif /* SB_USE_UNIT_SSHPUBKEYHANDLER */

#ifdef SB_USE_UNIT_SIMPLESSHSERVER
#  define SB_USE_GLOBAL_PROCS_SIMPLESSHSERVER
#  define SB_USE_CLASS_TELSIMPLESSHSERVER
#  define SB_USE_CLASS_TELSSHUSERS
#  define SB_USE_CLASS_TELCUSTOMSESSIONTHREAD
#  define SB_USE_CLASS_TELSIMPLESSHSERVERLISTENINGTHREAD
#  define SB_USE_CLASS_TELSIMPLESSHSERVERSESSIONTHREAD
#  define SB_USE_CLASS_TELSIMPLESSHSERVERFORWARDINGLISTENINGTHREAD
#  define SB_USE_CLASS_TELSIMPLESSHSERVERFORWARDINGSESSIONTHREAD
#endif /* SB_USE_UNIT_SIMPLESSHSERVER */

#ifdef SB_USE_UNIT_SSHFORWARDINGHANDLERS
#  define SB_USE_CLASS_TELTCPFORWARDINGSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TELCLIENTTCPFORWARDINGSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TELSERVERTCPFORWARDINGSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TELBUILTINTCPFORWARDINGSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TELBUILTINCLIENTTCPFORWARDINGSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TELBUILTINSERVERTCPFORWARDINGSSHSUBSYSTEMHANDLER
#endif /* SB_USE_UNIT_SSHFORWARDINGHANDLERS */

#ifdef SB_USE_UNIT_SSLCLIENT
#  define SB_USE_GLOBAL_PROCS_SSLCLIENT
#  define SB_USE_CLASS_TELCLIENTSSLCONNECTIONINFO
#  define SB_USE_CLASS_TELSSLCLIENT
#  define SB_USE_CLASS_TELCLIENTSSLCONNECTIONSETTINGS
#endif /* SB_USE_UNIT_SSLCLIENT */

#ifdef SB_USE_UNIT_SIMPLESSL
#  define SB_USE_GLOBAL_PROCS_SIMPLESSL
#  define SB_USE_CLASS_TELCUSTOMSIMPLESSLCLIENT
#  define SB_USE_CLASS_TELSIMPLESSLCLIENT
#endif /* SB_USE_UNIT_SIMPLESSL */

#ifdef SB_USE_UNIT_SSLCOMMON
#  define SB_USE_GLOBAL_PROCS_SSLCOMMON
#  define SB_USE_CLASS_TELSSLCERTIFICATETYPEHANDLER
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#  define SB_USE_CLASS_TELSSLCLASS
#  define SB_USE_CLASS_TELSSLCONNECTIONINFO
#  define SB_USE_CLASS_TELSSLSERVERNAME
#  define SB_USE_CLASS_TELHEARTBEATHELLOSSLEXTENSION
#  define SB_USE_CLASS_TELSERVERNAMESSLEXTENSION
#  define SB_USE_CLASS_TELUSERNAMESSLEXTENSION
#  define SB_USE_CLASS_TELECCURVESSLEXTENSION
#  define SB_USE_CLASS_TELECPOINTSSLEXTENSION
#  define SB_USE_CLASS_TELCERTIFICATETYPERESPONSE
#  define SB_USE_CLASS_TELCERTIFICATETYPEREQUEST
#  define SB_USE_CLASS_TELEXTENDEDMASTERSECRETEXTENSION
#  define SB_USE_CLASS_TELMAXFRAGMENTLENGTHSSLEXTENSION
#  define SB_USE_CLASS_TELSSLCERTURL
#  define SB_USE_CLASS_TELCLIENTCERTURLSSSLEXTENSION
#  define SB_USE_CLASS_TELSSLTRUSTEDCA
#  define SB_USE_CLASS_TELTRUSTEDCASSSLEXTENSION
#  define SB_USE_CLASS_TELTRUNCATEDHMACSSLEXTENSION
#  define SB_USE_CLASS_TELSSLOCSPSTATUSREQUEST
#  define SB_USE_CLASS_TELCERTIFICATESTATUSSSLEXTENSION
#  define SB_USE_CLASS_TELSESSIONTICKETSSLEXTENSION
#  define SB_USE_CLASS_TELCERTHASHTYPESSSLEXTENSION
#  define SB_USE_CLASS_TELRENEGOTIATIONINFOSSLEXTENSION
#  define SB_USE_CLASS_TELSIGNATUREALGORITHMSSSLEXTENSION
#  define SB_USE_CLASS_TELSRPSSLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSIONS
#  define SB_USE_CLASS_TELCLIENTSSLEXTENSIONS
#  define SB_USE_CLASS_TELSERVERSSLEXTENSIONS
#  define SB_USE_CLASS_TELSSLRETRANSMISSIONTIMER
#  define SB_USE_CLASS_TELSSLMEMORYMANAGER
#  define SB_USE_CLASS_TELSSLX509CERTIFICATETYPEHANDLER
#  define SB_USE_CLASS_TELSSLRAWKEYCERTIFICATETYPEHANDLER
#  define SB_USE_CLASS_TELDTLSFLIGHTITEM
#endif /* SB_USE_UNIT_SSLCOMMON */

#ifdef SB_USE_UNIT_CMDSSLCLIENT
#  define SB_USE_CLASS_TELCOMMANDSSLCLIENT
#endif /* SB_USE_UNIT_CMDSSLCLIENT */

#ifdef SB_USE_UNIT_DTLSCLIENT
#  define SB_USE_GLOBAL_PROCS_DTLSCLIENT
#  define SB_USE_CLASS_TELDTLSCLIENT
#endif /* SB_USE_UNIT_DTLSCLIENT */

#ifdef SB_USE_UNIT_SSLSERVER
#  define SB_USE_GLOBAL_PROCS_SSLSERVER
#  define SB_USE_CLASS_TELSERVERSSLCONNECTIONINFO
#  define SB_USE_CLASS_TELSSLSERVER
#  define SB_USE_CLASS_TELSSLSERVERENVIRONMENT
#endif /* SB_USE_UNIT_SSLSERVER */

#ifdef SB_USE_UNIT_SESSIONPOOL
#  define SB_USE_GLOBAL_PROCS_SESSIONPOOL
#  define SB_USE_CLASS_TELSESSIONPOOL
#endif /* SB_USE_UNIT_SESSIONPOOL */

#ifdef SB_USE_UNIT_DTLSSERVER
#  define SB_USE_GLOBAL_PROCS_DTLSSERVER
#  define SB_USE_CLASS_TELDTLSSERVER
#  define SB_USE_CLASS_TELDTLSSERVERFACTORY
#endif /* SB_USE_UNIT_DTLSSERVER */

#ifdef SB_USE_UNIT_XMLCHARSETS
#  define SB_USE_CLASS_TELXMLBUFFERINGSTREAM
#  define SB_USE_CLASS_TELXMLCODEC
#  define SB_USE_CLASS_TELXML8BITCODEC
#  define SB_USE_CLASS_TELXMLUTF8CODEC
#  define SB_USE_CLASS_TELXMLUNICODECODEC
#  define SB_USE_CLASS_TELXMLSTRINGCODEC
#endif /* SB_USE_UNIT_XMLCHARSETS */

#ifdef SB_USE_UNIT_XMLCORE
#  define SB_USE_GLOBAL_PROCS_XMLCORE
#  define SB_USE_CLASS_TELXMLDOMIMPLEMENTATION
#  define SB_USE_CLASS_TELXMLDOMNODE
#  define SB_USE_CLASS_TELXMLDOMDOCUMENT
#  define SB_USE_CLASS_TELXMLDOMDOCUMENTFRAGMENT
#  define SB_USE_CLASS_TELXMLNODESET
#  define SB_USE_CLASS_TELXMLDOMNODELIST
#  define SB_USE_CLASS_TELXMLDOMNAMEDNODEMAP
#  define SB_USE_CLASS_TELXMLDOMCHARACTERDATA
#  define SB_USE_CLASS_TELXMLDOMATTR
#  define SB_USE_CLASS_TELXMLDOMELEMENT
#  define SB_USE_CLASS_TELXMLDOMTEXT
#  define SB_USE_CLASS_TELXMLDOMCOMMENT
#  define SB_USE_CLASS_TELXMLDOMCDATASECTION
#  define SB_USE_CLASS_TELXMLDOMDOCUMENTTYPE
#  define SB_USE_CLASS_TELXMLDOMNOTATION
#  define SB_USE_CLASS_TELXMLDOMENTITY
#  define SB_USE_CLASS_TELXMLDOMENTITYREFERENCE
#  define SB_USE_CLASS_TELXMLDOMPROCESSINGINSTRUCTION
#  define SB_USE_CLASS_TELXMLPARSER
#  define SB_USE_CLASS_TELXMLNAMESPACEMAP
#  define SB_USE_CLASS_TELXMLCUSTOMFORMATTER
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_UNIT_XMLCORE */

#ifdef SB_USE_UNIT_XMLDEFS
#  define SB_USE_CLASS_TELVERSIONURI
#endif /* SB_USE_UNIT_XMLDEFS */

#ifdef SB_USE_UNIT_XMLPATH
#  define SB_USE_CLASS_TELXPATH
#  define SB_USE_CLASS_TELNUMBER
#  define SB_USE_CLASS_TELBOOLEAN
#  define SB_USE_CLASS_TELSTRING
#  define SB_USE_CLASS_TELXMLVARMAP
#  define SB_USE_CLASS_TELXPATHNODE
#  define SB_USE_CLASS_TELUNIONEXPRNODE
#  define SB_USE_CLASS_TELPATHEXPRNODE
#  define SB_USE_CLASS_TELLOCATIONPATHNODE
#  define SB_USE_CLASS_TELABSOLUTELOCATIONPATHNODE
#  define SB_USE_CLASS_TELRELATIVELOCATIONPATHNODE
#  define SB_USE_CLASS_TELSTEPNODE
#  define SB_USE_CLASS_TELPREDICATENODE
#  define SB_USE_CLASS_TELOREXPRNODE
#  define SB_USE_CLASS_TELANDEXPRNODE
#  define SB_USE_CLASS_TELEQUALITYEXPRNODE
#  define SB_USE_CLASS_TELRELATIONALEXPRNODE
#  define SB_USE_CLASS_TELADDITIVEEXPRNODE
#  define SB_USE_CLASS_TELMULTIPLICATIVEEXPRNODE
#  define SB_USE_CLASS_TELUNARYEXPRNODE
#  define SB_USE_CLASS_TELFILTEREXPRNODE
#  define SB_USE_CLASS_TELPRIMARYEXPRNODE
#  define SB_USE_CLASS_TELVARIABLEREFERENCENODE
#  define SB_USE_CLASS_TELLITERALNODE
#  define SB_USE_CLASS_TELNUMBERNODE
#  define SB_USE_CLASS_TELFUNCTIONCALLNODE
#endif /* SB_USE_UNIT_XMLPATH */

#ifdef SB_USE_UNIT_XMLUTILS
#  define SB_USE_GLOBAL_PROCS_XMLUTILS
#endif /* SB_USE_UNIT_XMLUTILS */

#ifdef SB_USE_UNIT_XMLADES
#  define SB_USE_GLOBAL_PROCS_XMLADES
#  define SB_USE_CLASS_TELXMLADESELEMENT
#  define SB_USE_CLASS_TELXMLANYTYPE
#  define SB_USE_CLASS_TELXMLANYTYPELIST
#  define SB_USE_CLASS_TELXMLOBJECTIDENTIFIER
#  define SB_USE_CLASS_TELXMLENCAPSULATEDPKIDATA
#  define SB_USE_CLASS_TELXMLENCAPSULATEDPKIDATALIST
#  define SB_USE_CLASS_TELXMLHASHDATAINFO
#  define SB_USE_CLASS_TELXMLHASHDATAINFOLIST
#  define SB_USE_CLASS_TELXMLCUSTOMTIMESTAMP
#  define SB_USE_CLASS_TELXMLCUSTOMTIMESTAMPLIST
#  define SB_USE_CLASS_TELXMLTIMESTAMP
#  define SB_USE_CLASS_TELXMLTIMESTAMPLIST
#  define SB_USE_CLASS_TELXMLINCLUDE
#  define SB_USE_CLASS_TELXMLINCLUDELIST
#  define SB_USE_CLASS_TELXMLTIMESTAMP_V1_2_2
#  define SB_USE_CLASS_TELXMLTIMESTAMPLIST_V1_2_2
#  define SB_USE_CLASS_TELCUSTOMTSPCLIENTLIST
#  define SB_USE_CLASS_TELXMLGENERICTIMESTAMP
#  define SB_USE_CLASS_TELXMLGENERICTIMESTAMPLIST
#  define SB_USE_CLASS_TELXMLDIGESTALGANDVALUE
#  define SB_USE_CLASS_TELXMLCERTID
#  define SB_USE_CLASS_TELXMLCERTIDLIST
#  define SB_USE_CLASS_TELXMLNOTICEREFERENCE
#  define SB_USE_CLASS_TELXMLSPUSERNOTICE
#  define SB_USE_CLASS_TELXMLSPURI
#  define SB_USE_CLASS_TELXMLSIGPOLICYQUALIFIER
#  define SB_USE_CLASS_TELXMLSIGNATUREPOLICYID
#  define SB_USE_CLASS_TELXMLSIGNATUREPOLICYIDENTIFIER
#  define SB_USE_CLASS_TELXMLCOUNTERSIGNATURE
#  define SB_USE_CLASS_TELXMLCOUNTERSIGNATURELIST
#  define SB_USE_CLASS_TELXMLDATAOBJECTFORMAT
#  define SB_USE_CLASS_TELXMLDATAOBJECTFORMATLIST
#  define SB_USE_CLASS_TELXMLCOMMITMENTTYPEQUALIFIER
#  define SB_USE_CLASS_TELXMLCOMMITMENTTYPEINDICATION
#  define SB_USE_CLASS_TELXMLCOMMITMENTTYPEINDICATIONLIST
#  define SB_USE_CLASS_TELXMLSIGNATUREPRODUCTIONPLACE
#  define SB_USE_CLASS_TELXMLENCAPSULATEDX509CERTIFICATES
#  define SB_USE_CLASS_TELXMLCERTIFIEDROLE
#  define SB_USE_CLASS_TELXMLCERTIFIEDROLESLIST
#  define SB_USE_CLASS_TELXMLCLAIMEDROLE
#  define SB_USE_CLASS_TELXMLCLAIMEDROLESLIST
#  define SB_USE_CLASS_TELXMLSIGNERROLE
#  define SB_USE_CLASS_TELXMLCOMPLETECERTIFICATEREFS
#  define SB_USE_CLASS_TELXMLCRLIDENTIFIER
#  define SB_USE_CLASS_TELXMLCRLREF
#  define SB_USE_CLASS_TELXMLCRLREFS
#  define SB_USE_CLASS_TELXMLOCSPIDENTIFIER
#  define SB_USE_CLASS_TELXMLOCSPREF
#  define SB_USE_CLASS_TELXMLOCSPREFS
#  define SB_USE_CLASS_TELXMLOTHERREF
#  define SB_USE_CLASS_TELXMLCOMPLETEREVOCATIONREFS
#  define SB_USE_CLASS_TELXMLCERTIFICATEVALUES
#  define SB_USE_CLASS_TELXMLENCAPSULATEDCRLVALUE
#  define SB_USE_CLASS_TELXMLCRLVALUES
#  define SB_USE_CLASS_TELXMLENCAPSULATEDOCSPVALUE
#  define SB_USE_CLASS_TELXMLOCSPVALUES
#  define SB_USE_CLASS_TELXMLREVOCATIONVALUES
#  define SB_USE_CLASS_TELXMLTIMESTAMPVALIDATIONDATA
#  define SB_USE_CLASS_TELXMLTIMESTAMPVALIDATIONDATALIST
#  define SB_USE_CLASS_TELXMLSIGNEDDATAOBJECTPROPERTIES
#  define SB_USE_CLASS_TELXMLUNSIGNEDDATAOBJECTPROPERTY
#  define SB_USE_CLASS_TELXMLSIGNEDSIGNATUREPROPERTIES
#  define SB_USE_CLASS_TELXMLUNSIGNEDSIGNATUREPROPERTIES
#  define SB_USE_CLASS_TELXMLSIGNEDPROPERTIES
#  define SB_USE_CLASS_TELXMLUNSIGNEDPROPERTIES
#  define SB_USE_CLASS_TELXMLQUALIFYINGPROPERTIES
#  define SB_USE_CLASS_TELXMLQUALIFYINGPROPERTIESREFERENCE
#  define SB_USE_CLASS_TELXMLQUALIFYINGPROPERTIESREFERENCELIST
#endif /* SB_USE_UNIT_XMLADES */

#ifdef SB_USE_UNIT_XMLADESINTF
#  define SB_USE_CLASS_TELXADESPROCESSOR
#  define SB_USE_CLASS_TELXADESSIGNER
#  define SB_USE_CLASS_TELXADESVERIFIER
#endif /* SB_USE_UNIT_XMLADESINTF */

#ifdef SB_USE_UNIT_XMLENC
#  define SB_USE_GLOBAL_PROCS_XMLENC
#  define SB_USE_CLASS_TELXMLENCRYPTEDTYPE
#  define SB_USE_CLASS_TELXMLENCPROCESSOR
#  define SB_USE_CLASS_TELXMLENCRYPTOR
#  define SB_USE_CLASS_TELXMLDECRYPTOR
#  define SB_USE_CLASS_TELXMLCIPHERREFERENCE
#  define SB_USE_CLASS_TELXMLCIPHERDATA
#  define SB_USE_CLASS_TELXMLENCRYPTIONMETHODTYPE
#  define SB_USE_CLASS_TELXMLENCRYPTIONPROPERTIES
#  define SB_USE_CLASS_TELXMLENCRYPTEDDATA
#  define SB_USE_CLASS_TELXMLENCRYPTEDKEY
#  define SB_USE_CLASS_TELXMLDECRYPTIONEXCEPT
#  define SB_USE_CLASS_TELXMLCUSTOMDECRYPTIONTRANSFORM
#  define SB_USE_CLASS_TELXMLDECRYPTIONTRANSFORM
#  define SB_USE_CLASS_TELXMLBINARYDECRYPTIONTRANSFORM
#endif /* SB_USE_UNIT_XMLENC */

#ifdef SB_USE_UNIT_XMLSEC
#  define SB_USE_GLOBAL_PROCS_XMLSEC
#  define SB_USE_CLASS_TELXMLKEYINFO
#  define SB_USE_CLASS_TELXMLALGORITHMPARAMETERS
#  define SB_USE_CLASS_TELXMLREFERENCE
#  define SB_USE_CLASS_TELXMLREFERENCELIST
#  define SB_USE_CLASS_TELXMLGOSTR3411PARAMETERS
#  define SB_USE_CLASS_TELXMLRSAPSSPARAMETERS
#  define SB_USE_CLASS_TELXMLKEYINFOITEM
#  define SB_USE_CLASS_TELXMLKEYINFODATA
#  define SB_USE_CLASS_TELXMLKEYINFOHMACDATA
#  define SB_USE_CLASS_TELXMLKEYINFOSYMMETRICDATA
#  define SB_USE_CLASS_TELXMLKEYINFOASYMMETRICDATA
#  define SB_USE_CLASS_TELXMLKEYINFORSADATA
#  define SB_USE_CLASS_TELXMLKEYINFODSADATA
#  define SB_USE_CLASS_TELXMLKEYINFODHDATA
#  define SB_USE_CLASS_TELXMLKEYINFOGOST2001DATA
#  define SB_USE_CLASS_TELXMLKEYINFOPGPDATA
#  define SB_USE_CLASS_TELXMLKEYINFOECDATA
#  define SB_USE_CLASS_TELXMLISSUERSERIAL
#  define SB_USE_CLASS_TELXMLKEYINFOX509DATA
#  define SB_USE_CLASS_TELXMLKEYINFONODE
#  define SB_USE_CLASS_TELXMLKEYINFORETRIEVALMETHOD
#  define SB_USE_CLASS_TELXMLKEYINFOAGREEMENTMETHOD
#  define SB_USE_CLASS_TELXMLPROPERTY
#  define SB_USE_CLASS_TELXMLPROPERTIES
#  define SB_USE_CLASS_TELXMLPROCESSOR
#  define SB_USE_CLASS_TELXMLFORMATTER
#  define SB_USE_CLASS_TELXMLDESCRIPTORMAP
#endif /* SB_USE_UNIT_XMLSEC */

#ifdef SB_USE_UNIT_XMLSIG
#  define SB_USE_GLOBAL_PROCS_XMLSIG
#  define SB_USE_CLASS_TELXMLSIGNATURE
#  define SB_USE_CLASS_TELXMLSIGPROCESSOR
#  define SB_USE_CLASS_TELXMLSIGNER
#  define SB_USE_CLASS_TELXMLVERIFIER
#  define SB_USE_CLASS_TELXMLSIGNATUREMETHODTYPE
#  define SB_USE_CLASS_TELXMLSIGNEDINFO
#  define SB_USE_CLASS_TELXMLMANIFEST
#  define SB_USE_CLASS_TELXMLSIGNATUREPROPERTIES
#  define SB_USE_CLASS_TELXMLOBJECT
#  define SB_USE_CLASS_TELXMLOBJECTLIST
#  define SB_USE_CLASS_TELXMLSIGNATUREVALUE
#endif /* SB_USE_UNIT_XMLSIG */

#ifdef SB_USE_UNIT_XMLTRANSFORM
#  define SB_USE_GLOBAL_PROCS_XMLTRANSFORM
#  define SB_USE_CLASS_TELXMLTRANSFORM
#  define SB_USE_CLASS_TELXMLNULLTRANSFORM
#  define SB_USE_CLASS_TELXMLBASE64TRANSFORM
#  define SB_USE_CLASS_TELXMLC14NTRANSFORM
#  define SB_USE_CLASS_TELXMLENVELOPEDSIGNATURETRANSFORM
#  define SB_USE_CLASS_TELXMLXPATHTRANSFORM
#  define SB_USE_CLASS_TELXMLXPATHFILTERITEM
#  define SB_USE_CLASS_TELXMLXPATHFILTER2TRANSFORM
#  define SB_USE_CLASS_TELXMLTRANSFORMCHAIN
#  define SB_USE_CLASS_TELXMLUNSUPPORTEDTRANSFORM
#endif /* SB_USE_UNIT_XMLTRANSFORM */

#ifdef SB_USE_UNIT_XMLSOAPCORE
#  define SB_USE_GLOBAL_PROCS_XMLSOAPCORE
#  define SB_USE_CLASS_TELXMLSOAPELEMENT
#  define SB_USE_CLASS_TELXMLSOAPHEADERBLOCK
#  define SB_USE_CLASS_TELXMLSOAPHEADER
#  define SB_USE_CLASS_TELXMLSOAPBODYENTRY
#  define SB_USE_CLASS_TELXMLSOAPBODY
#  define SB_USE_CLASS_TELXMLSOAPENVELOPE
#endif /* SB_USE_UNIT_XMLSOAPCORE */

#ifdef SB_USE_UNIT_XMLWSSCORE
#  define SB_USE_GLOBAL_PROCS_XMLWSSCORE
#  define SB_USE_CLASS_TELXMLWSSEELEMENT
#  define SB_USE_CLASS_TELXMLWSSEBASETOKEN
#  define SB_USE_CLASS_TELXMLWSSETEXTELEMENT
#  define SB_USE_CLASS_TELXMLWSSEPASSWORD
#  define SB_USE_CLASS_TELXMLWSSENONCE
#  define SB_USE_CLASS_TELXMLWSUDATETIME
#  define SB_USE_CLASS_TELXMLWSSEUSERNAMETOKEN
#  define SB_USE_CLASS_TELXMLWSUTIMESTAMP
#  define SB_USE_CLASS_TELXMLWSSEBINARYSECURITYTOKEN
#  define SB_USE_CLASS_TELXMLWSSESECURITY
#  define SB_USE_CLASS_TELXMLWSSEREFERENCE
#  define SB_USE_CLASS_TELXMLWSSEKEYIDENTIFIER
#  define SB_USE_CLASS_TELXMLWSSESECURITYTOKENREFERENCE
#endif /* SB_USE_UNIT_XMLWSSCORE */

#ifdef SB_USE_UNIT_XMLSOAP
#  define SB_USE_GLOBAL_PROCS_XMLSOAP
#  define SB_USE_CLASS_TELXMLSOAPMESSAGE
#  define SB_USE_CLASS_TELXMLSOAPCUSTOMSIGNATUREHANDLER
#  define SB_USE_CLASS_TELXMLSOAPBASESIGNATUREHANDLER
#endif /* SB_USE_UNIT_XMLSOAP */

#ifdef SB_USE_UNIT_XMLSOAPSECURITY
#  define SB_USE_GLOBAL_PROCS_XMLSOAPSECURITY
#  define SB_USE_CLASS_TELXMLSOAPSIGNATUREHANDLER
#  define SB_USE_CLASS_TELXMLWSSSIGNATUREHANDLER
#endif /* SB_USE_UNIT_XMLSOAPSECURITY */

#ifdef SB_USE_UNIT_XMLSOAPCLIENT
#  define SB_USE_GLOBAL_PROCS_XMLSOAPCLIENT
#  define SB_USE_CLASS_TELXMLSOAPCLIENT
#  define SB_USE_CLASS_TELXMLSOAPCUSTOMPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPBASEPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPSTRINGPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPBOOLEANPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPINTEGERPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPINT64PARAMETER
#  define SB_USE_CLASS_TELXMLSOAPDOUBLEPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPDATETIMEPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPBASE64BINARYPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPCOMPOUNDPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPPARAMETERSMANAGER
#  define SB_USE_CLASS_TELXMLSOAPFAULT
#endif /* SB_USE_UNIT_XMLSOAPCLIENT */

#ifdef SB_USE_UNIT_ARCBASE
#  define SB_USE_GLOBAL_PROCS_ARCBASE
#  define SB_USE_CLASS_TELBASEARCHIVE
#  define SB_USE_CLASS_TELARCHIVEDIRECTORYENTRY
#  define SB_USE_CLASS_TELARCPROCESSINGUNIT
#endif /* SB_USE_UNIT_ARCBASE */

#ifdef SB_USE_UNIT_ARCZIP
#  define SB_USE_GLOBAL_PROCS_ARCZIP
#  define SB_USE_CLASS_TELZIPARCHIVEDIRECTORYENTRY
#  define SB_USE_CLASS_TELZIPDOSFILEATTRIBUTES
#  define SB_USE_CLASS_TELZIPUNIXFILEATTRIBUTES
#  define SB_USE_CLASS_TELZIPSTRONGENCRYPTIONINFO
#  define SB_USE_CLASS_TELZIPSTRONGENCRYPTIONSIGNATUREINFO
#  define SB_USE_CLASS_TELZIPPROCESSINGUNIT
#  define SB_USE_CLASS_TELZIPSTOREDPROCESSINGUNIT
#  define SB_USE_CLASS_TELZIPDEFLATEDECOMPRESSINGUNIT
#  define SB_USE_CLASS_TELZIPDEFLATECOMPRESSINGUNIT
#  define SB_USE_CLASS_TELZIPBZIP2DECOMPRESSINGUNIT
#  define SB_USE_CLASS_TELZIPBZIP2COMPRESSINGUNIT
#  define SB_USE_CLASS_TELZIPOLDSTYLEENCRYPTINGUNIT
#  define SB_USE_CLASS_TELZIPOLDSTYLEDECRYPTINGUNIT
#  define SB_USE_CLASS_TELZIPSTRONGENCRYPTIONBASEUNIT
#  define SB_USE_CLASS_TELZIPSTRONGENCRYPTIONENCRYPTINGUNIT
#  define SB_USE_CLASS_TELZIPSTRONGENCRYPTIONDECRYPTINGUNIT
#  define SB_USE_CLASS_TELZIPSTRONGENCRYPTIONHASHINGUNIT
#  define SB_USE_CLASS_TELZIPWINZIPAESBASEUNIT
#  define SB_USE_CLASS_TELZIPWINZIPAESDECRYPTINGUNIT
#  define SB_USE_CLASS_TELZIPWINZIPAESENCRYPTINGUNIT
#  define SB_USE_CLASS_TELZIPREADER
#  define SB_USE_CLASS_TELZIPWRITER
#endif /* SB_USE_UNIT_ARCZIP */

#ifdef SB_USE_UNIT_ZIPENTITIES
#  define SB_USE_CLASS_TELZIPENTITY
#  define SB_USE_CLASS_TELZIPLOCALFILEHEADER
#  define SB_USE_CLASS_TELZIPCENTRALFILEHEADER
#  define SB_USE_CLASS_TELZIPDATADESCRIPTOR
#  define SB_USE_CLASS_TELZIPENTITYEXTENSIONS
#  define SB_USE_CLASS_TELZIPCENTRALDIRECTORYSIGNATURE
#  define SB_USE_CLASS_TELZIP64ENDOFCENTRALDIRECTORY
#  define SB_USE_CLASS_TELZIP64ENDOFCENTRALDIRECTORYLOCATOR
#  define SB_USE_CLASS_TELZIPENDOFCENTRALDIRECTORY
#  define SB_USE_CLASS_TELZIPARCHIVEEXTRADATA
#  define SB_USE_CLASS_TELZIPPROCESSOR
#  define SB_USE_CLASS_TELZIPENTITYEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYCUSTOMEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYZIP64INFOEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYSTRONGENCRYPTIONEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYWINZIPAESEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYCERTIFICATESTOREEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYSIGNATUREEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYCENTRALDIRSIGNATUREEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYUNIX1EXTENSION
#  define SB_USE_CLASS_TELZIPENTITYUNIX2EXTENSION
#  define SB_USE_CLASS_TELZIPENTITYEXTENDEDTIMESTAMPEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYUIDANDGIDEXTENSION
#endif /* SB_USE_UNIT_ZIPENTITIES */

#ifdef SB_USE_UNIT_ZIPUTILS
#  define SB_USE_GLOBAL_PROCS_ZIPUTILS
#endif /* SB_USE_UNIT_ZIPUTILS */

#ifdef SB_USE_UNIT_ARCTAR
#  define SB_USE_CLASS_TELTARARCHIVEDIRECTORYENTRY
#  define SB_USE_CLASS_TELTARFILEATTRIBUTES
#  define SB_USE_CLASS_TELTARPROCESSINGUNIT
#  define SB_USE_CLASS_TELTARREADER
#  define SB_USE_CLASS_TELTARWRITER
#endif /* SB_USE_UNIT_ARCTAR */

#ifdef SB_USE_UNIT_TARENTITIES
#  define SB_USE_CLASS_TELTARFILEHEADER
#  define SB_USE_CLASS_TELBASETARHEADER
#  define SB_USE_CLASS_TELUSTARTARHEADER
#  define SB_USE_CLASS_TELTARPROCESSOR
#endif /* SB_USE_UNIT_TARENTITIES */

#ifdef SB_USE_UNIT_TARUTILS
#  define SB_USE_GLOBAL_PROCS_TARUTILS
#endif /* SB_USE_UNIT_TARUTILS */

#ifdef SB_USE_UNIT_ARCGZIP
#  define SB_USE_CLASS_TELGZIPDECOMPRESSINGUNIT
#  define SB_USE_CLASS_TELGZIPCOMPRESSINGUNIT
#  define SB_USE_CLASS_TELGZIPFILEATTRIBUTES
#  define SB_USE_CLASS_TELGZIPREADER
#  define SB_USE_CLASS_TELGZIPWRITER
#endif /* SB_USE_UNIT_ARCGZIP */

#ifdef SB_USE_UNIT_ARCBZIP2
#  define SB_USE_CLASS_TELBZIP2DECOMPRESSINGUNIT
#  define SB_USE_CLASS_TELBZIP2COMPRESSINGUNIT
#  define SB_USE_CLASS_TELBZIP2READER
#  define SB_USE_CLASS_TELBZIP2WRITER
#endif /* SB_USE_UNIT_ARCBZIP2 */

#ifndef SB_WINCE_OR_NOT_WINDOWS
#ifdef SB_USE_UNIT_ZIPSFX
#  define SB_USE_GLOBAL_PROCS_ZIPSFX
#  define SB_USE_CLASS_TELZIPSFXSTUB
#endif /* SB_USE_UNIT_ZIPSFX */

#endif
#ifdef SB_WINDOWS
#ifdef SB_USE_UNIT_ZIPSFXMAKER
#  define SB_USE_CLASS_TELZIPSFXMAKER
#endif /* SB_USE_UNIT_ZIPSFXMAKER */
#endif

#ifdef SB_USE_UNIT_XMLSAMLBIND
#  define SB_USE_GLOBAL_PROCS_XMLSAMLBIND
#  define SB_USE_CLASS_TELSAMLBINDING
#  define SB_USE_CLASS_TELSAMLSOAPBINDING
#  define SB_USE_CLASS_TELSAMLCOMPRESSEDPROCESSOR
#  define SB_USE_CLASS_TELSAMLREDIRECTBINDING
#  define SB_USE_CLASS_TELSAMLPOSTBINDING
#  define SB_USE_CLASS_TELSAMLARTIFACT
#endif /* SB_USE_UNIT_XMLSAMLBIND */

#ifdef SB_USE_UNIT_XMLSAMLCOMMON
#  define SB_USE_GLOBAL_PROCS_XMLSAMLCOMMON
#  define SB_USE_CLASS_TELSAMLCLIENTSETTINGS
#  define SB_USE_CLASS_TELSAMLSESSION
#  define SB_USE_CLASS_TELCUSTOMSESSIONMANAGER
#  define SB_USE_CLASS_TELMEMORYSESSIONMANAGER
#  define SB_USE_CLASS_SBXMLSAMLCOMMON_TELSTRINGVALUE
#  define SB_USE_CLASS_TELCUSTOMARTIFACTSTORAGE
#  define SB_USE_CLASS_TELMEMORYARTIFACTSTORAGE
#  define SB_USE_CLASS_TELSAMLADAPTER
#endif /* SB_USE_UNIT_XMLSAMLCOMMON */

#ifdef SB_USE_UNIT_XMLSAMLCORE
#  define SB_USE_GLOBAL_PROCS_XMLSAMLCORE
#  define SB_USE_CLASS_TELSAMLELEMENT
#  define SB_USE_CLASS_TELSAMLCONDITIONSELEMENT
#  define SB_USE_CLASS_TELSAMLADVICEELEMENT
#  define SB_USE_CLASS_TELSAMLSUBJECTCONFIRMATIONDATAELEMENT
#  define SB_USE_CLASS_TELSAMLSTATEMENTABSTRACTTYPE
#  define SB_USE_CLASS_TELSAMLSUBJECTCONFIRMATIONELEMENT
#  define SB_USE_CLASS_TELSAMLSECURITYHANDLER
#  define SB_USE_CLASS_TELSAMLSIGNATUREHANDLER
#  define SB_USE_CLASS_TELSAMLENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELSAMLSUBJECTELEMENT
#  define SB_USE_CLASS_TELSAMLID
#  define SB_USE_CLASS_TELSAMLBASEIDELEMENT
#  define SB_USE_CLASS_TELSAMLNAMEIDELEMENT
#  define SB_USE_CLASS_TELSAMLENCRYPTEDELEMENT
#  define SB_USE_CLASS_TELSAMLENCRYPTEDIDELEMENT
#  define SB_USE_CLASS_TELSAMLISSUERELEMENT
#  define SB_USE_CLASS_TELSAMLASSERTIONTYPE
#  define SB_USE_CLASS_TELSAMLASSERTIONIDREFELEMENT
#  define SB_USE_CLASS_TELSAMLASSERTIONURIREFELEMENT
#  define SB_USE_CLASS_TELSAMLASSERTIONELEMENT
#  define SB_USE_CLASS_TELSAMLENCRYPTEDASSERTIONELEMENT
#  define SB_USE_CLASS_TELSAMLCONDITIONABSTRACTTYPE
#  define SB_USE_CLASS_TELSAMLAUDIENCEELEMENT
#  define SB_USE_CLASS_TELSAMLAUDIENCERESTRICTIONELEMENT
#  define SB_USE_CLASS_TELSAMLONETIMEUSEELEMENT
#  define SB_USE_CLASS_TELSAMLPROXYRESTRICTIONELEMENT
#  define SB_USE_CLASS_TELSAMLSUBJECTLOCALITYELEMENT
#  define SB_USE_CLASS_TELSAMLAUTHNCONTEXTELEMENT
#  define SB_USE_CLASS_TELSAMLAUTHNSTATEMENTELEMENT
#  define SB_USE_CLASS_TELSAMLATTRIBUTETYPE
#  define SB_USE_CLASS_TELSAMLATTRIBUTEVALUE
#  define SB_USE_CLASS_TELSAMLATTRIBUTEELEMENT
#  define SB_USE_CLASS_TELSAMLENCRYPTEDATTRIBUTEELEMENT
#  define SB_USE_CLASS_TELSAMLATTRIBUTESTATEMENTELEMENT
#  define SB_USE_CLASS_TELSAMLACTIONELEMENT
#  define SB_USE_CLASS_TELSAMLEVIDENCEELEMENT
#  define SB_USE_CLASS_TELSAMLAUTHZDECISIONSTATEMENTELEMENT
#endif /* SB_USE_UNIT_XMLSAMLCORE */

#ifdef SB_USE_UNIT_XMLSAMLMETADATA
#  define SB_USE_GLOBAL_PROCS_XMLSAMLMETADATA
#  define SB_USE_CLASS_TELSAMLMETADATAROOTELEMENT
#  define SB_USE_CLASS_TELSAMLLOCALIZEDNAMETYPE
#  define SB_USE_CLASS_TELSAMLLOCALIZEDURITYPE
#  define SB_USE_CLASS_TELSAMLENDPOINTTYPE
#  define SB_USE_CLASS_TELSAMLINDEXEDENDPOINTTYPE
#  define SB_USE_CLASS_TELSAMLENTITYDESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLENTITIESDESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLKEYDESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLORGANIZATIONELEMENT
#  define SB_USE_CLASS_TELSAMLCONTACTPERSONELEMENT
#  define SB_USE_CLASS_TELSAMLROLEDESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLAUTHNQUERYSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLASSERTIONIDREQUESTSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLAUTHNAUTHORITYDESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLATTRIBUTESERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLATTRIBUTEAUTHORITYDESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLAUTHZSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLPDPDESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLAFFILIATIONDESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLORGANIZATIONNAMEELEMENT
#  define SB_USE_CLASS_TELSAMLORGANIZATIONDISPLAYNAMEELEMENT
#  define SB_USE_CLASS_TELSAMLORGANIZATIONURLELEMENT
#  define SB_USE_CLASS_TELSAMLADDITIONALMETADATALOCATIONELEMENT
#  define SB_USE_CLASS_TELSAMLARTIFACTRESOLUTIONSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLSINGLELOGOUTSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLMANAGENAMEIDSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLSINGLESIGNONSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLNAMEIDMAPPINGSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLSSODESCRIPTORTYPE
#  define SB_USE_CLASS_TELSAMLIDPSSODESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLASSERTIONCONSUMERSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLREQUESTEDATTRIBUTEELEMENT
#  define SB_USE_CLASS_TELSAMLSERVICENAMEELEMENT
#  define SB_USE_CLASS_TELSAMLSERVICEDESCRIPTIONELEMENT
#  define SB_USE_CLASS_TELSAMLATTRIBUTECONSUMINGSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLSPSSODESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLENCRYPTIONMETHODTYPE
#  define SB_USE_CLASS_TELSAMLMETADATA
#  define SB_USE_CLASS_TELSAMLENDPOINT
#endif /* SB_USE_UNIT_XMLSAMLMETADATA */

#ifdef SB_USE_UNIT_XMLSAMLPROTOCOL
#  define SB_USE_CLASS_TELSAMLEXTENSIONSELEMENT
#  define SB_USE_CLASS_TELSAMLREQUESTABSTRACTTYPE
#  define SB_USE_CLASS_TELSAMLSTATUSCODEELEMENT
#  define SB_USE_CLASS_TELSAMLSTATUSMESSAGEELEMENT
#  define SB_USE_CLASS_TELSAMLSTATUSDETAILELEMENT
#  define SB_USE_CLASS_TELSAMLSTATUSELEMENT
#  define SB_USE_CLASS_TELSAMLSTATUSRESPONSETYPE
#  define SB_USE_CLASS_TELSAMLASSERTIONIDREQUESTELEMENT
#  define SB_USE_CLASS_TELSAMLSUBJECTQUERYABSTRACTTYPE
#  define SB_USE_CLASS_TELSAMLSUBJECTQUERYELEMENT
#  define SB_USE_CLASS_TELSAMLREQUESTEDAUTHNCONTEXTELEMENT
#  define SB_USE_CLASS_TELSAMLAUTHNQUERYELEMENT
#  define SB_USE_CLASS_TELSAMLATTRIBUTEQUERYELEMENT
#  define SB_USE_CLASS_TELSAMLAUTHZDECISIONQUERYELEMENT
#  define SB_USE_CLASS_TELSAMLRESPONSEELEMENT
#  define SB_USE_CLASS_TELSAMLNAMEIDPOLICYELEMENT
#  define SB_USE_CLASS_TELSAMLIDPENTRYELEMENT
#  define SB_USE_CLASS_TELSAMLIDPLISTELEMENT
#  define SB_USE_CLASS_TELSAMLSCOPINGELEMENT
#  define SB_USE_CLASS_TELSAMLAUTHNREQUESTELEMENT
#  define SB_USE_CLASS_TELSAMLARTIFACTRESOLVEELEMENT
#  define SB_USE_CLASS_TELSAMLARTIFACTRESPONSEELEMENT
#  define SB_USE_CLASS_TELSAMLMANAGENAMEIDREQUESTELEMENT
#  define SB_USE_CLASS_TELSAMLMANAGENAMEIDRESPONSEELEMENT
#  define SB_USE_CLASS_TELSAMLLOGOUTREQUESTELEMENT
#  define SB_USE_CLASS_TELSAMLLOGOUTRESPONSEELEMENT
#  define SB_USE_CLASS_TELSAMLNAMEIDMAPPINGREQUESTELEMENT
#  define SB_USE_CLASS_TELSAMLNAMEIDMAPPINGRESPONSEELEMENT
#endif /* SB_USE_UNIT_XMLSAMLPROTOCOL */

#ifdef SB_USE_UNIT_SAMLIDENTITYPROVIDER
#  define SB_USE_GLOBAL_PROCS_SAMLIDENTITYPROVIDER
#  define SB_USE_CLASS_TELSAMLIDPSESSION
#  define SB_USE_CLASS_TELSAMLSERVICEPROVIDERINFO
#  define SB_USE_CLASS_TELSAMLSPDATA
#  define SB_USE_CLASS_TELSAMLIDPCUSTOMAUTHSOURCE
#  define SB_USE_CLASS_TELSAMLIDRECORD
#  define SB_USE_CLASS_TELSAMLIDPPASSWORDMEMORYAUTHSOURCE
#  define SB_USE_CLASS_TELSAMLIDPSSOLINK
#  define SB_USE_CLASS_TELSAMLIDENTITYPROVIDER
#endif /* SB_USE_UNIT_SAMLIDENTITYPROVIDER */

#ifdef SB_USE_UNIT_SAMLSERVICEPROVIDER
#  define SB_USE_GLOBAL_PROCS_SAMLSERVICEPROVIDER
#  define SB_USE_CLASS_TELSAMLSPSESSION
#  define SB_USE_CLASS_TELSAMLREQUESTRESULT
#  define SB_USE_CLASS_TELSAMLONETIMEUSERECORD
#  define SB_USE_CLASS_TELSAMLCUSTOMONETIMEUSECACHE
#  define SB_USE_CLASS_TELSAMLMEMORYONETIMEUSECACHE
#  define SB_USE_CLASS_TELSAMLSERVICEPROVIDER
#endif /* SB_USE_UNIT_SAMLSERVICEPROVIDER */

#ifdef SB_USE_UNIT_DCCMS
#  define SB_USE_CLASS_TELDCCMSSIGNOPERATIONHANDLER
#endif /* SB_USE_UNIT_DCCMS */

#ifdef SB_USE_CLASS_TELDCCMSSIGNOPERATIONHANDLER
#  define SB_USE_CLASS_TELDCSIGNOPERATIONHANDLER
#endif /* SB_USE_CLASS_TELDCCMSSIGNOPERATIONHANDLER */

#ifdef SB_USE_CLASS_TELSAMLSERVICEPROVIDER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSAMLSERVICEPROVIDER */

#ifdef SB_USE_CLASS_TELSAMLMEMORYONETIMEUSECACHE
#  define SB_USE_CLASS_TELSAMLCUSTOMONETIMEUSECACHE
#endif /* SB_USE_CLASS_TELSAMLMEMORYONETIMEUSECACHE */

#ifdef SB_USE_CLASS_TELSAMLCUSTOMONETIMEUSECACHE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSAMLCUSTOMONETIMEUSECACHE */

#ifdef SB_USE_CLASS_TELSAMLONETIMEUSERECORD
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSAMLONETIMEUSERECORD */

#ifdef SB_USE_CLASS_TELSAMLREQUESTRESULT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSAMLREQUESTRESULT */

#ifdef SB_USE_CLASS_TELSAMLSPSESSION
#  define SB_USE_CLASS_TELSAMLSESSION
#endif /* SB_USE_CLASS_TELSAMLSPSESSION */

#ifdef SB_USE_CLASS_TELSAMLIDENTITYPROVIDER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSAMLIDENTITYPROVIDER */

#ifdef SB_USE_CLASS_TELSAMLIDPSSOLINK
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSAMLIDPSSOLINK */

#ifdef SB_USE_CLASS_TELSAMLIDPPASSWORDMEMORYAUTHSOURCE
#  define SB_USE_CLASS_TELSAMLIDPCUSTOMAUTHSOURCE
#endif /* SB_USE_CLASS_TELSAMLIDPPASSWORDMEMORYAUTHSOURCE */

#ifdef SB_USE_CLASS_TELSAMLIDRECORD
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSAMLIDRECORD */

#ifdef SB_USE_CLASS_TELSAMLIDPCUSTOMAUTHSOURCE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSAMLIDPCUSTOMAUTHSOURCE */

#ifdef SB_USE_CLASS_TELSAMLSPDATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSAMLSPDATA */

#ifdef SB_USE_CLASS_TELSAMLSERVICEPROVIDERINFO
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSAMLSERVICEPROVIDERINFO */

#ifdef SB_USE_CLASS_TELSAMLIDPSESSION
#  define SB_USE_CLASS_TELSAMLSESSION
#endif /* SB_USE_CLASS_TELSAMLIDPSESSION */

#ifdef SB_USE_CLASS_TELSAMLNAMEIDMAPPINGRESPONSEELEMENT
#  define SB_USE_CLASS_TELSAMLSTATUSRESPONSETYPE
#endif /* SB_USE_CLASS_TELSAMLNAMEIDMAPPINGRESPONSEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLNAMEIDMAPPINGREQUESTELEMENT
#  define SB_USE_CLASS_TELSAMLREQUESTABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLNAMEIDMAPPINGREQUESTELEMENT */

#ifdef SB_USE_CLASS_TELSAMLLOGOUTRESPONSEELEMENT
#  define SB_USE_CLASS_TELSAMLSTATUSRESPONSETYPE
#endif /* SB_USE_CLASS_TELSAMLLOGOUTRESPONSEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLLOGOUTREQUESTELEMENT
#  define SB_USE_CLASS_TELSAMLREQUESTABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLLOGOUTREQUESTELEMENT */

#ifdef SB_USE_CLASS_TELSAMLMANAGENAMEIDRESPONSEELEMENT
#  define SB_USE_CLASS_TELSAMLSTATUSRESPONSETYPE
#endif /* SB_USE_CLASS_TELSAMLMANAGENAMEIDRESPONSEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLMANAGENAMEIDREQUESTELEMENT
#  define SB_USE_CLASS_TELSAMLREQUESTABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLMANAGENAMEIDREQUESTELEMENT */

#ifdef SB_USE_CLASS_TELSAMLARTIFACTRESPONSEELEMENT
#  define SB_USE_CLASS_TELSAMLSTATUSRESPONSETYPE
#endif /* SB_USE_CLASS_TELSAMLARTIFACTRESPONSEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLARTIFACTRESOLVEELEMENT
#  define SB_USE_CLASS_TELSAMLREQUESTABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLARTIFACTRESOLVEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLAUTHNREQUESTELEMENT
#  define SB_USE_CLASS_TELSAMLREQUESTABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLAUTHNREQUESTELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSCOPINGELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLSCOPINGELEMENT */

#ifdef SB_USE_CLASS_TELSAMLIDPLISTELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLIDPLISTELEMENT */

#ifdef SB_USE_CLASS_TELSAMLIDPENTRYELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLIDPENTRYELEMENT */

#ifdef SB_USE_CLASS_TELSAMLNAMEIDPOLICYELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLNAMEIDPOLICYELEMENT */

#ifdef SB_USE_CLASS_TELSAMLRESPONSEELEMENT
#  define SB_USE_CLASS_TELSAMLSTATUSRESPONSETYPE
#endif /* SB_USE_CLASS_TELSAMLRESPONSEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLAUTHZDECISIONQUERYELEMENT
#  define SB_USE_CLASS_TELSAMLSUBJECTQUERYABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLAUTHZDECISIONQUERYELEMENT */

#ifdef SB_USE_CLASS_TELSAMLATTRIBUTEQUERYELEMENT
#  define SB_USE_CLASS_TELSAMLSUBJECTQUERYABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLATTRIBUTEQUERYELEMENT */

#ifdef SB_USE_CLASS_TELSAMLAUTHNQUERYELEMENT
#  define SB_USE_CLASS_TELSAMLSUBJECTQUERYABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLAUTHNQUERYELEMENT */

#ifdef SB_USE_CLASS_TELSAMLREQUESTEDAUTHNCONTEXTELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLREQUESTEDAUTHNCONTEXTELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSUBJECTQUERYELEMENT
#  define SB_USE_CLASS_TELSAMLSUBJECTQUERYABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLSUBJECTQUERYELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSUBJECTQUERYABSTRACTTYPE
#  define SB_USE_CLASS_TELSAMLREQUESTABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLSUBJECTQUERYABSTRACTTYPE */

#ifdef SB_USE_CLASS_TELSAMLASSERTIONIDREQUESTELEMENT
#  define SB_USE_CLASS_TELSAMLREQUESTABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLASSERTIONIDREQUESTELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSTATUSRESPONSETYPE
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLSTATUSRESPONSETYPE */

#ifdef SB_USE_CLASS_TELSAMLSTATUSELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLSTATUSELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSTATUSDETAILELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLSTATUSDETAILELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSTATUSMESSAGEELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLSTATUSMESSAGEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSTATUSCODEELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLSTATUSCODEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLREQUESTABSTRACTTYPE
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLREQUESTABSTRACTTYPE */

#ifdef SB_USE_CLASS_TELSAMLEXTENSIONSELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLEXTENSIONSELEMENT */

#ifdef SB_USE_CLASS_TELSAMLENDPOINT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSAMLENDPOINT */

#ifdef SB_USE_CLASS_TELSAMLMETADATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSAMLMETADATA */

#ifdef SB_USE_CLASS_TELSAMLENCRYPTIONMETHODTYPE
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLENCRYPTIONMETHODTYPE */

#ifdef SB_USE_CLASS_TELSAMLSPSSODESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLSSODESCRIPTORTYPE
#endif /* SB_USE_CLASS_TELSAMLSPSSODESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLATTRIBUTECONSUMINGSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLATTRIBUTECONSUMINGSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSERVICEDESCRIPTIONELEMENT
#  define SB_USE_CLASS_TELSAMLLOCALIZEDNAMETYPE
#endif /* SB_USE_CLASS_TELSAMLSERVICEDESCRIPTIONELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSERVICENAMEELEMENT
#  define SB_USE_CLASS_TELSAMLLOCALIZEDNAMETYPE
#endif /* SB_USE_CLASS_TELSAMLSERVICENAMEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLREQUESTEDATTRIBUTEELEMENT
#  define SB_USE_CLASS_TELSAMLATTRIBUTETYPE
#endif /* SB_USE_CLASS_TELSAMLREQUESTEDATTRIBUTEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLASSERTIONCONSUMERSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLINDEXEDENDPOINTTYPE
#endif /* SB_USE_CLASS_TELSAMLASSERTIONCONSUMERSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLIDPSSODESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLSSODESCRIPTORTYPE
#endif /* SB_USE_CLASS_TELSAMLIDPSSODESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSSODESCRIPTORTYPE
#  define SB_USE_CLASS_TELSAMLROLEDESCRIPTORELEMENT
#endif /* SB_USE_CLASS_TELSAMLSSODESCRIPTORTYPE */

#ifdef SB_USE_CLASS_TELSAMLNAMEIDMAPPINGSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLENDPOINTTYPE
#endif /* SB_USE_CLASS_TELSAMLNAMEIDMAPPINGSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSINGLESIGNONSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLENDPOINTTYPE
#endif /* SB_USE_CLASS_TELSAMLSINGLESIGNONSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLMANAGENAMEIDSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLENDPOINTTYPE
#endif /* SB_USE_CLASS_TELSAMLMANAGENAMEIDSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSINGLELOGOUTSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLENDPOINTTYPE
#endif /* SB_USE_CLASS_TELSAMLSINGLELOGOUTSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLARTIFACTRESOLUTIONSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLINDEXEDENDPOINTTYPE
#endif /* SB_USE_CLASS_TELSAMLARTIFACTRESOLUTIONSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLADDITIONALMETADATALOCATIONELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLADDITIONALMETADATALOCATIONELEMENT */

#ifdef SB_USE_CLASS_TELSAMLORGANIZATIONURLELEMENT
#  define SB_USE_CLASS_TELSAMLLOCALIZEDURITYPE
#endif /* SB_USE_CLASS_TELSAMLORGANIZATIONURLELEMENT */

#ifdef SB_USE_CLASS_TELSAMLORGANIZATIONDISPLAYNAMEELEMENT
#  define SB_USE_CLASS_TELSAMLLOCALIZEDNAMETYPE
#endif /* SB_USE_CLASS_TELSAMLORGANIZATIONDISPLAYNAMEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLORGANIZATIONNAMEELEMENT
#  define SB_USE_CLASS_TELSAMLLOCALIZEDNAMETYPE
#endif /* SB_USE_CLASS_TELSAMLORGANIZATIONNAMEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLAFFILIATIONDESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLAFFILIATIONDESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLPDPDESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLROLEDESCRIPTORELEMENT
#endif /* SB_USE_CLASS_TELSAMLPDPDESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLAUTHZSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLENDPOINTTYPE
#endif /* SB_USE_CLASS_TELSAMLAUTHZSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLATTRIBUTEAUTHORITYDESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLROLEDESCRIPTORELEMENT
#endif /* SB_USE_CLASS_TELSAMLATTRIBUTEAUTHORITYDESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLATTRIBUTESERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLENDPOINTTYPE
#endif /* SB_USE_CLASS_TELSAMLATTRIBUTESERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLAUTHNAUTHORITYDESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLROLEDESCRIPTORELEMENT
#endif /* SB_USE_CLASS_TELSAMLAUTHNAUTHORITYDESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLASSERTIONIDREQUESTSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLENDPOINTTYPE
#endif /* SB_USE_CLASS_TELSAMLASSERTIONIDREQUESTSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLAUTHNQUERYSERVICEELEMENT
#  define SB_USE_CLASS_TELSAMLENDPOINTTYPE
#endif /* SB_USE_CLASS_TELSAMLAUTHNQUERYSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLROLEDESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLROLEDESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLCONTACTPERSONELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLCONTACTPERSONELEMENT */

#ifdef SB_USE_CLASS_TELSAMLORGANIZATIONELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLORGANIZATIONELEMENT */

#ifdef SB_USE_CLASS_TELSAMLKEYDESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLKEYDESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLENTITIESDESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLMETADATAROOTELEMENT
#endif /* SB_USE_CLASS_TELSAMLENTITIESDESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLENTITYDESCRIPTORELEMENT
#  define SB_USE_CLASS_TELSAMLMETADATAROOTELEMENT
#endif /* SB_USE_CLASS_TELSAMLENTITYDESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLINDEXEDENDPOINTTYPE
#  define SB_USE_CLASS_TELSAMLENDPOINTTYPE
#endif /* SB_USE_CLASS_TELSAMLINDEXEDENDPOINTTYPE */

#ifdef SB_USE_CLASS_TELSAMLENDPOINTTYPE
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLENDPOINTTYPE */

#ifdef SB_USE_CLASS_TELSAMLLOCALIZEDURITYPE
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLLOCALIZEDURITYPE */

#ifdef SB_USE_CLASS_TELSAMLLOCALIZEDNAMETYPE
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLLOCALIZEDNAMETYPE */

#ifdef SB_USE_CLASS_TELSAMLMETADATAROOTELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLMETADATAROOTELEMENT */

#ifdef SB_USE_CLASS_TELSAMLAUTHZDECISIONSTATEMENTELEMENT
#  define SB_USE_CLASS_TELSAMLSTATEMENTABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLAUTHZDECISIONSTATEMENTELEMENT */

#ifdef SB_USE_CLASS_TELSAMLEVIDENCEELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLEVIDENCEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLACTIONELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLACTIONELEMENT */

#ifdef SB_USE_CLASS_TELSAMLATTRIBUTESTATEMENTELEMENT
#  define SB_USE_CLASS_TELSAMLSTATEMENTABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLATTRIBUTESTATEMENTELEMENT */

#ifdef SB_USE_CLASS_TELSAMLENCRYPTEDATTRIBUTEELEMENT
#  define SB_USE_CLASS_TELSAMLATTRIBUTETYPE
#endif /* SB_USE_CLASS_TELSAMLENCRYPTEDATTRIBUTEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLATTRIBUTEELEMENT
#  define SB_USE_CLASS_TELSAMLATTRIBUTETYPE
#endif /* SB_USE_CLASS_TELSAMLATTRIBUTEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLATTRIBUTEVALUE
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLATTRIBUTEVALUE */

#ifdef SB_USE_CLASS_TELSAMLATTRIBUTETYPE
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLATTRIBUTETYPE */

#ifdef SB_USE_CLASS_TELSAMLAUTHNSTATEMENTELEMENT
#  define SB_USE_CLASS_TELSAMLSTATEMENTABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLAUTHNSTATEMENTELEMENT */

#ifdef SB_USE_CLASS_TELSAMLAUTHNCONTEXTELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLAUTHNCONTEXTELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSUBJECTLOCALITYELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLSUBJECTLOCALITYELEMENT */

#ifdef SB_USE_CLASS_TELSAMLPROXYRESTRICTIONELEMENT
#  define SB_USE_CLASS_TELSAMLCONDITIONABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLPROXYRESTRICTIONELEMENT */

#ifdef SB_USE_CLASS_TELSAMLONETIMEUSEELEMENT
#  define SB_USE_CLASS_TELSAMLCONDITIONABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLONETIMEUSEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLAUDIENCERESTRICTIONELEMENT
#  define SB_USE_CLASS_TELSAMLCONDITIONABSTRACTTYPE
#endif /* SB_USE_CLASS_TELSAMLAUDIENCERESTRICTIONELEMENT */

#ifdef SB_USE_CLASS_TELSAMLAUDIENCEELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLAUDIENCEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLCONDITIONABSTRACTTYPE
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLCONDITIONABSTRACTTYPE */

#ifdef SB_USE_CLASS_TELSAMLENCRYPTEDASSERTIONELEMENT
#  define SB_USE_CLASS_TELSAMLASSERTIONELEMENT
#endif /* SB_USE_CLASS_TELSAMLENCRYPTEDASSERTIONELEMENT */

#ifdef SB_USE_CLASS_TELSAMLASSERTIONELEMENT
#  define SB_USE_CLASS_TELSAMLASSERTIONTYPE
#endif /* SB_USE_CLASS_TELSAMLASSERTIONELEMENT */

#ifdef SB_USE_CLASS_TELSAMLASSERTIONURIREFELEMENT
#  define SB_USE_CLASS_TELSAMLASSERTIONTYPE
#endif /* SB_USE_CLASS_TELSAMLASSERTIONURIREFELEMENT */

#ifdef SB_USE_CLASS_TELSAMLASSERTIONIDREFELEMENT
#  define SB_USE_CLASS_TELSAMLASSERTIONTYPE
#endif /* SB_USE_CLASS_TELSAMLASSERTIONIDREFELEMENT */

#ifdef SB_USE_CLASS_TELSAMLASSERTIONTYPE
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLASSERTIONTYPE */

#ifdef SB_USE_CLASS_TELSAMLISSUERELEMENT
#  define SB_USE_CLASS_TELSAMLNAMEIDELEMENT
#endif /* SB_USE_CLASS_TELSAMLISSUERELEMENT */

#ifdef SB_USE_CLASS_TELSAMLENCRYPTEDIDELEMENT
#  define SB_USE_CLASS_TELSAMLID
#endif /* SB_USE_CLASS_TELSAMLENCRYPTEDIDELEMENT */

#ifdef SB_USE_CLASS_TELSAMLENCRYPTEDELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLENCRYPTEDELEMENT */

#ifdef SB_USE_CLASS_TELSAMLNAMEIDELEMENT
#  define SB_USE_CLASS_TELSAMLID
#endif /* SB_USE_CLASS_TELSAMLNAMEIDELEMENT */

#ifdef SB_USE_CLASS_TELSAMLBASEIDELEMENT
#  define SB_USE_CLASS_TELSAMLID
#endif /* SB_USE_CLASS_TELSAMLBASEIDELEMENT */

#ifdef SB_USE_CLASS_TELSAMLID
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLID */

#ifdef SB_USE_CLASS_TELSAMLSUBJECTELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLSUBJECTELEMENT */

#ifdef SB_USE_CLASS_TELSAMLENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELSAMLSECURITYHANDLER
#endif /* SB_USE_CLASS_TELSAMLENCRYPTIONHANDLER */

#ifdef SB_USE_CLASS_TELSAMLSIGNATUREHANDLER
#  define SB_USE_CLASS_TELSAMLSECURITYHANDLER
#endif /* SB_USE_CLASS_TELSAMLSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELSAMLSECURITYHANDLER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSAMLSECURITYHANDLER */

#ifdef SB_USE_CLASS_TELSAMLSUBJECTCONFIRMATIONELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLSUBJECTCONFIRMATIONELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSTATEMENTABSTRACTTYPE
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLSTATEMENTABSTRACTTYPE */

#ifdef SB_USE_CLASS_TELSAMLSUBJECTCONFIRMATIONDATAELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLSUBJECTCONFIRMATIONDATAELEMENT */

#ifdef SB_USE_CLASS_TELSAMLADVICEELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLADVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLCONDITIONSELEMENT
#  define SB_USE_CLASS_TELSAMLELEMENT
#endif /* SB_USE_CLASS_TELSAMLCONDITIONSELEMENT */

#ifdef SB_USE_CLASS_TELSAMLELEMENT
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELSAMLELEMENT */

#ifdef SB_USE_CLASS_TELSAMLADAPTER
#  define SB_USE_CLASS_TELCUSTOMSAMLADAPTER
#endif /* SB_USE_CLASS_TELSAMLADAPTER */

#ifdef SB_USE_CLASS_TELMEMORYARTIFACTSTORAGE
#  define SB_USE_CLASS_TELCUSTOMARTIFACTSTORAGE
#endif /* SB_USE_CLASS_TELMEMORYARTIFACTSTORAGE */

#ifdef SB_USE_CLASS_TELCUSTOMARTIFACTSTORAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMARTIFACTSTORAGE */

#ifdef SB_USE_CLASS_SBXMLSAMLCOMMON_TELSTRINGVALUE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_SBXMLSAMLCOMMON_TELSTRINGVALUE */

#ifdef SB_USE_CLASS_TELMEMORYSESSIONMANAGER
#  define SB_USE_CLASS_TELCUSTOMSESSIONMANAGER
#endif /* SB_USE_CLASS_TELMEMORYSESSIONMANAGER */

#ifdef SB_USE_CLASS_TELCUSTOMSESSIONMANAGER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMSESSIONMANAGER */

#ifdef SB_USE_CLASS_TELSAMLSESSION
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSAMLSESSION */

#ifdef SB_USE_CLASS_TELSAMLCLIENTSETTINGS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSAMLCLIENTSETTINGS */

#ifdef SB_USE_CLASS_TELSAMLARTIFACT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSAMLARTIFACT */

#ifdef SB_USE_CLASS_TELSAMLPOSTBINDING
#  define SB_USE_CLASS_TELSAMLBINDING
#endif /* SB_USE_CLASS_TELSAMLPOSTBINDING */

#ifdef SB_USE_CLASS_TELSAMLREDIRECTBINDING
#  define SB_USE_CLASS_TELSAMLBINDING
#endif /* SB_USE_CLASS_TELSAMLREDIRECTBINDING */

#ifdef SB_USE_CLASS_TELSAMLCOMPRESSEDPROCESSOR
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSAMLCOMPRESSEDPROCESSOR */

#ifdef SB_USE_CLASS_TELSAMLSOAPBINDING
#  define SB_USE_CLASS_TELSAMLBINDING
#endif /* SB_USE_CLASS_TELSAMLSOAPBINDING */

#ifdef SB_USE_CLASS_TELSAMLBINDING
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSAMLBINDING */

#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TELZIPSFXMAKER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELZIPSFXMAKER */

#ifndef WINCE
#ifdef SB_USE_CLASS_TELZIPSFXSTUB
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELZIPSFXSTUB */
#endif
#endif

#ifdef SB_USE_CLASS_TELBZIP2WRITER
#  define SB_USE_CLASS_TELBZIP2READER
#endif /* SB_USE_CLASS_TELBZIP2WRITER */

#ifdef SB_USE_CLASS_TELBZIP2READER
#  define SB_USE_CLASS_TELBASEARCHIVE
#endif /* SB_USE_CLASS_TELBZIP2READER */

#ifdef SB_USE_CLASS_TELBZIP2COMPRESSINGUNIT
#  define SB_USE_CLASS_TELARCPROCESSINGUNIT
#endif /* SB_USE_CLASS_TELBZIP2COMPRESSINGUNIT */

#ifdef SB_USE_CLASS_TELBZIP2DECOMPRESSINGUNIT
#  define SB_USE_CLASS_TELARCPROCESSINGUNIT
#endif /* SB_USE_CLASS_TELBZIP2DECOMPRESSINGUNIT */

#ifdef SB_USE_CLASS_TELGZIPWRITER
#  define SB_USE_CLASS_TELGZIPREADER
#endif /* SB_USE_CLASS_TELGZIPWRITER */

#ifdef SB_USE_CLASS_TELGZIPREADER
#  define SB_USE_CLASS_TELBASEARCHIVE
#endif /* SB_USE_CLASS_TELGZIPREADER */

#ifdef SB_USE_CLASS_TELGZIPFILEATTRIBUTES
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGZIPFILEATTRIBUTES */

#ifdef SB_USE_CLASS_TELGZIPCOMPRESSINGUNIT
#  define SB_USE_CLASS_TELARCPROCESSINGUNIT
#endif /* SB_USE_CLASS_TELGZIPCOMPRESSINGUNIT */

#ifdef SB_USE_CLASS_TELGZIPDECOMPRESSINGUNIT
#  define SB_USE_CLASS_TELARCPROCESSINGUNIT
#endif /* SB_USE_CLASS_TELGZIPDECOMPRESSINGUNIT */

#ifdef SB_USE_CLASS_TELTARPROCESSOR
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELTARPROCESSOR */

#ifdef SB_USE_CLASS_TELUSTARTARHEADER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELUSTARTARHEADER */

#ifdef SB_USE_CLASS_TELBASETARHEADER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBASETARHEADER */

#ifdef SB_USE_CLASS_TELTARFILEHEADER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELTARFILEHEADER */

#ifdef SB_USE_CLASS_TELTARWRITER
#  define SB_USE_CLASS_TELTARREADER
#endif /* SB_USE_CLASS_TELTARWRITER */

#ifdef SB_USE_CLASS_TELTARREADER
#  define SB_USE_CLASS_TELBASEARCHIVE
#endif /* SB_USE_CLASS_TELTARREADER */

#ifdef SB_USE_CLASS_TELTARPROCESSINGUNIT
#  define SB_USE_CLASS_TELARCPROCESSINGUNIT
#endif /* SB_USE_CLASS_TELTARPROCESSINGUNIT */

#ifdef SB_USE_CLASS_TELTARFILEATTRIBUTES
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELTARFILEATTRIBUTES */

#ifdef SB_USE_CLASS_TELTARARCHIVEDIRECTORYENTRY
#  define SB_USE_CLASS_TELARCHIVEDIRECTORYENTRY
#endif /* SB_USE_CLASS_TELTARARCHIVEDIRECTORYENTRY */

#ifdef SB_USE_CLASS_TELZIPENTITYUIDANDGIDEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYEXTENSION
#endif /* SB_USE_CLASS_TELZIPENTITYUIDANDGIDEXTENSION */

#ifdef SB_USE_CLASS_TELZIPENTITYEXTENDEDTIMESTAMPEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYEXTENSION
#endif /* SB_USE_CLASS_TELZIPENTITYEXTENDEDTIMESTAMPEXTENSION */

#ifdef SB_USE_CLASS_TELZIPENTITYUNIX2EXTENSION
#  define SB_USE_CLASS_TELZIPENTITYEXTENSION
#endif /* SB_USE_CLASS_TELZIPENTITYUNIX2EXTENSION */

#ifdef SB_USE_CLASS_TELZIPENTITYUNIX1EXTENSION
#  define SB_USE_CLASS_TELZIPENTITYEXTENSION
#endif /* SB_USE_CLASS_TELZIPENTITYUNIX1EXTENSION */

#ifdef SB_USE_CLASS_TELZIPENTITYCENTRALDIRSIGNATUREEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYSIGNATUREEXTENSION
#endif /* SB_USE_CLASS_TELZIPENTITYCENTRALDIRSIGNATUREEXTENSION */

#ifdef SB_USE_CLASS_TELZIPENTITYSIGNATUREEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYEXTENSION
#endif /* SB_USE_CLASS_TELZIPENTITYSIGNATUREEXTENSION */

#ifdef SB_USE_CLASS_TELZIPENTITYCERTIFICATESTOREEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYEXTENSION
#endif /* SB_USE_CLASS_TELZIPENTITYCERTIFICATESTOREEXTENSION */

#ifdef SB_USE_CLASS_TELZIPENTITYWINZIPAESEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYEXTENSION
#endif /* SB_USE_CLASS_TELZIPENTITYWINZIPAESEXTENSION */

#ifdef SB_USE_CLASS_TELZIPENTITYSTRONGENCRYPTIONEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYEXTENSION
#endif /* SB_USE_CLASS_TELZIPENTITYSTRONGENCRYPTIONEXTENSION */

#ifdef SB_USE_CLASS_TELZIPENTITYZIP64INFOEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYEXTENSION
#endif /* SB_USE_CLASS_TELZIPENTITYZIP64INFOEXTENSION */

#ifdef SB_USE_CLASS_TELZIPENTITYCUSTOMEXTENSION
#  define SB_USE_CLASS_TELZIPENTITYEXTENSION
#endif /* SB_USE_CLASS_TELZIPENTITYCUSTOMEXTENSION */

#ifdef SB_USE_CLASS_TELZIPENTITYEXTENSION
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELZIPENTITYEXTENSION */

#ifdef SB_USE_CLASS_TELZIPPROCESSOR
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELZIPPROCESSOR */

#ifdef SB_USE_CLASS_TELZIPARCHIVEEXTRADATA
#  define SB_USE_CLASS_TELZIPENTITY
#endif /* SB_USE_CLASS_TELZIPARCHIVEEXTRADATA */

#ifdef SB_USE_CLASS_TELZIPENDOFCENTRALDIRECTORY
#  define SB_USE_CLASS_TELZIPENTITY
#endif /* SB_USE_CLASS_TELZIPENDOFCENTRALDIRECTORY */

#ifdef SB_USE_CLASS_TELZIP64ENDOFCENTRALDIRECTORYLOCATOR
#  define SB_USE_CLASS_TELZIPENTITY
#endif /* SB_USE_CLASS_TELZIP64ENDOFCENTRALDIRECTORYLOCATOR */

#ifdef SB_USE_CLASS_TELZIP64ENDOFCENTRALDIRECTORY
#  define SB_USE_CLASS_TELZIPENTITY
#endif /* SB_USE_CLASS_TELZIP64ENDOFCENTRALDIRECTORY */

#ifdef SB_USE_CLASS_TELZIPCENTRALDIRECTORYSIGNATURE
#  define SB_USE_CLASS_TELZIPENTITY
#endif /* SB_USE_CLASS_TELZIPCENTRALDIRECTORYSIGNATURE */

#ifdef SB_USE_CLASS_TELZIPENTITYEXTENSIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELZIPENTITYEXTENSIONS */

#ifdef SB_USE_CLASS_TELZIPDATADESCRIPTOR
#  define SB_USE_CLASS_TELZIPENTITY
#endif /* SB_USE_CLASS_TELZIPDATADESCRIPTOR */

#ifdef SB_USE_CLASS_TELZIPCENTRALFILEHEADER
#  define SB_USE_CLASS_TELZIPENTITY
#endif /* SB_USE_CLASS_TELZIPCENTRALFILEHEADER */

#ifdef SB_USE_CLASS_TELZIPLOCALFILEHEADER
#  define SB_USE_CLASS_TELZIPENTITY
#endif /* SB_USE_CLASS_TELZIPLOCALFILEHEADER */

#ifdef SB_USE_CLASS_TELZIPENTITY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELZIPENTITY */

#ifdef SB_USE_CLASS_TELZIPWRITER
#  define SB_USE_CLASS_TELZIPREADER
#endif /* SB_USE_CLASS_TELZIPWRITER */

#ifdef SB_USE_CLASS_TELZIPREADER
#  define SB_USE_CLASS_TELBASEARCHIVE
#endif /* SB_USE_CLASS_TELZIPREADER */

#ifdef SB_USE_CLASS_TELZIPWINZIPAESENCRYPTINGUNIT
#  define SB_USE_CLASS_TELZIPWINZIPAESBASEUNIT
#endif /* SB_USE_CLASS_TELZIPWINZIPAESENCRYPTINGUNIT */

#ifdef SB_USE_CLASS_TELZIPWINZIPAESDECRYPTINGUNIT
#  define SB_USE_CLASS_TELZIPWINZIPAESBASEUNIT
#endif /* SB_USE_CLASS_TELZIPWINZIPAESDECRYPTINGUNIT */

#ifdef SB_USE_CLASS_TELZIPWINZIPAESBASEUNIT
#  define SB_USE_CLASS_TELZIPPROCESSINGUNIT
#endif /* SB_USE_CLASS_TELZIPWINZIPAESBASEUNIT */

#ifdef SB_USE_CLASS_TELZIPSTRONGENCRYPTIONHASHINGUNIT
#  define SB_USE_CLASS_TELZIPPROCESSINGUNIT
#endif /* SB_USE_CLASS_TELZIPSTRONGENCRYPTIONHASHINGUNIT */

#ifdef SB_USE_CLASS_TELZIPSTRONGENCRYPTIONDECRYPTINGUNIT
#  define SB_USE_CLASS_TELZIPSTRONGENCRYPTIONBASEUNIT
#endif /* SB_USE_CLASS_TELZIPSTRONGENCRYPTIONDECRYPTINGUNIT */

#ifdef SB_USE_CLASS_TELZIPSTRONGENCRYPTIONENCRYPTINGUNIT
#  define SB_USE_CLASS_TELZIPSTRONGENCRYPTIONBASEUNIT
#endif /* SB_USE_CLASS_TELZIPSTRONGENCRYPTIONENCRYPTINGUNIT */

#ifdef SB_USE_CLASS_TELZIPSTRONGENCRYPTIONBASEUNIT
#  define SB_USE_CLASS_TELZIPPROCESSINGUNIT
#endif /* SB_USE_CLASS_TELZIPSTRONGENCRYPTIONBASEUNIT */

#ifdef SB_USE_CLASS_TELZIPOLDSTYLEDECRYPTINGUNIT
#  define SB_USE_CLASS_TELZIPPROCESSINGUNIT
#endif /* SB_USE_CLASS_TELZIPOLDSTYLEDECRYPTINGUNIT */

#ifdef SB_USE_CLASS_TELZIPOLDSTYLEENCRYPTINGUNIT
#  define SB_USE_CLASS_TELZIPPROCESSINGUNIT
#endif /* SB_USE_CLASS_TELZIPOLDSTYLEENCRYPTINGUNIT */

#ifdef SB_USE_CLASS_TELZIPBZIP2COMPRESSINGUNIT
#  define SB_USE_CLASS_TELZIPPROCESSINGUNIT
#endif /* SB_USE_CLASS_TELZIPBZIP2COMPRESSINGUNIT */

#ifdef SB_USE_CLASS_TELZIPBZIP2DECOMPRESSINGUNIT
#  define SB_USE_CLASS_TELZIPPROCESSINGUNIT
#endif /* SB_USE_CLASS_TELZIPBZIP2DECOMPRESSINGUNIT */

#ifdef SB_USE_CLASS_TELZIPDEFLATECOMPRESSINGUNIT
#  define SB_USE_CLASS_TELZIPPROCESSINGUNIT
#endif /* SB_USE_CLASS_TELZIPDEFLATECOMPRESSINGUNIT */

#ifdef SB_USE_CLASS_TELZIPDEFLATEDECOMPRESSINGUNIT
#  define SB_USE_CLASS_TELZIPPROCESSINGUNIT
#endif /* SB_USE_CLASS_TELZIPDEFLATEDECOMPRESSINGUNIT */

#ifdef SB_USE_CLASS_TELZIPSTOREDPROCESSINGUNIT
#  define SB_USE_CLASS_TELZIPPROCESSINGUNIT
#endif /* SB_USE_CLASS_TELZIPSTOREDPROCESSINGUNIT */

#ifdef SB_USE_CLASS_TELZIPPROCESSINGUNIT
#  define SB_USE_CLASS_TELARCPROCESSINGUNIT
#endif /* SB_USE_CLASS_TELZIPPROCESSINGUNIT */

#ifdef SB_USE_CLASS_TELZIPSTRONGENCRYPTIONSIGNATUREINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELZIPSTRONGENCRYPTIONSIGNATUREINFO */

#ifdef SB_USE_CLASS_TELZIPSTRONGENCRYPTIONINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELZIPSTRONGENCRYPTIONINFO */

#ifdef SB_USE_CLASS_TELZIPUNIXFILEATTRIBUTES
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELZIPUNIXFILEATTRIBUTES */

#ifdef SB_USE_CLASS_TELZIPDOSFILEATTRIBUTES
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELZIPDOSFILEATTRIBUTES */

#ifdef SB_USE_CLASS_TELZIPARCHIVEDIRECTORYENTRY
#  define SB_USE_CLASS_TELARCHIVEDIRECTORYENTRY
#endif /* SB_USE_CLASS_TELZIPARCHIVEDIRECTORYENTRY */

#ifdef SB_USE_CLASS_TELARCPROCESSINGUNIT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELARCPROCESSINGUNIT */

#ifdef SB_USE_CLASS_TELARCHIVEDIRECTORYENTRY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELARCHIVEDIRECTORYENTRY */

#ifdef SB_USE_CLASS_TELBASEARCHIVE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELBASEARCHIVE */

#ifdef SB_USE_CLASS_TELXMLSOAPFAULT
#  define SB_USE_CLASS_TELXMLSOAPELEMENT
#endif /* SB_USE_CLASS_TELXMLSOAPFAULT */

#ifdef SB_USE_CLASS_TELXMLSOAPPARAMETERSMANAGER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLSOAPPARAMETERSMANAGER */

#ifdef SB_USE_CLASS_TELXMLSOAPCOMPOUNDPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPCUSTOMPARAMETER
#endif /* SB_USE_CLASS_TELXMLSOAPCOMPOUNDPARAMETER */

#ifdef SB_USE_CLASS_TELXMLSOAPBASE64BINARYPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPBASEPARAMETER
#endif /* SB_USE_CLASS_TELXMLSOAPBASE64BINARYPARAMETER */

#ifdef SB_USE_CLASS_TELXMLSOAPDATETIMEPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPBASEPARAMETER
#endif /* SB_USE_CLASS_TELXMLSOAPDATETIMEPARAMETER */

#ifdef SB_USE_CLASS_TELXMLSOAPDOUBLEPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPBASEPARAMETER
#endif /* SB_USE_CLASS_TELXMLSOAPDOUBLEPARAMETER */

#ifdef SB_USE_CLASS_TELXMLSOAPINT64PARAMETER
#  define SB_USE_CLASS_TELXMLSOAPBASEPARAMETER
#endif /* SB_USE_CLASS_TELXMLSOAPINT64PARAMETER */

#ifdef SB_USE_CLASS_TELXMLSOAPINTEGERPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPBASEPARAMETER
#endif /* SB_USE_CLASS_TELXMLSOAPINTEGERPARAMETER */

#ifdef SB_USE_CLASS_TELXMLSOAPBOOLEANPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPBASEPARAMETER
#endif /* SB_USE_CLASS_TELXMLSOAPBOOLEANPARAMETER */

#ifdef SB_USE_CLASS_TELXMLSOAPSTRINGPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPBASEPARAMETER
#endif /* SB_USE_CLASS_TELXMLSOAPSTRINGPARAMETER */

#ifdef SB_USE_CLASS_TELXMLSOAPBASEPARAMETER
#  define SB_USE_CLASS_TELXMLSOAPCUSTOMPARAMETER
#endif /* SB_USE_CLASS_TELXMLSOAPBASEPARAMETER */

#ifdef SB_USE_CLASS_TELXMLSOAPCUSTOMPARAMETER
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLSOAPCUSTOMPARAMETER */

#ifdef SB_USE_CLASS_TELXMLSOAPCLIENT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELXMLSOAPCLIENT */

#ifdef SB_USE_CLASS_TELXMLWSSSIGNATUREHANDLER
#  define SB_USE_CLASS_TELXMLSOAPBASESIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELXMLWSSSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELXMLSOAPSIGNATUREHANDLER
#  define SB_USE_CLASS_TELXMLSOAPBASESIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELXMLSOAPSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELXMLSOAPBASESIGNATUREHANDLER
#  define SB_USE_CLASS_TELXMLSOAPCUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELXMLSOAPBASESIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELXMLSOAPCUSTOMSIGNATUREHANDLER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELXMLSOAPCUSTOMSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELXMLSOAPMESSAGE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELXMLSOAPMESSAGE */

#ifdef SB_USE_CLASS_TELXMLWSSESECURITYTOKENREFERENCE
#  define SB_USE_CLASS_TELXMLKEYINFODATA
#endif /* SB_USE_CLASS_TELXMLWSSESECURITYTOKENREFERENCE */

#ifdef SB_USE_CLASS_TELXMLWSSEKEYIDENTIFIER
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLWSSEKEYIDENTIFIER */

#ifdef SB_USE_CLASS_TELXMLWSSEREFERENCE
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLWSSEREFERENCE */

#ifdef SB_USE_CLASS_TELXMLWSSESECURITY
#  define SB_USE_CLASS_TELXMLWSSEELEMENT
#endif /* SB_USE_CLASS_TELXMLWSSESECURITY */

#ifdef SB_USE_CLASS_TELXMLWSSEBINARYSECURITYTOKEN
#  define SB_USE_CLASS_TELXMLWSSEBASETOKEN
#endif /* SB_USE_CLASS_TELXMLWSSEBINARYSECURITYTOKEN */

#ifdef SB_USE_CLASS_TELXMLWSUTIMESTAMP
#  define SB_USE_CLASS_TELXMLWSSEBASETOKEN
#endif /* SB_USE_CLASS_TELXMLWSUTIMESTAMP */

#ifdef SB_USE_CLASS_TELXMLWSSEUSERNAMETOKEN
#  define SB_USE_CLASS_TELXMLWSSEBASETOKEN
#endif /* SB_USE_CLASS_TELXMLWSSEUSERNAMETOKEN */

#ifdef SB_USE_CLASS_TELXMLWSUDATETIME
#  define SB_USE_CLASS_TELXMLWSSEELEMENT
#endif /* SB_USE_CLASS_TELXMLWSUDATETIME */

#ifdef SB_USE_CLASS_TELXMLWSSENONCE
#  define SB_USE_CLASS_TELXMLWSSETEXTELEMENT
#endif /* SB_USE_CLASS_TELXMLWSSENONCE */

#ifdef SB_USE_CLASS_TELXMLWSSEPASSWORD
#  define SB_USE_CLASS_TELXMLWSSETEXTELEMENT
#endif /* SB_USE_CLASS_TELXMLWSSEPASSWORD */

#ifdef SB_USE_CLASS_TELXMLWSSETEXTELEMENT
#  define SB_USE_CLASS_TELXMLWSSEELEMENT
#endif /* SB_USE_CLASS_TELXMLWSSETEXTELEMENT */

#ifdef SB_USE_CLASS_TELXMLWSSEBASETOKEN
#  define SB_USE_CLASS_TELXMLWSSEELEMENT
#endif /* SB_USE_CLASS_TELXMLWSSEBASETOKEN */

#ifdef SB_USE_CLASS_TELXMLWSSEELEMENT
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLWSSEELEMENT */

#ifdef SB_USE_CLASS_TELXMLSOAPENVELOPE
#  define SB_USE_CLASS_TELXMLSOAPELEMENT
#endif /* SB_USE_CLASS_TELXMLSOAPENVELOPE */

#ifdef SB_USE_CLASS_TELXMLSOAPBODY
#  define SB_USE_CLASS_TELXMLSOAPELEMENT
#endif /* SB_USE_CLASS_TELXMLSOAPBODY */

#ifdef SB_USE_CLASS_TELXMLSOAPBODYENTRY
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLSOAPBODYENTRY */

#ifdef SB_USE_CLASS_TELXMLSOAPHEADER
#  define SB_USE_CLASS_TELXMLSOAPELEMENT
#endif /* SB_USE_CLASS_TELXMLSOAPHEADER */

#ifdef SB_USE_CLASS_TELXMLSOAPHEADERBLOCK
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLSOAPHEADERBLOCK */

#ifdef SB_USE_CLASS_TELXMLSOAPELEMENT
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLSOAPELEMENT */

#ifdef SB_USE_CLASS_TELXMLUNSUPPORTEDTRANSFORM
#  define SB_USE_CLASS_TELXMLTRANSFORM
#endif /* SB_USE_CLASS_TELXMLUNSUPPORTEDTRANSFORM */

#ifdef SB_USE_CLASS_TELXMLTRANSFORMCHAIN
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLTRANSFORMCHAIN */

#ifdef SB_USE_CLASS_TELXMLXPATHFILTER2TRANSFORM
#  define SB_USE_CLASS_TELXMLTRANSFORM
#endif /* SB_USE_CLASS_TELXMLXPATHFILTER2TRANSFORM */

#ifdef SB_USE_CLASS_TELXMLXPATHFILTERITEM
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLXPATHFILTERITEM */

#ifdef SB_USE_CLASS_TELXMLXPATHTRANSFORM
#  define SB_USE_CLASS_TELXMLTRANSFORM
#endif /* SB_USE_CLASS_TELXMLXPATHTRANSFORM */

#ifdef SB_USE_CLASS_TELXMLENVELOPEDSIGNATURETRANSFORM
#  define SB_USE_CLASS_TELXMLTRANSFORM
#endif /* SB_USE_CLASS_TELXMLENVELOPEDSIGNATURETRANSFORM */

#ifdef SB_USE_CLASS_TELXMLC14NTRANSFORM
#  define SB_USE_CLASS_TELXMLTRANSFORM
#endif /* SB_USE_CLASS_TELXMLC14NTRANSFORM */

#ifdef SB_USE_CLASS_TELXMLBASE64TRANSFORM
#  define SB_USE_CLASS_TELXMLTRANSFORM
#endif /* SB_USE_CLASS_TELXMLBASE64TRANSFORM */

#ifdef SB_USE_CLASS_TELXMLNULLTRANSFORM
#  define SB_USE_CLASS_TELXMLTRANSFORM
#endif /* SB_USE_CLASS_TELXMLNULLTRANSFORM */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLRELATIONSHIPTRANSFORM
#  define SB_USE_CLASS_TELXMLTRANSFORM
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLRELATIONSHIPTRANSFORM */

#ifdef SB_USE_CLASS_TELXMLSIGNATUREVALUE
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLSIGNATUREVALUE */

#ifdef SB_USE_CLASS_TELXMLOBJECTLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLOBJECTLIST */

#ifdef SB_USE_CLASS_TELXMLOBJECT
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLOBJECT */

#ifdef SB_USE_CLASS_TELXMLSIGNATUREPROPERTIES
#  define SB_USE_CLASS_TELXMLPROPERTIES
#endif /* SB_USE_CLASS_TELXMLSIGNATUREPROPERTIES */

#ifdef SB_USE_CLASS_TELXMLMANIFEST
#  define SB_USE_CLASS_TELXMLREFERENCELIST
#endif /* SB_USE_CLASS_TELXMLMANIFEST */

#ifdef SB_USE_CLASS_TELXMLSIGNEDINFO
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLSIGNEDINFO */

#ifdef SB_USE_CLASS_TELXMLSIGNATUREMETHODTYPE
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLSIGNATUREMETHODTYPE */

#ifdef SB_USE_CLASS_TELXMLVERIFIER
#  define SB_USE_CLASS_TELXMLSIGPROCESSOR
#endif /* SB_USE_CLASS_TELXMLVERIFIER */

#ifdef SB_USE_CLASS_TELXMLSIGNER
#  define SB_USE_CLASS_TELXMLSIGPROCESSOR
#endif /* SB_USE_CLASS_TELXMLSIGNER */

#ifdef SB_USE_CLASS_TELXMLSIGPROCESSOR
#  define SB_USE_CLASS_TELXMLPROCESSOR
#endif /* SB_USE_CLASS_TELXMLSIGPROCESSOR */

#ifdef SB_USE_CLASS_TELXMLSIGNATURE
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLSIGNATURE */

#ifdef SB_USE_CLASS_TELXMLDESCRIPTORMAP
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLDESCRIPTORMAP */

#ifdef SB_USE_CLASS_TELXMLFORMATTER
#  define SB_USE_CLASS_TELXMLCUSTOMFORMATTER
#endif /* SB_USE_CLASS_TELXMLFORMATTER */

#ifdef SB_USE_CLASS_TELXMLENCRYPTOR
#  define SB_USE_CLASS_TELXMLENCPROCESSOR
#endif /* SB_USE_CLASS_TELXMLENCRYPTOR */

#ifdef SB_USE_CLASS_TELXMLENCRYPTIONPROPERTIES
#  define SB_USE_CLASS_TELXMLPROPERTIES
#endif /* SB_USE_CLASS_TELXMLENCRYPTIONPROPERTIES */

#ifdef SB_USE_CLASS_TELXMLPROPERTY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLPROPERTY */

#ifdef SB_USE_CLASS_TELXMLKEYINFOAGREEMENTMETHOD
#  define SB_USE_CLASS_TELXMLKEYINFOITEM
#endif /* SB_USE_CLASS_TELXMLKEYINFOAGREEMENTMETHOD */

#ifdef SB_USE_CLASS_TELXMLKEYINFORETRIEVALMETHOD
#  define SB_USE_CLASS_TELXMLKEYINFOITEM
#endif /* SB_USE_CLASS_TELXMLKEYINFORETRIEVALMETHOD */

#ifdef SB_USE_CLASS_TELXMLKEYINFONODE
#  define SB_USE_CLASS_TELXMLKEYINFOITEM
#endif /* SB_USE_CLASS_TELXMLKEYINFONODE */

#ifdef SB_USE_CLASS_TELXMLKEYINFOX509DATA
#  define SB_USE_CLASS_TELXMLKEYINFOASYMMETRICDATA
#endif /* SB_USE_CLASS_TELXMLKEYINFOX509DATA */

#ifdef SB_USE_CLASS_TELXMLISSUERSERIAL
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLISSUERSERIAL */

#ifdef SB_USE_CLASS_TELXMLKEYINFOECDATA
#  define SB_USE_CLASS_TELXMLKEYINFOASYMMETRICDATA
#endif /* SB_USE_CLASS_TELXMLKEYINFOECDATA */

#ifdef SB_USE_CLASS_TELXMLKEYINFOPGPDATA
#  define SB_USE_CLASS_TELXMLKEYINFOASYMMETRICDATA
#endif /* SB_USE_CLASS_TELXMLKEYINFOPGPDATA */

#ifdef SB_USE_CLASS_TELXMLKEYINFOGOST2001DATA
#  define SB_USE_CLASS_TELXMLKEYINFOASYMMETRICDATA
#endif /* SB_USE_CLASS_TELXMLKEYINFOGOST2001DATA */

#ifdef SB_USE_CLASS_TELXMLKEYINFODHDATA
#  define SB_USE_CLASS_TELXMLKEYINFOASYMMETRICDATA
#endif /* SB_USE_CLASS_TELXMLKEYINFODHDATA */

#ifdef SB_USE_CLASS_TELXMLKEYINFODSADATA
#  define SB_USE_CLASS_TELXMLKEYINFOASYMMETRICDATA
#endif /* SB_USE_CLASS_TELXMLKEYINFODSADATA */

#ifdef SB_USE_CLASS_TELXMLKEYINFORSADATA
#  define SB_USE_CLASS_TELXMLKEYINFOASYMMETRICDATA
#endif /* SB_USE_CLASS_TELXMLKEYINFORSADATA */

#ifdef SB_USE_CLASS_TELXMLKEYINFOASYMMETRICDATA
#  define SB_USE_CLASS_TELXMLKEYINFODATA
#endif /* SB_USE_CLASS_TELXMLKEYINFOASYMMETRICDATA */

#ifdef SB_USE_CLASS_TELXMLKEYINFOSYMMETRICDATA
#  define SB_USE_CLASS_TELXMLKEYINFODATA
#endif /* SB_USE_CLASS_TELXMLKEYINFOSYMMETRICDATA */

#ifdef SB_USE_CLASS_TELXMLKEYINFOHMACDATA
#  define SB_USE_CLASS_TELXMLKEYINFODATA
#endif /* SB_USE_CLASS_TELXMLKEYINFOHMACDATA */

#ifdef SB_USE_CLASS_TELXMLKEYINFODATA
#  define SB_USE_CLASS_TELXMLKEYINFOITEM
#endif /* SB_USE_CLASS_TELXMLKEYINFODATA */

#ifdef SB_USE_CLASS_TELXMLKEYINFOITEM
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLKEYINFOITEM */

#ifdef SB_USE_CLASS_TELXMLRSAPSSPARAMETERS
#  define SB_USE_CLASS_TELXMLALGORITHMPARAMETERS
#endif /* SB_USE_CLASS_TELXMLRSAPSSPARAMETERS */

#ifdef SB_USE_CLASS_TELXMLGOSTR3411PARAMETERS
#  define SB_USE_CLASS_TELXMLALGORITHMPARAMETERS
#endif /* SB_USE_CLASS_TELXMLGOSTR3411PARAMETERS */

#ifdef SB_USE_CLASS_TELXMLREFERENCELIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLREFERENCELIST */

#ifdef SB_USE_CLASS_TELXMLREFERENCE
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLREFERENCE */

#ifdef SB_USE_CLASS_TELXMLALGORITHMPARAMETERS
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLALGORITHMPARAMETERS */

#ifdef SB_USE_CLASS_TELXMLKEYINFO
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLKEYINFO */

#ifdef SB_USE_CLASS_TELXMLBINARYDECRYPTIONTRANSFORM
#  define SB_USE_CLASS_TELXMLCUSTOMDECRYPTIONTRANSFORM
#endif /* SB_USE_CLASS_TELXMLBINARYDECRYPTIONTRANSFORM */

#ifdef SB_USE_CLASS_TELXMLDECRYPTIONTRANSFORM
#  define SB_USE_CLASS_TELXMLCUSTOMDECRYPTIONTRANSFORM
#endif /* SB_USE_CLASS_TELXMLDECRYPTIONTRANSFORM */

#ifdef SB_USE_CLASS_TELXMLCUSTOMDECRYPTIONTRANSFORM
#  define SB_USE_CLASS_TELXMLTRANSFORM
#endif /* SB_USE_CLASS_TELXMLCUSTOMDECRYPTIONTRANSFORM */

#ifdef SB_USE_CLASS_TELXMLDECRYPTIONEXCEPT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLDECRYPTIONEXCEPT */

#ifdef SB_USE_CLASS_TELXMLENCRYPTEDKEY
#  define SB_USE_CLASS_TELXMLENCRYPTEDTYPE
#endif /* SB_USE_CLASS_TELXMLENCRYPTEDKEY */

#ifdef SB_USE_CLASS_TELXMLENCRYPTEDDATA
#  define SB_USE_CLASS_TELXMLENCRYPTEDTYPE
#endif /* SB_USE_CLASS_TELXMLENCRYPTEDDATA */

#ifdef SB_USE_CLASS_TELXMLPROPERTIES
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLPROPERTIES */

#ifdef SB_USE_CLASS_TELXMLENCRYPTIONMETHODTYPE
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLENCRYPTIONMETHODTYPE */

#ifdef SB_USE_CLASS_TELXMLCIPHERDATA
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLCIPHERDATA */

#ifdef SB_USE_CLASS_TELXMLCIPHERREFERENCE
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLCIPHERREFERENCE */

#ifdef SB_USE_CLASS_TELXMLDECRYPTOR
#  define SB_USE_CLASS_TELXMLENCPROCESSOR
#endif /* SB_USE_CLASS_TELXMLDECRYPTOR */

#ifdef SB_USE_CLASS_TELXMLENCPROCESSOR
#  define SB_USE_CLASS_TELXMLPROCESSOR
#endif /* SB_USE_CLASS_TELXMLENCPROCESSOR */

#ifdef SB_USE_CLASS_TELXMLPROCESSOR
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELXMLPROCESSOR */

#ifdef SB_USE_CLASS_TELXMLENCRYPTEDTYPE
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLENCRYPTEDTYPE */

#ifdef SB_USE_CLASS_TELXADESVERIFIER
#  define SB_USE_CLASS_TELXADESPROCESSOR
#endif /* SB_USE_CLASS_TELXADESVERIFIER */

#ifdef SB_USE_CLASS_TELXADESSIGNER
#  define SB_USE_CLASS_TELXADESPROCESSOR
#endif /* SB_USE_CLASS_TELXADESSIGNER */

#ifdef SB_USE_CLASS_TELXADESPROCESSOR
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELXADESPROCESSOR */

#ifdef SB_USE_CLASS_TELXMLQUALIFYINGPROPERTIESREFERENCELIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLQUALIFYINGPROPERTIESREFERENCELIST */

#ifdef SB_USE_CLASS_TELXMLQUALIFYINGPROPERTIESREFERENCE
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLQUALIFYINGPROPERTIESREFERENCE */

#ifdef SB_USE_CLASS_TELXMLQUALIFYINGPROPERTIES
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLQUALIFYINGPROPERTIES */

#ifdef SB_USE_CLASS_TELXMLUNSIGNEDPROPERTIES
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLUNSIGNEDPROPERTIES */

#ifdef SB_USE_CLASS_TELXMLSIGNEDPROPERTIES
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLSIGNEDPROPERTIES */

#ifdef SB_USE_CLASS_TELXMLUNSIGNEDSIGNATUREPROPERTIES
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLUNSIGNEDSIGNATUREPROPERTIES */

#ifdef SB_USE_CLASS_TELXMLSIGNEDSIGNATUREPROPERTIES
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLSIGNEDSIGNATUREPROPERTIES */

#ifdef SB_USE_CLASS_TELXMLUNSIGNEDDATAOBJECTPROPERTY
#  define SB_USE_CLASS_TELXMLANYTYPE
#endif /* SB_USE_CLASS_TELXMLUNSIGNEDDATAOBJECTPROPERTY */

#ifdef SB_USE_CLASS_TELXMLSIGNEDDATAOBJECTPROPERTIES
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLSIGNEDDATAOBJECTPROPERTIES */

#ifdef SB_USE_CLASS_TELXMLTIMESTAMPVALIDATIONDATALIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLTIMESTAMPVALIDATIONDATALIST */

#ifdef SB_USE_CLASS_TELXMLTIMESTAMPVALIDATIONDATA
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLTIMESTAMPVALIDATIONDATA */

#ifdef SB_USE_CLASS_TELXMLREVOCATIONVALUES
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLREVOCATIONVALUES */

#ifdef SB_USE_CLASS_TELXMLOCSPVALUES
#  define SB_USE_CLASS_TELXMLENCAPSULATEDPKIDATALIST
#endif /* SB_USE_CLASS_TELXMLOCSPVALUES */

#ifdef SB_USE_CLASS_TELXMLENCAPSULATEDOCSPVALUE
#  define SB_USE_CLASS_TELXMLENCAPSULATEDPKIDATA
#endif /* SB_USE_CLASS_TELXMLENCAPSULATEDOCSPVALUE */

#ifdef SB_USE_CLASS_TELXMLCRLVALUES
#  define SB_USE_CLASS_TELXMLENCAPSULATEDPKIDATALIST
#endif /* SB_USE_CLASS_TELXMLCRLVALUES */

#ifdef SB_USE_CLASS_TELXMLENCAPSULATEDCRLVALUE
#  define SB_USE_CLASS_TELXMLENCAPSULATEDPKIDATA
#endif /* SB_USE_CLASS_TELXMLENCAPSULATEDCRLVALUE */

#ifdef SB_USE_CLASS_TELXMLCERTIFICATEVALUES
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLCERTIFICATEVALUES */

#ifdef SB_USE_CLASS_TELXMLCOMPLETEREVOCATIONREFS
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLCOMPLETEREVOCATIONREFS */

#ifdef SB_USE_CLASS_TELXMLOTHERREF
#  define SB_USE_CLASS_TELXMLANYTYPE
#endif /* SB_USE_CLASS_TELXMLOTHERREF */

#ifdef SB_USE_CLASS_TELXMLOCSPREFS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLOCSPREFS */

#ifdef SB_USE_CLASS_TELXMLOCSPREF
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLOCSPREF */

#ifdef SB_USE_CLASS_TELXMLOCSPIDENTIFIER
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLOCSPIDENTIFIER */

#ifdef SB_USE_CLASS_TELXMLCRLREFS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLCRLREFS */

#ifdef SB_USE_CLASS_TELXMLCRLREF
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLCRLREF */

#ifdef SB_USE_CLASS_TELXMLCRLIDENTIFIER
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLCRLIDENTIFIER */

#ifdef SB_USE_CLASS_TELXMLCOMPLETECERTIFICATEREFS
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLCOMPLETECERTIFICATEREFS */

#ifdef SB_USE_CLASS_TELXMLSIGNERROLE
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLSIGNERROLE */

#ifdef SB_USE_CLASS_TELXMLCLAIMEDROLESLIST
#  define SB_USE_CLASS_TELXMLANYTYPELIST
#endif /* SB_USE_CLASS_TELXMLCLAIMEDROLESLIST */

#ifdef SB_USE_CLASS_TELXMLCLAIMEDROLE
#  define SB_USE_CLASS_TELXMLANYTYPE
#endif /* SB_USE_CLASS_TELXMLCLAIMEDROLE */

#ifdef SB_USE_CLASS_TELXMLCERTIFIEDROLESLIST
#  define SB_USE_CLASS_TELXMLENCAPSULATEDX509CERTIFICATES
#endif /* SB_USE_CLASS_TELXMLCERTIFIEDROLESLIST */

#ifdef SB_USE_CLASS_TELXMLCERTIFIEDROLE
#  define SB_USE_CLASS_TELXMLENCAPSULATEDPKIDATA
#endif /* SB_USE_CLASS_TELXMLCERTIFIEDROLE */

#ifdef SB_USE_CLASS_TELXMLENCAPSULATEDX509CERTIFICATES
#  define SB_USE_CLASS_TELXMLENCAPSULATEDPKIDATALIST
#endif /* SB_USE_CLASS_TELXMLENCAPSULATEDX509CERTIFICATES */

#ifdef SB_USE_CLASS_TELXMLSIGNATUREPRODUCTIONPLACE
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLSIGNATUREPRODUCTIONPLACE */

#ifdef SB_USE_CLASS_TELXMLCOMMITMENTTYPEINDICATIONLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLCOMMITMENTTYPEINDICATIONLIST */

#ifdef SB_USE_CLASS_TELXMLCOMMITMENTTYPEINDICATION
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLCOMMITMENTTYPEINDICATION */

#ifdef SB_USE_CLASS_TELXMLCOMMITMENTTYPEQUALIFIER
#  define SB_USE_CLASS_TELXMLANYTYPE
#endif /* SB_USE_CLASS_TELXMLCOMMITMENTTYPEQUALIFIER */

#ifdef SB_USE_CLASS_TELXMLDATAOBJECTFORMATLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLDATAOBJECTFORMATLIST */

#ifdef SB_USE_CLASS_TELXMLDATAOBJECTFORMAT
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLDATAOBJECTFORMAT */

#ifdef SB_USE_CLASS_TELXMLCOUNTERSIGNATURELIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLCOUNTERSIGNATURELIST */

#ifdef SB_USE_CLASS_TELXMLCOUNTERSIGNATURE
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLCOUNTERSIGNATURE */

#ifdef SB_USE_CLASS_TELXMLSIGNATUREPOLICYIDENTIFIER
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLSIGNATUREPOLICYIDENTIFIER */

#ifdef SB_USE_CLASS_TELXMLSIGNATUREPOLICYID
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLSIGNATUREPOLICYID */

#ifdef SB_USE_CLASS_TELXMLSIGPOLICYQUALIFIER
#  define SB_USE_CLASS_TELXMLANYTYPE
#endif /* SB_USE_CLASS_TELXMLSIGPOLICYQUALIFIER */

#ifdef SB_USE_CLASS_TELXMLSPURI
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLSPURI */

#ifdef SB_USE_CLASS_TELXMLSPUSERNOTICE
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLSPUSERNOTICE */

#ifdef SB_USE_CLASS_TELXMLNOTICEREFERENCE
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLNOTICEREFERENCE */

#ifdef SB_USE_CLASS_TELXMLCERTIDLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLCERTIDLIST */

#ifdef SB_USE_CLASS_TELXMLCERTID
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLCERTID */

#ifdef SB_USE_CLASS_TELXMLDIGESTALGANDVALUE
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLDIGESTALGANDVALUE */

#ifdef SB_USE_CLASS_TELXMLGENERICTIMESTAMPLIST
#  define SB_USE_CLASS_TELXMLCUSTOMTIMESTAMPLIST
#endif /* SB_USE_CLASS_TELXMLGENERICTIMESTAMPLIST */

#ifdef SB_USE_CLASS_TELXMLGENERICTIMESTAMP
#  define SB_USE_CLASS_TELXMLCUSTOMTIMESTAMP
#endif /* SB_USE_CLASS_TELXMLGENERICTIMESTAMP */

#ifdef SB_USE_CLASS_TELCUSTOMTSPCLIENTLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMTSPCLIENTLIST */

#ifdef SB_USE_CLASS_TELXMLTIMESTAMPLIST_V1_2_2
#  define SB_USE_CLASS_TELXMLCUSTOMTIMESTAMPLIST
#endif /* SB_USE_CLASS_TELXMLTIMESTAMPLIST_V1_2_2 */

#ifdef SB_USE_CLASS_TELXMLTIMESTAMP_V1_2_2
#  define SB_USE_CLASS_TELXMLCUSTOMTIMESTAMP
#endif /* SB_USE_CLASS_TELXMLTIMESTAMP_V1_2_2 */

#ifdef SB_USE_CLASS_TELXMLINCLUDELIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLINCLUDELIST */

#ifdef SB_USE_CLASS_TELXMLINCLUDE
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLINCLUDE */

#ifdef SB_USE_CLASS_TELXMLTIMESTAMPLIST
#  define SB_USE_CLASS_TELXMLCUSTOMTIMESTAMPLIST
#endif /* SB_USE_CLASS_TELXMLTIMESTAMPLIST */

#ifdef SB_USE_CLASS_TELXMLTIMESTAMP
#  define SB_USE_CLASS_TELXMLCUSTOMTIMESTAMP
#endif /* SB_USE_CLASS_TELXMLTIMESTAMP */

#ifdef SB_USE_CLASS_TELXMLCUSTOMTIMESTAMPLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLCUSTOMTIMESTAMPLIST */

#ifdef SB_USE_CLASS_TELXMLCUSTOMTIMESTAMP
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLCUSTOMTIMESTAMP */

#ifdef SB_USE_CLASS_TELXMLHASHDATAINFOLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLHASHDATAINFOLIST */

#ifdef SB_USE_CLASS_TELXMLHASHDATAINFO
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLHASHDATAINFO */

#ifdef SB_USE_CLASS_TELXMLENCAPSULATEDPKIDATALIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLENCAPSULATEDPKIDATALIST */

#ifdef SB_USE_CLASS_TELXMLENCAPSULATEDPKIDATA
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLENCAPSULATEDPKIDATA */

#ifdef SB_USE_CLASS_TELXMLOBJECTIDENTIFIER
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLOBJECTIDENTIFIER */

#ifdef SB_USE_CLASS_TELXMLANYTYPELIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLANYTYPELIST */

#ifdef SB_USE_CLASS_TELXMLANYTYPE
#  define SB_USE_CLASS_TELXMLADESELEMENT
#endif /* SB_USE_CLASS_TELXMLANYTYPE */

#ifdef SB_USE_CLASS_TELXMLADESELEMENT
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLADESELEMENT */

#ifdef SB_USE_CLASS_TELFUNCTIONCALLNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELFUNCTIONCALLNODE */

#ifdef SB_USE_CLASS_TELNUMBERNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELNUMBERNODE */

#ifdef SB_USE_CLASS_TELLITERALNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELLITERALNODE */

#ifdef SB_USE_CLASS_TELVARIABLEREFERENCENODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELVARIABLEREFERENCENODE */

#ifdef SB_USE_CLASS_TELPRIMARYEXPRNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELPRIMARYEXPRNODE */

#ifdef SB_USE_CLASS_TELFILTEREXPRNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELFILTEREXPRNODE */

#ifdef SB_USE_CLASS_TELUNARYEXPRNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELUNARYEXPRNODE */

#ifdef SB_USE_CLASS_TELMULTIPLICATIVEEXPRNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELMULTIPLICATIVEEXPRNODE */

#ifdef SB_USE_CLASS_TELADDITIVEEXPRNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELADDITIVEEXPRNODE */

#ifdef SB_USE_CLASS_TELRELATIONALEXPRNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELRELATIONALEXPRNODE */

#ifdef SB_USE_CLASS_TELEQUALITYEXPRNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELEQUALITYEXPRNODE */

#ifdef SB_USE_CLASS_TELANDEXPRNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELANDEXPRNODE */

#ifdef SB_USE_CLASS_TELOREXPRNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELOREXPRNODE */

#ifdef SB_USE_CLASS_TELPREDICATENODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELPREDICATENODE */

#ifdef SB_USE_CLASS_TELSTEPNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELSTEPNODE */

#ifdef SB_USE_CLASS_TELRELATIVELOCATIONPATHNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELRELATIVELOCATIONPATHNODE */

#ifdef SB_USE_CLASS_TELABSOLUTELOCATIONPATHNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELABSOLUTELOCATIONPATHNODE */

#ifdef SB_USE_CLASS_TELLOCATIONPATHNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELLOCATIONPATHNODE */

#ifdef SB_USE_CLASS_TELPATHEXPRNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELPATHEXPRNODE */

#ifdef SB_USE_CLASS_TELUNIONEXPRNODE
#  define SB_USE_CLASS_TELXPATHNODE
#endif /* SB_USE_CLASS_TELUNIONEXPRNODE */

#ifdef SB_USE_CLASS_TELXPATHNODE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXPATHNODE */

#ifdef SB_USE_CLASS_TELXMLVARMAP
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLVARMAP */

#ifdef SB_USE_CLASS_TELSTRING
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSTRING */

#ifdef SB_USE_CLASS_TELBOOLEAN
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOOLEAN */

#ifdef SB_USE_CLASS_TELNUMBER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELNUMBER */

#ifdef SB_USE_CLASS_TELXPATH
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXPATH */

#ifdef SB_USE_CLASS_TELVERSIONURI
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELVERSIONURI */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLRELATIONSHIP
#  define SB_USE_CLASS_TELOFFICEOPENXMLELEMENT
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLRELATIONSHIP */

#ifdef SB_USE_CLASS_TELXMLCUSTOMFORMATTER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLCUSTOMFORMATTER */

#ifdef SB_USE_CLASS_TELXMLNAMESPACEMAP
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLNAMESPACEMAP */

#ifdef SB_USE_CLASS_TELXMLPARSER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLPARSER */

#ifdef SB_USE_CLASS_TELXMLDOMPROCESSINGINSTRUCTION
#  define SB_USE_CLASS_TELXMLDOMNODE
#endif /* SB_USE_CLASS_TELXMLDOMPROCESSINGINSTRUCTION */

#ifdef SB_USE_CLASS_TELXMLDOMENTITYREFERENCE
#  define SB_USE_CLASS_TELXMLDOMNODE
#endif /* SB_USE_CLASS_TELXMLDOMENTITYREFERENCE */

#ifdef SB_USE_CLASS_TELXMLDOMENTITY
#  define SB_USE_CLASS_TELXMLDOMNODE
#endif /* SB_USE_CLASS_TELXMLDOMENTITY */

#ifdef SB_USE_CLASS_TELXMLDOMNOTATION
#  define SB_USE_CLASS_TELXMLDOMNODE
#endif /* SB_USE_CLASS_TELXMLDOMNOTATION */

#ifdef SB_USE_CLASS_TELXMLDOMDOCUMENTTYPE
#  define SB_USE_CLASS_TELXMLDOMNODE
#endif /* SB_USE_CLASS_TELXMLDOMDOCUMENTTYPE */

#ifdef SB_USE_CLASS_TELXMLDOMCDATASECTION
#  define SB_USE_CLASS_TELXMLDOMTEXT
#endif /* SB_USE_CLASS_TELXMLDOMCDATASECTION */

#ifdef SB_USE_CLASS_TELXMLDOMCOMMENT
#  define SB_USE_CLASS_TELXMLDOMCHARACTERDATA
#endif /* SB_USE_CLASS_TELXMLDOMCOMMENT */

#ifdef SB_USE_CLASS_TELXMLDOMTEXT
#  define SB_USE_CLASS_TELXMLDOMCHARACTERDATA
#endif /* SB_USE_CLASS_TELXMLDOMTEXT */

#ifdef SB_USE_CLASS_TELXMLDOMELEMENT
#  define SB_USE_CLASS_TELXMLDOMNODE
#endif /* SB_USE_CLASS_TELXMLDOMELEMENT */

#ifdef SB_USE_CLASS_TELXMLDOMATTR
#  define SB_USE_CLASS_TELXMLDOMNODE
#endif /* SB_USE_CLASS_TELXMLDOMATTR */

#ifdef SB_USE_CLASS_TELXMLDOMCHARACTERDATA
#  define SB_USE_CLASS_TELXMLDOMNODE
#endif /* SB_USE_CLASS_TELXMLDOMCHARACTERDATA */

#ifdef SB_USE_CLASS_TELXMLDOMNAMEDNODEMAP
#  define SB_USE_CLASS_TLIST
#endif /* SB_USE_CLASS_TELXMLDOMNAMEDNODEMAP */

#ifdef SB_USE_CLASS_TELXMLDOMNODELIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLDOMNODELIST */

#ifdef SB_USE_CLASS_TELXMLNODESET
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLNODESET */

#ifdef SB_USE_CLASS_TELXMLDOMDOCUMENTFRAGMENT
#  define SB_USE_CLASS_TELXMLDOMNODE
#endif /* SB_USE_CLASS_TELXMLDOMDOCUMENTFRAGMENT */

#ifdef SB_USE_CLASS_TELXMLDOMDOCUMENT
#  define SB_USE_CLASS_TELXMLDOMNODE
#endif /* SB_USE_CLASS_TELXMLDOMDOCUMENT */

#ifdef SB_USE_CLASS_TELXMLDOMNODE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLDOMNODE */

#ifdef SB_USE_CLASS_TELXMLDOMIMPLEMENTATION
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLDOMIMPLEMENTATION */

#ifdef SB_USE_CLASS_TELXMLSTRINGCODEC
#  define SB_USE_CLASS_TELXMLCODEC
#endif /* SB_USE_CLASS_TELXMLSTRINGCODEC */

#ifdef SB_USE_CLASS_TELXMLUNICODECODEC
#  define SB_USE_CLASS_TELXMLCODEC
#endif /* SB_USE_CLASS_TELXMLUNICODECODEC */

#ifdef SB_USE_CLASS_TELXMLUTF8CODEC
#  define SB_USE_CLASS_TELXMLCODEC
#endif /* SB_USE_CLASS_TELXMLUTF8CODEC */

#ifdef SB_USE_CLASS_TELXML8BITCODEC
#  define SB_USE_CLASS_TELXMLCODEC
#endif /* SB_USE_CLASS_TELXML8BITCODEC */

#ifdef SB_USE_CLASS_TELXMLCODEC
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLCODEC */

#ifdef SB_USE_CLASS_TELXMLBUFFERINGSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELXMLBUFFERINGSTREAM */

#ifdef SB_USE_CLASS_TELDTLSSERVERFACTORY
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELDTLSSERVERFACTORY */

#ifdef SB_USE_CLASS_TELDTLSSERVER
#  define SB_USE_CLASS_TELSSLSERVER
#endif /* SB_USE_CLASS_TELDTLSSERVER */

#ifdef SB_USE_CLASS_TELSESSIONPOOL
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSESSIONPOOL */

#ifdef SB_USE_CLASS_TELSSLSERVERENVIRONMENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSLSERVERENVIRONMENT */

#ifdef SB_USE_CLASS_TELSSLSERVER
#  define SB_USE_CLASS_TELSSLCLASS
#endif /* SB_USE_CLASS_TELSSLSERVER */

#ifdef SB_USE_CLASS_TELSERVERSSLCONNECTIONINFO
#  define SB_USE_CLASS_TELSSLCONNECTIONINFO
#endif /* SB_USE_CLASS_TELSERVERSSLCONNECTIONINFO */

#ifdef SB_USE_CLASS_TELDTLSCLIENT
#  define SB_USE_CLASS_TELSSLCLIENT
#endif /* SB_USE_CLASS_TELDTLSCLIENT */

#ifdef SB_USE_CLASS_TELSMTPCLIENT
#  define SB_USE_CLASS_TELCOMMANDSSLCLIENT
#endif /* SB_USE_CLASS_TELSMTPCLIENT */

#ifdef SB_USE_CLASS_TELDTLSFLIGHTITEM
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDTLSFLIGHTITEM */

#ifdef SB_USE_CLASS_TELSSLRAWKEYCERTIFICATETYPEHANDLER
#  define SB_USE_CLASS_TELSSLCERTIFICATETYPEHANDLER
#endif /* SB_USE_CLASS_TELSSLRAWKEYCERTIFICATETYPEHANDLER */

#ifdef SB_USE_CLASS_TELSSLX509CERTIFICATETYPEHANDLER
#  define SB_USE_CLASS_TELSSLCERTIFICATETYPEHANDLER
#endif /* SB_USE_CLASS_TELSSLX509CERTIFICATETYPEHANDLER */

#ifdef SB_USE_CLASS_TELSSLMEMORYMANAGER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSLMEMORYMANAGER */

#ifdef SB_USE_CLASS_TELSSLRETRANSMISSIONTIMER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSLRETRANSMISSIONTIMER */

#ifdef SB_USE_CLASS_TELSERVERSSLEXTENSIONS
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSIONS
#endif /* SB_USE_CLASS_TELSERVERSSLEXTENSIONS */

#ifdef SB_USE_CLASS_TELCLIENTSSLEXTENSIONS
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSIONS
#endif /* SB_USE_CLASS_TELCLIENTSSLEXTENSIONS */

#ifdef SB_USE_CLASS_TELCUSTOMSSLEXTENSIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMSSLEXTENSIONS */

#ifdef SB_USE_CLASS_TELSRPSSLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELSRPSSLEXTENSION */

#ifdef SB_USE_CLASS_TELSIGNATUREALGORITHMSSSLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELSIGNATUREALGORITHMSSSLEXTENSION */

#ifdef SB_USE_CLASS_TELRENEGOTIATIONINFOSSLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELRENEGOTIATIONINFOSSLEXTENSION */

#ifdef SB_USE_CLASS_TELCERTHASHTYPESSSLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELCERTHASHTYPESSSLEXTENSION */

#ifdef SB_USE_CLASS_TELSESSIONTICKETSSLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELSESSIONTICKETSSLEXTENSION */

#ifdef SB_USE_CLASS_TELCERTIFICATESTATUSSSLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELCERTIFICATESTATUSSSLEXTENSION */

#ifdef SB_USE_CLASS_TELSSLOCSPSTATUSREQUEST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSLOCSPSTATUSREQUEST */

#ifdef SB_USE_CLASS_TELTRUNCATEDHMACSSLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELTRUNCATEDHMACSSLEXTENSION */

#ifdef SB_USE_CLASS_TELTRUSTEDCASSSLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELTRUSTEDCASSSLEXTENSION */

#ifdef SB_USE_CLASS_TELSSLTRUSTEDCA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSLTRUSTEDCA */

#ifdef SB_USE_CLASS_TELCLIENTCERTURLSSSLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELCLIENTCERTURLSSSLEXTENSION */

#ifdef SB_USE_CLASS_TELSSLCERTURL
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSLCERTURL */

#ifdef SB_USE_CLASS_TELMAXFRAGMENTLENGTHSSLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELMAXFRAGMENTLENGTHSSLEXTENSION */

#ifdef SB_USE_CLASS_TELEXTENDEDMASTERSECRETEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELEXTENDEDMASTERSECRETEXTENSION */

#ifdef SB_USE_CLASS_TELCERTIFICATETYPEREQUEST
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELCERTIFICATETYPEREQUEST */

#ifdef SB_USE_CLASS_TELCERTIFICATETYPERESPONSE
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELCERTIFICATETYPERESPONSE */

#ifdef SB_USE_CLASS_TELECPOINTSSLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELECPOINTSSLEXTENSION */

#ifdef SB_USE_CLASS_TELECCURVESSLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELECCURVESSLEXTENSION */

#ifdef SB_USE_CLASS_TELUSERNAMESSLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELUSERNAMESSLEXTENSION */

#ifdef SB_USE_CLASS_TELSERVERNAMESSLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELSERVERNAMESSLEXTENSION */

#ifdef SB_USE_CLASS_TELHEARTBEATHELLOSSLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#endif /* SB_USE_CLASS_TELHEARTBEATHELLOSSLEXTENSION */

#ifdef SB_USE_CLASS_TELSSLSERVERNAME
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSLSERVERNAME */

#ifdef SB_USE_CLASS_TELCLIENTSSLCONNECTIONINFO
#  define SB_USE_CLASS_TELSSLCONNECTIONINFO
#endif /* SB_USE_CLASS_TELCLIENTSSLCONNECTIONINFO */

#ifdef SB_USE_CLASS_TELSSLCLIENT
#  define SB_USE_CLASS_TELSSLCLASS
#endif /* SB_USE_CLASS_TELSSLCLIENT */

#ifdef SB_USE_CLASS_TELCUSTOMSSLEXTENSION
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMSSLEXTENSION */

#ifdef SB_USE_CLASS_TELSSLCLIENTPGPCERTIFICATETYPEHANDLER
#  define SB_USE_CLASS_TELSSLPGPCERTIFICATETYPEHANDLER
#endif /* SB_USE_CLASS_TELSSLCLIENTPGPCERTIFICATETYPEHANDLER */

#ifdef SB_USE_CLASS_TELLDAPSKEYSERVERCLIENT
#  define SB_USE_CLASS_TELLDAPSCLIENT
#endif /* SB_USE_CLASS_TELLDAPSKEYSERVERCLIENT */

#ifdef SB_USE_CLASS_TELHTTPSWEBDAVCLIENT
#  define SB_USE_CLASS_TELHTTPSCLIENT
#endif /* SB_USE_CLASS_TELHTTPSWEBDAVCLIENT */

#ifdef SB_USE_CLASS_TELCLIENTSSLCONNECTIONSETTINGS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCLIENTSSLCONNECTIONSETTINGS */

#ifdef SB_USE_CLASS_TELSSLCLASS
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSSLCLASS */

#ifdef SB_USE_CLASS_TELSSLCONNECTIONINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSLCONNECTIONINFO */

#ifdef SB_USE_CLASS_TELBUILTINSERVERTCPFORWARDINGSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TELBUILTINTCPFORWARDINGSSHSUBSYSTEMHANDLER
#endif /* SB_USE_CLASS_TELBUILTINSERVERTCPFORWARDINGSSHSUBSYSTEMHANDLER */

#ifdef SB_USE_CLASS_TELBUILTINCLIENTTCPFORWARDINGSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TELBUILTINTCPFORWARDINGSSHSUBSYSTEMHANDLER
#endif /* SB_USE_CLASS_TELBUILTINCLIENTTCPFORWARDINGSSHSUBSYSTEMHANDLER */

#ifdef SB_USE_CLASS_TELBUILTINTCPFORWARDINGSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TELCUSTOMSOCKETFORWARDINGSSHSUBSYSTEMHANDLER
#endif /* SB_USE_CLASS_TELBUILTINTCPFORWARDINGSSHSUBSYSTEMHANDLER */

#ifdef SB_USE_CLASS_TELSERVERTCPFORWARDINGSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TELTCPFORWARDINGSSHSUBSYSTEMHANDLER
#endif /* SB_USE_CLASS_TELSERVERTCPFORWARDINGSSHSUBSYSTEMHANDLER */

#ifdef SB_USE_CLASS_TELCLIENTTCPFORWARDINGSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TELTCPFORWARDINGSSHSUBSYSTEMHANDLER
#endif /* SB_USE_CLASS_TELCLIENTTCPFORWARDINGSSHSUBSYSTEMHANDLER */

#ifdef SB_USE_CLASS_TELTCPFORWARDINGSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TELCUSTOMSOCKETFORWARDINGSSHSUBSYSTEMHANDLER
#endif /* SB_USE_CLASS_TELTCPFORWARDINGSSHSUBSYSTEMHANDLER */

#ifdef SB_USE_CLASS_TELSIMPLESSHSERVERFORWARDINGSESSIONTHREAD
#  define SB_USE_CLASS_TELCUSTOMSESSIONTHREAD
#endif /* SB_USE_CLASS_TELSIMPLESSHSERVERFORWARDINGSESSIONTHREAD */

#ifdef SB_USE_CLASS_TELSIMPLESSHSERVERFORWARDINGLISTENINGTHREAD
#  define SB_USE_CLASS_TELCUSTOMSESSIONTHREAD
#endif /* SB_USE_CLASS_TELSIMPLESSHSERVERFORWARDINGLISTENINGTHREAD */

#ifdef SB_USE_CLASS_TELSIMPLESFTPSERVERSESSIONTHREAD
#  define SB_USE_CLASS_TELSIMPLESSHSERVERSESSIONTHREAD
#endif /* SB_USE_CLASS_TELSIMPLESFTPSERVERSESSIONTHREAD */

#ifdef SB_USE_CLASS_TELSIMPLESSHSERVERLISTENINGTHREAD
#  define SB_USE_CLASS_TELCUSTOMSESSIONTHREAD
#endif /* SB_USE_CLASS_TELSIMPLESSHSERVERLISTENINGTHREAD */

#ifdef SB_USE_CLASS_TELSIMPLESSHSERVERSESSIONTHREAD
#  define SB_USE_CLASS_TELCUSTOMSESSIONTHREAD
#endif /* SB_USE_CLASS_TELSIMPLESSHSERVERSESSIONTHREAD */

#ifdef SB_USE_CLASS_TELSSHUSERS
#  define SB_USE_CLASS_TELUSERS
#endif /* SB_USE_CLASS_TELSSHUSERS */

#ifdef SB_USE_CLASS_TELSIMPLESFTPSERVER
#  define SB_USE_CLASS_TELSIMPLESSHSERVER
#endif /* SB_USE_CLASS_TELSIMPLESFTPSERVER */

#ifdef SB_USE_CLASS_TELPUBLICKEYSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TELCUSTOMSSHSUBSYSTEMHANDLER
#endif /* SB_USE_CLASS_TELPUBLICKEYSSHSUBSYSTEMHANDLER */

#ifdef SB_USE_CLASS_TELSSHPUBLICKEYSERVER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSSHPUBLICKEYSERVER */

#ifdef SB_USE_CLASS_TELSSHCONNECTIONHANDLER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSHCONNECTIONHANDLER */

#ifdef SB_USE_CLASS_TELSSHSUBSYSTEMTHREAD
#  define SB_USE_CLASS_TTHREAD
#endif /* SB_USE_CLASS_TELSSHSUBSYSTEMTHREAD */

#ifdef SB_USE_CLASS_TELCUSTOMSOCKETFORWARDINGSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TELCUSTOMSSHSUBSYSTEMHANDLER
#endif /* SB_USE_CLASS_TELCUSTOMSOCKETFORWARDINGSSHSUBSYSTEMHANDLER */

#ifndef SB_WINCE_OR_NOT_WINDOWS
#ifdef SB_USE_CLASS_TELSHELLSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TELCUSTOMSSHSUBSYSTEMHANDLER
#endif /* SB_USE_CLASS_TELSHELLSSHSUBSYSTEMHANDLER */
#endif

#ifdef SB_USE_CLASS_TELSFTPSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TELCUSTOMSSHSUBSYSTEMHANDLER
#endif /* SB_USE_CLASS_TELSFTPSSHSUBSYSTEMHANDLER */

#ifdef SB_USE_CLASS_TELSSHSERVER
#  define SB_USE_CLASS_TELSSHCLASS
#endif /* SB_USE_CLASS_TELSSHSERVER */

#ifdef SB_USE_CLASS_TELSSHSERVERADDITIONALSETTINGS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSHSERVERADDITIONALSETTINGS */

#ifdef SB_USE_CLASS_TELSSHSERVERTUNNELCONNECTION
#  define SB_USE_CLASS_TELSSHTUNNELCONNECTION
#endif /* SB_USE_CLASS_TELSSHSERVERTUNNELCONNECTION */

#ifdef SB_USE_CLASS_TELSSHUSER
#  define SB_USE_CLASS_TELCUSTOMUSER
#endif /* SB_USE_CLASS_TELSSHUSER */

#ifndef WINCE
#ifdef SB_USE_CLASS_TELOPENSSHAUTHAGENT
#  define SB_USE_CLASS_TELSSHAUTHAGENT
#endif /* SB_USE_CLASS_TELOPENSSHAUTHAGENT */

#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TELPAGEANTAUTHAGENT
#  define SB_USE_CLASS_TELSSHAUTHAGENT
#endif /* SB_USE_CLASS_TELPAGEANTAUTHAGENT */

#endif
#ifdef SB_USE_CLASS_TELSSHAUTHAGENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSHAUTHAGENT */
#endif

#ifdef SB_USE_CLASS_TELSSHPUBLICKEYCLIENT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSSHPUBLICKEYCLIENT */

#ifdef SB_USE_CLASS_TELSSHPUBLICKEYATTRIBUTES
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSHPUBLICKEYATTRIBUTES */

#ifdef SB_USE_CLASS_TELSSHSCHEDULEDSPECIALMESSAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSHSCHEDULEDSPECIALMESSAGE */

#ifdef SB_USE_CLASS_TELSSHREMOTEPORTFORWARDINGSESSION
#  define SB_USE_CLASS_TELSSHFORWARDINGSESSION
#endif /* SB_USE_CLASS_TELSSHREMOTEPORTFORWARDINGSESSION */

#ifdef SB_USE_CLASS_TELSSHLOCALPORTFORWARDINGSESSION
#  define SB_USE_CLASS_TELSSHFORWARDINGSESSION
#endif /* SB_USE_CLASS_TELSSHLOCALPORTFORWARDINGSESSION */

#ifdef SB_USE_CLASS_TELSSHREMOTETUNNELSTATE
#  define SB_USE_CLASS_TELSSHTUNNELSTATE
#endif /* SB_USE_CLASS_TELSSHREMOTETUNNELSTATE */

#ifdef SB_USE_CLASS_TELSSHLOCALTUNNELSTATE
#  define SB_USE_CLASS_TELSSHTUNNELSTATE
#endif /* SB_USE_CLASS_TELSSHLOCALTUNNELSTATE */

#ifdef SB_USE_CLASS_TELSSHLPFLISTENINGTHREAD
#  define SB_USE_CLASS_TTHREAD
#endif /* SB_USE_CLASS_TELSSHLPFLISTENINGTHREAD */

#ifdef SB_USE_CLASS_TELSSHTUNNELSTATE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSHTUNNELSTATE */

#ifdef SB_USE_CLASS_TELSSHREMOTEPORTFORWARDING
#  define SB_USE_CLASS_TELSSHCUSTOMFORWARDING
#endif /* SB_USE_CLASS_TELSSHREMOTEPORTFORWARDING */

#ifdef SB_USE_CLASS_TELSSHLOCALPORTFORWARDING
#  define SB_USE_CLASS_TELSSHCUSTOMFORWARDING
#endif /* SB_USE_CLASS_TELSSHLOCALPORTFORWARDING */

#ifdef SB_USE_CLASS_TELSSHFORWARDINGINTERCEPT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSSHFORWARDINGINTERCEPT */

#ifdef SB_USE_CLASS_TELSSHCUSTOMFORWARDING
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSSHCUSTOMFORWARDING */

#ifdef SB_USE_CLASS_TELSSHFORWARDINGSESSION
#  define SB_USE_CLASS_TTHREAD
#endif /* SB_USE_CLASS_TELSSHFORWARDINGSESSION */

#ifdef SB_USE_CLASS_TELSSHFORWARDINGTUNNEL
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSHFORWARDINGTUNNEL */

#ifdef SB_USE_CLASS_TELSSHFORWARDEDCONNECTION
#  define SB_USE_CLASS_TTHREAD
#endif /* SB_USE_CLASS_TELSSHFORWARDEDCONNECTION */

#ifdef SB_USE_CLASS_TELSIMPLESSHCLIENT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSIMPLESSHCLIENT */

#ifdef SB_USE_CLASS_TELSSHPGPAUTHHANDLER
#  define SB_USE_CLASS_TELSSHAUTHHANDLER
#endif /* SB_USE_CLASS_TELSSHPGPAUTHHANDLER */

#ifdef SB_USE_CLASS_TELAUTHENTICATIONAGENTSSHTUNNEL
#  define SB_USE_CLASS_TELCUSTOMSSHTUNNEL
#endif /* SB_USE_CLASS_TELAUTHENTICATIONAGENTSSHTUNNEL */

#ifdef SB_USE_CLASS_TELX11FORWARDSSHTUNNEL
#  define SB_USE_CLASS_TELCUSTOMSSHTUNNEL
#endif /* SB_USE_CLASS_TELX11FORWARDSSHTUNNEL */

#ifdef SB_USE_CLASS_TELLOCALPORTFORWARDSSHTUNNELPARAMS
#  define SB_USE_CLASS_TELCUSTOMSSHTUNNELPARAMS
#endif /* SB_USE_CLASS_TELLOCALPORTFORWARDSSHTUNNELPARAMS */

#ifdef SB_USE_CLASS_TELLOCALPORTFORWARDSSHTUNNEL
#  define SB_USE_CLASS_TELCUSTOMSSHTUNNEL
#endif /* SB_USE_CLASS_TELLOCALPORTFORWARDSSHTUNNEL */

#ifdef SB_USE_CLASS_TELREMOTEPORTFORWARDSSHTUNNEL
#  define SB_USE_CLASS_TELCUSTOMSSHTUNNEL
#endif /* SB_USE_CLASS_TELREMOTEPORTFORWARDSSHTUNNEL */

#ifdef SB_USE_CLASS_TELSUBSYSTEMSSHTUNNEL
#  define SB_USE_CLASS_TELCUSTOMSSHTUNNEL
#endif /* SB_USE_CLASS_TELSUBSYSTEMSSHTUNNEL */

#ifdef SB_USE_CLASS_TELCOMMANDSSHTUNNEL
#  define SB_USE_CLASS_TELCUSTOMSSHTUNNEL
#endif /* SB_USE_CLASS_TELCOMMANDSSHTUNNEL */

#ifdef SB_USE_CLASS_TELSHELLSSHTUNNEL
#  define SB_USE_CLASS_TELCUSTOMSSHTUNNEL
#endif /* SB_USE_CLASS_TELSHELLSSHTUNNEL */

#ifdef SB_USE_CLASS_TELCUSTOMSSHTUNNELPARAMS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMSSHTUNNELPARAMS */

#ifdef SB_USE_CLASS_TELSSHCLIENTTUNNELCONNECTION
#  define SB_USE_CLASS_TELSSHTUNNELCONNECTION
#endif /* SB_USE_CLASS_TELSSHCLIENTTUNNELCONNECTION */

#ifdef SB_USE_CLASS_TELCUSTOMSSHTUNNEL
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCUSTOMSSHTUNNEL */

#ifdef SB_USE_CLASS_TELSSHCLIENTTUNNELLIST
#  define SB_USE_CLASS_TELSSHTUNNELLIST
#endif /* SB_USE_CLASS_TELSSHCLIENTTUNNELLIST */

#ifdef SB_USE_CLASS_TELSSHCLIENT
#  define SB_USE_CLASS_TELSSHCLASS
#endif /* SB_USE_CLASS_TELSSHCLIENT */

#ifdef SB_USE_CLASS_TELSSHTUNNELCONNECTION
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSHTUNNELCONNECTION */

#ifdef SB_USE_CLASS_TELSSHTUNNELLIST
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSSHTUNNELLIST */

#ifdef SB_USE_CLASS_TELSSHCLASS
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSSHCLASS */

#ifdef SB_USE_CLASS_TELTERMINALINFO
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELTERMINALINFO */

#ifdef SB_USE_CLASS_TELSSHMEMORYKEYSTORAGE
#  define SB_USE_CLASS_TELSSHCUSTOMKEYSTORAGE
#endif /* SB_USE_CLASS_TELSSHMEMORYKEYSTORAGE */

#ifdef SB_USE_CLASS_TELSSHPKCS11KEYSTORAGE
#  define SB_USE_CLASS_TELSSHCUSTOMKEYSTORAGE
#endif /* SB_USE_CLASS_TELSSHPKCS11KEYSTORAGE */

#ifdef SB_USE_CLASS_TELSSHPGPKEY
#  define SB_USE_CLASS_TELSSHKEY
#endif /* SB_USE_CLASS_TELSSHPGPKEY */

#ifdef SB_USE_CLASS_TELMESSAGEPARTHANDLERSMIMECADES
#  define SB_USE_CLASS_TELMESSAGEPARTHANDLERSMIME
#endif /* SB_USE_CLASS_TELMESSAGEPARTHANDLERSMIMECADES */

#ifdef SB_USE_CLASS_TELSIMPLESMIMEOPTIONS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELSIMPLESMIMEOPTIONS */

#ifdef SB_USE_CLASS_TELSIMPLESMIMEMESSAGE
#  define SB_USE_CLASS_TELSIMPLEMIMEMESSAGE
#endif /* SB_USE_CLASS_TELSIMPLESMIMEMESSAGE */

#ifdef SB_USE_CLASS_TELMESSAGEPARTHANDLERSMIME
#  define SB_USE_CLASS_TELMESSAGEPARTHANDLER
#endif /* SB_USE_CLASS_TELMESSAGEPARTHANDLERSMIME */

#ifdef SB_USE_CLASS_TELCUSTOMSESSIONTHREAD
#  define SB_USE_CLASS_TTHREAD
#endif /* SB_USE_CLASS_TELCUSTOMSESSIONTHREAD */

#ifdef SB_USE_CLASS_TELSIMPLESSHSFTPSEARCHREC
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSIMPLESSHSFTPSEARCHREC */

#ifdef SB_USE_CLASS_TELSIMPLESSHSERVER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSIMPLESSHSERVER */

#ifdef SB_USE_CLASS_TELSFTPSERVER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSFTPSERVER */

#ifdef SB_USE_CLASS_TSBSFTPHANDLE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSBSFTPHANDLE */

#ifdef SB_USE_CLASS_TELCUSTOMSSHSUBSYSTEMHANDLER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMSSHSUBSYSTEMHANDLER */

#ifdef SB_USE_CLASS_TELSIMPLESFTPCLIENT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSIMPLESFTPCLIENT */

#ifdef SB_USE_CLASS_TELSFTPREMOVALMANAGER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSFTPREMOVALMANAGER */

#ifdef SB_USE_CLASS_TELSFTPREMOVALTARGET
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSFTPREMOVALTARGET */

#ifdef SB_USE_CLASS_TELSFTPTRANSFERMANAGER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSFTPTRANSFERMANAGER */

#ifdef SB_USE_CLASS_TELSFTPTRANSFERBLOCK
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSFTPTRANSFERBLOCK */

#ifdef SB_USE_CLASS_TSBSFTPTEXTHANDLEINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSBSFTPTEXTHANDLEINFO */

#ifdef SB_USE_CLASS_TSBSFTPOPENREQUESTINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSBSFTPOPENREQUESTINFO */

#ifdef SB_USE_CLASS_TELSFTPFILEINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSFTPFILEINFO */

#ifdef SB_USE_CLASS_TELSFTPFILEATTRIBUTES
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSFTPFILEATTRIBUTES */

#ifdef SB_USE_CLASS_TELSFTPEXTENDEDPROPERTIES
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELSFTPEXTENDEDPROPERTIES */

#ifdef SB_USE_CLASS_TSBSFTPACE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSBSFTPACE */

#ifdef SB_USE_CLASS_TELSFTPSTATVFSREPLY
#  define SB_USE_CLASS_TELSFTPEXTENDEDREPLY
#endif /* SB_USE_CLASS_TELSFTPSTATVFSREPLY */

#ifdef SB_USE_CLASS_TELSFTPSPACEAVAILABLEREPLY
#  define SB_USE_CLASS_TELSFTPEXTENDEDREPLY
#endif /* SB_USE_CLASS_TELSFTPSPACEAVAILABLEREPLY */

#ifdef SB_USE_CLASS_TELSFTPCHECKFILEREPLY
#  define SB_USE_CLASS_TELSFTPEXTENDEDREPLY
#endif /* SB_USE_CLASS_TELSFTPCHECKFILEREPLY */

#ifdef SB_USE_CLASS_TELSFTPCOPYDATAEXTENSION
#  define SB_USE_CLASS_TSBSFTPEXTENDEDATTRIBUTE
#endif /* SB_USE_CLASS_TELSFTPCOPYDATAEXTENSION */

#ifdef SB_USE_CLASS_TELSFTPCOPYFILEEXTENSION
#  define SB_USE_CLASS_TSBSFTPEXTENDEDATTRIBUTE
#endif /* SB_USE_CLASS_TELSFTPCOPYFILEEXTENSION */

#ifdef SB_USE_CLASS_TELSFTPHOMEDIRECTORYEXTENSION
#  define SB_USE_CLASS_TSBSFTPEXTENDEDATTRIBUTE
#endif /* SB_USE_CLASS_TELSFTPHOMEDIRECTORYEXTENSION */

#ifdef SB_USE_CLASS_TELSFTPSPACEAVAILABLEEXTENSION
#  define SB_USE_CLASS_TSBSFTPEXTENDEDATTRIBUTE
#endif /* SB_USE_CLASS_TELSFTPSPACEAVAILABLEEXTENSION */

#ifdef SB_USE_CLASS_TELSFTPSTATVFSEXTENSION
#  define SB_USE_CLASS_TSBSFTPEXTENDEDATTRIBUTE
#endif /* SB_USE_CLASS_TELSFTPSTATVFSEXTENSION */

#ifdef SB_USE_CLASS_TELSFTPCHECKFILEEXTENSION
#  define SB_USE_CLASS_TSBSFTPEXTENDEDATTRIBUTE
#endif /* SB_USE_CLASS_TELSFTPCHECKFILEEXTENSION */

#ifdef SB_USE_CLASS_TELSFTPVENDORIDEXTENSION
#  define SB_USE_CLASS_TSBSFTPEXTENDEDATTRIBUTE
#endif /* SB_USE_CLASS_TELSFTPVENDORIDEXTENSION */

#ifdef SB_USE_CLASS_TELSFTPSUPPORTEDEXTENSION
#  define SB_USE_CLASS_TSBSFTPEXTENDEDATTRIBUTE
#endif /* SB_USE_CLASS_TELSFTPSUPPORTEDEXTENSION */

#ifdef SB_USE_CLASS_TELSFTPVERSIONSELECTEXTENSION
#  define SB_USE_CLASS_TSBSFTPEXTENDEDATTRIBUTE
#endif /* SB_USE_CLASS_TELSFTPVERSIONSELECTEXTENSION */

#ifdef SB_USE_CLASS_TELSFTPFILENAMECHARSETEXTENSION
#  define SB_USE_CLASS_TSBSFTPEXTENDEDATTRIBUTE
#endif /* SB_USE_CLASS_TELSFTPFILENAMECHARSETEXTENSION */

#ifdef SB_USE_CLASS_TELSFTPFILENAMETRANSLATIONEXTENSION
#  define SB_USE_CLASS_TSBSFTPEXTENDEDATTRIBUTE
#endif /* SB_USE_CLASS_TELSFTPFILENAMETRANSLATIONEXTENSION */

#ifdef SB_USE_CLASS_TELSFTPVERSIONSEXTENSION
#  define SB_USE_CLASS_TSBSFTPEXTENDEDATTRIBUTE
#endif /* SB_USE_CLASS_TELSFTPVERSIONSEXTENSION */

#ifdef SB_USE_CLASS_TELSFTPNEWLINEEXTENSION
#  define SB_USE_CLASS_TSBSFTPEXTENDEDATTRIBUTE
#endif /* SB_USE_CLASS_TELSFTPNEWLINEEXTENSION */

#ifdef SB_USE_CLASS_TELSFTPEXTENDEDREPLY
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELSFTPEXTENDEDREPLY */

#ifdef SB_USE_CLASS_TSBSFTPEXTENDEDATTRIBUTE
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TSBSFTPEXTENDEDATTRIBUTE */

#ifdef SB_USE_CLASS_TELSFTPCLIENT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSFTPCLIENT */

#ifdef SB_USE_CLASS_TELSFTPSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELSFTPSTREAM */

#ifdef SB_USE_CLASS_TELECIESCRYPTO
#  define SB_USE_CLASS_TELCUSTOMCRYPTO
#endif /* SB_USE_CLASS_TELECIESCRYPTO */

#ifdef SB_USE_CLASS_TELTOTPSERVER
#  define SB_USE_CLASS_TELOTPSERVER
#endif /* SB_USE_CLASS_TELTOTPSERVER */

#ifdef SB_USE_CLASS_TELHOTPSERVER
#  define SB_USE_CLASS_TELOTPSERVER
#endif /* SB_USE_CLASS_TELHOTPSERVER */

#ifdef SB_USE_CLASS_TELOTPSERVER
#  define SB_USE_CLASS_TELOTPCLASS
#endif /* SB_USE_CLASS_TELOTPSERVER */

#ifdef SB_USE_CLASS_TELOTPUSERSTORAGE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELOTPUSERSTORAGE */

#ifdef SB_USE_CLASS_TELOTPUSERFACTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOTPUSERFACTORY */

#ifdef SB_USE_CLASS_TELTOTPUSER
#  define SB_USE_CLASS_TELOTPUSER
#endif /* SB_USE_CLASS_TELTOTPUSER */

#ifdef SB_USE_CLASS_TELHOTPUSER
#  define SB_USE_CLASS_TELOTPUSER
#endif /* SB_USE_CLASS_TELHOTPUSER */

#ifdef SB_USE_CLASS_TELOTPUSER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOTPUSER */

#ifdef SB_USE_CLASS_TELTOTPCLIENT
#  define SB_USE_CLASS_TELOTPCLIENT
#endif /* SB_USE_CLASS_TELTOTPCLIENT */

#ifdef SB_USE_CLASS_TELHOTPCLIENT
#  define SB_USE_CLASS_TELOTPCLIENT
#endif /* SB_USE_CLASS_TELHOTPCLIENT */

#ifdef SB_USE_CLASS_TELOTPCLIENT
#  define SB_USE_CLASS_TELOTPCLASS
#endif /* SB_USE_CLASS_TELOTPCLIENT */

#ifdef SB_USE_CLASS_TELTOTPPASSWORDGENERATOR
#  define SB_USE_CLASS_TELHOTPPASSWORDGENERATOR
#endif /* SB_USE_CLASS_TELTOTPPASSWORDGENERATOR */

#ifdef SB_USE_CLASS_TELHOTPPASSWORDGENERATOR
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELHOTPPASSWORDGENERATOR */

#ifdef SB_USE_CLASS_TELOTPCLASS
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELOTPCLASS */

#ifdef SB_USE_CLASS_TELFULLPKIRESPONSE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELFULLPKIRESPONSE */

#ifdef SB_USE_CLASS_TELFULLPKIREQUEST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELFULLPKIREQUEST */

#ifdef SB_USE_CLASS_TELMODCERTIFICATIONREQUESTATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELMODCERTIFICATIONREQUESTATTRIBUTE */

#ifdef SB_USE_CLASS_TELCERTTEMPLATE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCERTTEMPLATE */

#ifdef SB_USE_CLASS_TELPUBLICKEYINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPUBLICKEYINFO */

#ifdef SB_USE_CLASS_TELOPTIONALVALIDITY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOPTIONALVALIDITY */

#ifdef SB_USE_CLASS_TELCONTROLPROCESSEDATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELCONTROLPROCESSEDATTRIBUTE */

#ifdef SB_USE_CLASS_TELPUBLICATIONINFORMATIONATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELPUBLICATIONINFORMATIONATTRIBUTE */

#ifdef SB_USE_CLASS_TELPKIPUBLICATIONINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKIPUBLICATIONINFO */

#ifdef SB_USE_CLASS_TELSINGLEPUBINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSINGLEPUBINFO */

#ifdef SB_USE_CLASS_TELPOPLINKRANDOMATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELPOPLINKRANDOMATTRIBUTE */

#ifdef SB_USE_CLASS_TELBATCHRESPONSESATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELBATCHRESPONSESATTRIBUTE */

#ifdef SB_USE_CLASS_TELBATCHREQUESTSATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELBATCHREQUESTSATTRIBUTE */

#ifdef SB_USE_CLASS_TELAUTHENTICATEDDATAATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELAUTHENTICATEDDATAATTRIBUTE */

#ifdef SB_USE_CLASS_TELPUBLISHTRUSTANCHORSATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELPUBLISHTRUSTANCHORSATTRIBUTE */

#ifdef SB_USE_CLASS_TELCONFIRMCERTACCEPTANCEATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELCONFIRMCERTACCEPTANCEATTRIBUTE */

#ifdef SB_USE_CLASS_TELQUERYPENDINGATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELQUERYPENDINGATTRIBUTE */

#ifdef SB_USE_CLASS_TELRESPONSEINFORMATIONATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELRESPONSEINFORMATIONATTRIBUTE */

#ifdef SB_USE_CLASS_TELREGISTRATIONINFORMATIONATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELREGISTRATIONINFORMATIONATTRIBUTE */

#ifdef SB_USE_CLASS_TELREVOCATIONREQUESTATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELREVOCATIONREQUESTATTRIBUTE */

#ifdef SB_USE_CLASS_TELGETCRLATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELGETCRLATTRIBUTE */

#ifdef SB_USE_CLASS_TELGETCERTIFICATEATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELGETCERTIFICATEATTRIBUTE */

#ifdef SB_USE_CLASS_TELLRAPOPWITNESSATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELLRAPOPWITNESSATTRIBUTE */

#ifdef SB_USE_CLASS_TELDECRYPTEDPOPATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELDECRYPTEDPOPATTRIBUTE */

#ifdef SB_USE_CLASS_TELENCRYPTEDPOPATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELENCRYPTEDPOPATTRIBUTE */

#ifdef SB_USE_CLASS_TELRECIPIENTNONCEATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELRECIPIENTNONCEATTRIBUTE */

#ifdef SB_USE_CLASS_TELSENDERNONCEATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELSENDERNONCEATTRIBUTE */

#ifdef SB_USE_CLASS_TELTRANSACTIONIDENTIFIERATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELTRANSACTIONIDENTIFIERATTRIBUTE */

#ifdef SB_USE_CLASS_TELDATARETURNATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELDATARETURNATTRIBUTE */

#ifdef SB_USE_CLASS_TELPOPLINKWITNESSATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELPOPLINKWITNESSATTRIBUTE */

#ifdef SB_USE_CLASS_TELPOPLINKWITNESSV2ATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELPOPLINKWITNESSV2ATTRIBUTE */

#ifdef SB_USE_CLASS_TELIDENTITYPROOFATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELIDENTITYPROOFATTRIBUTE */

#ifdef SB_USE_CLASS_TELIDENTITYPROOFV2ATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELIDENTITYPROOFV2ATTRIBUTE */

#ifdef SB_USE_CLASS_TELADDEXTENSIONSATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELADDEXTENSIONSATTRIBUTE */

#ifdef SB_USE_CLASS_TELCMCSTATUSINFOV2ATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELCMCSTATUSINFOV2ATTRIBUTE */

#ifdef SB_USE_CLASS_TELEXTENDEDFAILINFO
#  define SB_USE_CLASS_TELBODYPARTREFERENCE
#endif /* SB_USE_CLASS_TELEXTENDEDFAILINFO */

#ifdef SB_USE_CLASS_TELBODYPARTPATH
#  define SB_USE_CLASS_TELBODYPARTREFERENCE
#endif /* SB_USE_CLASS_TELBODYPARTPATH */

#ifdef SB_USE_CLASS_TELBODYPARTID
#  define SB_USE_CLASS_TELBODYPARTREFERENCE
#endif /* SB_USE_CLASS_TELBODYPARTID */

#ifdef SB_USE_CLASS_TELBODYPARTREFERENCE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBODYPARTREFERENCE */

#ifdef SB_USE_CLASS_TELCMCSTATUSINFOATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELCMCSTATUSINFOATTRIBUTE */

#ifdef SB_USE_CLASS_TELPENDINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPENDINFO */

#ifdef SB_USE_CLASS_TELIDENTIFICATIONATTRIBUTE
#  define SB_USE_CLASS_TELCONTROLATTRIBUTE
#endif /* SB_USE_CLASS_TELIDENTIFICATIONATTRIBUTE */

#ifdef SB_USE_CLASS_TELCONTROLATTRIBUTE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCONTROLATTRIBUTE */

#ifdef SB_USE_CLASS_TELPKIRESPONSE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKIRESPONSE */

#ifdef SB_USE_CLASS_TELPKIDATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKIDATA */

#ifdef SB_USE_CLASS_TELOTHERMSG
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOTHERMSG */

#ifdef SB_USE_CLASS_TELTAGGEDCONTENTINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELTAGGEDCONTENTINFO */

#ifdef SB_USE_CLASS_TELCONTENTINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCONTENTINFO */

#ifdef SB_USE_CLASS_TELTAGGEDREQUEST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELTAGGEDREQUEST */

#ifdef SB_USE_CLASS_TELEXTERNALLYDEFINEDCERTIFICATIONREQUEST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELEXTERNALLYDEFINEDCERTIFICATIONREQUEST */

#ifdef SB_USE_CLASS_TELTAGGEDCERTIFICATIONREQUEST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELTAGGEDCERTIFICATIONREQUEST */

#ifdef SB_USE_CLASS_TELTAGGEDATTRIBUTE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELTAGGEDATTRIBUTE */

#ifdef SB_USE_CLASS_TELATTRIBUTEVALUE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELATTRIBUTEVALUE */

#ifdef SB_USE_CLASS_TELCADESSIGNATUREPROCESSOR
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCADESSIGNATUREPROCESSOR */

#ifdef SB_USE_CLASS_TELCADESREVOCATIONINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCADESREVOCATIONINFO */

#ifdef SB_USE_CLASS_TELPKCS11SSHKEY
#  define SB_USE_CLASS_TELSSHKEY
#endif /* SB_USE_CLASS_TELPKCS11SSHKEY */

#ifdef SB_USE_CLASS_TELSSHPKCS11CONSUMERKEYSTORAGE
#  define SB_USE_CLASS_TELPKCS11CONSUMER
#endif /* SB_USE_CLASS_TELSSHPKCS11CONSUMERKEYSTORAGE */

#ifdef SB_USE_CLASS_TELSSHCUSTOMKEYSTORAGE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSSHCUSTOMKEYSTORAGE */

#ifdef SB_USE_CLASS_TELX509CERTIFICATEEX
#  define SB_USE_CLASS_TELX509CERTIFICATE
#endif /* SB_USE_CLASS_TELX509CERTIFICATEEX */

#ifdef SB_USE_CLASS_TELCERTIFICATEREVOCATIONLISTEX
#  define SB_USE_CLASS_TELCERTIFICATEREVOCATIONLIST
#endif /* SB_USE_CLASS_TELCERTIFICATEREVOCATIONLISTEX */

#ifdef SB_USE_CLASS_TELAUTHENTICODEVERIFIER
#  define SB_USE_CLASS_TELAUTHENTICODEPROCESSOR
#endif /* SB_USE_CLASS_TELAUTHENTICODEVERIFIER */

#ifdef SB_USE_CLASS_TELAUTHENTICODESIGNER
#  define SB_USE_CLASS_TELAUTHENTICODEPROCESSOR
#endif /* SB_USE_CLASS_TELAUTHENTICODESIGNER */

#ifdef SB_USE_CLASS_TELAUTHENTICODEPROCESSOR
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELAUTHENTICODEPROCESSOR */

#ifdef SB_USE_CLASS_TELFILETSPSERVER
#  define SB_USE_CLASS_TELCUSTOMTSPSERVER
#endif /* SB_USE_CLASS_TELFILETSPSERVER */

#ifdef SB_USE_CLASS_TELCUSTOMTSPSERVER
#  define SB_USE_CLASS_TELTSPCLASS
#endif /* SB_USE_CLASS_TELCUSTOMTSPSERVER */

#ifdef SB_USE_CLASS_TELSERVERTSPINFO
#  define SB_USE_CLASS_TELTSPINFO
#endif /* SB_USE_CLASS_TELSERVERTSPINFO */

#ifdef SB_USE_CLASS_TELOCSPSERVER
#  define SB_USE_CLASS_TELOCSPCLASS
#endif /* SB_USE_CLASS_TELOCSPSERVER */

#ifdef SB_USE_CLASS_TELCERTIFICATEREQUEST
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCERTIFICATEREQUEST */

#ifdef SB_USE_CLASS_TELPKCS11CONSUMERCERTSTORAGE
#  define SB_USE_CLASS_TELPKCS11CONSUMER
#endif /* SB_USE_CLASS_TELPKCS11CONSUMERCERTSTORAGE */

#ifdef SB_USE_CLASS_TELPKCS11STGCTX
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11STGCTX */

#ifdef SB_USE_CLASS_TELPKCS11CERTSTORAGE
#  define SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#endif /* SB_USE_CLASS_TELPKCS11CERTSTORAGE */

#ifdef SB_USE_CLASS_TELPKCS11CONSUMERMANAGER
#  define SB_USE_CLASS_TELPKCS11CONSUMER
#endif /* SB_USE_CLASS_TELPKCS11CONSUMERMANAGER */

#ifdef SB_USE_CLASS_TELPKCS11MANAGERSECRETKEYOBJECT
#  define SB_USE_CLASS_TELPKCS11MANAGERKEYOBJECT
#endif /* SB_USE_CLASS_TELPKCS11MANAGERSECRETKEYOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11MANAGERPRIVATEKEYOBJECT
#  define SB_USE_CLASS_TELPKCS11MANAGERKEYOBJECT
#endif /* SB_USE_CLASS_TELPKCS11MANAGERPRIVATEKEYOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11MANAGERPUBLICKEYOBJECT
#  define SB_USE_CLASS_TELPKCS11MANAGERKEYOBJECT
#endif /* SB_USE_CLASS_TELPKCS11MANAGERPUBLICKEYOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11MANAGERKEYOBJECT
#  define SB_USE_CLASS_TELPKCS11MANAGEROBJECT
#endif /* SB_USE_CLASS_TELPKCS11MANAGERKEYOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11MANAGERCERTIFICATEOBJECT
#  define SB_USE_CLASS_TELPKCS11MANAGEROBJECT
#endif /* SB_USE_CLASS_TELPKCS11MANAGERCERTIFICATEOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11MANAGERDATAOBJECT
#  define SB_USE_CLASS_TELPKCS11MANAGEROBJECT
#endif /* SB_USE_CLASS_TELPKCS11MANAGERDATAOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11MANAGEROBJECT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11MANAGEROBJECT */

#ifdef SB_USE_CLASS_TELPKCS11MANAGER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELPKCS11MANAGER */

#ifdef SB_USE_CLASS_TELSLOTEVENTMONITORINGTHREAD
#  define SB_USE_CLASS_TTHREAD
#endif /* SB_USE_CLASS_TELSLOTEVENTMONITORINGTHREAD */

#ifdef SB_USE_CLASS_TELPKCS11ALGORITHMCONVERTER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11ALGORITHMCONVERTER */

#ifdef SB_USE_CLASS_TELPKCS11ALGORITHMINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11ALGORITHMINFO */

#ifdef SB_USE_CLASS_TELPKCS11MODULELIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11MODULELIST */

#ifdef SB_USE_CLASS_TELPKCS11NSSPARAMS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11NSSPARAMS */

#ifdef SB_USE_CLASS_TELPKCS11UTILS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11UTILS */

#ifdef SB_USE_CLASS_TELPKCS11DOMAINPARAMETERSOBJECT
#  define SB_USE_CLASS_TELPKCS11OBJECT
#endif /* SB_USE_CLASS_TELPKCS11DOMAINPARAMETERSOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11SECRETKEYOBJECT
#  define SB_USE_CLASS_TELPKCS11KEYOBJECT
#endif /* SB_USE_CLASS_TELPKCS11SECRETKEYOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11PRIVATEKEYOBJECT
#  define SB_USE_CLASS_TELPKCS11KEYOBJECT
#endif /* SB_USE_CLASS_TELPKCS11PRIVATEKEYOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11PUBLICKEYOBJECT
#  define SB_USE_CLASS_TELPKCS11KEYOBJECT
#endif /* SB_USE_CLASS_TELPKCS11PUBLICKEYOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11KEYOBJECT
#  define SB_USE_CLASS_TELPKCS11OBJECT
#endif /* SB_USE_CLASS_TELPKCS11KEYOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11X509ATTRIBUTECERTIFICATEOBJECT
#  define SB_USE_CLASS_TELPKCS11CERTIFICATEOBJECT
#endif /* SB_USE_CLASS_TELPKCS11X509ATTRIBUTECERTIFICATEOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11WTLSCERTIFICATEOBJECT
#  define SB_USE_CLASS_TELPKCS11CERTIFICATEOBJECT
#endif /* SB_USE_CLASS_TELPKCS11WTLSCERTIFICATEOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11X509CERTIFICATEOBJECT
#  define SB_USE_CLASS_TELPKCS11CERTIFICATEOBJECT
#endif /* SB_USE_CLASS_TELPKCS11X509CERTIFICATEOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11CERTIFICATEOBJECT
#  define SB_USE_CLASS_TELPKCS11OBJECT
#endif /* SB_USE_CLASS_TELPKCS11CERTIFICATEOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11DATAOBJECT
#  define SB_USE_CLASS_TELPKCS11OBJECT
#endif /* SB_USE_CLASS_TELPKCS11DATAOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11OBJECT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11OBJECT */

#ifdef SB_USE_CLASS_TELPKCS11ATTRIBUTELIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11ATTRIBUTELIST */

#ifdef SB_USE_CLASS_TELPKCS11CONSUMER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11CONSUMER */

#ifndef MACOS
#ifdef SB_USE_CLASS_TELPKCS11SESSIONINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11SESSIONINFO */
#endif
#ifdef SB_IOS
#ifdef SB_USE_CLASS_TELPKCS11FUNCTIONSMANAGER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11FUNCTIONSMANAGER */
#endif

#ifndef MACOS
#ifdef SB_USE_CLASS_TELPKCS11SLOTINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11SLOTINFO */

#ifdef SB_USE_CLASS_TELPKCS11MODULE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11MODULE */

#ifdef SB_USE_CLASS_TELPKCS11ECPARAMSDIRECTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11ECPARAMSDIRECTORY */

#ifdef SB_USE_CLASS_TELPKCS11CRYPTOCONTEXT
#  define SB_USE_CLASS_TELCUSTOMCRYPTOCONTEXT
#endif /* SB_USE_CLASS_TELPKCS11CRYPTOCONTEXT */

#ifdef SB_USE_CLASS_TELPKCS11CRYPTOKEY
#  define SB_USE_CLASS_TELCUSTOMCRYPTOKEY
#endif /* SB_USE_CLASS_TELPKCS11CRYPTOKEY */

#ifdef SB_USE_CLASS_TELPKCS11CRYPTOPROVIDER
#  define SB_USE_CLASS_TELEXTERNALCRYPTOPROVIDER
#endif /* SB_USE_CLASS_TELPKCS11CRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELPKCS11CRYPTOPROVIDEROPTIONS
#  define SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDEROPTIONS
#endif /* SB_USE_CLASS_TELPKCS11CRYPTOPROVIDEROPTIONS */

#ifdef SB_USE_CLASS_TELSIGNEDANDENVELOPEDCMSMESSAGE
#  define SB_USE_CLASS_TELSIGNEDCMSMESSAGE
#endif /* SB_USE_CLASS_TELSIGNEDANDENVELOPEDCMSMESSAGE */

#ifdef SB_USE_CLASS_TELSIGNEDCMSMESSAGE
#  define SB_USE_CLASS_TELCMSMESSAGE
#endif /* SB_USE_CLASS_TELSIGNEDCMSMESSAGE */

#ifdef SB_USE_CLASS_TELCMSCONTENTHASH
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSCONTENTHASH */

#ifdef SB_USE_CLASS_TELCMSMESSAGE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCMSMESSAGE */

#ifdef SB_USE_CLASS_TELATSHASHINDEXPROCESSOR
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELATSHASHINDEXPROCESSOR */

#ifdef SB_USE_CLASS_TELCMSTIMESTAMP
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSTIMESTAMP */

#ifdef SB_USE_CLASS_TELCMSSIGNATURE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSSIGNATURE */

#ifdef SB_USE_CLASS_TELCMSSIGNATUREPOLICYSTORE
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSSIGNATUREPOLICYSTORE */

#ifdef SB_USE_CLASS_TELCMSSIGNERATTRIBUTES
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSSIGNERATTRIBUTES */

#ifdef SB_USE_CLASS_TELCMSSIGNINGCERTIFICATE
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSSIGNINGCERTIFICATE */

#ifdef SB_USE_CLASS_TELCMSSIGNERLOCATION
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSSIGNERLOCATION */

#ifdef SB_USE_CLASS_TELCMSCOMMITMENTTYPEINDICATION
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSCOMMITMENTTYPEINDICATION */

#ifdef SB_USE_CLASS_TELCMSCONTENTREFERENCE
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSCONTENTREFERENCE */

#ifdef SB_USE_CLASS_TELCMSCONTENTHINTS
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSCONTENTHINTS */

#ifdef SB_USE_CLASS_TELCMSSIGNATUREPOLICY
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSSIGNATUREPOLICY */

#ifdef SB_USE_CLASS_TELCMSSIGPOLICYQUALIFIER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSSIGPOLICYQUALIFIER */

#ifdef SB_USE_CLASS_TELCMSCONTENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSCONTENT */

#ifdef SB_USE_CLASS_TELCMSREVOCATIONVALUES
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSREVOCATIONVALUES */

#ifdef SB_USE_CLASS_TELCMSREVOCATIONREFS
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSREVOCATIONREFS */

#ifdef SB_USE_CLASS_TELCMSREVOCATIONREF
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSREVOCATIONREF */

#ifdef SB_USE_CLASS_TELCMSOCSPRESPONSESID
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSOCSPRESPONSESID */

#ifdef SB_USE_CLASS_TELCMSOCSPIDENTIFIER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSOCSPIDENTIFIER */

#ifdef SB_USE_CLASS_TELCMSCRLVALIDATEDID
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSCRLVALIDATEDID */

#ifdef SB_USE_CLASS_TELCMSCRLIDENTIFIER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSCRLIDENTIFIER */

#ifdef SB_USE_CLASS_TELCMSCERTIFICATEREFS
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSCERTIFICATEREFS */

#ifdef SB_USE_CLASS_TELCMSSIGNERIDENTIFIER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSSIGNERIDENTIFIER */

#ifdef SB_USE_CLASS_TELCMSHASH
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSHASH */

#ifdef SB_USE_CLASS_TELCMSPROPERTY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSPROPERTY */

#ifdef SB_USE_CLASS_TELASN1DIRECTORYSTRING
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELASN1DIRECTORYSTRING */

#ifdef SB_USE_CLASS_TELSSLSERVERPGPCERTIFICATETYPEHANDLER
#  define SB_USE_CLASS_TELSSLPGPCERTIFICATETYPEHANDLER
#endif /* SB_USE_CLASS_TELSSLSERVERPGPCERTIFICATETYPEHANDLER */

#ifdef SB_USE_CLASS_TELSSLPGPCERTIFICATETYPEHANDLER
#  define SB_USE_CLASS_TELSSLCERTIFICATETYPEHANDLER
#endif /* SB_USE_CLASS_TELSSLPGPCERTIFICATETYPEHANDLER */

#ifdef SB_USE_CLASS_TELSSLCERTIFICATETYPEHANDLER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSSLCERTIFICATETYPEHANDLER */

#ifdef SB_USE_CLASS_TELSSHAUTHHANDLER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSSHAUTHHANDLER */

#ifdef SB_USE_CLASS_TELSSHKEY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSHKEY */

#ifdef SB_USE_CLASS_TELSIMPLEPGPMIMEMESSAGE
#  define SB_USE_CLASS_TELSIMPLEMIMEMESSAGE
#endif /* SB_USE_CLASS_TELSIMPLEPGPMIMEMESSAGE */

#ifdef SB_USE_CLASS_TELSIMPLEPGPMIMEOPTIONS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELSIMPLEPGPMIMEOPTIONS */

#ifdef SB_USE_CLASS_TELMESSAGEPARTHANDLERPGPKEYS
#  define SB_USE_CLASS_TELMESSAGEPARTHANDLER
#endif /* SB_USE_CLASS_TELMESSAGEPARTHANDLERPGPKEYS */

#ifdef SB_USE_CLASS_TELMESSAGEPARTHANDLERPGPMIME
#  define SB_USE_CLASS_TELMESSAGEPARTHANDLER
#endif /* SB_USE_CLASS_TELMESSAGEPARTHANDLERPGPMIME */

#ifdef SB_USE_CLASS_TELLDAPSCLIENT
#  define SB_USE_CLASS_TELSIMPLESSLCLIENT
#endif /* SB_USE_CLASS_TELLDAPSCLIENT */

#ifdef SB_USE_CLASS_TELLDAPSKEYSERVERSEARCHFILTER
#  define SB_USE_CLASS_TELLDAPSSEARCHFILTER
#endif /* SB_USE_CLASS_TELLDAPSKEYSERVERSEARCHFILTER */

#ifndef SB_WINCE_OR_LINUX
#ifdef SB_USE_CLASS_TELPGPSFXMAKER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPGPSFXMAKER */

#ifdef SB_USE_CLASS_TELPGPSFXSTUB
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELPGPSFXSTUB */

#endif
#else
#ifdef SB_USE_CLASS_TELPKCS11SESSIONINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11SESSIONINFO */

#ifdef SB_USE_CLASS_TELPKCS11SLOTINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11SLOTINFO */

#ifdef SB_USE_CLASS_TELPKCS11MODULE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11MODULE */

#ifdef SB_USE_CLASS_TELPKCS11ECPARAMSDIRECTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS11ECPARAMSDIRECTORY */

#ifdef SB_USE_CLASS_TELPKCS11CRYPTOCONTEXT
#  define SB_USE_CLASS_TELCUSTOMCRYPTOCONTEXT
#endif /* SB_USE_CLASS_TELPKCS11CRYPTOCONTEXT */

#ifdef SB_USE_CLASS_TELPKCS11CRYPTOKEY
#  define SB_USE_CLASS_TELCUSTOMCRYPTOKEY
#endif /* SB_USE_CLASS_TELPKCS11CRYPTOKEY */

#ifdef SB_USE_CLASS_TELPKCS11CRYPTOPROVIDER
#  define SB_USE_CLASS_TELEXTERNALCRYPTOPROVIDER
#endif /* SB_USE_CLASS_TELPKCS11CRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELPKCS11CRYPTOPROVIDEROPTIONS
#  define SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDEROPTIONS
#endif /* SB_USE_CLASS_TELPKCS11CRYPTOPROVIDEROPTIONS */

#ifdef SB_USE_CLASS_TELSIGNEDANDENVELOPEDCMSMESSAGE
#  define SB_USE_CLASS_TELSIGNEDCMSMESSAGE
#endif /* SB_USE_CLASS_TELSIGNEDANDENVELOPEDCMSMESSAGE */

#ifdef SB_USE_CLASS_TELSIGNEDCMSMESSAGE
#  define SB_USE_CLASS_TELCMSMESSAGE
#endif /* SB_USE_CLASS_TELSIGNEDCMSMESSAGE */

#ifdef SB_USE_CLASS_TELCMSCONTENTHASH
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSCONTENTHASH */

#ifdef SB_USE_CLASS_TELCMSMESSAGE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCMSMESSAGE */

#ifdef SB_USE_CLASS_TELATSHASHINDEXPROCESSOR
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELATSHASHINDEXPROCESSOR */

#ifdef SB_USE_CLASS_TELCMSTIMESTAMP
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSTIMESTAMP */

#ifdef SB_USE_CLASS_TELCMSSIGNATURE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSSIGNATURE */

#ifdef SB_USE_CLASS_TELCMSSIGNATUREPOLICYSTORE
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSSIGNATUREPOLICYSTORE */

#ifdef SB_USE_CLASS_TELCMSSIGNERATTRIBUTES
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSSIGNERATTRIBUTES */

#ifdef SB_USE_CLASS_TELCMSSIGNINGCERTIFICATE
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSSIGNINGCERTIFICATE */

#ifdef SB_USE_CLASS_TELCMSSIGNERLOCATION
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSSIGNERLOCATION */

#ifdef SB_USE_CLASS_TELCMSCOMMITMENTTYPEINDICATION
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSCOMMITMENTTYPEINDICATION */

#ifdef SB_USE_CLASS_TELCMSCONTENTREFERENCE
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSCONTENTREFERENCE */

#ifdef SB_USE_CLASS_TELCMSCONTENTHINTS
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSCONTENTHINTS */

#ifdef SB_USE_CLASS_TELCMSSIGNATUREPOLICY
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSSIGNATUREPOLICY */

#ifdef SB_USE_CLASS_TELCMSSIGPOLICYQUALIFIER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSSIGPOLICYQUALIFIER */

#ifdef SB_USE_CLASS_TELCMSCONTENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSCONTENT */

#ifdef SB_USE_CLASS_TELCMSREVOCATIONVALUES
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSREVOCATIONVALUES */

#ifdef SB_USE_CLASS_TELCMSREVOCATIONREFS
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSREVOCATIONREFS */

#ifdef SB_USE_CLASS_TELCMSREVOCATIONREF
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSREVOCATIONREF */

#ifdef SB_USE_CLASS_TELCMSOCSPRESPONSESID
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSOCSPRESPONSESID */

#ifdef SB_USE_CLASS_TELCMSOCSPIDENTIFIER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSOCSPIDENTIFIER */

#ifdef SB_USE_CLASS_TELCMSCRLVALIDATEDID
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSCRLVALIDATEDID */

#ifdef SB_USE_CLASS_TELCMSCRLIDENTIFIER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSCRLIDENTIFIER */

#ifdef SB_USE_CLASS_TELCMSCERTIFICATEREFS
#  define SB_USE_CLASS_TELCMSPROPERTY
#endif /* SB_USE_CLASS_TELCMSCERTIFICATEREFS */

#ifdef SB_USE_CLASS_TELCMSSIGNERIDENTIFIER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSSIGNERIDENTIFIER */

#ifdef SB_USE_CLASS_TELCMSHASH
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSHASH */

#ifdef SB_USE_CLASS_TELCMSPROPERTY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCMSPROPERTY */

#ifdef SB_USE_CLASS_TELASN1DIRECTORYSTRING
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELASN1DIRECTORYSTRING */

#ifdef SB_USE_CLASS_TELSSLSERVERPGPCERTIFICATETYPEHANDLER
#  define SB_USE_CLASS_TELSSLPGPCERTIFICATETYPEHANDLER
#endif /* SB_USE_CLASS_TELSSLSERVERPGPCERTIFICATETYPEHANDLER */

#ifdef SB_USE_CLASS_TELSSLPGPCERTIFICATETYPEHANDLER
#  define SB_USE_CLASS_TELSSLCERTIFICATETYPEHANDLER
#endif /* SB_USE_CLASS_TELSSLPGPCERTIFICATETYPEHANDLER */

#ifdef SB_USE_CLASS_TELSSLCERTIFICATETYPEHANDLER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSSLCERTIFICATETYPEHANDLER */

#ifdef SB_USE_CLASS_TELSSHAUTHHANDLER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSSHAUTHHANDLER */

#ifdef SB_USE_CLASS_TELSSHKEY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSSHKEY */

#ifdef SB_USE_CLASS_TELSIMPLEPGPMIMEMESSAGE
#  define SB_USE_CLASS_TELSIMPLEMIMEMESSAGE
#endif /* SB_USE_CLASS_TELSIMPLEPGPMIMEMESSAGE */

#ifdef SB_USE_CLASS_TELSIMPLEPGPMIMEOPTIONS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELSIMPLEPGPMIMEOPTIONS */

#ifdef SB_USE_CLASS_TELMESSAGEPARTHANDLERPGPKEYS
#  define SB_USE_CLASS_TELMESSAGEPARTHANDLER
#endif /* SB_USE_CLASS_TELMESSAGEPARTHANDLERPGPKEYS */

#ifdef SB_USE_CLASS_TELMESSAGEPARTHANDLERPGPMIME
#  define SB_USE_CLASS_TELMESSAGEPARTHANDLER
#endif /* SB_USE_CLASS_TELMESSAGEPARTHANDLERPGPMIME */

#ifdef SB_USE_CLASS_TELLDAPSCLIENT
#  define SB_USE_CLASS_TELSIMPLESSLCLIENT
#endif /* SB_USE_CLASS_TELLDAPSCLIENT */

#ifdef SB_USE_CLASS_TELLDAPSKEYSERVERSEARCHFILTER
#  define SB_USE_CLASS_TELLDAPSSEARCHFILTER
#endif /* SB_USE_CLASS_TELLDAPSKEYSERVERSEARCHFILTER */
#endif

#ifdef SB_USE_CLASS_TELPGPENTITYSTREAM
#  define SB_USE_CLASS_TELPGPSTREAM
#endif /* SB_USE_CLASS_TELPGPENTITYSTREAM */

#ifdef SB_USE_CLASS_TELPGPCLEARTEXTVERIFYINGSTREAM
#  define SB_USE_CLASS_TELPGPSTREAM
#endif /* SB_USE_CLASS_TELPGPCLEARTEXTVERIFYINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPSIGNINGSTREAM
#  define SB_USE_CLASS_TELPGPSTREAM
#endif /* SB_USE_CLASS_TELPGPSIGNINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPDECOMPRESSINGSTREAM
#  define SB_USE_CLASS_TELPGPSTREAM
#endif /* SB_USE_CLASS_TELPGPDECOMPRESSINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPCOMPRESSINGSTREAM
#  define SB_USE_CLASS_TELPGPSTREAM
#endif /* SB_USE_CLASS_TELPGPCOMPRESSINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPDECRYPTINGSTREAM
#  define SB_USE_CLASS_TELPGPSTREAM
#endif /* SB_USE_CLASS_TELPGPDECRYPTINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPENCRYPTINGSTREAM
#  define SB_USE_CLASS_TELPGPSTREAM
#endif /* SB_USE_CLASS_TELPGPENCRYPTINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPUNENVELOPINGSTREAM
#  define SB_USE_CLASS_TELPGPSTREAM
#endif /* SB_USE_CLASS_TELPGPUNENVELOPINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPENVELOPINGSTREAM
#  define SB_USE_CLASS_TELPGPSTREAM
#endif /* SB_USE_CLASS_TELPGPENVELOPINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPDEARMORINGSTREAM
#  define SB_USE_CLASS_TELPGPSTREAM
#endif /* SB_USE_CLASS_TELPGPDEARMORINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPARMORINGSTREAM
#  define SB_USE_CLASS_TELPGPSTREAM
#endif /* SB_USE_CLASS_TELPGPARMORINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPSTREAM
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELPGPSTREAM */

#ifdef SB_USE_CLASS_TELPGPHASHINGPOOL
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPGPHASHINGPOOL */

#ifdef SB_USE_CLASS_TELPGPJPEGIMAGE
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELPGPJPEGIMAGE */

#ifdef SB_USE_CLASS_TELPGPKEYRING
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELPGPKEYRING */

#ifdef SB_USE_CLASS_TELPGPUSERATTR
#  define SB_USE_CLASS_TELPGPCUSTOMUSER
#endif /* SB_USE_CLASS_TELPGPUSERATTR */

#ifdef SB_USE_CLASS_TELPGPUSERID
#  define SB_USE_CLASS_TELPGPCUSTOMUSER
#endif /* SB_USE_CLASS_TELPGPUSERID */

#ifdef SB_USE_CLASS_TELPGPCUSTOMUSER
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELPGPCUSTOMUSER */

#ifdef SB_USE_CLASS_TELPGPSIGNATURE
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELPGPSIGNATURE */

#ifdef SB_USE_CLASS_TELPGPTRUST
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELPGPTRUST */

#ifdef SB_USE_CLASS_TELPGPSECRETKEY
#  define SB_USE_CLASS_TELPGPCUSTOMSECRETKEY
#endif /* SB_USE_CLASS_TELPGPSECRETKEY */

#ifdef SB_USE_CLASS_TELPGPSECRETSUBKEY
#  define SB_USE_CLASS_TELPGPCUSTOMSECRETKEY
#endif /* SB_USE_CLASS_TELPGPSECRETSUBKEY */

#ifdef SB_USE_CLASS_TELPGPCUSTOMSECRETKEY
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELPGPCUSTOMSECRETKEY */

#ifdef SB_USE_CLASS_TELPGPPUBLICKEY
#  define SB_USE_CLASS_TELPGPCUSTOMPUBLICKEY
#endif /* SB_USE_CLASS_TELPGPPUBLICKEY */

#ifdef SB_USE_CLASS_TELPGPPUBLICSUBKEY
#  define SB_USE_CLASS_TELPGPCUSTOMPUBLICKEY
#endif /* SB_USE_CLASS_TELPGPPUBLICSUBKEY */

#ifdef SB_USE_CLASS_TELPGPCUSTOMPUBLICKEY
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELPGPCUSTOMPUBLICKEY */

#ifdef SB_USE_CLASS_TELPGPSTREAMIO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPGPSTREAMIO */

#ifdef SB_USE_CLASS_TELPGPSTUBENTITY
#  define SB_USE_CLASS_TELPGPENTITY
#endif /* SB_USE_CLASS_TELPGPSTUBENTITY */

#ifdef SB_USE_CLASS_TELPGPSTREAMPROCESSOR
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELPGPSTREAMPROCESSOR */

#ifdef SB_USE_CLASS_TELPGPCOMPRESSED
#  define SB_USE_CLASS_TELPGPSTREAMINGENTITY
#endif /* SB_USE_CLASS_TELPGPCOMPRESSED */

#ifdef SB_USE_CLASS_TELPGPSYMMETRICALLYENCRYPTED
#  define SB_USE_CLASS_TELPGPSTREAMINGENTITY
#endif /* SB_USE_CLASS_TELPGPSYMMETRICALLYENCRYPTED */

#ifdef SB_USE_CLASS_TELPGPLITERAL
#  define SB_USE_CLASS_TELPGPSTREAMINGENTITY
#endif /* SB_USE_CLASS_TELPGPLITERAL */

#ifdef SB_USE_CLASS_TELPGPSTREAMINGENTITY
#  define SB_USE_CLASS_TELPGPENTITY
#endif /* SB_USE_CLASS_TELPGPSTREAMINGENTITY */

#ifdef SB_USE_CLASS_TELPGPSECRETKEYENTITY
#  define SB_USE_CLASS_TELPGPPUBLICKEYENTITY
#endif /* SB_USE_CLASS_TELPGPSECRETKEYENTITY */

#ifdef SB_USE_CLASS_TELPGPONEPASSSIGNATUREENTITY
#  define SB_USE_CLASS_TELPGPENTITY
#endif /* SB_USE_CLASS_TELPGPONEPASSSIGNATUREENTITY */

#ifdef SB_USE_CLASS_TELPGPSYMMETRICKEYENCRYPTEDSESSIONKEYENTITY
#  define SB_USE_CLASS_TELPGPENTITY
#endif /* SB_USE_CLASS_TELPGPSYMMETRICKEYENCRYPTEDSESSIONKEYENTITY */

#ifdef SB_USE_CLASS_TELPGPPUBLICKEYENCRYPTEDSESSIONKEYENTITY
#  define SB_USE_CLASS_TELPGPENTITY
#endif /* SB_USE_CLASS_TELPGPPUBLICKEYENCRYPTEDSESSIONKEYENTITY */

#ifdef SB_USE_CLASS_TELPGPTRUSTENTITY
#  define SB_USE_CLASS_TELPGPENTITY
#endif /* SB_USE_CLASS_TELPGPTRUSTENTITY */

#ifdef SB_USE_CLASS_TELPGPSIGNATURESUBPACKETS
#  define SB_USE_CLASS_TLIST
#endif /* SB_USE_CLASS_TELPGPSIGNATURESUBPACKETS */

#ifdef SB_USE_CLASS_TELPGPX509SIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPX509SIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPTARGETSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPTARGETSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPFEATURESSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPFEATURESSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPREASONFORREVOCATIONSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPREASONFORREVOCATIONSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPSIGNERSUSERIDSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPSIGNERSUSERIDSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPKEYFLAGSSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPKEYFLAGSSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPPOLICYURLSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPPOLICYURLSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPPRIMARYUSERIDSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPPRIMARYUSERIDSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPPREFERREDKEYSERVERSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPPREFERREDKEYSERVERSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPKEYSERVERPREFERENCESSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPKEYSERVERPREFERENCESSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPPREFERREDCOMPRESSIONALGORITHMSSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPPREFERREDCOMPRESSIONALGORITHMSSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPPREFERREDHASHALGORITHMSSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPPREFERREDHASHALGORITHMSSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPNOTATIONDATASIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPNOTATIONDATASIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPISSUERKEYIDSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPISSUERKEYIDSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPREVOCATIONKEYSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPREVOCATIONKEYSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPPREFERREDSYMMETRICALGORITHMSSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPPREFERREDSYMMETRICALGORITHMSSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPKEYEXPIRATIONTIMESIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPKEYEXPIRATIONTIMESIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPREVOCABLESIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPREVOCABLESIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPREGULAREXPRESSIONSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPREGULAREXPRESSIONSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPTRUSTSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPTRUSTSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPEXPORTABLECERTIFICATIONSIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPEXPORTABLECERTIFICATIONSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPEMBEDDEDSIGNATURESIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPEMBEDDEDSIGNATURESIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPEXPIRATIONTIMESIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPEXPIRATIONTIMESIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPCREATIONTIMESIGNATURESUBPACKET
#  define SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#endif /* SB_USE_CLASS_TELPGPCREATIONTIMESIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELPGPSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPSIGNATUREENTITY
#  define SB_USE_CLASS_TELPGPENTITY
#endif /* SB_USE_CLASS_TELPGPSIGNATUREENTITY */

#ifdef SB_USE_CLASS_TELPGPUSERATTRENTITY
#  define SB_USE_CLASS_TELPGPENTITY
#endif /* SB_USE_CLASS_TELPGPUSERATTRENTITY */

#ifdef SB_USE_CLASS_TELPGPUSERATTRIMAGESUBPACKET
#  define SB_USE_CLASS_TELPGPUSERATTRSUBPACKET
#endif /* SB_USE_CLASS_TELPGPUSERATTRIMAGESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPUSERATTRSUBPACKET
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELPGPUSERATTRSUBPACKET */

#ifdef SB_USE_CLASS_TELPGPUSERIDENTITY
#  define SB_USE_CLASS_TELPGPENTITY
#endif /* SB_USE_CLASS_TELPGPUSERIDENTITY */

#ifdef SB_USE_CLASS_TELPGPS2K
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELPGPS2K */

#ifdef SB_USE_CLASS_TELPGPPUBLICKEYENTITY
#  define SB_USE_CLASS_TELPGPENTITY
#endif /* SB_USE_CLASS_TELPGPPUBLICKEYENTITY */

#ifdef SB_USE_CLASS_TELPGPENTITY
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELPGPENTITY */

#ifdef SB_USE_CLASS_TELPGPREADER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELPGPREADER */

#ifdef SB_USE_CLASS_TELPGPPROCESSINGUNIT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPGPPROCESSINGUNIT */

#ifdef SB_USE_CLASS_TELPGPWRITER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELPGPWRITER */

#ifdef SB_USE_CLASS_TELPDFADVANCEDPUBLICKEYSECURITYHANDLER
#  define SB_USE_CLASS_TELPDFPUBLICKEYSECURITYHANDLER
#endif /* SB_USE_CLASS_TELPDFADVANCEDPUBLICKEYSECURITYHANDLER */

#ifdef SB_USE_CLASS_TELPDFPERMISSIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFPERMISSIONS */

#ifdef SB_USE_CLASS_TELPDFPUBLICKEYREVOCATIONINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFPUBLICKEYREVOCATIONINFO */

#ifdef SB_USE_CLASS_TELPDFPUBLICKEYRECIPIENTGROUP
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFPUBLICKEYRECIPIENTGROUP */

#ifdef SB_USE_CLASS_TELPDFPUBLICKEYSECURITYHANDLER
#  define SB_USE_CLASS_TELPDFSECURITYHANDLER
#endif /* SB_USE_CLASS_TELPDFPUBLICKEYSECURITYHANDLER */

#ifdef SB_USE_CLASS_TELPDFPASSWORDSECURITYHANDLER
#  define SB_USE_CLASS_TELPDFSECURITYHANDLER
#endif /* SB_USE_CLASS_TELPDFPASSWORDSECURITYHANDLER */

#ifdef SB_USE_CLASS_TELPDFXREFS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFXREFS */

#ifdef SB_USE_CLASS_TELPDFXREFENTRY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFXREFENTRY */

#ifdef SB_USE_CLASS_TELPDFXREF
#  define SB_USE_CLASS_TELPDFCPXOBJ
#endif /* SB_USE_CLASS_TELPDFXREF */

#ifdef SB_USE_CLASS_TELPDFREF
#  define SB_USE_CLASS_TELPDFOBJECT
#endif /* SB_USE_CLASS_TELPDFREF */

#ifdef SB_USE_CLASS_TELPDFINDIRECT
#  define SB_USE_CLASS_TELPDFCPXOBJ
#endif /* SB_USE_CLASS_TELPDFINDIRECT */

#ifdef SB_USE_CLASS_TELPDFSTREAM
#  define SB_USE_CLASS_TELPDFCPXOBJ
#endif /* SB_USE_CLASS_TELPDFSTREAM */

#ifdef SB_USE_CLASS_TELPDFDICTIONARY
#  define SB_USE_CLASS_TELPDFARRAY
#endif /* SB_USE_CLASS_TELPDFDICTIONARY */

#ifdef SB_USE_CLASS_TELPDFARRAY
#  define SB_USE_CLASS_TELPDFCPXOBJ
#endif /* SB_USE_CLASS_TELPDFARRAY */

#ifdef SB_USE_CLASS_TELPDFCPXOBJ
#  define SB_USE_CLASS_TELPDFOBJECT
#endif /* SB_USE_CLASS_TELPDFCPXOBJ */

#ifdef SB_USE_CLASS_TELPDFNAME
#  define SB_USE_CLASS_TELPDFOBJECT
#endif /* SB_USE_CLASS_TELPDFNAME */

#ifdef SB_USE_CLASS_TELPDFCOMMENT
#  define SB_USE_CLASS_TELPDFOBJECT
#endif /* SB_USE_CLASS_TELPDFCOMMENT */

#ifdef SB_USE_CLASS_TELPDFSTRING
#  define SB_USE_CLASS_TELPDFOBJECT
#endif /* SB_USE_CLASS_TELPDFSTRING */

#ifdef SB_USE_CLASS_TELPDFREAL
#  define SB_USE_CLASS_TELPDFOBJECT
#endif /* SB_USE_CLASS_TELPDFREAL */

#ifdef SB_USE_CLASS_TELPDFBOOLEAN
#  define SB_USE_CLASS_TELPDFOBJECT
#endif /* SB_USE_CLASS_TELPDFBOOLEAN */

#ifdef SB_USE_CLASS_TELPDFNULL
#  define SB_USE_CLASS_TELPDFOBJECT
#endif /* SB_USE_CLASS_TELPDFNULL */

#ifdef SB_USE_CLASS_TELPDFFILE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFFILE */

#ifdef SB_USE_CLASS_TELPDFOBJECT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFOBJECT */

#ifdef SB_USE_CLASS_TELPDFLEGALCONTENTATTESTATION
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFLEGALCONTENTATTESTATION */

#ifdef SB_USE_CLASS_TELPDFFILEATTACHMENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFFILEATTACHMENT */

#ifdef SB_USE_CLASS_TELPDFPAGEINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFPAGEINFO */

#ifdef SB_USE_CLASS_TELPDFREQUIREMENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFREQUIREMENT */

#ifdef SB_USE_CLASS_TELPDFREQUIREMENTHANDLER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFREQUIREMENTHANDLER */

#ifdef SB_USE_CLASS_TELPDFENCODINGHANDLER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFENCODINGHANDLER */

#ifdef SB_USE_CLASS_TELPDFSIGNATUREINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFSIGNATUREINFO */

#ifdef SB_USE_CLASS_TELPDFSIGNATURE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFSIGNATURE */

#ifdef SB_USE_CLASS_TELPDFSIGNATUREWIDGETPROPS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFSIGNATUREWIDGETPROPS */

#ifdef SB_USE_CLASS_TELPDFSIGNATUREWIDGETTEXTLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFSIGNATUREWIDGETTEXTLIST */

#ifdef SB_USE_CLASS_TELPDFSIGNATUREWIDGETTEXT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFSIGNATUREWIDGETTEXT */

#ifdef SB_USE_CLASS_TELPDFCIDFONT
#  define SB_USE_CLASS_TELPDFCUSTOMFONT
#endif /* SB_USE_CLASS_TELPDFCIDFONT */

#ifdef SB_USE_CLASS_TELPDFMETRICW2
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFMETRICW2 */

#ifdef SB_USE_CLASS_TELPDFMETRICW
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFMETRICW */

#ifdef SB_USE_CLASS_TELPDFCOMPOSITEFONT
#  define SB_USE_CLASS_TELPDFCUSTOMFONT
#endif /* SB_USE_CLASS_TELPDFCOMPOSITEFONT */

#ifdef SB_USE_CLASS_TELPDFSIMPLEFONT
#  define SB_USE_CLASS_TELPDFCUSTOMFONT
#endif /* SB_USE_CLASS_TELPDFSIMPLEFONT */

#ifdef SB_USE_CLASS_TELPDFCUSTOMFONT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFCUSTOMFONT */

#ifdef SB_USE_CLASS_TELPDFCIDSYSTEMINFO
#  define SB_USE_CLASS_TELPDFCUSTOMFONTOBJECT
#endif /* SB_USE_CLASS_TELPDFCIDSYSTEMINFO */

#ifdef SB_USE_CLASS_TELPDFCIDFONTDESCRIPTOR
#  define SB_USE_CLASS_TELPDFFONTDESCRIPTOR
#endif /* SB_USE_CLASS_TELPDFCIDFONTDESCRIPTOR */

#ifdef SB_USE_CLASS_TELPDFFONTDESCRIPTOR
#  define SB_USE_CLASS_TELPDFCUSTOMFONTOBJECT
#endif /* SB_USE_CLASS_TELPDFFONTDESCRIPTOR */

#ifdef SB_USE_CLASS_TELPDFENCODING
#  define SB_USE_CLASS_TELPDFCUSTOMFONTOBJECT
#endif /* SB_USE_CLASS_TELPDFENCODING */

#ifdef SB_USE_CLASS_TELPDFCUSTOMFONTOBJECT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFCUSTOMFONTOBJECT */

#ifdef SB_USE_CLASS_TELPDFIMAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFIMAGE */

#ifdef SB_USE_CLASS_TELPDFBYTERANGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFBYTERANGE */

#ifdef SB_USE_CLASS_TELPDFSECURITYHANDLER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELPDFSECURITYHANDLER */

#ifdef SB_USE_CLASS_TELPDFSIGREFENTRY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFSIGREFENTRY */

#ifdef SB_USE_CLASS_TELPDFURPROPERTIES
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPDFURPROPERTIES */

#ifdef SB_USE_CLASS_TELPDFDOCUMENT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELPDFDOCUMENT */

#ifdef SB_USE_CLASS_TELOPENOFFICEXMLMANIFEST
#  define SB_USE_CLASS_TELOFFICEOPENXMLELEMENT
#endif /* SB_USE_CLASS_TELOPENOFFICEXMLMANIFEST */

#ifdef SB_USE_CLASS_TELOPENOFFICEXMLMANIFESTFILEENTRY
#  define SB_USE_CLASS_TELOFFICEOPENXMLELEMENT
#endif /* SB_USE_CLASS_TELOPENOFFICEXMLMANIFESTFILEENTRY */

#ifdef SB_USE_CLASS_TELOPENOFFICEXMLMANIFESTENCRYPTIONDATA
#  define SB_USE_CLASS_TELOFFICEOPENXMLELEMENT
#endif /* SB_USE_CLASS_TELOPENOFFICEXMLMANIFESTENCRYPTIONDATA */

#ifdef SB_USE_CLASS_TELOPENOFFICEXMLMANIFESTSTARTKEYGENERATION
#  define SB_USE_CLASS_TELOFFICEOPENXMLELEMENT
#endif /* SB_USE_CLASS_TELOPENOFFICEXMLMANIFESTSTARTKEYGENERATION */

#ifdef SB_USE_CLASS_TELOPENOFFICEXMLMANIFESTKEYDERIVATION
#  define SB_USE_CLASS_TELOFFICEOPENXMLELEMENT
#endif /* SB_USE_CLASS_TELOPENOFFICEXMLMANIFESTKEYDERIVATION */

#ifdef SB_USE_CLASS_TELOPENOFFICEXMLMANIFESTALGORITHM
#  define SB_USE_CLASS_TELOFFICEOPENXMLELEMENT
#endif /* SB_USE_CLASS_TELOPENOFFICEXMLMANIFESTALGORITHM */

#ifdef SB_USE_CLASS_TELOFFICEXMLFIXEDDOCUMENT
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELOFFICEXMLFIXEDDOCUMENT */

#ifdef SB_USE_CLASS_TELOFFICEXMLPAGECONTENT
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELOFFICEXMLPAGECONTENT */

#ifdef SB_USE_CLASS_TELOFFICEXMLFIXEDDOCUMENTSEQUENCE
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELOFFICEXMLFIXEDDOCUMENTSEQUENCE */

#ifdef SB_USE_CLASS_TELOFFICEXMLSIGNATUREDEFINITION
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELOFFICEXMLSIGNATUREDEFINITION */

#ifdef SB_USE_CLASS_TELOFFICEXMLSPOTLOCATION
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELOFFICEXMLSPOTLOCATION */

#ifdef SB_USE_CLASS_TELOFFICEXMLSIGNATUREINFOV1
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOFFICEXMLSIGNATUREINFOV1 */

#ifdef SB_USE_CLASS_TELXMLTRANSFORM
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELXMLTRANSFORM */

#ifdef SB_USE_CLASS_TELOFFICEXMLSIGNATURETIME
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELOFFICEXMLSIGNATURETIME */

#ifdef SB_USE_CLASS_TELOFFICEXMLENCRYPTION
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELOFFICEXMLENCRYPTION */

#ifdef SB_USE_CLASS_TELOFFICEXMLPASSWORDKEYENCRYPTOR
#  define SB_USE_CLASS_TELOFFICEXMLKEYENCRYPTOR
#endif /* SB_USE_CLASS_TELOFFICEXMLPASSWORDKEYENCRYPTOR */

#ifdef SB_USE_CLASS_TELOFFICEXMLKEYENCRYPTORS
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELOFFICEXMLKEYENCRYPTORS */

#ifdef SB_USE_CLASS_TELOFFICEXMLKEYENCRYPTOR
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELOFFICEXMLKEYENCRYPTOR */

#ifdef SB_USE_CLASS_TELOFFICEXMLDATAINTEGRITY
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELOFFICEXMLDATAINTEGRITY */

#ifdef SB_USE_CLASS_TELOFFICEXMLKEYDATA
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELOFFICEXMLKEYDATA */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLCOREPROPERTIES
#  define SB_USE_CLASS_TELOFFICEOPENXMLELEMENT
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLCOREPROPERTIES */

#ifdef SB_USE_CLASS_TELOFFICEXMLDCDATE
#  define SB_USE_CLASS_TELOFFICEOPENXMLELEMENT
#endif /* SB_USE_CLASS_TELOFFICEXMLDCDATE */

#ifdef SB_USE_CLASS_TELOFFICEXMLDCSIMPLELITERAL
#  define SB_USE_CLASS_TELOFFICEOPENXMLELEMENT
#endif /* SB_USE_CLASS_TELOFFICEXMLDCSIMPLELITERAL */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLCONTENTTYPES
#  define SB_USE_CLASS_TELOFFICEOPENXMLELEMENT
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLCONTENTTYPES */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLOVERRIDELIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLOVERRIDELIST */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLOVERRIDE
#  define SB_USE_CLASS_TELOFFICEOPENXMLELEMENT
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLOVERRIDE */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLDEFAULTLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLDEFAULTLIST */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLDEFAULT
#  define SB_USE_CLASS_TELOFFICEOPENXMLELEMENT
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLDEFAULT */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLRELATIONSHIPS
#  define SB_USE_CLASS_TELOFFICEOPENXMLELEMENT
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLRELATIONSHIPS */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLELEMENT
#  define SB_USE_CLASS_TELXMLCUSTOMELEMENT
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLELEMENT */

#ifdef SB_USE_CLASS_TELXMLCUSTOMELEMENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELXMLCUSTOMELEMENT */

#ifdef SB_USE_CLASS_TELOPENOFFICESIGNATUREHANDLER
#  define SB_USE_CLASS_TELOPENOFFICECUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOPENOFFICESIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOPENOFFICESIGNEDENTRY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOPENOFFICESIGNEDENTRY */

#ifdef SB_USE_CLASS_TELOFFICEOPENXPSSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEOPENXMLBASESIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOFFICEOPENXPSSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEOPENXMLBASESIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLBASESIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLBASESIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLSIGNEDRELATIONSHIPPART
#  define SB_USE_CLASS_TELOFFICEOPENXMLSIGNEDPART
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLSIGNEDRELATIONSHIPPART */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLSIGNEDPART
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLSIGNEDPART */

#ifdef SB_USE_CLASS_TELOFFICEBINARYXMLSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEBINARYCUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOFFICEBINARYXMLSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEBINARYSIGNEDENTRY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOFFICEBINARYSIGNEDENTRY */

#ifdef SB_USE_CLASS_TELOFFICEBINARYCRYPTOAPISIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEBINARYCUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOFFICEBINARYCRYPTOAPISIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEBINARYRC4CRYPTOAPIENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOFFICEBINARYCUSTOMENCRYPTIONHANDLER
#endif /* SB_USE_CLASS_TELOFFICEBINARYRC4CRYPTOAPIENCRYPTIONHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEBINARYRC4ENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOFFICEBINARYCUSTOMENCRYPTIONHANDLER
#endif /* SB_USE_CLASS_TELOFFICEBINARYRC4ENCRYPTIONHANDLER */

#ifdef SB_USE_CLASS_TELOPENOFFICEENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOPENOFFICECUSTOMENCRYPTIONHANDLER
#endif /* SB_USE_CLASS_TELOPENOFFICEENCRYPTIONHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLPASSWORDKEYENCRYPTOR
#  define SB_USE_CLASS_TELOFFICEOPENXMLKEYENCRYPTOR
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLPASSWORDKEYENCRYPTOR */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLKEYENCRYPTOR
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLKEYENCRYPTOR */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLAGILEENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMENCRYPTIONHANDLER
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLAGILEENCRYPTIONHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLSTANDARDENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMENCRYPTIONHANDLER
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLSTANDARDENCRYPTIONHANDLER */

#ifdef SB_USE_CLASS_TELOPENOFFICEPACKAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOPENOFFICEPACKAGE */

#ifdef SB_USE_CLASS_TELOFFICEZIPPACKAGE
#  define SB_USE_CLASS_TELOFFICEPACKAGE
#endif /* SB_USE_CLASS_TELOFFICEZIPPACKAGE */

#ifdef SB_USE_CLASS_TELOFFICEPACKAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOFFICEPACKAGE */

#ifdef SB_USE_CLASS_TELOFFICEPACKAGEPART
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOFFICEPACKAGEPART */

#ifdef SB_USE_CLASS_TELOFFICEPOWERPOINTPERSISTDIRECTORYATOM
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEPOWERPOINTPERSISTDIRECTORYATOM */

#ifdef SB_USE_CLASS_TELOFFICEPOWERPOINTPERSISTDIRECTORYENTRY
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEPOWERPOINTPERSISTDIRECTORYENTRY */

#ifdef SB_USE_CLASS_TELOFFICEPOWERPOINTUSEREDITATOM
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEPOWERPOINTUSEREDITATOM */

#ifdef SB_USE_CLASS_TELOFFICEPOWERPOINTRECORDHEADER
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEPOWERPOINTRECORDHEADER */

#ifdef SB_USE_CLASS_TELOFFICEWORKBOOKFILEPASS
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEWORKBOOKFILEPASS */

#ifdef SB_USE_CLASS_TELOFFICEWORKBOOKBOF
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEWORKBOOKBOF */

#ifdef SB_USE_CLASS_TELOFFICEWORKBOOKRECORDINFO
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEWORKBOOKRECORDINFO */

#ifdef SB_USE_CLASS_TELOFFICEWORDFIB
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEWORDFIB */

#ifdef SB_USE_CLASS_TELOFFICEWORDFIBRGFCLCB
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEWORDFIBRGFCLCB */

#ifdef SB_USE_CLASS_TELOFFICEWORDFIBBASE
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEWORDFIBBASE */

#ifdef SB_USE_CLASS_TELOFFICECRYPTOAPIDIGITALSIGNATURE
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICECRYPTOAPIDIGITALSIGNATURE */

#ifdef SB_USE_CLASS_TELOFFICEDOCSIGSERIALIZEDCERTSTORE
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEDOCSIGSERIALIZEDCERTSTORE */

#ifdef SB_USE_CLASS_TELOFFICECERTSTORECERTIFICATEGROUP
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICECERTSTORECERTIFICATEGROUP */

#ifdef SB_USE_CLASS_TELOFFICECERTIFICATEINFO
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICECERTIFICATEINFO */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTEDSTREAMDESCRIPTOR
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTEDSTREAMDESCRIPTOR */

#ifdef SB_USE_CLASS_TELOFFICEXOROBFUSCATION
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEXOROBFUSCATION */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV4
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV4 */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV3
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV3 */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV2
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV2 */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV1
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV1 */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTIONINFO
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTIONINFO */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTIONVERIFIER
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTIONVERIFIER */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTIONHEADER
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTIONHEADER */

#ifdef SB_USE_CLASS_TELOFFICEENDUSERLICENSEHEADER
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEENDUSERLICENSEHEADER */

#ifdef SB_USE_CLASS_TELOFFICEIRMDSTRANSFORMINFO
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEIRMDSTRANSFORMINFO */

#ifdef SB_USE_CLASS_TELOFFICEEXTENSIBILITYHEADER
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEEXTENSIBILITYHEADER */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTIONTRANSFORMINFO
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTIONTRANSFORMINFO */

#ifdef SB_USE_CLASS_TELOFFICETRANSFORMINFOHEADER
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICETRANSFORMINFOHEADER */

#ifdef SB_USE_CLASS_TELOFFICEDATASPACEDEFINITION
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEDATASPACEDEFINITION */

#ifdef SB_USE_CLASS_TELOFFICEDATASPACEMAP
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEDATASPACEMAP */

#ifdef SB_USE_CLASS_TELOFFICEDATASPACEMAPENTRY
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEDATASPACEMAPENTRY */

#ifdef SB_USE_CLASS_TELOFFICEDATASPACEREFERENCECOMPONENT
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEDATASPACEREFERENCECOMPONENT */

#ifdef SB_USE_CLASS_TELOFFICEDATASPACEVERSIONINFO
#  define SB_USE_CLASS_TELOFFICEBINARYOBJECT
#endif /* SB_USE_CLASS_TELOFFICEDATASPACEVERSIONINFO */

#ifdef SB_USE_CLASS_TELOFFICEBINARYOBJECT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOFFICEBINARYOBJECT */

#ifdef SB_USE_CLASS_TELOFFICEDOCUMENT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELOFFICEDOCUMENT */

#ifdef SB_USE_CLASS_TELOPENOFFICEDOCUMENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOPENOFFICEDOCUMENT */

#ifdef SB_USE_CLASS_TELOFFICEOPENXPSDOCUMENT
#  define SB_USE_CLASS_TELOFFICEOPENXMLPACKAGE
#endif /* SB_USE_CLASS_TELOFFICEOPENXPSDOCUMENT */

#ifdef SB_USE_CLASS_TELOFFICEOPENXPSFIXEDDOCUMENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOFFICEOPENXPSFIXEDDOCUMENT */

#ifdef SB_USE_CLASS_TELOFFICEOPENXPSPAGECONTENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOFFICEOPENXPSPAGECONTENT */

#ifdef SB_USE_CLASS_TELOFFICEOPENXPSSIGNATUREDEFINITION
#  define SB_USE_CLASS_TELOFFICEOPENXMLSIGNATUREVIEW
#endif /* SB_USE_CLASS_TELOFFICEOPENXPSSIGNATUREDEFINITION */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLDOCUMENT
#  define SB_USE_CLASS_TELOFFICEOPENXMLPACKAGE
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLDOCUMENT */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLSIGNATURELINE
#  define SB_USE_CLASS_TELOFFICEOPENXMLSIGNATUREVIEW
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLSIGNATURELINE */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLPACKAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLPACKAGE */

#ifdef SB_USE_CLASS_TELOFFICEBINARYDOCUMENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOFFICEBINARYDOCUMENT */

#ifdef SB_USE_CLASS_TELOPENOFFICEINVALIDSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOPENOFFICECUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOPENOFFICEINVALIDSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOPENOFFICEUNSUPPORTEDSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOPENOFFICECUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOPENOFFICEUNSUPPORTEDSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOPENOFFICECUSTOMSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICECUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOPENOFFICECUSTOMSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLINVALIDSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLINVALIDSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLUNSUPPORTEDSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLUNSUPPORTEDSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICECUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEBINARYINVALIDSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEBINARYCUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOFFICEBINARYINVALIDSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEBINARYUNSUPPORTEDSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICEBINARYCUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOFFICEBINARYUNSUPPORTEDSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEBINARYCUSTOMSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICECUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOFFICEBINARYCUSTOMSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICECUSTOMSIGNATUREHANDLER
#  define SB_USE_CLASS_TELOFFICECUSTOMSECURITYHANDLER
#endif /* SB_USE_CLASS_TELOFFICECUSTOMSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOPENOFFICECUSTOMENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOFFICECUSTOMENCRYPTIONHANDLER
#endif /* SB_USE_CLASS_TELOPENOFFICECUSTOMENCRYPTIONHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOFFICECUSTOMENCRYPTIONHANDLER
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMENCRYPTIONHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEBINARYCUSTOMENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOFFICECUSTOMENCRYPTIONHANDLER
#endif /* SB_USE_CLASS_TELOFFICEBINARYCUSTOMENCRYPTIONHANDLER */

#ifdef SB_USE_CLASS_TELOFFICECUSTOMENCRYPTIONHANDLER
#  define SB_USE_CLASS_TELOFFICECUSTOMSECURITYHANDLER
#endif /* SB_USE_CLASS_TELOFFICECUSTOMENCRYPTIONHANDLER */

#ifdef SB_USE_CLASS_TELOFFICECUSTOMSECURITYHANDLER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELOFFICECUSTOMSECURITYHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLSIGNATUREVIEW
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLSIGNATUREVIEW */

#ifdef SB_USE_CLASS_TELCOMPOUNDFILESTREAMENTRY
#  define SB_USE_CLASS_TELCOMPOUNDFILECUSTOMENTRY
#endif /* SB_USE_CLASS_TELCOMPOUNDFILESTREAMENTRY */

#ifdef SB_USE_CLASS_TELCOMPOUNDFILEDIRECTORYSTREAM
#  define SB_USE_CLASS_TELCOMPOUNDFILEVIRTUALSTREAM
#endif /* SB_USE_CLASS_TELCOMPOUNDFILEDIRECTORYSTREAM */

#ifdef SB_USE_CLASS_TELCOMPOUNDFILETABLESTREAM
#  define SB_USE_CLASS_TELCOMPOUNDFILEVIRTUALSTREAM
#endif /* SB_USE_CLASS_TELCOMPOUNDFILETABLESTREAM */

#ifdef SB_USE_CLASS_TELCOMPOUNDFILEVIRTUALSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELCOMPOUNDFILEVIRTUALSTREAM */

#ifdef SB_USE_CLASS_TELCOMPOUNDFILESTORAGEENTRY
#  define SB_USE_CLASS_TELCOMPOUNDFILECUSTOMENTRY
#endif /* SB_USE_CLASS_TELCOMPOUNDFILESTORAGEENTRY */

#ifdef SB_USE_CLASS_TELCOMPOUNDFILECUSTOMENTRY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCOMPOUNDFILECUSTOMENTRY */

#ifdef SB_USE_CLASS_TELCOMPOUNDFILESTORAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCOMPOUNDFILESTORAGE */

#ifdef SB_USE_CLASS_TELSIMPLEMIMEMESSAGE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSIMPLEMIMEMESSAGE */

#ifdef SB_USE_CLASS_TELSIMPLEMIMEATTACHMENT
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELSIMPLEMIMEATTACHMENT */

#ifdef SB_USE_CLASS_TWIDESTRINGMIMESTREAM
#  define SB_USE_CLASS_TELCUSTOMMEMORYMIMESTREAM
#endif /* SB_USE_CLASS_TWIDESTRINGMIMESTREAM */

#ifdef SB_USE_CLASS_TANSISTRINGMIMESTREAM
#  define SB_USE_CLASS_TELCUSTOMMEMORYMIMESTREAM
#endif /* SB_USE_CLASS_TANSISTRINGMIMESTREAM */

#ifdef SB_USE_CLASS_TELMEMORYMIMESTREAM
#  define SB_USE_CLASS_TELCUSTOMMEMORYMIMESTREAM
#endif /* SB_USE_CLASS_TELMEMORYMIMESTREAM */

#ifdef SB_USE_CLASS_TELCUSTOMMEMORYMIMESTREAM
#  define SB_USE_CLASS_TELCUSTOMMIMESTREAM
#endif /* SB_USE_CLASS_TELCUSTOMMEMORYMIMESTREAM */

#ifdef SB_USE_CLASS_TNULLMIMESTREAM
#  define SB_USE_CLASS_TELCUSTOMMIMESTREAM
#endif /* SB_USE_CLASS_TNULLMIMESTREAM */

#ifdef SB_USE_CLASS_TELBASE64STREAM
#  define SB_USE_CLASS_TELMIMEENCODINGSTREAM
#endif /* SB_USE_CLASS_TELBASE64STREAM */

#ifdef SB_USE_CLASS_TELBINARYSTREAM
#  define SB_USE_CLASS_TEL8BITSTREAM
#endif /* SB_USE_CLASS_TELBINARYSTREAM */

#ifdef SB_USE_CLASS_TEL8BITSTREAM
#  define SB_USE_CLASS_TELMIMEENCODINGSTREAM
#endif /* SB_USE_CLASS_TEL8BITSTREAM */

#ifdef SB_USE_CLASS_TEL7BITSTREAM
#  define SB_USE_CLASS_TELMIMEENCODINGSTREAM
#endif /* SB_USE_CLASS_TEL7BITSTREAM */

#ifdef SB_USE_CLASS_TELQUOTEDPRINTABLESTREAM
#  define SB_USE_CLASS_TELMIMEENCODINGSTREAM
#endif /* SB_USE_CLASS_TELQUOTEDPRINTABLESTREAM */

#ifdef SB_USE_CLASS_TELMIMEENCODINGSTREAM
#  define SB_USE_CLASS_TELCUSTOMMIMESTREAM
#endif /* SB_USE_CLASS_TELMIMEENCODINGSTREAM */

#ifdef SB_USE_CLASS_TELCUSTOMMIMESTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELCUSTOMMIMESTREAM */

#ifdef SB_USE_CLASS_TELXMLPART
#  define SB_USE_CLASS_TELMESSAGEPART
#endif /* SB_USE_CLASS_TELXMLPART */

#ifdef SB_USE_CLASS_TELREGISTEREDMESSAGEPARTHANDLERS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELREGISTEREDMESSAGEPARTHANDLERS */

#ifdef SB_USE_CLASS_TELCONVERTER
#  define SB_USE_CLASS_TPLCONVERTER
#endif /* SB_USE_CLASS_TELCONVERTER */

#ifdef SB_USE_CLASS_TELMESSAGEPARTHANDLER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELMESSAGEPARTHANDLER */

#ifdef SB_USE_CLASS_TELPLAINTEXTPART
#  define SB_USE_CLASS_TELMULTIPARTLIST
#endif /* SB_USE_CLASS_TELPLAINTEXTPART */

#ifdef SB_USE_CLASS_TELMULTIPARTLIST
#  define SB_USE_CLASS_TELMESSAGEPART
#endif /* SB_USE_CLASS_TELMULTIPARTLIST */

#ifdef SB_USE_CLASS_TELMESSAGEPART
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELMESSAGEPART */

#ifdef SB_USE_CLASS_TELMAILADDRESS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELMAILADDRESS */

#ifdef SB_USE_CLASS_TELMAILADDRESSLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELMAILADDRESSLIST */

#ifdef SB_USE_CLASS_TELMAILADDRESSGROUP
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELMAILADDRESSGROUP */

#ifdef SB_USE_CLASS_TELMESSAGEHEADERFIELD
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELMESSAGEHEADERFIELD */

#ifdef SB_USE_CLASS_TELMESSAGEHEADER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELMESSAGEHEADER */

#ifdef SB_USE_CLASS_TELMESSAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELMESSAGE */

#ifdef SB_USE_CLASS_TELDKSIGNATURE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDKSIGNATURE */

#ifdef SB_USE_CLASS_TELDOMAINKEYSVERIFIER
#  define SB_USE_CLASS_TELDOMAINKEYSCLASS
#endif /* SB_USE_CLASS_TELDOMAINKEYSVERIFIER */

#ifdef SB_USE_CLASS_TELDOMAINKEYSSIGNER
#  define SB_USE_CLASS_TELDOMAINKEYSCLASS
#endif /* SB_USE_CLASS_TELDOMAINKEYSSIGNER */

#ifdef SB_USE_CLASS_TELDOMAINKEYSCLASS
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELDOMAINKEYSCLASS */

#ifdef SB_USE_CLASS_TELDKDNSRECORD
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELDKDNSRECORD */

#ifdef SB_USE_CLASS_TELDKRSAPUBLICKEY
#  define SB_USE_CLASS_TELDKPUBLICKEY
#endif /* SB_USE_CLASS_TELDKRSAPUBLICKEY */

#ifdef SB_USE_CLASS_TELDKPUBLICKEY
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELDKPUBLICKEY */

#ifdef SB_USE_CLASS_TELIMAPPARSER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELIMAPPARSER */

#ifdef SB_USE_CLASS_TELIMAPCLIENT
#  define SB_USE_CLASS_TELCUSTOMSIMPLESSLCLIENT
#endif /* SB_USE_CLASS_TELIMAPCLIENT */

#ifdef SB_USE_CLASS_TELIMAPTIMEOUTTHREAD
#  define SB_USE_CLASS_TTHREAD
#endif /* SB_USE_CLASS_TELIMAPTIMEOUTTHREAD */

#ifdef SB_USE_CLASS_TELIMAPIDLETHREAD
#  define SB_USE_CLASS_TTHREAD
#endif /* SB_USE_CLASS_TELIMAPIDLETHREAD */

#ifdef SB_USE_CLASS_TELIMAPIDLEUPDATE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELIMAPIDLEUPDATE */

#ifdef SB_USE_CLASS_TELIMAPFETCHRESPONSE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELIMAPFETCHRESPONSE */

#ifdef SB_USE_CLASS_TELIMAPFETCHRESPONSELINE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELIMAPFETCHRESPONSELINE */

#ifdef SB_USE_CLASS_TELIMAPFETCHRESPONSEITEM
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELIMAPFETCHRESPONSEITEM */

#ifdef SB_USE_CLASS_TELIMAPMAILBOXESLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELIMAPMAILBOXESLIST */

#ifdef SB_USE_CLASS_TELIMAPMAILBOXINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELIMAPMAILBOXINFO */

#ifdef SB_USE_CLASS_TELIMAPMAILBOXSTATE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELIMAPMAILBOXSTATE */

#ifdef SB_USE_CLASS_TELIMAPLITERALCONTEXT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELIMAPLITERALCONTEXT */

#ifdef SB_USE_CLASS_TELPOP3CLIENT
#  define SB_USE_CLASS_TELCUSTOMSIMPLESSLCLIENT
#endif /* SB_USE_CLASS_TELPOP3CLIENT */

#ifdef SB_USE_CLASS_TELCOMMANDSSLCLIENT
#  define SB_USE_CLASS_TELSIMPLESSLCLIENT
#endif /* SB_USE_CLASS_TELCOMMANDSSLCLIENT */

#ifdef SB_USE_CLASS_TELLDAPMODIFYMESSAGE
#  define SB_USE_CLASS_TELLDAPMESSAGE
#endif /* SB_USE_CLASS_TELLDAPMODIFYMESSAGE */

#ifdef SB_USE_CLASS_TELLDAPDELETEMESSAGE
#  define SB_USE_CLASS_TELLDAPMESSAGE
#endif /* SB_USE_CLASS_TELLDAPDELETEMESSAGE */

#ifdef SB_USE_CLASS_TELLDAPSEARCHREFERENCEMESSAGE
#  define SB_USE_CLASS_TELLDAPMESSAGE
#endif /* SB_USE_CLASS_TELLDAPSEARCHREFERENCEMESSAGE */

#ifdef SB_USE_CLASS_TELLDAPSEARCHENTRYMESSAGE
#  define SB_USE_CLASS_TELLDAPMESSAGE
#endif /* SB_USE_CLASS_TELLDAPSEARCHENTRYMESSAGE */

#ifdef SB_USE_CLASS_TELLDAPPARTIALATTRIBUTE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELLDAPPARTIALATTRIBUTE */

#ifdef SB_USE_CLASS_TELLDAPATTRIBUTEVALUE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELLDAPATTRIBUTEVALUE */

#ifdef SB_USE_CLASS_TELLDAPSEARCHMESSAGE
#  define SB_USE_CLASS_TELLDAPMESSAGE
#endif /* SB_USE_CLASS_TELLDAPSEARCHMESSAGE */

#ifdef SB_USE_CLASS_TELLDAPBINDRESPONSEMESSAGE
#  define SB_USE_CLASS_TELLDAPMESSAGE
#endif /* SB_USE_CLASS_TELLDAPBINDRESPONSEMESSAGE */

#ifdef SB_USE_CLASS_TELLDAPRESULTMESSAGE
#  define SB_USE_CLASS_TELLDAPMESSAGE
#endif /* SB_USE_CLASS_TELLDAPRESULTMESSAGE */

#ifdef SB_USE_CLASS_TELLDAPRESULT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELLDAPRESULT */

#ifdef SB_USE_CLASS_TELLDAPUNBINDMESSAGE
#  define SB_USE_CLASS_TELLDAPMESSAGE
#endif /* SB_USE_CLASS_TELLDAPUNBINDMESSAGE */

#ifdef SB_USE_CLASS_TELLDAPSASLBINDMESSAGE
#  define SB_USE_CLASS_TELLDAPMESSAGE
#endif /* SB_USE_CLASS_TELLDAPSASLBINDMESSAGE */

#ifdef SB_USE_CLASS_TELLDAPSIMPLEBINDMESSAGE
#  define SB_USE_CLASS_TELLDAPMESSAGE
#endif /* SB_USE_CLASS_TELLDAPSIMPLEBINDMESSAGE */

#ifdef SB_USE_CLASS_TELLDAPMESSAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELLDAPMESSAGE */

#ifdef SB_USE_CLASS_TELSIMPLESSLCLIENT
#  define SB_USE_CLASS_TELCUSTOMSIMPLESSLCLIENT
#endif /* SB_USE_CLASS_TELSIMPLESSLCLIENT */

#ifdef SB_USE_CLASS_TELLDAPURL
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELLDAPURL */

#ifdef SB_USE_CLASS_TELLDAPRESPONSE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELLDAPRESPONSE */

#ifdef SB_USE_CLASS_TELLDAPSSEARCHFILTER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELLDAPSSEARCHFILTER */

#ifdef SB_USE_CLASS_TELLDAPCRLRETRIEVERFACTORY
#  define SB_USE_CLASS_TELCUSTOMCRLRETRIEVERFACTORY
#endif /* SB_USE_CLASS_TELLDAPCRLRETRIEVERFACTORY */

#ifdef SB_USE_CLASS_TELLDAPCRLRETRIEVER
#  define SB_USE_CLASS_TELCUSTOMCRLRETRIEVER
#endif /* SB_USE_CLASS_TELLDAPCRLRETRIEVER */

#ifdef SB_USE_CLASS_TELLDAPCERTIFICATERETRIEVERFACTORY
#  define SB_USE_CLASS_TELCUSTOMCERTIFICATERETRIEVERFACTORY
#endif /* SB_USE_CLASS_TELLDAPCERTIFICATERETRIEVERFACTORY */

#ifdef SB_USE_CLASS_TELLDAPCERTIFICATERETRIEVER
#  define SB_USE_CLASS_TELCUSTOMCERTIFICATERETRIEVER
#endif /* SB_USE_CLASS_TELLDAPCERTIFICATERETRIEVER */

#ifdef SB_USE_CLASS_TELLDAPCERTSTORAGE
#  define SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#endif /* SB_USE_CLASS_TELLDAPCERTSTORAGE */

#ifdef SB_USE_CLASS_TELWEBSOCKETSERVER
#  define SB_USE_CLASS_TELWEBSOCKETBASE
#endif /* SB_USE_CLASS_TELWEBSOCKETSERVER */

#ifdef SB_USE_CLASS_TELDIGESTAUTH
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDIGESTAUTH */

#ifdef SB_USE_CLASS_TELHTTPSSERVER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELHTTPSSERVER */

#ifdef SB_USE_CLASS_TELMULTIPARTFORMLIST
#  define SB_USE_CLASS_TELMULTIPARTFORMDATA
#endif /* SB_USE_CLASS_TELMULTIPARTFORMLIST */

#ifdef SB_USE_CLASS_TELMULTIPARTFORMDATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELMULTIPARTFORMDATA */

#ifdef SB_USE_CLASS_TELHTTPSERVERRESPONSEPARAMS
#  define SB_USE_CLASS_TELHTTPPARAMS
#endif /* SB_USE_CLASS_TELHTTPSERVERRESPONSEPARAMS */

#ifdef SB_USE_CLASS_TELHTTPSERVERREQUESTPARAMS
#  define SB_USE_CLASS_TELHTTPCUSTOMREQUESTPARAMS
#endif /* SB_USE_CLASS_TELHTTPSERVERREQUESTPARAMS */

#ifdef SB_USE_CLASS_TELRESTCLIENT
#  define SB_USE_CLASS_TELHTTPSCLIENT
#endif /* SB_USE_CLASS_TELRESTCLIENT */

#ifdef SB_USE_CLASS_TELWEBSOCKETCLIENT
#  define SB_USE_CLASS_TELWEBSOCKETBASE
#endif /* SB_USE_CLASS_TELWEBSOCKETCLIENT */

#ifdef SB_USE_CLASS_TELWEBSOCKETSUBPROTOCOLS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBSOCKETSUBPROTOCOLS */

#ifdef SB_USE_CLASS_TELWEBSOCKETEXTENSIONS
#  define SB_USE_CLASS_TELWEBSOCKETEXTENSION
#endif /* SB_USE_CLASS_TELWEBSOCKETEXTENSIONS */

#ifdef SB_USE_CLASS_TELWEBSOCKETSUBPROTOCOL
#  define SB_USE_CLASS_TELWEBSOCKETOPTION
#endif /* SB_USE_CLASS_TELWEBSOCKETSUBPROTOCOL */

#ifdef SB_USE_CLASS_TELWEBSOCKETBASE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBSOCKETBASE */

#ifdef SB_USE_CLASS_TELWEBSOCKETEXTENSION
#  define SB_USE_CLASS_TELWEBSOCKETOPTION
#endif /* SB_USE_CLASS_TELWEBSOCKETEXTENSION */

#ifdef SB_USE_CLASS_TELWEBSOCKETOPTION
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBSOCKETOPTION */

#ifdef SB_USE_CLASS_TELWEBSOCKETMESSAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBSOCKETMESSAGE */

#ifdef SB_USE_CLASS_TELCOOKIEMANAGER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCOOKIEMANAGER */

#ifdef SB_USE_CLASS_TELCOOKIEDOMAIN
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCOOKIEDOMAIN */

#ifdef SB_USE_CLASS_TELCOOKIE
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELCOOKIE */

#ifdef SB_USE_CLASS_TELOAUTH2REDIRECTRECEIVER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELOAUTH2REDIRECTRECEIVER */

#ifdef SB_USE_CLASS_TELOAUTH2CLIENT
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELOAUTH2CLIENT */

#ifdef SB_USE_CLASS_TELOAUTH2REQUEST
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELOAUTH2REQUEST */

#ifdef SB_USE_CLASS_TELOAUTH2SETTINGS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELOAUTH2SETTINGS */

#ifdef SB_USE_CLASS_TELHTTPCRLRETRIEVERFACTORY
#  define SB_USE_CLASS_TELCUSTOMCRLRETRIEVERFACTORY
#endif /* SB_USE_CLASS_TELHTTPCRLRETRIEVERFACTORY */

#ifdef SB_USE_CLASS_TELHTTPCRLRETRIEVER
#  define SB_USE_CLASS_TELCUSTOMCRLRETRIEVER
#endif /* SB_USE_CLASS_TELHTTPCRLRETRIEVER */

#ifdef SB_USE_CLASS_TELHTTPCERTIFICATERETRIEVERFACTORY
#  define SB_USE_CLASS_TELCUSTOMCERTIFICATERETRIEVERFACTORY
#endif /* SB_USE_CLASS_TELHTTPCERTIFICATERETRIEVERFACTORY */

#ifdef SB_USE_CLASS_TELHTTPCERTIFICATERETRIEVER
#  define SB_USE_CLASS_TELCUSTOMCERTIFICATERETRIEVER
#endif /* SB_USE_CLASS_TELHTTPCERTIFICATERETRIEVER */

#ifdef SB_USE_CLASS_TELHTTPOCSPCLIENTFACTORY
#  define SB_USE_CLASS_TELCUSTOMOCSPCLIENTFACTORY
#endif /* SB_USE_CLASS_TELHTTPOCSPCLIENTFACTORY */

#ifdef SB_USE_CLASS_TELHTTPOCSPCLIENT
#  define SB_USE_CLASS_TELOCSPCLIENT
#endif /* SB_USE_CLASS_TELHTTPOCSPCLIENT */

#ifdef SB_USE_CLASS_TELHTTPTSPCLIENT
#  define SB_USE_CLASS_TELCUSTOMTSPCLIENT
#endif /* SB_USE_CLASS_TELHTTPTSPCLIENT */

#ifdef SB_USE_CLASS_SBHTTPSCLIENT_TELSTRINGVALUE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_SBHTTPSCLIENT_TELSTRINGVALUE */

#ifdef SB_USE_CLASS_TELHTTPSCLIENT
#  define SB_USE_CLASS_TELCUSTOMSIMPLESSLCLIENT
#endif /* SB_USE_CLASS_TELHTTPSCLIENT */

#ifdef SB_USE_CLASS_TELHTTPREQUESTPARAMS
#  define SB_USE_CLASS_TELHTTPCUSTOMREQUESTPARAMS
#endif /* SB_USE_CLASS_TELHTTPREQUESTPARAMS */

#ifdef SB_USE_CLASS_TELHTTPUTILS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELHTTPUTILS */

#ifdef SB_USE_CLASS_TELHTTPCOMPRESSEDPROCESSOR
#  define SB_USE_CLASS_TELHTTPENCODINGPROCESSOR
#endif /* SB_USE_CLASS_TELHTTPCOMPRESSEDPROCESSOR */

#ifdef SB_USE_CLASS_TELHTTPCHUNKEDPROCESSOR
#  define SB_USE_CLASS_TELHTTPENCODINGPROCESSOR
#endif /* SB_USE_CLASS_TELHTTPCHUNKEDPROCESSOR */

#ifdef SB_USE_CLASS_TELHTTPENCODINGPROCESSOR
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELHTTPENCODINGPROCESSOR */

#ifdef SB_USE_CLASS_TELHTTPMULTIPARTLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELHTTPMULTIPARTLIST */

#ifdef SB_USE_CLASS_TELHTTPMULTIPARTPART
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELHTTPMULTIPARTPART */

#ifdef SB_USE_CLASS_TELHTTPCUSTOMREQUESTPARAMS
#  define SB_USE_CLASS_TELHTTPPARAMS
#endif /* SB_USE_CLASS_TELHTTPCUSTOMREQUESTPARAMS */

#ifdef SB_USE_CLASS_TELHTTPPARAMS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELHTTPPARAMS */

#ifdef SB_USE_CLASS_TELHTTPRANGES
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELHTTPRANGES */

#ifdef SB_USE_CLASS_TELCUSTOMSAMLADAPTER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMSAMLADAPTER */

#ifdef SB_USE_CLASS_TELHTTPSCLIENTPARAMS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELHTTPSCLIENTPARAMS */

#ifdef SB_USE_CLASS_TELFTPSUSERS
#  define SB_USE_CLASS_TELUSERS
#endif /* SB_USE_CLASS_TELFTPSUSERS */

#ifdef SB_USE_CLASS_TELSIMPLEFTPSSERVERLISTENINGTHREAD
#  define SB_USE_CLASS_TTHREAD
#endif /* SB_USE_CLASS_TELSIMPLEFTPSSERVERLISTENINGTHREAD */

#ifdef SB_USE_CLASS_TELSIMPLEFTPSSERVER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSIMPLEFTPSSERVER */

#ifdef SB_USE_CLASS_TELSIMPLEFTPSSERVERSESSIONTHREAD
#  define SB_USE_CLASS_TTHREAD
#endif /* SB_USE_CLASS_TELSIMPLEFTPSSERVERSESSIONTHREAD */

#ifdef SB_USE_CLASS_TELFTPSSERVER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELFTPSSERVER */

#ifdef SB_USE_CLASS_TELFTPSUSER
#  define SB_USE_CLASS_TELCUSTOMUSER
#endif /* SB_USE_CLASS_TELFTPSUSER */

#ifdef SB_USE_CLASS_TELFTPSSERVERMESSAGETABLE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELFTPSSERVERMESSAGETABLE */

#ifdef SB_USE_CLASS_TELFTPSSERVERFILEINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELFTPSSERVERFILEINFO */

#ifdef SB_USE_CLASS_TELMULTIPARTSTREAMPART
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELMULTIPARTSTREAMPART */

#ifdef SB_USE_CLASS_TELFTPSTRANSFERCHUNK
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELFTPSTRANSFERCHUNK */

#ifdef SB_USE_CLASS_TELMULTIPARTSTREAMACCESS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELMULTIPARTSTREAMACCESS */

#ifdef SB_USE_CLASS_TELFTPSTRANSFERMANAGER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELFTPSTRANSFERMANAGER */

#ifdef SB_USE_CLASS_TELFTPPROXYSETTINGS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELFTPPROXYSETTINGS */

#ifdef SB_USE_CLASS_TELFTPFILEINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELFTPFILEINFO */

#ifdef SB_USE_CLASS_TELSIMPLEFTPSCLIENT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSIMPLEFTPSCLIENT */

#ifdef SB_USE_CLASS_TELAS2MESSAGE
#  define SB_USE_CLASS_TELASMESSAGE
#endif /* SB_USE_CLASS_TELAS2MESSAGE */

#ifdef SB_USE_CLASS_TELAS2RECEIPT
#  define SB_USE_CLASS_TELASRECEIPT
#endif /* SB_USE_CLASS_TELAS2RECEIPT */

#ifdef SB_USE_CLASS_TELASMESSAGECONTENTDIGESTS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELASMESSAGECONTENTDIGESTS */

#ifdef SB_USE_CLASS_TELASMESSAGEERRORLIST
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELASMESSAGEERRORLIST */

#ifdef SB_USE_CLASS_TELASMESSAGEERROR
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELASMESSAGEERROR */

#ifdef SB_USE_CLASS_TELAS2COMPRESSION
#  define SB_USE_CLASS_TELASSMIMECOMPRESSION
#endif /* SB_USE_CLASS_TELAS2COMPRESSION */

#ifdef SB_USE_CLASS_TELAS3COMPRESSION
#  define SB_USE_CLASS_TELASSMIMECOMPRESSION
#endif /* SB_USE_CLASS_TELAS3COMPRESSION */

#ifdef SB_USE_CLASS_TELAS2SIGNATURE
#  define SB_USE_CLASS_TELASSMIMESIGNATURE
#endif /* SB_USE_CLASS_TELAS2SIGNATURE */

#ifdef SB_USE_CLASS_TELASSMIMEMESSAGEVERIFIER
#  define SB_USE_CLASS_TELASMESSAGEVERIFIER
#endif /* SB_USE_CLASS_TELASSMIMEMESSAGEVERIFIER */

#ifdef SB_USE_CLASS_TELASSMIMEMESSAGESIGNER
#  define SB_USE_CLASS_TELASMESSAGESIGNER
#endif /* SB_USE_CLASS_TELASSMIMEMESSAGESIGNER */

#ifdef SB_USE_CLASS_TELAS3SIGNATURE
#  define SB_USE_CLASS_TELASSMIMESIGNATURE
#endif /* SB_USE_CLASS_TELAS3SIGNATURE */

#ifdef SB_USE_CLASS_TELASMESSAGEVERIFIER
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELASMESSAGEVERIFIER */

#ifdef SB_USE_CLASS_TELASMESSAGESIGNER
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELASMESSAGESIGNER */

#ifdef SB_USE_CLASS_TELAS2ENCRYPTION
#  define SB_USE_CLASS_TELASSMIMEENCRYPTION
#endif /* SB_USE_CLASS_TELAS2ENCRYPTION */

#ifdef SB_USE_CLASS_TELASSMIMEMESSAGEENCRYPTOR
#  define SB_USE_CLASS_TELASMESSAGEENCRYPTOR
#endif /* SB_USE_CLASS_TELASSMIMEMESSAGEENCRYPTOR */

#ifdef SB_USE_CLASS_TELASSMIMEMESSAGEDECRYPTOR
#  define SB_USE_CLASS_TELASMESSAGEDECRYPTOR
#endif /* SB_USE_CLASS_TELASSMIMEMESSAGEDECRYPTOR */

#ifdef SB_USE_CLASS_TELAS3ENCRYPTION
#  define SB_USE_CLASS_TELASSMIMEENCRYPTION
#endif /* SB_USE_CLASS_TELAS3ENCRYPTION */

#ifdef SB_USE_CLASS_TELASMESSAGEENCRYPTOR
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELASMESSAGEENCRYPTOR */

#ifdef SB_USE_CLASS_TELASMESSAGEDECRYPTOR
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELASMESSAGEDECRYPTOR */

#ifdef SB_USE_CLASS_TELAS2RECEIPTREQUEST
#  define SB_USE_CLASS_TELASRECEIPTREQUEST
#endif /* SB_USE_CLASS_TELAS2RECEIPTREQUEST */

#ifdef SB_USE_CLASS_TELAS3CLIENT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELAS3CLIENT */

#ifdef SB_USE_CLASS_TELAS3SOCKETOPTIONS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELAS3SOCKETOPTIONS */

#ifdef SB_USE_CLASS_TELAS3PROXYOPTIONS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELAS3PROXYOPTIONS */

#ifdef SB_USE_CLASS_TELAS3FTPOPTIONS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELAS3FTPOPTIONS */

#ifdef SB_USE_CLASS_TELAS3WEBTUNNELOPTIONS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELAS3WEBTUNNELOPTIONS */

#ifdef SB_USE_CLASS_TELAS3SSLOPTIONS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELAS3SSLOPTIONS */

#ifdef SB_USE_CLASS_TELAS3SOCKSOPTIONS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELAS3SOCKSOPTIONS */

#ifdef SB_USE_CLASS_TELAS3MESSAGE
#  define SB_USE_CLASS_TELASMESSAGE
#endif /* SB_USE_CLASS_TELAS3MESSAGE */

#ifdef SB_USE_CLASS_TELAS3RECEIPT
#  define SB_USE_CLASS_TELASRECEIPT
#endif /* SB_USE_CLASS_TELAS3RECEIPT */

#ifdef SB_USE_CLASS_TELASSMIMECOMPRESSION
#  define SB_USE_CLASS_TELASCOMPRESSION
#endif /* SB_USE_CLASS_TELASSMIMECOMPRESSION */

#ifdef SB_USE_CLASS_TELASSMIMESIGNATURE
#  define SB_USE_CLASS_TELASSIGNATURE
#endif /* SB_USE_CLASS_TELASSMIMESIGNATURE */

#ifdef SB_USE_CLASS_TELASSMIMEENCRYPTION
#  define SB_USE_CLASS_TELASENCRYPTION
#endif /* SB_USE_CLASS_TELASSMIMEENCRYPTION */

#ifdef SB_USE_CLASS_TELAS3RECEIPTREQUEST
#  define SB_USE_CLASS_TELASRECEIPTREQUEST
#endif /* SB_USE_CLASS_TELAS3RECEIPTREQUEST */

#ifdef SB_USE_CLASS_TELAS2CLIENT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELAS2CLIENT */

#ifdef SB_USE_CLASS_TELAS2WEBTUNNELOPTIONS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELAS2WEBTUNNELOPTIONS */

#ifdef SB_USE_CLASS_TELAS2SSLOPTIONS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELAS2SSLOPTIONS */

#ifdef SB_USE_CLASS_TELAS2SOCKSOPTIONS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELAS2SOCKSOPTIONS */

#ifdef SB_USE_CLASS_TELAS2SOCKETOPTIONS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELAS2SOCKETOPTIONS */

#ifdef SB_USE_CLASS_TELAS2PROXYOPTIONS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELAS2PROXYOPTIONS */

#ifdef SB_USE_CLASS_TELAS2HTTPOPTIONS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELAS2HTTPOPTIONS */

#ifdef SB_USE_CLASS_TELASMESSAGE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELASMESSAGE */

#ifdef SB_USE_CLASS_TELASRECEIPT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELASRECEIPT */

#ifdef SB_USE_CLASS_TELASCOMPRESSION
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELASCOMPRESSION */

#ifdef SB_USE_CLASS_TELASSIGNATURE
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELASSIGNATURE */

#ifdef SB_USE_CLASS_TELASENCRYPTION
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELASENCRYPTION */

#ifdef SB_USE_CLASS_TELASRECEIPTREQUEST
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELASRECEIPTREQUEST */

#ifdef SB_USE_CLASS_TELDCSTANDARDSERVER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDCSTANDARDSERVER */

#ifdef SB_USE_CLASS_TELDCGENERICSIGNOPERATIONHANDLER
#  define SB_USE_CLASS_TELDCSIGNOPERATIONHANDLER
#endif /* SB_USE_CLASS_TELDCGENERICSIGNOPERATIONHANDLER */

#ifdef SB_USE_CLASS_TELDCX509SIGNOPERATIONHANDLER
#  define SB_USE_CLASS_TELDCSIGNOPERATIONHANDLER
#endif /* SB_USE_CLASS_TELDCX509SIGNOPERATIONHANDLER */

#ifdef SB_USE_CLASS_TELDCSIGNOPERATIONHANDLER
#  define SB_USE_CLASS_TELDCOPERATIONHANDLER
#endif /* SB_USE_CLASS_TELDCSIGNOPERATIONHANDLER */

#ifdef SB_USE_CLASS_TELDCOPERATIONHANDLER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDCOPERATIONHANDLER */

#ifdef SB_USE_CLASS_TELDCXMLENCODING
#  define SB_USE_CLASS_TELDCENCODING
#endif /* SB_USE_CLASS_TELDCXMLENCODING */

#ifdef SB_USE_CLASS_TELWEBDAVOCTETCOLLATION
#  define SB_USE_CLASS_TELWEBDAVCOLLATION
#endif /* SB_USE_CLASS_TELWEBDAVOCTETCOLLATION */

#ifdef SB_USE_CLASS_TELWEBDAVASCIICOLLATION
#  define SB_USE_CLASS_TELWEBDAVCOLLATION
#endif /* SB_USE_CLASS_TELWEBDAVASCIICOLLATION */

#ifdef SB_USE_CLASS_TELWEBDAVUNICODECOLLATION
#  define SB_USE_CLASS_TELWEBDAVCOLLATION
#endif /* SB_USE_CLASS_TELWEBDAVUNICODECOLLATION */

#ifdef SB_USE_CLASS_TELWEBDAVCOLLATION
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVCOLLATION */

#ifdef SB_USE_CLASS_TELCALDAVOPTIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCALDAVOPTIONS */

#ifdef SB_USE_CLASS_TELCARDDAVOPTIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCARDDAVOPTIONS */

#ifdef SB_USE_CLASS_TELWEBDAVACLOPTIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVACLOPTIONS */

#ifdef SB_USE_CLASS_TELWEBDAVMEMORYLOCKLIST
#  define SB_USE_CLASS_TELWEBDAVCUSTOMLOCKLIST
#endif /* SB_USE_CLASS_TELWEBDAVMEMORYLOCKLIST */

#ifdef SB_USE_CLASS_TELWEBDAVFINDMEMORYLOCKHANDLE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVFINDMEMORYLOCKHANDLE */

#ifdef SB_USE_CLASS_TELWEBDAVCUSTOMLOCKLIST
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELWEBDAVCUSTOMLOCKLIST */

#ifdef SB_USE_CLASS_TELWEBDAVIFHEADER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVIFHEADER */

#ifdef SB_USE_CLASS_TELWEBDAVIFRESOURCE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVIFRESOURCE */

#ifdef SB_USE_CLASS_TELWEBDAVIFSTATE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVIFSTATE */

#ifdef SB_USE_CLASS_TELWEBDAVPROPERTY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVPROPERTY */

#ifdef SB_USE_CLASS_TELWEBDAVCALENDARREQUEST
#  define SB_USE_CLASS_TELWEBDAVEXTENDEDREQUEST
#endif /* SB_USE_CLASS_TELWEBDAVCALENDARREQUEST */

#ifdef SB_USE_CLASS_TELWEBDAVCOMP
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVCOMP */

#ifdef SB_USE_CLASS_TELWEBDAVLIMITFREEBUSYSET
#  define SB_USE_CLASS_TELWEBDAVTIMERANGEBASE
#endif /* SB_USE_CLASS_TELWEBDAVLIMITFREEBUSYSET */

#ifdef SB_USE_CLASS_TELWEBDAVEXPAND
#  define SB_USE_CLASS_TELWEBDAVTIMERANGEBASE
#endif /* SB_USE_CLASS_TELWEBDAVEXPAND */

#ifdef SB_USE_CLASS_TELWEBDAVLIMITRECURRENCESET
#  define SB_USE_CLASS_TELWEBDAVTIMERANGEBASE
#endif /* SB_USE_CLASS_TELWEBDAVLIMITRECURRENCESET */

#ifdef SB_USE_CLASS_TELWEBDAVADDRESSBOOKREQUEST
#  define SB_USE_CLASS_TELWEBDAVEXTENDEDREQUEST
#endif /* SB_USE_CLASS_TELWEBDAVADDRESSBOOKREQUEST */

#ifdef SB_USE_CLASS_TELWEBDAVEXTENDEDREQUEST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVEXTENDEDREQUEST */

#ifdef SB_USE_CLASS_TELCALDAVCOMPFILTER
#  define SB_USE_CLASS_TELWEBDAVFILTER
#endif /* SB_USE_CLASS_TELCALDAVCOMPFILTER */

#ifdef SB_USE_CLASS_TELCALDAVPROPFILTER
#  define SB_USE_CLASS_TELWEBDAVFILTER
#endif /* SB_USE_CLASS_TELCALDAVPROPFILTER */

#ifdef SB_USE_CLASS_TELWEBDAVTIMERANGE
#  define SB_USE_CLASS_TELWEBDAVTIMERANGEBASE
#endif /* SB_USE_CLASS_TELWEBDAVTIMERANGE */

#ifdef SB_USE_CLASS_TELWEBDAVTIMERANGEBASE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVTIMERANGEBASE */

#ifdef SB_USE_CLASS_TELCALDAVPARAMFILTER
#  define SB_USE_CLASS_TELWEBDAVFILTER
#endif /* SB_USE_CLASS_TELCALDAVPARAMFILTER */

#ifdef SB_USE_CLASS_TELCALDAVTEXTMATCHFILTER
#  define SB_USE_CLASS_TELWEBDAVTEXTMATCHFILTER
#endif /* SB_USE_CLASS_TELCALDAVTEXTMATCHFILTER */

#ifdef SB_USE_CLASS_TELWEBDAVPRINCIPALMEMORYBACKEND
#  define SB_USE_CLASS_TELWEBDAVPRINCIPALBACKEND
#endif /* SB_USE_CLASS_TELWEBDAVPRINCIPALMEMORYBACKEND */

#ifdef SB_USE_CLASS_TELWEBDAVPRINCIPALBACKEND
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVPRINCIPALBACKEND */

#ifdef SB_USE_CLASS_TELWEBDAVINMEMORYPRINCIPAL
#  define SB_USE_CLASS_SBWEBDAVSERVER_TELWEBDAVPRINCIPAL
#endif /* SB_USE_CLASS_TELWEBDAVINMEMORYPRINCIPAL */

#ifdef SB_USE_CLASS_SBWEBDAVSERVER_TELWEBDAVPRINCIPAL
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_SBWEBDAVSERVER_TELWEBDAVPRINCIPAL */

#ifdef SB_USE_CLASS_TELWEBDAVSERVER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELWEBDAVSERVER */

#ifdef SB_USE_CLASS_TELVCALENDAR
#  define SB_USE_CLASS_TELDIRINFO
#endif /* SB_USE_CLASS_TELVCALENDAR */

#ifdef SB_USE_CLASS_TELVCARD
#  define SB_USE_CLASS_TELDIRINFO
#endif /* SB_USE_CLASS_TELVCARD */

#ifdef SB_USE_CLASS_TELDIRINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDIRINFO */

#ifdef SB_USE_CLASS_TELDIRINFOPROPERTIESLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDIRINFOPROPERTIESLIST */

#ifdef SB_USE_CLASS_TELDIRINFOPROPERTY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDIRINFOPROPERTY */

#ifdef SB_USE_CLASS_TELDIRINFOATTRIBUTE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDIRINFOATTRIBUTE */

#ifdef SB_USE_CLASS_TELWEBDAVACLRESTRICTIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVACLRESTRICTIONS */

#ifdef SB_USE_CLASS_TELWEBDAVACL
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVACL */

#ifdef SB_USE_CLASS_TELWEBDAVACE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVACE */

#ifdef SB_USE_CLASS_TELCARDDAVPARAMFILTER
#  define SB_USE_CLASS_TELWEBDAVFILTER
#endif /* SB_USE_CLASS_TELCARDDAVPARAMFILTER */

#ifdef SB_USE_CLASS_TELCARDDAVFILTER
#  define SB_USE_CLASS_TELWEBDAVFILTER
#endif /* SB_USE_CLASS_TELCARDDAVFILTER */

#ifdef SB_USE_CLASS_TELCARDDAVPROPFILTER
#  define SB_USE_CLASS_TELWEBDAVFILTER
#endif /* SB_USE_CLASS_TELCARDDAVPROPFILTER */

#ifdef SB_USE_CLASS_TELCARDDAVTEXTMATCHFILTER
#  define SB_USE_CLASS_TELWEBDAVTEXTMATCHFILTER
#endif /* SB_USE_CLASS_TELCARDDAVTEXTMATCHFILTER */

#ifdef SB_USE_CLASS_TELWEBDAVTEXTMATCHFILTER
#  define SB_USE_CLASS_TELWEBDAVFILTER
#endif /* SB_USE_CLASS_TELWEBDAVTEXTMATCHFILTER */

#ifdef SB_USE_CLASS_TELWEBDAVFILTER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVFILTER */

#ifdef SB_USE_CLASS_TELWEBDAVLOCK
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVLOCK */

#ifdef SB_USE_CLASS_TELWEBDAVNAMESPACEPREFIXMAP
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVNAMESPACEPREFIXMAP */

#ifdef SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST */

#ifdef SB_USE_CLASS_TELWEBDAVPROPERTYINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVPROPERTYINFO */

#ifdef SB_USE_CLASS_TELCARDDAVREPORTCONTEXT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCARDDAVREPORTCONTEXT */

#ifdef SB_USE_CLASS_TELCARDDAVADDRESSBOOKINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCARDDAVADDRESSBOOKINFO */

#ifdef SB_USE_CLASS_TELCARDDAVSUPPORTEDADDRESSDATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCARDDAVSUPPORTEDADDRESSDATA */

#ifdef SB_USE_CLASS_TELWEBDAVPRINCIPALLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVPRINCIPALLIST */

#ifdef SB_USE_CLASS_SBWEBDAVCLIENT_TELWEBDAVPRINCIPAL
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_SBWEBDAVCLIENT_TELWEBDAVPRINCIPAL */

#ifdef SB_USE_CLASS_TELWEBDAVERRORLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVERRORLIST */

#ifdef SB_USE_CLASS_TELWEBDAVOBJECTLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVOBJECTLIST */

#ifdef SB_USE_CLASS_TELWEBDAVERRORRESPONSE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVERRORRESPONSE */

#ifdef SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELWEBDAVPRINCIPALSEARCHPROPERTYSETRESPONSE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVPRINCIPALSEARCHPROPERTYSETRESPONSE */

#ifdef SB_USE_CLASS_TELWEBDAVSUPPORTEDPRIVILEGESET
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVSUPPORTEDPRIVILEGESET */

#ifdef SB_USE_CLASS_TELWEBDAVSUPPORTEDPRIVILEGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVSUPPORTEDPRIVILEGE */

#ifdef SB_USE_CLASS_TELWEBDAVPRIVILEGESET
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVPRIVILEGESET */

#ifdef SB_USE_CLASS_TELWEBDAVERROR
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVERROR */

#ifdef SB_USE_CLASS_TELWEBDAVMULTISTATUSRESPONSE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVMULTISTATUSRESPONSE */

#ifdef SB_USE_CLASS_TELWEBDAVLOCKLIST
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELWEBDAVLOCKLIST */

#ifdef SB_USE_CLASS_TELWEBDAVCLIENT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELWEBDAVCLIENT */

#ifdef SB_USE_CLASS_TELCUSTOMSIMPLESSLCLIENT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCUSTOMSIMPLESSLCLIENT */

#ifdef SB_USE_CLASS_TELBOXCOMMENTS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXCOMMENTS */

#ifdef SB_USE_CLASS_TELBOXCOMMENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXCOMMENT */

#ifdef SB_USE_CLASS_TELBOXDATASTORAGEOBJECTPERMISSIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXDATASTORAGEOBJECTPERMISSIONS */

#ifdef SB_USE_CLASS_TELBOXCOLLABORATIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXCOLLABORATIONS */

#ifdef SB_USE_CLASS_TELBOXCOLLABORATION
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXCOLLABORATION */

#ifdef SB_USE_CLASS_TELBOXSHAREDLINKPERMISSIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXSHAREDLINKPERMISSIONS */

#ifdef SB_USE_CLASS_TELBOXSHAREDLINK
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXSHAREDLINK */

#ifdef SB_USE_CLASS_TELBOXGROUPS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXGROUPS */

#ifdef SB_USE_CLASS_TELBOXGROUP
#  define SB_USE_CLASS_TELBOXGROUPINFO
#endif /* SB_USE_CLASS_TELBOXGROUP */

#ifdef SB_USE_CLASS_TELBOXGROUPMEMBERS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXGROUPMEMBERS */

#ifdef SB_USE_CLASS_TELBOXGROUPMEMBER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXGROUPMEMBER */

#ifdef SB_USE_CLASS_TELBOXUSERS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXUSERS */

#ifdef SB_USE_CLASS_TELBOXUSER
#  define SB_USE_CLASS_TELBOXUSERINFO
#endif /* SB_USE_CLASS_TELBOXUSER */

#ifdef SB_USE_CLASS_TELBOXGROUPMEMBERSHIPS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXGROUPMEMBERSHIPS */

#ifdef SB_USE_CLASS_TELBOXGROUPMEMBERSHIP
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXGROUPMEMBERSHIP */

#ifdef SB_USE_CLASS_TELBOXUSEREMAILALIASES
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXUSEREMAILALIASES */

#ifdef SB_USE_CLASS_TELBOXUSEREMAILALIAS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXUSEREMAILALIAS */

#ifdef SB_USE_CLASS_TELBOXENTERPRISE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXENTERPRISE */

#ifdef SB_USE_CLASS_TELBOXUSERINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXUSERINFO */

#ifdef SB_USE_CLASS_TELBOXGROUPINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBOXGROUPINFO */

#ifdef SB_USE_CLASS_TELBOXFOLDER
#  define SB_USE_CLASS_TELBOXDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELBOXFOLDER */

#ifdef SB_USE_CLASS_TELBOXFILE
#  define SB_USE_CLASS_TELBOXDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELBOXFILE */

#ifdef SB_USE_CLASS_TELBOXDATASTORAGEOBJECT
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELBOXDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELBOXDATASTORAGE
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGE
#endif /* SB_USE_CLASS_TELBOXDATASTORAGE */

#ifdef SB_USE_CLASS_TELPROTECTEDOBJECTDOWNLOADSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELPROTECTEDOBJECTDOWNLOADSTREAM */

#ifdef SB_USE_CLASS_TELPROTECTEDOBJECTREADER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPROTECTEDOBJECTREADER */

#ifdef SB_USE_CLASS_TELPROTECTEDOBJECTUPLOADSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELPROTECTEDOBJECTUPLOADSTREAM */

#ifdef SB_USE_CLASS_TELMETADATACACHE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELMETADATACACHE */

#ifdef SB_USE_CLASS_TELPROXYSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELPROXYSTREAM */

#ifdef SB_USE_CLASS_TELZLIBDATASTORAGEENCODINGHANDLER
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGEENCODINGHANDLER
#endif /* SB_USE_CLASS_TELZLIBDATASTORAGEENCODINGHANDLER */

#ifdef SB_USE_CLASS_TELDROPBOXACCOUNTINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDROPBOXACCOUNTINFO */

#ifdef SB_USE_CLASS_TELDROPBOXDATASTORAGEOBJECT
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELDROPBOXDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELDROPBOXDATASTORAGE
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGE
#endif /* SB_USE_CLASS_TELDROPBOXDATASTORAGE */

#ifdef SB_USE_CLASS_TELONEDRIVEUSERINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELONEDRIVEUSERINFO */

#ifdef SB_USE_CLASS_TELONEDRIVEALBUM
#  define SB_USE_CLASS_TELONEDRIVEFOLDER
#endif /* SB_USE_CLASS_TELONEDRIVEALBUM */

#ifdef SB_USE_CLASS_TELONEDRIVEVIDEO
#  define SB_USE_CLASS_TELONEDRIVETAGGEDOBJECT
#endif /* SB_USE_CLASS_TELONEDRIVEVIDEO */

#ifdef SB_USE_CLASS_TELONEDRIVEPHOTOIMAGES
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELONEDRIVEPHOTOIMAGES */

#ifdef SB_USE_CLASS_TELONEDRIVEPHOTOIMAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELONEDRIVEPHOTOIMAGE */

#ifdef SB_USE_CLASS_TELONEDRIVEPHOTO
#  define SB_USE_CLASS_TELONEDRIVETAGGEDOBJECT
#endif /* SB_USE_CLASS_TELONEDRIVEPHOTO */

#ifdef SB_USE_CLASS_TELONEDRIVEAUDIO
#  define SB_USE_CLASS_TELONEDRIVEFILE
#endif /* SB_USE_CLASS_TELONEDRIVEAUDIO */

#ifdef SB_USE_CLASS_TELONEDRIVENOTEBOOK
#  define SB_USE_CLASS_TELONEDRIVEFILE
#endif /* SB_USE_CLASS_TELONEDRIVENOTEBOOK */

#ifdef SB_USE_CLASS_TELONEDRIVETAG
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELONEDRIVETAG */

#ifdef SB_USE_CLASS_TELONEDRIVETAGGEDOBJECT
#  define SB_USE_CLASS_TELONEDRIVEFILE
#endif /* SB_USE_CLASS_TELONEDRIVETAGGEDOBJECT */

#ifdef SB_USE_CLASS_TELONEDRIVECOMMENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELONEDRIVECOMMENT */

#ifdef SB_USE_CLASS_TELONEDRIVEFRIEND
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELONEDRIVEFRIEND */

#ifdef SB_USE_CLASS_TELONEDRIVEFILE
#  define SB_USE_CLASS_TELONEDRIVEDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELONEDRIVEFILE */

#ifdef SB_USE_CLASS_TELONEDRIVETAGS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELONEDRIVETAGS */

#ifdef SB_USE_CLASS_TELONEDRIVECOMMENTS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELONEDRIVECOMMENTS */

#ifdef SB_USE_CLASS_TELONEDRIVEFOLDER
#  define SB_USE_CLASS_TELONEDRIVEDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELONEDRIVEFOLDER */

#ifdef SB_USE_CLASS_TELONEDRIVEDATASTORAGEOBJECT
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELONEDRIVEDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELONEDRIVEDATASTORAGE
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGE
#endif /* SB_USE_CLASS_TELONEDRIVEDATASTORAGE */

#ifdef SB_USE_CLASS_TELGOOGLEDOCUMENT
#  define SB_USE_CLASS_TELGOOGLEDRIVECUSTOMFILE
#endif /* SB_USE_CLASS_TELGOOGLEDOCUMENT */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVEFILE
#  define SB_USE_CLASS_TELGOOGLEDRIVECUSTOMFILE
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEFILE */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVECUSTOMFILE
#  define SB_USE_CLASS_TELGOOGLEDRIVEDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDRIVECUSTOMFILE */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVEPERMISSIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEPERMISSIONS */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVEPERMISSION
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEPERMISSION */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVEPROPERTY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEPROPERTY */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVEREPLY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEREPLY */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVECOMMENTS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDRIVECOMMENTS */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVEACCOUNTINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEACCOUNTINFO */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVEUSER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEUSER */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVEREPLIES
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEREPLIES */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVECOMMENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDRIVECOMMENT */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVEPROPERTIES
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEPROPERTIES */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVEFOLDER
#  define SB_USE_CLASS_TELGOOGLEDRIVEDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEFOLDER */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVEDATASTORAGEOBJECT
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVEDATASTORAGE
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGE
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEDATASTORAGE */

#ifdef SB_USE_CLASS_TELGOOGLEPREFIXEDMETADATAPROCESSINGSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELGOOGLEPREFIXEDMETADATAPROCESSINGSTREAM */

#ifdef SB_USE_CLASS_TELGOOGLEBASE64DECODINGSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELGOOGLEBASE64DECODINGSTREAM */

#ifdef SB_USE_CLASS_TELGOOGLEBASE64ENCODINGSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELGOOGLEBASE64ENCODINGSTREAM */

#ifdef SB_USE_CLASS_TELGOOGLEPREFIXEDPOSTFIXEDUPLOADSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELGOOGLEPREFIXEDPOSTFIXEDUPLOADSTREAM */

#ifdef SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECT
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECTLINKS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECTLINKS */

#ifdef SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECTCATEGORIES
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECTCATEGORIES */

#ifdef SB_USE_CLASS_TELGOOGLEDATASTORAGE
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGE
#endif /* SB_USE_CLASS_TELGOOGLEDATASTORAGE */

#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINERLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINERLIST */

#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER */

#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELWINAZUREACCESSPOLICY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWINAZUREACCESSPOLICY */

#ifdef SB_USE_CLASS_TELWINAZURESINGLEACCESSPOLICY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWINAZURESINGLEACCESSPOLICY */

#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGELISTSTATE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGELISTSTATE */

#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGE
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGE
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGE */

#ifdef SB_USE_CLASS_TELAUTHENTICATEDDATAREADSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELAUTHENTICATEDDATAREADSTREAM */

#ifdef SB_USE_CLASS_TELAUTHENTICATEDDATAWRITESTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELAUTHENTICATEDDATAWRITESTREAM */

#ifdef SB_USE_CLASS_TELCHUNKEDDECRYPTINGSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELCHUNKEDDECRYPTINGSTREAM */

#ifdef SB_USE_CLASS_TELCHUNKEDENCRYPTINGSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELCHUNKEDENCRYPTINGSTREAM */

#ifdef SB_USE_CLASS_TELFILEDATASTORAGE
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGE
#endif /* SB_USE_CLASS_TELFILEDATASTORAGE */

#ifdef SB_USE_CLASS_TELFILEDATASTORAGEOBJECT
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELFILEDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKETLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKETLIST */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKET
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKET */

#ifdef SB_USE_CLASS_TELAWSS3ACCESSCONTROLPOLICY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELAWSS3ACCESSCONTROLPOLICY */

#ifdef SB_USE_CLASS_TELAWSS3ACCESSCONTROLGRANT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELAWSS3ACCESSCONTROLGRANT */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGELISTSTATE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGELISTSTATE */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGE
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGE
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGE */

#ifdef SB_USE_CLASS_TELDATASTORAGEENCODINGHANDLERSFACTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDATASTORAGEENCODINGHANDLERSFACTORY */

#ifdef SB_USE_CLASS_TELDATASTORAGESECURITYHANDLERSFACTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDATASTORAGESECURITYHANDLERSFACTORY */

#ifdef SB_USE_CLASS_TELDEFAULTDATASTORAGESECURITYHANDLER
#  define SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#endif /* SB_USE_CLASS_TELDEFAULTDATASTORAGESECURITYHANDLER */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGE */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELDATASTORAGEOBJECTLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDATASTORAGEOBJECTLIST */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */

#ifdef SB_USE_CLASS_TELDSKEYPROTECTIONHANDLERSFACTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDSKEYPROTECTIONHANDLERSFACTORY */

#ifdef SB_USE_CLASS_TELDSPLAINKEYPROTECTIONHANDLER
#  define SB_USE_CLASS_TELDSCUSTOMKEYPROTECTIONHANDLER
#endif /* SB_USE_CLASS_TELDSPLAINKEYPROTECTIONHANDLER */

#ifdef SB_USE_CLASS_TELDSENCRYPTEDDATAKEYPROTECTIONHANDLER
#  define SB_USE_CLASS_TELDSCUSTOMKEYPROTECTIONHANDLER
#endif /* SB_USE_CLASS_TELDSENCRYPTEDDATAKEYPROTECTIONHANDLER */

#ifdef SB_USE_CLASS_TELDSENVELOPEDDATAKEYPROTECTIONHANDLER
#  define SB_USE_CLASS_TELDSCUSTOMKEYPROTECTIONHANDLER
#endif /* SB_USE_CLASS_TELDSENVELOPEDDATAKEYPROTECTIONHANDLER */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGEENCODINGHANDLER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGEENCODINGHANDLER */

#ifdef SB_USE_CLASS_TELDSCUSTOMKEYPROTECTIONHANDLER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDSCUSTOMKEYPROTECTIONHANDLER */

#ifdef SB_USE_CLASS_TELCUSTOMUSER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMUSER */

#ifdef SB_USE_CLASS_TELUSERS
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELUSERS */

#ifdef SB_USE_CLASS_TELDICTIONARY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDICTIONARY */

#ifdef SB_USE_CLASS_TELDICTIONARYENTRY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDICTIONARYENTRY */

#ifdef SB_USE_CLASS_TELBCRYPT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBCRYPT */

#ifdef SB_USE_CLASS_TELJSONVALUE
#  define SB_USE_CLASS_TELJSONENTITY
#endif /* SB_USE_CLASS_TELJSONVALUE */

#ifdef SB_USE_CLASS_TELJSONOBJECT
#  define SB_USE_CLASS_TELJSONENTITY
#endif /* SB_USE_CLASS_TELJSONOBJECT */

#ifdef SB_USE_CLASS_TELJSONARRAY
#  define SB_USE_CLASS_TELJSONENTITY
#endif /* SB_USE_CLASS_TELJSONARRAY */

#ifdef SB_USE_CLASS_TELJSONENTITY
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELJSONENTITY */

#ifdef SB_USE_CLASS_TELBUILTINIDEASYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINIDEASYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINEXTENDEDSYMMETRICCRYPTOFACTORY
#  define SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTOFACTORY
#endif /* SB_USE_CLASS_TELBUILTINEXTENDEDSYMMETRICCRYPTOFACTORY */

#ifdef SB_USE_CLASS_TELBUILTINEXTENDEDCRYPTOPROVIDER
#  define SB_USE_CLASS_TELBUILTINCRYPTOPROVIDER
#endif /* SB_USE_CLASS_TELBUILTINEXTENDEDCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELUNICODECONVERTER
#  define SB_USE_CLASS_TELSTRINGCONVERTER
#endif /* SB_USE_CLASS_TELUNICODECONVERTER */

#ifdef SB_USE_CLASS_TPLISO_8859_1
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLISO_8859_1 */

#ifdef SB_USE_CLASS_TPLARMSCII_8
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLARMSCII_8 */

#ifdef SB_USE_CLASS_TPLSHIFTJISCODE
#  define SB_USE_CLASS_TPLCONVERTINGCHARSET
#endif /* SB_USE_CLASS_TPLSHIFTJISCODE */

#ifdef SB_USE_CLASS_TPLEUC_JP
#  define SB_USE_CLASS_TPLCUSTOMEUCCHARSET
#endif /* SB_USE_CLASS_TPLEUC_JP */

#ifdef SB_USE_CLASS_TPLATARIST
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLATARIST */

#ifdef SB_USE_CLASS_TPLCP1006
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP1006 */

#ifdef SB_USE_CLASS_TPLWIDESTRINGSTREAMPOOL
#  define SB_USE_CLASS_TPLCUSTOMSTRINGSTREAMPOOL
#endif /* SB_USE_CLASS_TPLWIDESTRINGSTREAMPOOL */

#ifdef SB_USE_CLASS_TPLANSISTRINGSTREAMPOOL
#  define SB_USE_CLASS_TPLCUSTOMSTRINGSTREAMPOOL
#endif /* SB_USE_CLASS_TPLANSISTRINGSTREAMPOOL */

#ifdef SB_USE_CLASS_TPLCUSTOMSTRINGSTREAMPOOL
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TPLCUSTOMSTRINGSTREAMPOOL */

#ifdef SB_USE_CLASS_TPLBYTEARRAYSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TPLBYTEARRAYSTREAM */

#ifdef SB_USE_CLASS_TPLWIDESTRINGSTREAM
#  define SB_USE_CLASS_TPLCUSTOMSTRINGSTREAM
#endif /* SB_USE_CLASS_TPLWIDESTRINGSTREAM */

#ifdef SB_USE_CLASS_TPLANSISTRINGSTREAM
#  define SB_USE_CLASS_TPLCUSTOMSTRINGSTREAM
#endif /* SB_USE_CLASS_TPLANSISTRINGSTREAM */

#ifdef SB_USE_CLASS_TPLCUSTOMSTRINGSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TPLCUSTOMSTRINGSTREAM */

#ifdef SB_USE_CLASS_TPLCONVBUFFER
#  define SB_USE_CLASS_TINTERFACEDOBJECT
#endif /* SB_USE_CLASS_TPLCONVBUFFER */

#ifdef SB_USE_CLASS_TPLUTF7_IMAP
#  define SB_USE_CLASS_TPLCUSTOMUTF7
#endif /* SB_USE_CLASS_TPLUTF7_IMAP */

#ifdef SB_USE_CLASS_TPLUTF7
#  define SB_USE_CLASS_TPLCUSTOMUTF7
#endif /* SB_USE_CLASS_TPLUTF7 */

#ifdef SB_USE_CLASS_TPLCUSTOMUTF7
#  define SB_USE_CLASS_TPLCHARSET
#endif /* SB_USE_CLASS_TPLCUSTOMUTF7 */

#ifdef SB_USE_CLASS_TPLUTF8
#  define SB_USE_CLASS_TPLCHARSET
#endif /* SB_USE_CLASS_TPLUTF8 */

#ifdef SB_USE_CLASS_TPLUTF16BE
#  define SB_USE_CLASS_TPLUTF16
#endif /* SB_USE_CLASS_TPLUTF16BE */

#ifdef SB_USE_CLASS_TPLUTF16
#  define SB_USE_CLASS_TPLCUSTOMUTF
#endif /* SB_USE_CLASS_TPLUTF16 */

#ifdef SB_USE_CLASS_TPLUTF32BE
#  define SB_USE_CLASS_TPLUTF32
#endif /* SB_USE_CLASS_TPLUTF32BE */

#ifdef SB_USE_CLASS_TPLUTF32
#  define SB_USE_CLASS_TPLCUSTOMUTF
#endif /* SB_USE_CLASS_TPLUTF32 */

#ifdef SB_USE_CLASS_TPLCUSTOMUTF
#  define SB_USE_CLASS_TPLCHARSET
#endif /* SB_USE_CLASS_TPLCUSTOMUTF */

#ifdef SB_USE_CLASS_TPLCONVERTER
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TPLCONVERTER */

#ifdef SB_USE_CLASS_TPLISO_2022_KR
#  define SB_USE_CLASS_TPLCUSTOMISO_2022CHARSET
#endif /* SB_USE_CLASS_TPLISO_2022_KR */

#ifdef SB_USE_CLASS_TPLEUC_KR
#  define SB_USE_CLASS_TPLCUSTOMEUCCHARSET
#endif /* SB_USE_CLASS_TPLEUC_KR */

#ifdef SB_USE_CLASS_TPLJOHAB
#  define SB_USE_CLASS_TPLMIXEDCHARSET
#endif /* SB_USE_CLASS_TPLJOHAB */

#ifdef SB_USE_CLASS_TPLJOHABNONHANGUL
#  define SB_USE_CLASS_TPLCONVERTINGCHARSET
#endif /* SB_USE_CLASS_TPLJOHABNONHANGUL */

#ifdef SB_USE_CLASS_TPLJOHABHANGUL
#  define SB_USE_CLASS_TPLCHARSET
#endif /* SB_USE_CLASS_TPLJOHABHANGUL */

#ifdef SB_USE_CLASS_TPLCP949
#  define SB_USE_CLASS_TPLMIXEDCHARSET
#endif /* SB_USE_CLASS_TPLCP949 */

#ifdef SB_USE_CLASS_TPLEUC_TW
#  define SB_USE_CLASS_TPLCUSTOMEUCCHARSET
#endif /* SB_USE_CLASS_TPLEUC_TW */

#ifdef SB_USE_CLASS_TPLCNS_11643
#  define SB_USE_CLASS_TPLMIXEDCHARSET
#endif /* SB_USE_CLASS_TPLCNS_11643 */

#ifdef SB_USE_CLASS_TPLCP950
#  define SB_USE_CLASS_TPLMIXEDCHARSET
#endif /* SB_USE_CLASS_TPLCP950 */

#ifdef SB_USE_CLASS_TPLBIGFIVEHKSCS
#  define SB_USE_CLASS_TPLMIXEDCHARSET
#endif /* SB_USE_CLASS_TPLBIGFIVEHKSCS */

#ifdef SB_USE_CLASS_TPLISO_2022_CN_EXT
#  define SB_USE_CLASS_TPLCUSTOMISO_2022CHARSET
#endif /* SB_USE_CLASS_TPLISO_2022_CN_EXT */

#ifdef SB_USE_CLASS_TPLISO_2022_CN
#  define SB_USE_CLASS_TPLCUSTOMISO_2022CHARSET
#endif /* SB_USE_CLASS_TPLISO_2022_CN */

#ifdef SB_USE_CLASS_TPLGB_18030
#  define SB_USE_CLASS_TPLMIXEDCHARSET
#endif /* SB_USE_CLASS_TPLGB_18030 */

#ifdef SB_USE_CLASS_TPLGB_18030CODE
#  define SB_USE_CLASS_TPLCHARSET
#endif /* SB_USE_CLASS_TPLGB_18030CODE */

#ifdef SB_USE_CLASS_TPLHZ_GB_2312
#  define SB_USE_CLASS_TPLMIXEDCHARSET
#endif /* SB_USE_CLASS_TPLHZ_GB_2312 */

#ifdef SB_USE_CLASS_TPLGBK
#  define SB_USE_CLASS_TPLMIXEDCHARSET
#endif /* SB_USE_CLASS_TPLGBK */

#ifdef SB_USE_CLASS_TPLISO_2022_JP_2
#  define SB_USE_CLASS_TPLCUSTOMISO_2022CHARSET
#endif /* SB_USE_CLASS_TPLISO_2022_JP_2 */

#ifdef SB_USE_CLASS_TPLISO_2022_JP_1
#  define SB_USE_CLASS_TPLCUSTOMISO_2022CHARSET
#endif /* SB_USE_CLASS_TPLISO_2022_JP_1 */

#ifdef SB_USE_CLASS_TPLISO_2022_JP
#  define SB_USE_CLASS_TPLCUSTOMISO_2022CHARSET
#endif /* SB_USE_CLASS_TPLISO_2022_JP */

#ifdef SB_USE_CLASS_TPLCUSTOMEUCCHARSET
#  define SB_USE_CLASS_TPLMIXEDCHARSET
#endif /* SB_USE_CLASS_TPLCUSTOMEUCCHARSET */

#ifdef SB_USE_CLASS_TPLSHIFTJIS
#  define SB_USE_CLASS_TPLMIXEDCHARSET
#endif /* SB_USE_CLASS_TPLSHIFTJIS */

#ifdef SB_USE_CLASS_TPLCONVERTINGCHARSET
#  define SB_USE_CLASS_TPLCHARSET
#endif /* SB_USE_CLASS_TPLCONVERTINGCHARSET */

#ifdef SB_USE_CLASS_TPLCUSTOMISO_2022CHARSET
#  define SB_USE_CLASS_TPLMIXEDCHARSET
#endif /* SB_USE_CLASS_TPLCUSTOMISO_2022CHARSET */

#ifdef SB_USE_CLASS_TPLMIXEDCHARSET
#  define SB_USE_CLASS_TPLCHARSET
#endif /* SB_USE_CLASS_TPLMIXEDCHARSET */

#ifdef SB_USE_CLASS_TPLVISCII
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLVISCII */

#ifdef SB_USE_CLASS_TPLUHC
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLUHC */

#ifdef SB_USE_CLASS_TPLSHIFTJISDATA
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLSHIFTJISDATA */

#ifdef SB_USE_CLASS_TPLNEXTSTEP
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLNEXTSTEP */

#ifdef SB_USE_CLASS_TPLMACTURKISH
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLMACTURKISH */

#ifdef SB_USE_CLASS_TPLMACTHAI
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLMACTHAI */

#ifdef SB_USE_CLASS_TPLMACROMANIAN
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLMACROMANIAN */

#ifdef SB_USE_CLASS_TPLMACROMAN
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLMACROMAN */

#ifdef SB_USE_CLASS_TPLMACICELANDIC
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLMACICELANDIC */

#ifdef SB_USE_CLASS_TPLMACHEBREW
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLMACHEBREW */

#ifdef SB_USE_CLASS_TPLMACGREEK
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLMACGREEK */

#ifdef SB_USE_CLASS_TPLMACGAELIC
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLMACGAELIC */

#ifdef SB_USE_CLASS_TPLMACCYRILLIC
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLMACCYRILLIC */

#ifdef SB_USE_CLASS_TPLMACCROATIAN
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLMACCROATIAN */

#ifdef SB_USE_CLASS_TPLMACCENTRALEUROPEAN
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLMACCENTRALEUROPEAN */

#ifdef SB_USE_CLASS_TPLMACCELTIC
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLMACCELTIC */

#ifdef SB_USE_CLASS_TPLKS_X_1001
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLKS_X_1001 */

#ifdef SB_USE_CLASS_TPLKOI8U
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLKOI8U */

#ifdef SB_USE_CLASS_TPLKOI8T
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLKOI8T */

#ifdef SB_USE_CLASS_TPLKOI8RU
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLKOI8RU */

#ifdef SB_USE_CLASS_TPLKOI8R
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLKOI8R */

#ifdef SB_USE_CLASS_TPLJIS_0212
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLJIS_0212 */

#ifdef SB_USE_CLASS_TPLJIS_0208
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLJIS_0208 */

#ifdef SB_USE_CLASS_TPLJIS_0201
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLJIS_0201 */

#ifdef SB_USE_CLASS_TPLISO_IR_165DATA
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLISO_IR_165DATA */

#ifdef SB_USE_CLASS_TPLISO_8859_9
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLISO_8859_9 */

#ifdef SB_USE_CLASS_TPLISO_8859_8I
#  define SB_USE_CLASS_TPLISO_8859_8
#endif /* SB_USE_CLASS_TPLISO_8859_8I */

#ifdef SB_USE_CLASS_TPLISO_8859_8
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLISO_8859_8 */

#ifdef SB_USE_CLASS_TPLISO_8859_7
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLISO_8859_7 */

#ifdef SB_USE_CLASS_TPLISO_8859_6
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLISO_8859_6 */

#ifdef SB_USE_CLASS_TPLISO_8859_5
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLISO_8859_5 */

#ifdef SB_USE_CLASS_TPLISO_8859_4
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLISO_8859_4 */

#ifdef SB_USE_CLASS_TPLISO_8859_3
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLISO_8859_3 */

#ifdef SB_USE_CLASS_TPLISO_8859_2
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLISO_8859_2 */

#ifdef SB_USE_CLASS_TPLISO_8859_16
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLISO_8859_16 */

#ifdef SB_USE_CLASS_TPLISO_8859_15
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLISO_8859_15 */

#ifdef SB_USE_CLASS_TPLISO_8859_14
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLISO_8859_14 */

#ifdef SB_USE_CLASS_TPLISO_8859_13
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLISO_8859_13 */

#ifdef SB_USE_CLASS_TPLISO_8859_11
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLISO_8859_11 */

#ifdef SB_USE_CLASS_TPLISO_8859_10
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLISO_8859_10 */

#ifdef SB_USE_CLASS_TPLHPROMAN8
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLHPROMAN8 */

#ifdef SB_USE_CLASS_TPLHKSCSDATA
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLHKSCSDATA */

#ifdef SB_USE_CLASS_TPLGEOSTD8
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLGEOSTD8 */

#ifdef SB_USE_CLASS_TPLGEORGIANPS
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLGEORGIANPS */

#ifdef SB_USE_CLASS_TPLGEORGIANACADEMY
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLGEORGIANACADEMY */

#ifdef SB_USE_CLASS_TPLGBKDATA
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLGBKDATA */

#ifdef SB_USE_CLASS_TPLGB_2312
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLGB_2312 */

#ifdef SB_USE_CLASS_TPLGB_18030DATA
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLGB_18030DATA */

#ifdef SB_USE_CLASS_TPLCP950DATA
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLCP950DATA */

#ifdef SB_USE_CLASS_TPLCP875
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLCP875 */

#ifdef SB_USE_CLASS_TPLCP874
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP874 */

#ifdef SB_USE_CLASS_TPLCP869
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP869 */

#ifdef SB_USE_CLASS_TPLCP866
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP866 */

#ifdef SB_USE_CLASS_TPLCP865
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP865 */

#ifdef SB_USE_CLASS_TPLCP864
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP864 */

#ifdef SB_USE_CLASS_TPLCP863
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP863 */

#ifdef SB_USE_CLASS_TPLCP862
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP862 */

#ifdef SB_USE_CLASS_TPLCP861
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP861 */

#ifdef SB_USE_CLASS_TPLCP860
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP860 */

#ifdef SB_USE_CLASS_TPLCP857
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP857 */

#ifdef SB_USE_CLASS_TPLCP856
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP856 */

#ifdef SB_USE_CLASS_TPLCP855
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP855 */

#ifdef SB_USE_CLASS_TPLCP853
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP853 */

#ifdef SB_USE_CLASS_TPLCP852
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP852 */

#ifdef SB_USE_CLASS_TPLCP850
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP850 */

#ifdef SB_USE_CLASS_TPLCP775
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP775 */

#ifdef SB_USE_CLASS_TPLCP737
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP737 */

#ifdef SB_USE_CLASS_TPLCP500
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLCP500 */

#ifdef SB_USE_CLASS_TPLCP437
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP437 */

#ifdef SB_USE_CLASS_TPLCP424
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLCP424 */

#ifdef SB_USE_CLASS_TPLCP037
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLCP037 */

#ifdef SB_USE_CLASS_TPLCP1258
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP1258 */

#ifdef SB_USE_CLASS_TPLCP1257
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP1257 */

#ifdef SB_USE_CLASS_TPLCP1256
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP1256 */

#ifdef SB_USE_CLASS_TPLCP1255
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP1255 */

#ifdef SB_USE_CLASS_TPLCP1254
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP1254 */

#ifdef SB_USE_CLASS_TPLCP1253
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP1253 */

#ifdef SB_USE_CLASS_TPLCP1252
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP1252 */

#ifdef SB_USE_CLASS_TPLCP1251
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP1251 */

#ifdef SB_USE_CLASS_TPLCP1250
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP1250 */

#ifdef SB_USE_CLASS_TPLCP1133
#  define SB_USE_CLASS_TPLASCII
#endif /* SB_USE_CLASS_TPLCP1133 */

#ifdef SB_USE_CLASS_TPLCP1131
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLCP1131 */

#ifdef SB_USE_CLASS_TPLASCII
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLASCII */

#ifdef SB_USE_CLASS_TPLCNS_11643_F
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLCNS_11643_F */

#ifdef SB_USE_CLASS_TPLCNS_11643_7
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLCNS_11643_7 */

#ifdef SB_USE_CLASS_TPLCNS_11643_6
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLCNS_11643_6 */

#ifdef SB_USE_CLASS_TPLCNS_11643_5
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLCNS_11643_5 */

#ifdef SB_USE_CLASS_TPLCNS_11643_4
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLCNS_11643_4 */

#ifdef SB_USE_CLASS_TPLCNS_11643_3
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLCNS_11643_3 */

#ifdef SB_USE_CLASS_TPLCNS_11643_2
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLCNS_11643_2 */

#ifdef SB_USE_CLASS_TPLCNS_11643_1
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLCNS_11643_1 */

#ifdef SB_USE_CLASS_TPLBIGFIVE
#  define SB_USE_CLASS_TPLTABLECHARSET
#endif /* SB_USE_CLASS_TPLBIGFIVE */

#ifdef SB_USE_CLASS_TPLTABLECHARSET
#  define SB_USE_CLASS_TPLCHARSET
#endif /* SB_USE_CLASS_TPLTABLECHARSET */

#ifdef SB_USE_CLASS_TPLCHARSET
#  define SB_USE_CLASS_TINTERFACEDOBJECT
#endif /* SB_USE_CLASS_TPLCHARSET */

#ifdef SB_USE_CLASS_TELDCNODE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDCNODE */

#ifdef SB_USE_CLASS_TELDCENCODING
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDCENCODING */

#ifdef SB_USE_CLASS_TELDCDEFAULTREQUESTFACTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDCDEFAULTREQUESTFACTORY */

#ifdef SB_USE_CLASS_TELDCPKCS7SIGNPARAMETERS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDCPKCS7SIGNPARAMETERS */

#ifdef SB_USE_CLASS_TELDCASYNCSTATECOLLECTION
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDCASYNCSTATECOLLECTION */

#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */

#ifdef SB_USE_CLASS_TELDCMESSAGEFACTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDCMESSAGEFACTORY */

#ifdef SB_USE_CLASS_TELDCBATCHMESSAGE
#  define SB_USE_CLASS_TELDCBASEMESSAGE
#endif /* SB_USE_CLASS_TELDCBATCHMESSAGE */

#ifdef SB_USE_CLASS_TELDCOPERATIONRESPONSEMESSAGE
#  define SB_USE_CLASS_TELDCBASEMESSAGE
#endif /* SB_USE_CLASS_TELDCOPERATIONRESPONSEMESSAGE */

#ifdef SB_USE_CLASS_TELDCOPERATIONREQUESTMESSAGE
#  define SB_USE_CLASS_TELDCBASEMESSAGE
#endif /* SB_USE_CLASS_TELDCOPERATIONREQUESTMESSAGE */

#ifdef SB_USE_CLASS_TELDCERRORMESSAGE
#  define SB_USE_CLASS_TELDCBASEMESSAGE
#endif /* SB_USE_CLASS_TELDCERRORMESSAGE */

#ifdef SB_USE_CLASS_TELDCUNSUPPORTEDMESSAGE
#  define SB_USE_CLASS_TELDCBASEMESSAGE
#endif /* SB_USE_CLASS_TELDCUNSUPPORTEDMESSAGE */

#ifdef SB_USE_CLASS_TELDCBASEMESSAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDCBASEMESSAGE */

#ifdef SB_USE_CLASS_TELZLIBDECOMPRESSINGSTREAM
#  define SB_USE_CLASS_TELCUSTOMDECOMPRESSINGSTREAM
#endif /* SB_USE_CLASS_TELZLIBDECOMPRESSINGSTREAM */

#ifdef SB_USE_CLASS_TELZLIBCOMPRESSINGSTREAM
#  define SB_USE_CLASS_TELCUSTOMCOMPRESSINGSTREAM
#endif /* SB_USE_CLASS_TELZLIBCOMPRESSINGSTREAM */

#ifdef SB_USE_CLASS_TELCUSTOMDECOMPRESSINGSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELCUSTOMDECOMPRESSINGSTREAM */

#ifdef SB_USE_CLASS_TELCUSTOMCOMPRESSINGSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELCUSTOMCOMPRESSINGSTREAM */

#ifdef SB_USE_CLASS_TELSASLXOAUTH2CLIENT
#  define SB_USE_CLASS_TELSASLCLIENT
#endif /* SB_USE_CLASS_TELSASLXOAUTH2CLIENT */

#ifndef SB_WINCE_OR_NOT_WINDOWS
#ifdef SB_USE_CLASS_TELSASLNTLMCLIENT
#  define SB_USE_CLASS_TELSASLCLIENT
#endif /* SB_USE_CLASS_TELSASLNTLMCLIENT */
#endif

#ifdef SB_USE_CLASS_TELSASLDIGESTMD5CLIENT
#  define SB_USE_CLASS_TELSASLCLIENT
#endif /* SB_USE_CLASS_TELSASLDIGESTMD5CLIENT */

#ifdef SB_USE_CLASS_TELSASLEXTERNALCLIENT
#  define SB_USE_CLASS_TELSASLCLIENT
#endif /* SB_USE_CLASS_TELSASLEXTERNALCLIENT */

#ifdef SB_USE_CLASS_TELSASLANONYMOUSCLIENT
#  define SB_USE_CLASS_TELSASLCLIENT
#endif /* SB_USE_CLASS_TELSASLANONYMOUSCLIENT */

#ifdef SB_USE_CLASS_TELSASLCRAMMD5CLIENT
#  define SB_USE_CLASS_TELSASLCLIENT
#endif /* SB_USE_CLASS_TELSASLCRAMMD5CLIENT */

#ifdef SB_USE_CLASS_TELSASLLOGINCLIENT
#  define SB_USE_CLASS_TELSASLCLIENT
#endif /* SB_USE_CLASS_TELSASLLOGINCLIENT */

#ifdef SB_USE_CLASS_TELSASLPLAINCLIENT
#  define SB_USE_CLASS_TELSASLCLIENT
#endif /* SB_USE_CLASS_TELSASLPLAINCLIENT */

#ifdef SB_USE_CLASS_TELSASLCLIENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSASLCLIENT */

#ifdef SB_USE_CLASS_TELDISKFILESYSTEMADAPTER
#  define SB_USE_CLASS_TELCUSTOMFILESYSTEMADAPTER
#endif /* SB_USE_CLASS_TELDISKFILESYSTEMADAPTER */

#ifdef SB_USE_CLASS_TELCUSTOMFILESYSTEMADAPTER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCUSTOMFILESYSTEMADAPTER */

#ifdef SB_USE_CLASS_TELVFSENTRYINFORMATIONLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELVFSENTRYINFORMATIONLIST */

#ifdef SB_USE_CLASS_TELVFSENTRYINFORMATION
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELVFSENTRYINFORMATION */

#ifdef SB_USE_CLASS_TELDNSCACHE
#  define SB_USE_CLASS_TELDNSRESOURCERECORDSET
#endif /* SB_USE_CLASS_TELDNSCACHE */

#ifdef SB_USE_CLASS_TELDNSNEXTSECURE3PARAMRECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSNEXTSECURE3PARAMRECORD */

#ifdef SB_USE_CLASS_TELDNSNEXTSECURE3RECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSNEXTSECURE3RECORD */

#ifdef SB_USE_CLASS_TELDNSNEXTSECURERECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSNEXTSECURERECORD */

#ifdef SB_USE_CLASS_TELDNSSIGNATURERECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSSIGNATURERECORD */

#ifdef SB_USE_CLASS_TELDNSDELEGATIONSIGNERRECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSDELEGATIONSIGNERRECORD */

#ifdef SB_USE_CLASS_TELDNSPUBLICKEYRECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSPUBLICKEYRECORD */

#ifdef SB_USE_CLASS_TELDNSEXTENSIONSRECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSEXTENSIONSRECORD */

#ifdef SB_USE_CLASS_TELDNSSERVICELOCATIONRECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSSERVICELOCATIONRECORD */

#ifdef SB_USE_CLASS_TELDNSIPV6ADDRESSRECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSIPV6ADDRESSRECORD */

#ifdef SB_USE_CLASS_TELDNSTEXTSTRINGSRECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSTEXTSTRINGSRECORD */

#ifdef SB_USE_CLASS_TELDNSMAILEXCHANGERECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSMAILEXCHANGERECORD */

#ifdef SB_USE_CLASS_TELDNSMAILINFORECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSMAILINFORECORD */

#ifdef SB_USE_CLASS_TELDNSHOSTINFORECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSHOSTINFORECORD */

#ifdef SB_USE_CLASS_TELDNSDOMAINNAMEPOINTERRECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSDOMAINNAMEPOINTERRECORD */

#ifdef SB_USE_CLASS_TELDNSWELLKNOWNSERVICERECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSWELLKNOWNSERVICERECORD */

#ifdef SB_USE_CLASS_TELDNSSTARTOFAUTHORITYRECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSSTARTOFAUTHORITYRECORD */

#ifdef SB_USE_CLASS_TELDNSCANONICALNAMERECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSCANONICALNAMERECORD */

#ifdef SB_USE_CLASS_TELDNSNAMESERVERRECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSNAMESERVERRECORD */

#ifdef SB_USE_CLASS_TELDNSIPV4ADDRESSRECORD
#  define SB_USE_CLASS_TELDNSRESOURCERECORD
#endif /* SB_USE_CLASS_TELDNSIPV4ADDRESSRECORD */

#ifdef SB_USE_CLASS_TELDNSRESOURCERECORD
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELDNSRESOURCERECORD */

#ifdef SB_USE_CLASS_TELDNSRESOLVER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELDNSRESOLVER */

#ifdef SB_USE_CLASS_TELDNSCLIENT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELDNSCLIENT */

#ifdef SB_USE_CLASS_TELDNSMESSAGE
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELDNSMESSAGE */

#ifdef SB_USE_CLASS_TELDNSMESSAGEEXTENSIONS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELDNSMESSAGEEXTENSIONS */

#ifdef SB_USE_CLASS_TELDNSRESOURCERECORDSET
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELDNSRESOURCERECORDSET */

#ifdef SB_USE_CLASS_TELDNSQUESTIONLIST
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELDNSQUESTIONLIST */

#ifdef SB_USE_CLASS_TELDNSQUESTION
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELDNSQUESTION */

#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TELGSSWINAUTHMECHANISM
#  define SB_USE_CLASS_TELGSSBASEMECHANISM
#endif /* SB_USE_CLASS_TELGSSWINAUTHMECHANISM */

#ifdef SB_USE_CLASS_TELGSSWINNAME
#  define SB_USE_CLASS_TELGSSCUSTOMNAME
#endif /* SB_USE_CLASS_TELGSSWINNAME */

#ifdef SB_USE_CLASS_TELGSSWINCONTEXT
#  define SB_USE_CLASS_TELGSSCUSTOMCONTEXT
#endif /* SB_USE_CLASS_TELGSSWINCONTEXT */
#endif

#ifdef SB_USE_CLASS_TELGSSMECHANISMCOLLECTION
#  define SB_USE_CLASS_TELGSSBASEMECHANISM
#endif /* SB_USE_CLASS_TELGSSMECHANISMCOLLECTION */

#ifdef SB_USE_CLASS_TELGSSAPIMECHANISM
#  define SB_USE_CLASS_TELGSSBASEMECHANISM
#endif /* SB_USE_CLASS_TELGSSAPIMECHANISM */

#ifdef SB_USE_CLASS_TELGSSAPINAME
#  define SB_USE_CLASS_TELGSSCUSTOMNAME
#endif /* SB_USE_CLASS_TELGSSAPINAME */

#ifdef SB_USE_CLASS_TELGSSAPICONTEXT
#  define SB_USE_CLASS_TELGSSCUSTOMCONTEXT
#endif /* SB_USE_CLASS_TELGSSAPICONTEXT */

#ifdef SB_USE_CLASS_TELGSSBASEMECHANISM
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGSSBASEMECHANISM */

#ifdef SB_USE_CLASS_TELGSSCUSTOMNAME
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGSSCUSTOMNAME */

#ifdef SB_USE_CLASS_TELGSSCUSTOMCONTEXT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGSSCUSTOMCONTEXT */

#ifdef SB_USE_CLASS_TELGOST
#  define SB_USE_CLASS_TELGOSTBASE
#endif /* SB_USE_CLASS_TELGOST */

#ifdef SB_USE_CLASS_TELGOSTSIGNER
#  define SB_USE_CLASS_TELGOSTSIGNERBASE
#endif /* SB_USE_CLASS_TELGOSTSIGNER */

#ifdef SB_USE_CLASS_TELGOSTSIGNERBASE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGOSTSIGNERBASE */

#ifdef SB_USE_CLASS_TELGOSTMD
#  define SB_USE_CLASS_TELGOSTBASE
#endif /* SB_USE_CLASS_TELGOSTMD */

#ifdef SB_USE_CLASS_TELGOSTBASE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELGOSTBASE */

#ifdef SB_USE_CLASS_TELECDOMAINPARAMETERS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELECDOMAINPARAMETERS */

#ifdef SB_USE_CLASS_TELUMAC
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELUMAC */

#ifdef SB_USE_CLASS_TELTARWRITERLOW
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELTARWRITERLOW */

#ifdef SB_USE_CLASS_TELTARREADERLOW
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELTARREADERLOW */

#ifdef SB_USE_CLASS_TELSOCKETTSPCLIENT
#  define SB_USE_CLASS_TELCUSTOMTSPCLIENT
#endif /* SB_USE_CLASS_TELSOCKETTSPCLIENT */

#ifdef SB_USE_CLASS_TELFILETSPCLIENT
#  define SB_USE_CLASS_TELCUSTOMTSPCLIENT
#endif /* SB_USE_CLASS_TELFILETSPCLIENT */

#ifdef SB_USE_CLASS_TELCUSTOMTSPCLIENT
#  define SB_USE_CLASS_TELTSPCLASS
#endif /* SB_USE_CLASS_TELCUSTOMTSPCLIENT */

#ifdef SB_USE_CLASS_TELCLIENTTSPINFO
#  define SB_USE_CLASS_TELTSPINFO
#endif /* SB_USE_CLASS_TELCLIENTTSPINFO */

#ifdef SB_USE_CLASS_TELTSPCLASS
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELTSPCLASS */

#ifdef SB_USE_CLASS_TELTSPINFO
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELTSPINFO */

#ifdef SB_USE_CLASS_TELPUBLICKEYCOMPUTATIONTOKEN
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPUBLICKEYCOMPUTATIONTOKEN */

#ifdef SB_USE_CLASS_TELPUBLICKEYASYNCCALCULATOR
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELPUBLICKEYASYNCCALCULATOR */

#ifdef SB_USE_CLASS_TELAEADCHACHA20POLY1305SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELAEADCHACHA20POLY1305SYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELCHACHA20SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELCHACHA20SYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELIDENTITYSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELIDENTITYSYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELGOST28147SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELGOST28147SYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELRABBITSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELRABBITSYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELSEEDSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELSEEDSYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELSERPENTSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELSERPENTSYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELCAMELLIASYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELCAMELLIASYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TEL3DESSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TEL3DESSYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELDESSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELDESSYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELRC4SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELRC4SYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELRC2SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELRC2SYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELCAST128SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELCAST128SYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELIDEASYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELIDEASYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELTWOFISHSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELTWOFISHSYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELBLOWFISHSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELBLOWFISHSYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELAESSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELAESSYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELSYMMETRICCRYPTOFACTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSYMMETRICCRYPTOFACTORY */

#ifdef SB_USE_CLASS_TELSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELCUSTOMCRYPTO
#endif /* SB_USE_CLASS_TELSYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELSYMMETRICKEYMATERIAL
#  define SB_USE_CLASS_TELKEYMATERIAL
#endif /* SB_USE_CLASS_TELSYMMETRICKEYMATERIAL */

#ifdef SB_USE_CLASS_TELSRPCREDENTIALSTORE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSRPCREDENTIALSTORE */

#ifdef SB_USE_CLASS_TELSRPCREDENTIAL
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSRPCREDENTIAL */

#ifdef SB_USE_CLASS_TELREMOTESIGNINGPARAMS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELREMOTESIGNINGPARAMS */

#ifdef SB_USE_CLASS_TELPUBLICKEYCRYPTOFACTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPUBLICKEYCRYPTOFACTORY */

#ifdef SB_USE_CLASS_TELGOST2001PUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELGOST2001PUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELGOST2001KEYMATERIAL
#  define SB_USE_CLASS_TELPUBLICKEYMATERIAL
#endif /* SB_USE_CLASS_TELGOST2001KEYMATERIAL */

#ifdef SB_USE_CLASS_TELGOST94PUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELGOST94PUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELGOST94KEYMATERIAL
#  define SB_USE_CLASS_TELPUBLICKEYMATERIAL
#endif /* SB_USE_CLASS_TELGOST94KEYMATERIAL */

#ifdef SB_USE_CLASS_TELSRPPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELSRPPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELSRPKEYMATERIAL
#  define SB_USE_CLASS_TELPUBLICKEYMATERIAL
#endif /* SB_USE_CLASS_TELSRPKEYMATERIAL */

#ifdef SB_USE_CLASS_TELELGAMALPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELELGAMALPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELELGAMALKEYMATERIAL
#  define SB_USE_CLASS_TELPUBLICKEYMATERIAL
#endif /* SB_USE_CLASS_TELELGAMALKEYMATERIAL */

#ifdef SB_USE_CLASS_TELDHPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELDHPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELDHKEYMATERIAL
#  define SB_USE_CLASS_TELPUBLICKEYMATERIAL
#endif /* SB_USE_CLASS_TELDHKEYMATERIAL */

#ifdef SB_USE_CLASS_TELECDHPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELECDHPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELECDSAPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELECDSAPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELECKEYMATERIAL
#  define SB_USE_CLASS_TELPUBLICKEYMATERIAL
#endif /* SB_USE_CLASS_TELECKEYMATERIAL */

#ifdef SB_USE_CLASS_TELDSAPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELDSAPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELDSAKEYMATERIAL
#  define SB_USE_CLASS_TELPUBLICKEYMATERIAL
#endif /* SB_USE_CLASS_TELDSAKEYMATERIAL */

#ifdef SB_USE_CLASS_TELRSAPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELRSAPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELRSAKEYMATERIAL
#  define SB_USE_CLASS_TELPUBLICKEYMATERIAL
#endif /* SB_USE_CLASS_TELRSAKEYMATERIAL */

#ifdef SB_USE_CLASS_TELPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELCUSTOMCRYPTO
#endif /* SB_USE_CLASS_TELPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELPUBLICKEYMATERIAL
#  define SB_USE_CLASS_TELKEYMATERIAL
#endif /* SB_USE_CLASS_TELPUBLICKEYMATERIAL */

#ifdef SB_USE_CLASS_TELOCSPRESPONSESTORAGE
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELOCSPRESPONSESTORAGE */

#ifdef SB_USE_CLASS_TELOCSPCLIENTMANAGER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOCSPCLIENTMANAGER */

#ifdef SB_USE_CLASS_TELCUSTOMOCSPCLIENTFACTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMOCSPCLIENTFACTORY */

#ifdef SB_USE_CLASS_TELFILEOCSPCLIENT
#  define SB_USE_CLASS_TELOCSPCLIENT
#endif /* SB_USE_CLASS_TELFILEOCSPCLIENT */

#ifdef SB_USE_CLASS_TELOCSPRESPONSE
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELOCSPRESPONSE */

#ifdef SB_USE_CLASS_TELOCSPSINGLERESPONSE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOCSPSINGLERESPONSE */

#ifdef SB_USE_CLASS_TELOCSPRESPONDERID
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELOCSPRESPONDERID */

#ifdef SB_USE_CLASS_TELOCSPCLIENT
#  define SB_USE_CLASS_TELOCSPCLASS
#endif /* SB_USE_CLASS_TELOCSPCLIENT */

#ifdef SB_USE_CLASS_TELOCSPCLASS
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELOCSPCLASS */

#ifdef SB_USE_CLASS_TELSMIMEMESSAGEVERIFIER
#  define SB_USE_CLASS_TELMESSAGEVERIFIER
#endif /* SB_USE_CLASS_TELSMIMEMESSAGEVERIFIER */

#ifdef SB_USE_CLASS_TELSMIMEMESSAGESIGNER
#  define SB_USE_CLASS_TELMESSAGESIGNER
#endif /* SB_USE_CLASS_TELSMIMEMESSAGESIGNER */

#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TELWINCERTSTORAGE
#  define SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#endif /* SB_USE_CLASS_TELWINCERTSTORAGE */
#endif
#ifdef MACOS
#ifdef SB_USE_CLASS_TELJKS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELJKS */

#ifdef SB_USE_CLASS_TELPKCS12MESSAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS12MESSAGE */

#ifdef SB_USE_CLASS_TELPKCS8PRIVATEKEY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS8PRIVATEKEY */

#ifdef SB_USE_CLASS_TELPKCS8PRIVATEKEYINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS8PRIVATEKEYINFO */

#ifdef SB_USE_CLASS_TELPKCS8ENCRYPTEDPRIVATEKEYINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS8ENCRYPTEDPRIVATEKEYINFO */

#ifdef SB_USE_CLASS_TELPKCS7ISSUER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7ISSUER */

#ifdef SB_USE_CLASS_TELPKCS7ATTRIBUTES
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7ATTRIBUTES */

#ifdef SB_USE_CLASS_TELPKCS7TIMESTAMPEDDATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7TIMESTAMPEDDATA */

#ifdef SB_USE_CLASS_TELPKCS7TIMESTAMPANDCRL
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7TIMESTAMPANDCRL */

#ifdef SB_USE_CLASS_TELPKCS7AUTHENTICATEDDATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7AUTHENTICATEDDATA */

#ifdef SB_USE_CLASS_TELPKCS7SIGNEDANDENVELOPEDDATA
#  define SB_USE_CLASS_TINTERFACEDPERSISTENT
#endif /* SB_USE_CLASS_TELPKCS7SIGNEDANDENVELOPEDDATA */

#ifdef SB_USE_CLASS_TELPKCS7ENCRYPTEDDATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7ENCRYPTEDDATA */

#ifdef SB_USE_CLASS_TELPKCS7DIGESTEDDATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7DIGESTEDDATA */

#ifdef SB_USE_CLASS_TELPKCS7SIGNEDDATA
#  define SB_USE_CLASS_TINTERFACEDPERSISTENT
#endif /* SB_USE_CLASS_TELPKCS7SIGNEDDATA */

#ifdef SB_USE_CLASS_TELPKCS7SIGNER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7SIGNER */

#ifdef SB_USE_CLASS_TELPKCS7COMPRESSEDDATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7COMPRESSEDDATA */

#ifdef SB_USE_CLASS_TELPKCS7ENVELOPEDDATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7ENVELOPEDDATA */

#ifdef SB_USE_CLASS_TELPKCS7MESSAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7MESSAGE */

#ifdef SB_USE_CLASS_TELPKCS7ENCRYPTEDCONTENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7ENCRYPTEDCONTENT */

#ifdef SB_USE_CLASS_TELPKCS7CONTENTPART
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7CONTENTPART */

#ifdef SB_USE_CLASS_TELPKCS7RECIPIENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7RECIPIENT */

#ifdef SB_USE_CLASS_TELPKCS5PBE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS5PBE */

#ifdef SB_USE_CLASS_TELMESSAGETIMESTAMPVERIFIER
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#endif /* SB_USE_CLASS_TELMESSAGETIMESTAMPVERIFIER */

#ifdef SB_USE_CLASS_TELMESSAGETIMESTAMPER
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#endif /* SB_USE_CLASS_TELMESSAGETIMESTAMPER */

#ifdef SB_USE_CLASS_TELMESSAGECOMPRESSOR
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#endif /* SB_USE_CLASS_TELMESSAGECOMPRESSOR */

#ifdef SB_USE_CLASS_TELMESSAGEDECOMPRESSOR
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#endif /* SB_USE_CLASS_TELMESSAGEDECOMPRESSOR */

#ifdef SB_USE_CLASS_TELMESSAGESIGNER
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#endif /* SB_USE_CLASS_TELMESSAGESIGNER */

#ifdef SB_USE_CLASS_TELMESSAGEVERIFIER
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#endif /* SB_USE_CLASS_TELMESSAGEVERIFIER */

#ifdef SB_USE_CLASS_TELMESSAGEDECRYPTOR
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#endif /* SB_USE_CLASS_TELMESSAGEDECRYPTOR */

#ifdef SB_USE_CLASS_TELMESSAGEENCRYPTOR
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#endif /* SB_USE_CLASS_TELMESSAGEENCRYPTOR */

#ifdef SB_USE_CLASS_TELMESSAGEPROCESSOR
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELMESSAGEPROCESSOR */

#ifdef SB_USE_CLASS_TELFILECERTSTORAGE
#  define SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#endif /* SB_USE_CLASS_TELFILECERTSTORAGE */
#endif

#ifndef MACOS
#ifdef SB_USE_CLASS_TELJKS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELJKS */

#ifdef SB_USE_CLASS_TELPKCS12MESSAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS12MESSAGE */

#ifdef SB_USE_CLASS_TELPKCS8PRIVATEKEY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS8PRIVATEKEY */

#ifdef SB_USE_CLASS_TELPKCS8PRIVATEKEYINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS8PRIVATEKEYINFO */

#ifdef SB_USE_CLASS_TELPKCS8ENCRYPTEDPRIVATEKEYINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS8ENCRYPTEDPRIVATEKEYINFO */

#ifdef SB_USE_CLASS_TELPKCS7ISSUER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7ISSUER */

#ifdef SB_USE_CLASS_TELPKCS7ATTRIBUTES
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7ATTRIBUTES */

#ifdef SB_USE_CLASS_TELPKCS7TIMESTAMPEDDATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7TIMESTAMPEDDATA */

#ifdef SB_USE_CLASS_TELPKCS7TIMESTAMPANDCRL
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7TIMESTAMPANDCRL */

#ifdef SB_USE_CLASS_TELPKCS7AUTHENTICATEDDATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7AUTHENTICATEDDATA */

#ifdef SB_USE_CLASS_TELPKCS7SIGNEDANDENVELOPEDDATA
#  define SB_USE_CLASS_TINTERFACEDPERSISTENT
#endif /* SB_USE_CLASS_TELPKCS7SIGNEDANDENVELOPEDDATA */

#ifdef SB_USE_CLASS_TELPKCS7ENCRYPTEDDATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7ENCRYPTEDDATA */

#ifdef SB_USE_CLASS_TELPKCS7DIGESTEDDATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7DIGESTEDDATA */

#ifdef SB_USE_CLASS_TELPKCS7SIGNEDDATA
#  define SB_USE_CLASS_TINTERFACEDPERSISTENT
#endif /* SB_USE_CLASS_TELPKCS7SIGNEDDATA */

#ifdef SB_USE_CLASS_TELPKCS7SIGNER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7SIGNER */

#ifdef SB_USE_CLASS_TELPKCS7COMPRESSEDDATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7COMPRESSEDDATA */

#ifdef SB_USE_CLASS_TELPKCS7ENVELOPEDDATA
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7ENVELOPEDDATA */

#ifdef SB_USE_CLASS_TELPKCS7MESSAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7MESSAGE */

#ifdef SB_USE_CLASS_TELPKCS7ENCRYPTEDCONTENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7ENCRYPTEDCONTENT */

#ifdef SB_USE_CLASS_TELPKCS7CONTENTPART
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7CONTENTPART */

#ifdef SB_USE_CLASS_TELPKCS7RECIPIENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS7RECIPIENT */

#ifdef SB_USE_CLASS_TELPKCS5PBE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPKCS5PBE */

#ifdef SB_USE_CLASS_TELMESSAGETIMESTAMPVERIFIER
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#endif /* SB_USE_CLASS_TELMESSAGETIMESTAMPVERIFIER */

#ifdef SB_USE_CLASS_TELMESSAGETIMESTAMPER
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#endif /* SB_USE_CLASS_TELMESSAGETIMESTAMPER */

#ifdef SB_USE_CLASS_TELMESSAGECOMPRESSOR
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#endif /* SB_USE_CLASS_TELMESSAGECOMPRESSOR */

#ifdef SB_USE_CLASS_TELMESSAGEDECOMPRESSOR
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#endif /* SB_USE_CLASS_TELMESSAGEDECOMPRESSOR */

#ifdef SB_USE_CLASS_TELMESSAGESIGNER
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#endif /* SB_USE_CLASS_TELMESSAGESIGNER */

#ifdef SB_USE_CLASS_TELMESSAGEVERIFIER
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#endif /* SB_USE_CLASS_TELMESSAGEVERIFIER */

#ifdef SB_USE_CLASS_TELMESSAGEDECRYPTOR
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#endif /* SB_USE_CLASS_TELMESSAGEDECRYPTOR */

#ifdef SB_USE_CLASS_TELMESSAGEENCRYPTOR
#  define SB_USE_CLASS_TELMESSAGEPROCESSOR
#endif /* SB_USE_CLASS_TELMESSAGEENCRYPTOR */

#ifdef SB_USE_CLASS_TELMESSAGEPROCESSOR
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELMESSAGEPROCESSOR */

#ifdef SB_USE_CLASS_TELFILECERTSTORAGE
#  define SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#endif /* SB_USE_CLASS_TELFILECERTSTORAGE */

#ifdef SB_USE_CLASS_TELCACHECERTSTORAGE
#  define SB_USE_CLASS_TELMEMORYCERTSTORAGE
#endif /* SB_USE_CLASS_TELCACHECERTSTORAGE */

#ifdef SB_USE_CLASS_TELCERTIFICATELOOKUP
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCERTIFICATELOOKUP */

#else
#ifdef SB_USE_CLASS_TELCACHECERTSTORAGE
#  define SB_USE_CLASS_TELMEMORYCERTSTORAGE
#endif /* SB_USE_CLASS_TELCACHECERTSTORAGE */

#ifdef SB_USE_CLASS_TELCERTIFICATELOOKUP
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCERTIFICATELOOKUP */

#ifdef SB_USE_CLASS_TELAPPLECERTSTORAGE
#  define SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#endif /* SB_USE_CLASS_TELAPPLECERTSTORAGE */

#ifdef SB_USE_CLASS_TELRDNCONVERTER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELRDNCONVERTER */

#ifdef SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME */
#endif

#ifdef SB_USE_CLASS_TELMEMORYCERTSTORAGE
#  define SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#endif /* SB_USE_CLASS_TELMEMORYCERTSTORAGE */

#ifndef MACOS
#ifdef SB_USE_CLASS_TELRDNCONVERTER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELRDNCONVERTER */

#ifdef SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME */

#else
#ifdef SB_USE_CLASS_TELX509CACHEDCERTIFICATE
#  define SB_USE_CLASS_TELX509CERTIFICATE
#endif /* SB_USE_CLASS_TELX509CACHEDCERTIFICATE */

#ifdef SB_USE_CLASS_TELX509CERTIFICATEVALIDATIONRESULT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELX509CERTIFICATEVALIDATIONRESULT */

#ifdef SB_USE_CLASS_TELX509CERTIFICATEVALIDATORLOGGER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELX509CERTIFICATEVALIDATORLOGGER */

#ifdef SB_USE_CLASS_TELX509CERTIFICATEVALIDATOR
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELX509CERTIFICATEVALIDATOR */

#ifdef SB_USE_CLASS_TELCERTIFICATERETRIEVERMANAGER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCERTIFICATERETRIEVERMANAGER */

#ifdef SB_USE_CLASS_TELCUSTOMCERTIFICATERETRIEVERFACTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMCERTIFICATERETRIEVERFACTORY */

#ifdef SB_USE_CLASS_TELFILECERTIFICATERETRIEVER
#  define SB_USE_CLASS_TELCUSTOMCERTIFICATERETRIEVER
#endif /* SB_USE_CLASS_TELFILECERTIFICATERETRIEVER */

#ifdef SB_USE_CLASS_TELCUSTOMCERTIFICATERETRIEVER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCUSTOMCERTIFICATERETRIEVER */

#ifdef SB_USE_CLASS_TELCRLMANAGER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCRLMANAGER */

#ifdef SB_USE_CLASS_TELCUSTOMCRLRETRIEVERFACTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMCRLRETRIEVERFACTORY */

#ifdef SB_USE_CLASS_TELCUSTOMCRLRETRIEVER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCUSTOMCRLRETRIEVER */

#ifdef SB_USE_CLASS_TELCRLCACHESTORAGE
#  define SB_USE_CLASS_TELMEMORYCRLSTORAGE
#endif /* SB_USE_CLASS_TELCRLCACHESTORAGE */

#ifdef SB_USE_CLASS_TELMEMORYCRLSTORAGE
#  define SB_USE_CLASS_TELCUSTOMCRLSTORAGE
#endif /* SB_USE_CLASS_TELMEMORYCRLSTORAGE */

#ifdef SB_USE_CLASS_TELCRLLOOKUP
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCRLLOOKUP */

#ifdef SB_USE_CLASS_TELCUSTOMCRLSTORAGE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCUSTOMCRLSTORAGE */

#ifdef SB_USE_CLASS_TELCERTIFICATEREVOCATIONLIST
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCERTIFICATEREVOCATIONLIST */

#ifdef SB_USE_CLASS_TELREVOCATIONITEM
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELREVOCATIONITEM */

#ifdef SB_USE_CLASS_TELCRLENTRYEXTENSIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCRLENTRYEXTENSIONS */

#ifdef SB_USE_CLASS_TELCRLEXTENSIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCRLEXTENSIONS */

#ifdef SB_USE_CLASS_TELISSUINGDISTRIBUTIONPOINTCRLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELISSUINGDISTRIBUTIONPOINTCRLEXTENSION */

#ifdef SB_USE_CLASS_TELCERTIFICATEISSUERCRLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELCERTIFICATEISSUERCRLEXTENSION */

#ifdef SB_USE_CLASS_TELINVALIDITYDATECRLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELINVALIDITYDATECRLEXTENSION */

#ifdef SB_USE_CLASS_TELHOLDINSTRUCTIONCODECRLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELHOLDINSTRUCTIONCODECRLEXTENSION */

#ifdef SB_USE_CLASS_TELREASONCODECRLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELREASONCODECRLEXTENSION */

#ifdef SB_USE_CLASS_TELDELTACRLINDICATORCRLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELDELTACRLINDICATORCRLEXTENSION */

#ifdef SB_USE_CLASS_TELCRLNUMBERCRLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELCRLNUMBERCRLEXTENSION */

#ifdef SB_USE_CLASS_TELAUTHORITYKEYIDENTIFIERCRLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELAUTHORITYKEYIDENTIFIERCRLEXTENSION */

#ifdef SB_USE_CLASS_TELEXTENSIONREADER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELEXTENSIONREADER */

#ifdef SB_USE_CLASS_TELEXTENSIONWRITER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELEXTENSIONWRITER */

#ifdef SB_USE_CLASS_TELCERTIFICATEEXTENSIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCERTIFICATEEXTENSIONS */

#ifdef SB_USE_CLASS_TELSUBJECTDIRECTORYATTRIBUTESEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELSUBJECTDIRECTORYATTRIBUTESEXTENSION */

#ifdef SB_USE_CLASS_TELAUTHORITYINFORMATIONACCESSEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELAUTHORITYINFORMATIONACCESSEXTENSION */

#ifdef SB_USE_CLASS_TELACCESSDESCRIPTION
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELACCESSDESCRIPTION */

#ifdef SB_USE_CLASS_TELCRLDISTRIBUTIONPOINTSEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELCRLDISTRIBUTIONPOINTSEXTENSION */

#ifdef SB_USE_CLASS_TELDISTRIBUTIONPOINT
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELDISTRIBUTIONPOINT */

#ifdef SB_USE_CLASS_TELEXTENDEDKEYUSAGEEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELEXTENDEDKEYUSAGEEXTENSION */

#ifdef SB_USE_CLASS_TELPOLICYCONSTRAINTSEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELPOLICYCONSTRAINTSEXTENSION */

#ifdef SB_USE_CLASS_TELNAMECONSTRAINTSEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELNAMECONSTRAINTSEXTENSION */

#ifdef SB_USE_CLASS_TELNAMECONSTRAINT
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELNAMECONSTRAINT */

#ifdef SB_USE_CLASS_TELBASICCONSTRAINTSEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELBASICCONSTRAINTSEXTENSION */

#ifdef SB_USE_CLASS_TELALTERNATIVENAMEEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELALTERNATIVENAMEEXTENSION */

#ifdef SB_USE_CLASS_TELPOLICYMAPPINGSEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELPOLICYMAPPINGSEXTENSION */

#ifdef SB_USE_CLASS_TELPOLICYMAPPING
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELPOLICYMAPPING */

#ifdef SB_USE_CLASS_TELCERTIFICATEPOLICIESEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELCERTIFICATEPOLICIESEXTENSION */

#ifdef SB_USE_CLASS_TELSINGLEPOLICYINFORMATION
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELSINGLEPOLICYINFORMATION */

#ifdef SB_USE_CLASS_TELSINGLEPOLICYQUALIFIER
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELSINGLEPOLICYQUALIFIER */

#ifdef SB_USE_CLASS_TELUSERNOTICE
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELUSERNOTICE */

#ifdef SB_USE_CLASS_TELCOMMONNAME
#  define SB_USE_CLASS_TELNETSCAPESTRING
#endif /* SB_USE_CLASS_TELCOMMONNAME */

#ifdef SB_USE_CLASS_TELNETSCAPECOMMENT
#  define SB_USE_CLASS_TELNETSCAPESTRING
#endif /* SB_USE_CLASS_TELNETSCAPECOMMENT */

#ifdef SB_USE_CLASS_TELNETSCAPESERVERNAME
#  define SB_USE_CLASS_TELNETSCAPESTRING
#endif /* SB_USE_CLASS_TELNETSCAPESERVERNAME */

#ifdef SB_USE_CLASS_TELNETSCAPECAPOLICY
#  define SB_USE_CLASS_TELNETSCAPESTRING
#endif /* SB_USE_CLASS_TELNETSCAPECAPOLICY */

#ifdef SB_USE_CLASS_TELNETSCAPERENEWALURL
#  define SB_USE_CLASS_TELNETSCAPESTRING
#endif /* SB_USE_CLASS_TELNETSCAPERENEWALURL */

#ifdef SB_USE_CLASS_TELNETSCAPECAREVOKEURL
#  define SB_USE_CLASS_TELNETSCAPESTRING
#endif /* SB_USE_CLASS_TELNETSCAPECAREVOKEURL */

#ifdef SB_USE_CLASS_TELNETSCAPEREVOKEURL
#  define SB_USE_CLASS_TELNETSCAPESTRING
#endif /* SB_USE_CLASS_TELNETSCAPEREVOKEURL */

#ifdef SB_USE_CLASS_TELNETSCAPEBASEURL
#  define SB_USE_CLASS_TELNETSCAPESTRING
#endif /* SB_USE_CLASS_TELNETSCAPEBASEURL */

#ifdef SB_USE_CLASS_TELNETSCAPESTRING
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELNETSCAPESTRING */

#ifdef SB_USE_CLASS_TELNETSCAPECERTTYPEEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELNETSCAPECERTTYPEEXTENSION */

#ifdef SB_USE_CLASS_TELPRIVATEKEYUSAGEPERIODEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELPRIVATEKEYUSAGEPERIODEXTENSION */

#ifdef SB_USE_CLASS_TELKEYUSAGEEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELKEYUSAGEEXTENSION */

#ifdef SB_USE_CLASS_TELSUBJECTKEYIDENTIFIEREXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELSUBJECTKEYIDENTIFIEREXTENSION */

#ifdef SB_USE_CLASS_TELAUTHORITYKEYIDENTIFIEREXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELAUTHORITYKEYIDENTIFIEREXTENSION */

#ifdef SB_USE_CLASS_TELCUSTOMEXTENSION
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELCUSTOMEXTENSION */

#ifdef SB_USE_CLASS_TELGENERALNAMES
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELGENERALNAMES */

#ifdef SB_USE_CLASS_TELGENERALNAME
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELGENERALNAME */

#ifdef SB_USE_CLASS_TELPERMANENTIDENTIFIER
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELPERMANENTIDENTIFIER */

#ifdef SB_USE_CLASS_TELOTHERNAME
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELOTHERNAME */

#ifdef SB_USE_CLASS_TELEDIPARTYNAME
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELEDIPARTYNAME */
#endif

#ifdef SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#  define SB_USE_CLASS_TELBASECERTSTORAGE
#endif /* SB_USE_CLASS_TELCUSTOMCERTSTORAGE */

#ifndef MACOS
#ifdef SB_USE_CLASS_TELX509CACHEDCERTIFICATE
#  define SB_USE_CLASS_TELX509CERTIFICATE
#endif /* SB_USE_CLASS_TELX509CACHEDCERTIFICATE */

#ifdef SB_USE_CLASS_TELX509CERTIFICATEVALIDATIONRESULT
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELX509CERTIFICATEVALIDATIONRESULT */

#ifdef SB_USE_CLASS_TELX509CERTIFICATEVALIDATORLOGGER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELX509CERTIFICATEVALIDATORLOGGER */

#ifdef SB_USE_CLASS_TELX509CERTIFICATEVALIDATOR
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELX509CERTIFICATEVALIDATOR */

#ifdef SB_USE_CLASS_TELCERTIFICATERETRIEVERMANAGER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCERTIFICATERETRIEVERMANAGER */

#ifdef SB_USE_CLASS_TELCUSTOMCERTIFICATERETRIEVERFACTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMCERTIFICATERETRIEVERFACTORY */

#ifdef SB_USE_CLASS_TELFILECERTIFICATERETRIEVER
#  define SB_USE_CLASS_TELCUSTOMCERTIFICATERETRIEVER
#endif /* SB_USE_CLASS_TELFILECERTIFICATERETRIEVER */

#ifdef SB_USE_CLASS_TELCUSTOMCERTIFICATERETRIEVER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCUSTOMCERTIFICATERETRIEVER */

#ifdef SB_USE_CLASS_TELCRLMANAGER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCRLMANAGER */

#ifdef SB_USE_CLASS_TELCUSTOMCRLRETRIEVERFACTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMCRLRETRIEVERFACTORY */

#ifdef SB_USE_CLASS_TELCUSTOMCRLRETRIEVER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCUSTOMCRLRETRIEVER */

#ifdef SB_USE_CLASS_TELCRLCACHESTORAGE
#  define SB_USE_CLASS_TELMEMORYCRLSTORAGE
#endif /* SB_USE_CLASS_TELCRLCACHESTORAGE */

#ifdef SB_USE_CLASS_TELMEMORYCRLSTORAGE
#  define SB_USE_CLASS_TELCUSTOMCRLSTORAGE
#endif /* SB_USE_CLASS_TELMEMORYCRLSTORAGE */

#ifdef SB_USE_CLASS_TELCRLLOOKUP
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCRLLOOKUP */

#ifdef SB_USE_CLASS_TELCUSTOMCRLSTORAGE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCUSTOMCRLSTORAGE */

#ifdef SB_USE_CLASS_TELCERTIFICATEREVOCATIONLIST
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCERTIFICATEREVOCATIONLIST */

#ifdef SB_USE_CLASS_TELREVOCATIONITEM
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELREVOCATIONITEM */

#ifdef SB_USE_CLASS_TELCRLENTRYEXTENSIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCRLENTRYEXTENSIONS */

#ifdef SB_USE_CLASS_TELCRLEXTENSIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCRLEXTENSIONS */

#ifdef SB_USE_CLASS_TELISSUINGDISTRIBUTIONPOINTCRLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELISSUINGDISTRIBUTIONPOINTCRLEXTENSION */

#ifdef SB_USE_CLASS_TELCERTIFICATEISSUERCRLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELCERTIFICATEISSUERCRLEXTENSION */

#ifdef SB_USE_CLASS_TELINVALIDITYDATECRLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELINVALIDITYDATECRLEXTENSION */

#ifdef SB_USE_CLASS_TELHOLDINSTRUCTIONCODECRLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELHOLDINSTRUCTIONCODECRLEXTENSION */

#ifdef SB_USE_CLASS_TELREASONCODECRLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELREASONCODECRLEXTENSION */

#ifdef SB_USE_CLASS_TELDELTACRLINDICATORCRLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELDELTACRLINDICATORCRLEXTENSION */

#ifdef SB_USE_CLASS_TELCRLNUMBERCRLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELCRLNUMBERCRLEXTENSION */

#ifdef SB_USE_CLASS_TELAUTHORITYKEYIDENTIFIERCRLEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELAUTHORITYKEYIDENTIFIERCRLEXTENSION */

#ifdef SB_USE_CLASS_TELEXTENSIONREADER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELEXTENSIONREADER */

#ifdef SB_USE_CLASS_TELEXTENSIONWRITER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELEXTENSIONWRITER */

#ifdef SB_USE_CLASS_TELCERTIFICATEEXTENSIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCERTIFICATEEXTENSIONS */

#ifdef SB_USE_CLASS_TELSUBJECTDIRECTORYATTRIBUTESEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELSUBJECTDIRECTORYATTRIBUTESEXTENSION */

#ifdef SB_USE_CLASS_TELAUTHORITYINFORMATIONACCESSEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELAUTHORITYINFORMATIONACCESSEXTENSION */

#ifdef SB_USE_CLASS_TELACCESSDESCRIPTION
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELACCESSDESCRIPTION */

#ifdef SB_USE_CLASS_TELCRLDISTRIBUTIONPOINTSEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELCRLDISTRIBUTIONPOINTSEXTENSION */

#ifdef SB_USE_CLASS_TELDISTRIBUTIONPOINT
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELDISTRIBUTIONPOINT */

#ifdef SB_USE_CLASS_TELEXTENDEDKEYUSAGEEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELEXTENDEDKEYUSAGEEXTENSION */

#ifdef SB_USE_CLASS_TELPOLICYCONSTRAINTSEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELPOLICYCONSTRAINTSEXTENSION */

#ifdef SB_USE_CLASS_TELNAMECONSTRAINTSEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELNAMECONSTRAINTSEXTENSION */

#ifdef SB_USE_CLASS_TELNAMECONSTRAINT
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELNAMECONSTRAINT */

#ifdef SB_USE_CLASS_TELBASICCONSTRAINTSEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELBASICCONSTRAINTSEXTENSION */

#ifdef SB_USE_CLASS_TELALTERNATIVENAMEEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELALTERNATIVENAMEEXTENSION */

#ifdef SB_USE_CLASS_TELPOLICYMAPPINGSEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELPOLICYMAPPINGSEXTENSION */

#ifdef SB_USE_CLASS_TELPOLICYMAPPING
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELPOLICYMAPPING */

#ifdef SB_USE_CLASS_TELCERTIFICATEPOLICIESEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELCERTIFICATEPOLICIESEXTENSION */

#ifdef SB_USE_CLASS_TELSINGLEPOLICYINFORMATION
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELSINGLEPOLICYINFORMATION */

#ifdef SB_USE_CLASS_TELSINGLEPOLICYQUALIFIER
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELSINGLEPOLICYQUALIFIER */

#ifdef SB_USE_CLASS_TELUSERNOTICE
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELUSERNOTICE */

#ifdef SB_USE_CLASS_TELCOMMONNAME
#  define SB_USE_CLASS_TELNETSCAPESTRING
#endif /* SB_USE_CLASS_TELCOMMONNAME */

#ifdef SB_USE_CLASS_TELNETSCAPECOMMENT
#  define SB_USE_CLASS_TELNETSCAPESTRING
#endif /* SB_USE_CLASS_TELNETSCAPECOMMENT */

#ifdef SB_USE_CLASS_TELNETSCAPESERVERNAME
#  define SB_USE_CLASS_TELNETSCAPESTRING
#endif /* SB_USE_CLASS_TELNETSCAPESERVERNAME */

#ifdef SB_USE_CLASS_TELNETSCAPECAPOLICY
#  define SB_USE_CLASS_TELNETSCAPESTRING
#endif /* SB_USE_CLASS_TELNETSCAPECAPOLICY */

#ifdef SB_USE_CLASS_TELNETSCAPERENEWALURL
#  define SB_USE_CLASS_TELNETSCAPESTRING
#endif /* SB_USE_CLASS_TELNETSCAPERENEWALURL */

#ifdef SB_USE_CLASS_TELNETSCAPECAREVOKEURL
#  define SB_USE_CLASS_TELNETSCAPESTRING
#endif /* SB_USE_CLASS_TELNETSCAPECAREVOKEURL */

#ifdef SB_USE_CLASS_TELNETSCAPEREVOKEURL
#  define SB_USE_CLASS_TELNETSCAPESTRING
#endif /* SB_USE_CLASS_TELNETSCAPEREVOKEURL */

#ifdef SB_USE_CLASS_TELNETSCAPEBASEURL
#  define SB_USE_CLASS_TELNETSCAPESTRING
#endif /* SB_USE_CLASS_TELNETSCAPEBASEURL */

#ifdef SB_USE_CLASS_TELNETSCAPESTRING
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELNETSCAPESTRING */

#ifdef SB_USE_CLASS_TELNETSCAPECERTTYPEEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELNETSCAPECERTTYPEEXTENSION */

#ifdef SB_USE_CLASS_TELPRIVATEKEYUSAGEPERIODEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELPRIVATEKEYUSAGEPERIODEXTENSION */

#ifdef SB_USE_CLASS_TELKEYUSAGEEXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELKEYUSAGEEXTENSION */

#ifdef SB_USE_CLASS_TELSUBJECTKEYIDENTIFIEREXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELSUBJECTKEYIDENTIFIEREXTENSION */

#ifdef SB_USE_CLASS_TELAUTHORITYKEYIDENTIFIEREXTENSION
#  define SB_USE_CLASS_TELCUSTOMEXTENSION
#endif /* SB_USE_CLASS_TELAUTHORITYKEYIDENTIFIEREXTENSION */

#ifdef SB_USE_CLASS_TELCUSTOMEXTENSION
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELCUSTOMEXTENSION */

#ifdef SB_USE_CLASS_TELGENERALNAMES
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELGENERALNAMES */

#ifdef SB_USE_CLASS_TELGENERALNAME
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELGENERALNAME */

#ifdef SB_USE_CLASS_TELPERMANENTIDENTIFIER
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELPERMANENTIDENTIFIER */

#ifdef SB_USE_CLASS_TELOTHERNAME
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELOTHERNAME */

#ifdef SB_USE_CLASS_TELEDIPARTYNAME
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELEDIPARTYNAME */

#ifdef SB_USE_CLASS_TELBASECERTSTORAGE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELBASECERTSTORAGE */
#endif

#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */

#ifdef SB_USE_CLASS_TELX509CERTIFICATECHAIN
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELX509CERTIFICATECHAIN */

#ifdef SB_USE_CLASS_TELTBSCERTIFICATE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELTBSCERTIFICATE */

#ifdef SB_USE_CLASS_TELSUBJECTPUBLICKEYINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSUBJECTPUBLICKEYINFO */

#ifdef SB_USE_CLASS_TELFIPSCOMPLIANTCRYPTOPROVIDERMANAGER
#  define SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER
#endif /* SB_USE_CLASS_TELFIPSCOMPLIANTCRYPTOPROVIDERMANAGER */

#ifdef SB_USE_CLASS_TELBUILTINCRYPTOPROVIDERMANAGER
#  define SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER
#endif /* SB_USE_CLASS_TELBUILTINCRYPTOPROVIDERMANAGER */

#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TELCNGCRYPTOPROVIDERHANDLEMANAGER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCNGCRYPTOPROVIDERHANDLEMANAGER */
#else
#ifdef SB_USE_CLASS_TELBUILTINAEADCHACHA20POLY1305SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINAEADCHACHA20POLY1305SYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINCHACHA20SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINCHACHA20SYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINGOST28147SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINGOST28147SYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINRC4SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINRC4SYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINIDENTITYSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINIDENTITYSYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTOFACTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTOFACTORY */
#endif

#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TELCNGCRYPTOPROVIDERHANDLEINFO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCNGCRYPTOPROVIDERHANDLEINFO */

#ifdef SB_USE_CLASS_TELWIN32CRYPTOPROVIDER
#  define SB_USE_CLASS_TELEXTERNALCRYPTOPROVIDER
#endif /* SB_USE_CLASS_TELWIN32CRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELWIN32CRYPTOPROVIDEROPTIONS
#  define SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDEROPTIONS
#endif /* SB_USE_CLASS_TELWIN32CRYPTOPROVIDEROPTIONS */

#ifdef SB_USE_CLASS_TELBUILTINAEADCHACHA20POLY1305SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINAEADCHACHA20POLY1305SYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINCHACHA20SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINCHACHA20SYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINGOST28147SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINGOST28147SYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINRC4SYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINRC4SYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINIDENTITYSYMMETRICCRYPTO
#  define SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINIDENTITYSYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTOFACTORY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTOFACTORY */

#endif
#ifndef LINUX
#ifdef SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINGOST2001PUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINGOST2001PUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINGOST94PUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINGOST94PUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINECDHPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINECDHPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINECDSAPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINECDSAPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINDHPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINDHPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINELGAMALPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINELGAMALPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINDSAPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINDSAPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINRSAPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINRSAPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINGOST34102001CRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINGOST34102001CRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINGOST341094CRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINGOST341094CRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINECCRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINECCRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINDHCRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINDHCRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINELGAMALCRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINELGAMALCRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINDSACRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINDSACRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINRSACRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINRSACRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINMACKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINMACKEY */

#ifdef SB_USE_CLASS_TELBUILTINHASHFUNCTION
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBUILTINHASHFUNCTION */

#ifdef SB_USE_CLASS_TELBUILTINCRYPTOPROVIDER
#  define SB_USE_CLASS_TELBLACKBOXCRYPTOPROVIDER
#endif /* SB_USE_CLASS_TELBUILTINCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELBUILTINCRYPTOKEY
#  define SB_USE_CLASS_TELCUSTOMCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINCRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINCRYPTOPROVIDEROPTIONS
#  define SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDEROPTIONS
#endif /* SB_USE_CLASS_TELBUILTINCRYPTOPROVIDEROPTIONS */

#ifdef SB_USE_CLASS_TELEXTERNALCRYPTOPROVIDER
#  define SB_USE_CLASS_TELBLACKBOXCRYPTOPROVIDER
#endif /* SB_USE_CLASS_TELEXTERNALCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELBLACKBOXCRYPTOPROVIDER
#  define SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#endif /* SB_USE_CLASS_TELBLACKBOXCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDEROPTIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDEROPTIONS */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOCONTEXT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOCONTEXT */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOKEY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOKEY */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOKEYSTORAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOKEYSTORAGE */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELTIMER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELTIMER */

#ifdef SB_USE_CLASS_TTIMERTHREAD
#  define SB_USE_CLASS_TTHREAD
#endif /* SB_USE_CLASS_TTIMERTHREAD */

#ifdef SB_USE_CLASS_TELSTRINGTOKENIZER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSTRINGTOKENIZER */

#ifdef SB_USE_CLASS_TELPORTKNOCK
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELPORTKNOCK */

#ifdef SB_USE_CLASS_TELPORTKNOCKENTRY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPORTKNOCKENTRY */

#ifdef SB_USE_CLASS_TELSOCKETSETTINGS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSOCKETSETTINGS */
#ifndef WINCE

#ifndef MACOS
#ifdef SB_USE_CLASS_TELDNSSETTINGS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELDNSSETTINGS */
#endif
#endif
#ifndef MACOS

#endif
#ifdef SB_USE_CLASS_TELCLIENTSOCKETBINDING
#  define SB_USE_CLASS_TELCUSTOMSOCKETBINDING
#endif /* SB_USE_CLASS_TELCLIENTSOCKETBINDING */

#ifdef SB_USE_CLASS_TELCUSTOMSOCKETBINDING
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELCUSTOMSOCKETBINDING */

#ifdef SB_USE_CLASS_TELSOCKET
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSOCKET */

#ifdef SB_USE_CLASS_TELSHAREDRESOURCE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSHAREDRESOURCE */

#else
#ifdef SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINSYMMETRICCRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINGOST2001PUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINGOST2001PUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINGOST94PUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINGOST94PUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINECDHPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINECDHPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINECDSAPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINECDSAPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINDHPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINDHPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINELGAMALPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINELGAMALPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINDSAPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINDSAPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINRSAPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#endif /* SB_USE_CLASS_TELBUILTINRSAPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBUILTINPUBLICKEYCRYPTO */

#ifdef SB_USE_CLASS_TELBUILTINGOST34102001CRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINGOST34102001CRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINGOST341094CRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINGOST341094CRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINECCRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINECCRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINDHCRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINDHCRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINELGAMALCRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINELGAMALCRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINDSACRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINDSACRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINRSACRYPTOKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINRSACRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINMACKEY
#  define SB_USE_CLASS_TELBUILTINCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINMACKEY */

#ifdef SB_USE_CLASS_TELBUILTINHASHFUNCTION
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBUILTINHASHFUNCTION */

#ifdef SB_USE_CLASS_TELBUILTINCRYPTOPROVIDER
#  define SB_USE_CLASS_TELBLACKBOXCRYPTOPROVIDER
#endif /* SB_USE_CLASS_TELBUILTINCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELBUILTINCRYPTOKEY
#  define SB_USE_CLASS_TELCUSTOMCRYPTOKEY
#endif /* SB_USE_CLASS_TELBUILTINCRYPTOKEY */

#ifdef SB_USE_CLASS_TELBUILTINCRYPTOPROVIDEROPTIONS
#  define SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDEROPTIONS
#endif /* SB_USE_CLASS_TELBUILTINCRYPTOPROVIDEROPTIONS */

#ifdef SB_USE_CLASS_TELEXTERNALCRYPTOPROVIDER
#  define SB_USE_CLASS_TELBLACKBOXCRYPTOPROVIDER
#endif /* SB_USE_CLASS_TELEXTERNALCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELBLACKBOXCRYPTOPROVIDER
#  define SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#endif /* SB_USE_CLASS_TELBLACKBOXCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDEROPTIONS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDEROPTIONS */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOCONTEXT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOCONTEXT */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOKEY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOKEY */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOKEYSTORAGE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOKEYSTORAGE */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELTIMER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELTIMER */

#ifdef SB_USE_CLASS_TTIMERTHREAD
#  define SB_USE_CLASS_TTHREAD
#endif /* SB_USE_CLASS_TTIMERTHREAD */

#ifdef SB_USE_CLASS_TELSTRINGTOKENIZER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSTRINGTOKENIZER */

#ifdef SB_USE_CLASS_TELPORTKNOCK
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELPORTKNOCK */

#ifdef SB_USE_CLASS_TELPORTKNOCKENTRY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELPORTKNOCKENTRY */

#ifdef SB_USE_CLASS_TELSOCKETSETTINGS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSOCKETSETTINGS */

#ifdef SB_USE_CLASS_TELCLIENTSOCKETBINDING
#  define SB_USE_CLASS_TELCUSTOMSOCKETBINDING
#endif /* SB_USE_CLASS_TELCLIENTSOCKETBINDING */

#ifdef SB_USE_CLASS_TELCUSTOMSOCKETBINDING
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TELCUSTOMSOCKETBINDING */

#ifdef SB_USE_CLASS_TELSOCKET
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSOCKET */

#ifdef SB_USE_CLASS_TELSHAREDRESOURCE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSHAREDRESOURCE */

#endif
#ifndef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSEMAPHORE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSEMAPHORE */
#endif

#ifdef SB_USE_CLASS_TELSBLICENSEMANAGER
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELSBLICENSEMANAGER */

#ifdef SB_USE_CLASS_TELWRITECACHINGSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELWRITECACHINGSTREAM */

#ifdef SB_USE_CLASS_TELREADCACHINGSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELREADCACHINGSTREAM */

#ifdef SB_USE_CLASS_TELMULTISTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TELMULTISTREAM */

#ifdef SB_USE_CLASS_TELDATASTREAM
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELDATASTREAM */

#ifdef SB_USE_CLASS_TELFILESTREAM
#  define SB_USE_CLASS_TFILESTREAM
#endif /* SB_USE_CLASS_TELFILESTREAM */

#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TELPLATFORMSTRINGCONVERTER
#  define SB_USE_CLASS_TELSTRINGCONVERTER
#endif /* SB_USE_CLASS_TELPLATFORMSTRINGCONVERTER */
#else
#ifdef SB_USE_CLASS_TELSTRINGCONVERTER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSTRINGCONVERTER */
#endif

#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSTRINGCONVERTER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSTRINGCONVERTER */
#endif
#ifdef MACOS
#ifdef SB_USE_CLASS_TELDEBUGEXCEPTIONHANDLER
#  define SB_USE_CLASS_TELSTANDARDEXCEPTIONHANDLER
#endif /* SB_USE_CLASS_TELDEBUGEXCEPTIONHANDLER */
#endif

#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TELDEBUGEXCEPTIONHANDLER
#  define SB_USE_CLASS_TELSTANDARDEXCEPTIONHANDLER
#endif /* SB_USE_CLASS_TELDEBUGEXCEPTIONHANDLER */

#ifdef SB_USE_CLASS_TELSTANDARDEXCEPTIONHANDLER
#  define SB_USE_CLASS_TELCUSTOMEXCEPTIONHANDLER
#endif /* SB_USE_CLASS_TELSTANDARDEXCEPTIONHANDLER */

#ifdef SB_USE_CLASS_TELCUSTOMEXCEPTIONHANDLER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMEXCEPTIONHANDLER */

#ifdef SB_USE_CLASS_TSBOBJECTLIST
#  define SB_USE_CLASS_TLIST
#endif /* SB_USE_CLASS_TSBOBJECTLIST */

#ifdef SB_USE_CLASS_TELBYTEARRAYLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBYTEARRAYLIST */

#endif
#ifdef LINUX
#ifdef SB_USE_CLASS_TELDEBUGEXCEPTIONHANDLER
#  define SB_USE_CLASS_TELSTANDARDEXCEPTIONHANDLER
#endif /* SB_USE_CLASS_TELDEBUGEXCEPTIONHANDLER */

#ifdef SB_USE_CLASS_TELSTANDARDEXCEPTIONHANDLER
#  define SB_USE_CLASS_TELCUSTOMEXCEPTIONHANDLER
#endif /* SB_USE_CLASS_TELSTANDARDEXCEPTIONHANDLER */

#ifdef SB_USE_CLASS_TELCUSTOMEXCEPTIONHANDLER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMEXCEPTIONHANDLER */

#ifdef SB_USE_CLASS_TSBOBJECTLIST
#  define SB_USE_CLASS_TLIST
#endif /* SB_USE_CLASS_TSBOBJECTLIST */

#ifdef SB_USE_CLASS_TELBYTEARRAYLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBYTEARRAYLIST */

#ifdef SB_USE_CLASS_TELSTRINGLIST
#  define SB_USE_CLASS_TSTRINGLIST
#endif /* SB_USE_CLASS_TELSTRINGLIST */

#endif
#ifndef MACOS
#ifdef SB_USE_CLASS_TELBYTEARRAYHOLDER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBYTEARRAYHOLDER */

#ifdef SB_USE_CLASS_TELSTRINGHOLDER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSTRINGHOLDER */

#ifdef SB_USE_CLASS_TELRSAANTITIMINGPARAMS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELRSAANTITIMINGPARAMS */

#ifdef SB_USE_CLASS_TELRANDOM
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELRANDOM */

#ifdef SB_USE_CLASS_TELPEMPROCESSOR
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELPEMPROCESSOR */

#ifdef SB_USE_CLASS_TELHASHFUNCTION
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELHASHFUNCTION */

#ifdef SB_USE_CLASS_TELHMACKEYMATERIAL
#  define SB_USE_CLASS_TELKEYMATERIAL
#endif /* SB_USE_CLASS_TELHMACKEYMATERIAL */

#ifdef SB_USE_CLASS_TELASN1CONSTRAINEDTAG
#  define SB_USE_CLASS_TELASN1CUSTOMTAG
#endif /* SB_USE_CLASS_TELASN1CONSTRAINEDTAG */

#ifdef SB_USE_CLASS_TELASN1SIMPLETAG
#  define SB_USE_CLASS_TELASN1CUSTOMTAG
#endif /* SB_USE_CLASS_TELASN1SIMPLETAG */

#ifdef SB_USE_CLASS_TELASN1DATASOURCE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELASN1DATASOURCE */

#ifdef SB_USE_CLASS_TELASN1CUSTOMTAG
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELASN1CUSTOMTAG */

#ifdef SB_USE_CLASS_TELASN1PARSER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELASN1PARSER */

#ifdef SB_USE_CLASS_TELKEYMATERIALSTORAGE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELKEYMATERIALSTORAGE */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTO */

#ifdef SB_USE_CLASS_TELKEYMATERIAL
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELKEYMATERIAL */

#ifdef SB_USE_CLASS_TSBBYTEARRAYPOINTER
#  define SB_USE_CLASS_TSBARRAYPOINTER
#endif /* SB_USE_CLASS_TSBBYTEARRAYPOINTER */

#ifdef SB_USE_CLASS_TSBUINT32ARRAYPOINTER
#  define SB_USE_CLASS_TSBARRAYPOINTER
#endif /* SB_USE_CLASS_TSBUINT32ARRAYPOINTER */

#ifdef SB_USE_CLASS_TSBINT32ARRAYPOINTER
#  define SB_USE_CLASS_TSBARRAYPOINTER
#endif /* SB_USE_CLASS_TSBINT32ARRAYPOINTER */

#ifdef SB_USE_CLASS_TSBARRAYPOINTER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSBARRAYPOINTER */

#ifdef SB_USE_CLASS_TSBUINT16ONUINT32ARRAY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSBUINT16ONUINT32ARRAY */

#ifdef SB_USE_CLASS_TSBBYTEONUINT32ARRAY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSBBYTEONUINT32ARRAY */

#ifdef SB_USE_CLASS_TSBUINT16ONBYTEARRAY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSBUINT16ONBYTEARRAY */

#ifdef SB_USE_CLASS_TSBUINT32ARRAY
#  define SB_USE_CLASS_TSBDATAARRAY
#endif /* SB_USE_CLASS_TSBUINT32ARRAY */

#ifdef SB_USE_CLASS_TSBINT32ARRAY
#  define SB_USE_CLASS_TSBDATAARRAY
#endif /* SB_USE_CLASS_TSBINT32ARRAY */

#ifdef SB_USE_CLASS_TSBUINT16ARRAY
#  define SB_USE_CLASS_TSBDATAARRAY
#endif /* SB_USE_CLASS_TSBUINT16ARRAY */

#ifdef SB_USE_CLASS_TSBINT16ARRAY
#  define SB_USE_CLASS_TSBDATAARRAY
#endif /* SB_USE_CLASS_TSBINT16ARRAY */

#ifdef SB_USE_CLASS_TSBBYTEARRAY
#  define SB_USE_CLASS_TSBDATAARRAY
#endif /* SB_USE_CLASS_TSBBYTEARRAY */

#ifdef SB_USE_CLASS_TSBBYTEDATAARRAY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSBBYTEDATAARRAY */

#ifdef SB_USE_CLASS_TSBDATAARRAY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSBDATAARRAY */

#ifdef SB_USE_CLASS_BZ_STREAM
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_BZ_STREAM */

#ifdef SB_USE_CLASS_DSTATE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_DSTATE */

#ifdef SB_USE_CLASS_ESTATE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_ESTATE */
#else
#ifdef SB_USE_CLASS_TELSTANDARDEXCEPTIONHANDLER
#  define SB_USE_CLASS_TELCUSTOMEXCEPTIONHANDLER
#endif /* SB_USE_CLASS_TELSTANDARDEXCEPTIONHANDLER */

#ifdef SB_USE_CLASS_TELCUSTOMEXCEPTIONHANDLER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMEXCEPTIONHANDLER */

#ifdef SB_USE_CLASS_TSBOBJECTLIST
#  define SB_USE_CLASS_TLIST
#endif /* SB_USE_CLASS_TSBOBJECTLIST */

#ifdef SB_USE_CLASS_TELBYTEARRAYLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBYTEARRAYLIST */

#ifdef SB_USE_CLASS_TELSTRINGLIST
#  define SB_USE_CLASS_TSTRINGLIST
#endif /* SB_USE_CLASS_TELSTRINGLIST */

#ifdef SB_USE_CLASS_TELBYTEARRAYHOLDER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELBYTEARRAYHOLDER */

#ifdef SB_USE_CLASS_TELSTRINGHOLDER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELSTRINGHOLDER */

#ifdef SB_USE_CLASS_TELRSAANTITIMINGPARAMS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELRSAANTITIMINGPARAMS */

#ifdef SB_USE_CLASS_TELRANDOM
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELRANDOM */

#ifdef SB_USE_CLASS_TELPEMPROCESSOR
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELPEMPROCESSOR */

#ifdef SB_USE_CLASS_TELHASHFUNCTION
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELHASHFUNCTION */

#ifdef SB_USE_CLASS_TELHMACKEYMATERIAL
#  define SB_USE_CLASS_TELKEYMATERIAL
#endif /* SB_USE_CLASS_TELHMACKEYMATERIAL */

#ifdef SB_USE_CLASS_TELASN1CONSTRAINEDTAG
#  define SB_USE_CLASS_TELASN1CUSTOMTAG
#endif /* SB_USE_CLASS_TELASN1CONSTRAINEDTAG */

#ifdef SB_USE_CLASS_TELASN1SIMPLETAG
#  define SB_USE_CLASS_TELASN1CUSTOMTAG
#endif /* SB_USE_CLASS_TELASN1SIMPLETAG */

#ifdef SB_USE_CLASS_TELASN1DATASOURCE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELASN1DATASOURCE */

#ifdef SB_USE_CLASS_TELASN1CUSTOMTAG
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELASN1CUSTOMTAG */

#ifdef SB_USE_CLASS_TELASN1PARSER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELASN1PARSER */

#ifdef SB_USE_CLASS_TELKEYMATERIALSTORAGE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELKEYMATERIALSTORAGE */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTO
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTO */

#ifdef SB_USE_CLASS_TELKEYMATERIAL
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELKEYMATERIAL */

#ifdef SB_USE_CLASS_TSBBYTEARRAYPOINTER
#  define SB_USE_CLASS_TSBARRAYPOINTER
#endif /* SB_USE_CLASS_TSBBYTEARRAYPOINTER */

#ifdef SB_USE_CLASS_TSBUINT32ARRAYPOINTER
#  define SB_USE_CLASS_TSBARRAYPOINTER
#endif /* SB_USE_CLASS_TSBUINT32ARRAYPOINTER */

#ifdef SB_USE_CLASS_TSBINT32ARRAYPOINTER
#  define SB_USE_CLASS_TSBARRAYPOINTER
#endif /* SB_USE_CLASS_TSBINT32ARRAYPOINTER */

#ifdef SB_USE_CLASS_TSBARRAYPOINTER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSBARRAYPOINTER */

#ifdef SB_USE_CLASS_TSBUINT16ONUINT32ARRAY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSBUINT16ONUINT32ARRAY */

#ifdef SB_USE_CLASS_TSBBYTEONUINT32ARRAY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSBBYTEONUINT32ARRAY */

#ifdef SB_USE_CLASS_TSBUINT16ONBYTEARRAY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSBUINT16ONBYTEARRAY */

#ifdef SB_USE_CLASS_TSBUINT32ARRAY
#  define SB_USE_CLASS_TSBDATAARRAY
#endif /* SB_USE_CLASS_TSBUINT32ARRAY */

#ifdef SB_USE_CLASS_TSBINT32ARRAY
#  define SB_USE_CLASS_TSBDATAARRAY
#endif /* SB_USE_CLASS_TSBINT32ARRAY */

#ifdef SB_USE_CLASS_TSBUINT16ARRAY
#  define SB_USE_CLASS_TSBDATAARRAY
#endif /* SB_USE_CLASS_TSBUINT16ARRAY */

#ifdef SB_USE_CLASS_TSBINT16ARRAY
#  define SB_USE_CLASS_TSBDATAARRAY
#endif /* SB_USE_CLASS_TSBINT16ARRAY */

#ifdef SB_USE_CLASS_TSBBYTEARRAY
#  define SB_USE_CLASS_TSBDATAARRAY
#endif /* SB_USE_CLASS_TSBBYTEARRAY */

#ifdef SB_USE_CLASS_TSBBYTEDATAARRAY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSBBYTEDATAARRAY */

#ifdef SB_USE_CLASS_TSBDATAARRAY
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSBDATAARRAY */

#ifdef SB_USE_CLASS_BZ_STREAM
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_BZ_STREAM */

#ifdef SB_USE_CLASS_DSTATE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_DSTATE */

#ifdef SB_USE_CLASS_ESTATE
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_ESTATE */

#ifdef SB_USE_CLASS_TELBASECERTSTORAGE
#  define SB_USE_CLASS_TCOMPONENT
#endif /* SB_USE_CLASS_TELBASECERTSTORAGE */
#endif

#ifdef SB_USE_CLASS_TELGOST3411WITHGOST3410ALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELALGORITHMIDENTIFIER
#endif /* SB_USE_CLASS_TELGOST3411WITHGOST3410ALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELGOST3410ALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELALGORITHMIDENTIFIER
#endif /* SB_USE_CLASS_TELGOST3410ALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELGOST3411ALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELALGORITHMIDENTIFIER
#endif /* SB_USE_CLASS_TELGOST3411ALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELECDSAALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELALGORITHMIDENTIFIER
#endif /* SB_USE_CLASS_TELECDSAALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELECALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELALGORITHMIDENTIFIER
#endif /* SB_USE_CLASS_TELECALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELDHALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELALGORITHMIDENTIFIER
#endif /* SB_USE_CLASS_TELDHALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELDSAALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELALGORITHMIDENTIFIER
#endif /* SB_USE_CLASS_TELDSAALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELRSAOAEPALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELALGORITHMIDENTIFIER
#endif /* SB_USE_CLASS_TELRSAOAEPALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELRSAPSSALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELALGORITHMIDENTIFIER
#endif /* SB_USE_CLASS_TELRSAPSSALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELRSAALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TELALGORITHMIDENTIFIER
#endif /* SB_USE_CLASS_TELRSAALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELALGORITHMIDENTIFIER
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TELALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TTHREAD
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TTHREAD */

#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASS_TSTRINGS
#endif /* SB_USE_CLASS_TSTRINGLIST */

#ifdef SB_USE_CLASS_TSTRINGS
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TSTRINGS */

#ifdef SB_USE_CLASS_TMEMORYSTREAM
#  define SB_USE_CLASS_TCUSTOMMEMORYSTREAM
#endif /* SB_USE_CLASS_TMEMORYSTREAM */

#ifdef SB_USE_CLASS_TCOMPONENT
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TCOMPONENT */

#ifdef SB_USE_CLASS_TCUSTOMMEMORYSTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_TCUSTOMMEMORYSTREAM */

#ifdef SB_USE_CLASS_TLIST
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TLIST */

#ifdef SB_USE_CLASS_TINTERFACEDPERSISTENT
#  define SB_USE_CLASS_TPERSISTENT
#endif /* SB_USE_CLASS_TINTERFACEDPERSISTENT */

#ifdef SB_USE_CLASS_TINTERFACEDOBJECT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TINTERFACEDOBJECT */

#ifdef SB_USE_CLASS_TFILESTREAM
#  define SB_USE_CLASS_THANDLESTREAM
#endif /* SB_USE_CLASS_TFILESTREAM */

#ifdef SB_USE_CLASS_THANDLESTREAM
#  define SB_USE_CLASS_TSTREAM
#endif /* SB_USE_CLASS_THANDLESTREAM */

#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TSTREAM */

#ifdef SB_USE_CLASS_TPERSISTENT
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TPERSISTENT */

#ifdef SB_USE_CLASS_TBITS
#  define SB_USE_CLASS_TOBJECT
#endif /* SB_USE_CLASS_TBITS */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOKEY
#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOKEY_AND_TELCUSTOMCRYPTOPROVIDER
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOKEY */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOPROVIDER_AND_TELCUSTOMCRYPTOPROVIDERMANAGER
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOKEY
#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOKEY_AND_TELCUSTOMCRYPTOPROVIDER_AND_TELCUSTOMCRYPTOPROVIDERMANAGER
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOKEY */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#ifdef SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOPROVIDER_AND_TELRELATIVEDISTINGUISHEDNAME
#endif /* SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#ifdef SB_USE_CLASS_TELHMACKEYMATERIAL
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOPROVIDER_AND_TELHMACKEYMATERIAL
#endif /* SB_USE_CLASS_TELHMACKEYMATERIAL */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER
#ifdef SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOPROVIDER_AND_TELCUSTOMCRYPTOPROVIDERMANAGER_AND_TELRELATIVEDISTINGUISHEDNAME
#endif /* SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER
#ifdef SB_USE_CLASS_TELHMACKEYMATERIAL
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOPROVIDER_AND_TELCUSTOMCRYPTOPROVIDERMANAGER_AND_TELHMACKEYMATERIAL
#endif /* SB_USE_CLASS_TELHMACKEYMATERIAL */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOKEY
#ifdef SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOKEY_AND_TELRELATIVEDISTINGUISHEDNAME
#endif /* SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOKEY */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOKEYSTORAGE
#ifdef SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOKEYSTORAGE_AND_TELRELATIVEDISTINGUISHEDNAME
#endif /* SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOKEYSTORAGE */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOCONTEXT
#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOKEY
#ifdef SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOCONTEXT_AND_TELCUSTOMCRYPTOKEY_AND_TELRELATIVEDISTINGUISHEDNAME
#endif /* SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOKEY */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOCONTEXT */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOCONTEXT
#ifdef SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOCONTEXT_AND_TELRELATIVEDISTINGUISHEDNAME
#endif /* SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOCONTEXT */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOKEY
#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#ifdef SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOKEY_AND_TELCUSTOMCRYPTOPROVIDER_AND_TELRELATIVEDISTINGUISHEDNAME
#endif /* SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOKEY */

#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#ifdef SB_USE_CLASS_TELWIN32CRYPTOPROVIDEROPTIONS
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOPROVIDER_AND_TELWIN32CRYPTOPROVIDEROPTIONS
#endif /* SB_USE_CLASS_TELWIN32CRYPTOPROVIDEROPTIONS */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER */
#endif

#ifdef SB_USE_CLASS_TELGENERALNAMES
#ifdef SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME
#  define SB_USE_CLASSES_TELGENERALNAMES_AND_TELRELATIVEDISTINGUISHEDNAME
#endif /* SB_USE_CLASS_TELRELATIVEDISTINGUISHEDNAME */
#endif /* SB_USE_CLASS_TELGENERALNAMES */

#ifdef SB_USE_CLASS_TELDISTRIBUTIONPOINT
#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#ifdef SB_USE_CLASS_TLIST
#  define SB_USE_CLASSES_TELDISTRIBUTIONPOINT_AND_TELX509CERTIFICATE_AND_TLIST
#endif /* SB_USE_CLASS_TLIST */
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */
#endif /* SB_USE_CLASS_TELDISTRIBUTIONPOINT */

#ifdef SB_USE_CLASS_TELCERTIFICATEREVOCATIONLIST
#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#  define SB_USE_CLASSES_TELCERTIFICATEREVOCATIONLIST_AND_TELX509CERTIFICATE
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */
#endif /* SB_USE_CLASS_TELCERTIFICATEREVOCATIONLIST */

#ifdef SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#  define SB_USE_CLASSES_TELCUSTOMCERTSTORAGE_AND_TELX509CERTIFICATE
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */
#endif /* SB_USE_CLASS_TELCUSTOMCERTSTORAGE */

#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#ifdef SB_USE_CLASS_TELX509CERTIFICATEVALIDATOR
#  define SB_USE_CLASSES_TELX509CERTIFICATE_AND_TELX509CERTIFICATEVALIDATOR
#endif /* SB_USE_CLASS_TELX509CERTIFICATEVALIDATOR */
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */

#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#ifdef SB_USE_CLASS_TELX509CERTIFICATECHAIN
#  define SB_USE_CLASSES_TELX509CERTIFICATE_AND_TELX509CERTIFICATECHAIN
#endif /* SB_USE_CLASS_TELX509CERTIFICATECHAIN */
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */

#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELDCASYNCSTATE_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */

#ifdef SB_USE_CLASS_TELASN1CONSTRAINEDTAG
#ifdef SB_USE_CLASS_TOBJECT
#  define SB_USE_CLASSES_TELASN1CONSTRAINEDTAG_AND_TOBJECT
#endif /* SB_USE_CLASS_TOBJECT */
#endif /* SB_USE_CLASS_TELASN1CONSTRAINEDTAG */

#ifdef SB_USE_CLASS_TELASN1CONSTRAINEDTAG
#ifdef SB_USE_CLASS_TELPKCS7SIGNER
#  define SB_USE_CLASSES_TELASN1CONSTRAINEDTAG_AND_TELPKCS7SIGNER
#endif /* SB_USE_CLASS_TELPKCS7SIGNER */
#endif /* SB_USE_CLASS_TELASN1CONSTRAINEDTAG */

#ifdef SB_USE_CLASS_TELASN1CUSTOMTAG
#ifdef SB_USE_CLASS_TELPKCS7SIGNER
#  define SB_USE_CLASSES_TELASN1CUSTOMTAG_AND_TELPKCS7SIGNER
#endif /* SB_USE_CLASS_TELPKCS7SIGNER */
#endif /* SB_USE_CLASS_TELASN1CUSTOMTAG */

#ifdef SB_USE_CLASS_TELASN1CONSTRAINEDTAG
#ifdef SB_USE_CLASS_TELPKCS7ATTRIBUTES
#  define SB_USE_CLASSES_TELASN1CONSTRAINEDTAG_AND_TELPKCS7ATTRIBUTES
#endif /* SB_USE_CLASS_TELPKCS7ATTRIBUTES */
#endif /* SB_USE_CLASS_TELASN1CONSTRAINEDTAG */

#ifdef SB_USE_CLASS_TELASN1CUSTOMTAG
#ifdef SB_USE_CLASS_TELPKCS7ATTRIBUTES
#  define SB_USE_CLASSES_TELASN1CUSTOMTAG_AND_TELPKCS7ATTRIBUTES
#endif /* SB_USE_CLASS_TELPKCS7ATTRIBUTES */
#endif /* SB_USE_CLASS_TELASN1CUSTOMTAG */

#ifdef SB_USE_CLASS_TELPKCS7ISSUER
#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#  define SB_USE_CLASSES_TELPKCS7ISSUER_AND_TELX509CERTIFICATE
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */
#endif /* SB_USE_CLASS_TELPKCS7ISSUER */

#ifdef SB_USE_CLASS_TELPUBLICKEYMATERIAL
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELPUBLICKEYMATERIAL_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELPUBLICKEYMATERIAL */

#ifdef SB_USE_CLASS_TELGSSCUSTOMCONTEXT
#ifdef SB_USE_CLASS_TELGSSCUSTOMNAME
#  define SB_USE_CLASSES_TELGSSCUSTOMCONTEXT_AND_TELGSSCUSTOMNAME
#endif /* SB_USE_CLASS_TELGSSCUSTOMNAME */
#endif /* SB_USE_CLASS_TELGSSCUSTOMCONTEXT */

#ifdef SB_USE_CLASS_TELDNSPUBLICKEYRECORD
#ifdef SB_USE_CLASS_TELDNSSIGNATURERECORD
#  define SB_USE_CLASSES_TELDNSPUBLICKEYRECORD_AND_TELDNSSIGNATURERECORD
#endif /* SB_USE_CLASS_TELDNSSIGNATURERECORD */
#endif /* SB_USE_CLASS_TELDNSPUBLICKEYRECORD */

#ifdef SB_USE_CLASS_TELSASLCLIENT
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELSASLCLIENT_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TELSASLCLIENT */

#ifdef SB_USE_CLASS_TELDCENCODING
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELDCENCODING_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELDCENCODING */

#ifdef SB_USE_CLASS_TELDCBASEMESSAGE
#ifdef SB_USE_CLASS_TELDCENCODING
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELDCBASEMESSAGE_AND_TELDCENCODING_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELDCENCODING */
#endif /* SB_USE_CLASS_TELDCBASEMESSAGE */

#ifdef SB_USE_CLASS_TELDCBASEMESSAGE
#ifdef SB_USE_CLASS_TELDCNODE
#  define SB_USE_CLASSES_TELDCBASEMESSAGE_AND_TELDCNODE
#endif /* SB_USE_CLASS_TELDCNODE */
#endif /* SB_USE_CLASS_TELDCBASEMESSAGE */

#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TELDCPKCS7SIGNPARAMETERS
#  define SB_USE_CLASSES_TELDCASYNCSTATE_AND_TELDCPKCS7SIGNPARAMETERS
#endif /* SB_USE_CLASS_TELDCPKCS7SIGNPARAMETERS */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */

#ifdef SB_USE_CLASS_TELDCNODE
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELDCNODE_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELDCNODE */

#ifdef SB_USE_CLASS_TELJSONENTITY
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELJSONENTITY_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELJSONENTITY */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGEOBJECT_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGEOBJECT_AND_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGEOBJECT_AND_TELCUSTOMDATASTORAGESECURITYHANDLER
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT
#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEOBJECT_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELSTRINGLIST
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEOBJECT_AND_TELSTRINGLIST
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#endif
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKET
#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEBUCKET_AND_TELAWSS3DATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKET */

#ifdef SB_USE_CLASS_TELDATASTORAGEOBJECTLIST
#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELDATASTORAGEOBJECTLIST_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELSTRINGLIST
#  define SB_USE_CLASSES_TELDATASTORAGEOBJECTLIST_AND_TELSTRINGLIST
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#endif
#endif /* SB_USE_CLASS_TELDATASTORAGEOBJECTLIST */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKET
#ifdef SB_USE_CLASS_TELDATASTORAGEOBJECTLIST
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEBUCKET_AND_TELDATASTORAGEOBJECTLIST
#endif /* SB_USE_CLASS_TELDATASTORAGEOBJECTLIST */
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKET */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGELISTSTATE
#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGELISTSTATE_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELSTRINGLIST
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGELISTSTATE_AND_TELSTRINGLIST
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#endif
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGELISTSTATE */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGELISTSTATE
#ifdef SB_USE_CLASS_TELDATASTORAGEOBJECTLIST
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGELISTSTATE_AND_TELDATASTORAGEOBJECTLIST
#endif /* SB_USE_CLASS_TELDATASTORAGEOBJECTLIST */
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGELISTSTATE */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEOBJECT_AND_TELCUSTOMDATASTORAGESECURITYHANDLER
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKET
#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEBUCKET_AND_TELAWSS3DATASTORAGEOBJECT_AND_TELCUSTOMDATASTORAGESECURITYHANDLER
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKET */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEOBJECT_AND_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELSTRINGLIST
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEOBJECT_AND_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELSTRINGLIST
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#endif
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifndef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSTRINGLIST
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELSTRINGLIST_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TSTREAM
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TSTREAM_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TSTREAM */
#endif
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifndef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSTRINGLIST
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEOBJECT_AND_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELSTRINGLIST_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TSTREAM
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEOBJECT_AND_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TSTREAM_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TSTREAM */
#endif
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEOBJECT_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT */

#ifndef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSTRINGLIST
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELSTRINGLIST_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TSTREAM
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TSTREAM_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TSTREAM */
#endif

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT
#ifndef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSTRINGLIST
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEOBJECT_AND_TELSTRINGLIST_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TSTREAM
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEOBJECT_AND_TSTREAM_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TSTREAM */
#endif
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEOBJECT_AND_TELCUSTOMDATASTORAGEOBJECT_AND_TELCUSTOMDATASTORAGESECURITYHANDLER
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGEOBJECT_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELSTRINGLIST
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGEOBJECT_AND_TELSTRINGLIST
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#endif
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELAWSS3ACCESSCONTROLPOLICY
#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT
#  define SB_USE_CLASSES_TELAWSS3ACCESSCONTROLPOLICY_AND_TELAWSS3DATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELAWSS3ACCESSCONTROLPOLICY */

#ifdef SB_USE_CLASS_TELAWSS3ACCESSCONTROLPOLICY
#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELAWSS3ACCESSCONTROLPOLICY_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELSTRINGLIST
#  define SB_USE_CLASSES_TELAWSS3ACCESSCONTROLPOLICY_AND_TELSTRINGLIST
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#endif
#endif /* SB_USE_CLASS_TELAWSS3ACCESSCONTROLPOLICY */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKET
#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEBUCKET_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELSTRINGLIST
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEBUCKET_AND_TELSTRINGLIST
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#endif
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKET */

#ifdef SB_USE_CLASS_TELAWSS3ACCESSCONTROLPOLICY
#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKET
#  define SB_USE_CLASSES_TELAWSS3ACCESSCONTROLPOLICY_AND_TELAWSS3DATASTORAGEBUCKET
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKET */
#endif /* SB_USE_CLASS_TELAWSS3ACCESSCONTROLPOLICY */

#ifdef SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKETLIST
#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEBUCKETLIST_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELSTRINGLIST
#  define SB_USE_CLASSES_TELAWSS3DATASTORAGEBUCKETLIST_AND_TELSTRINGLIST
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#endif
#endif /* SB_USE_CLASS_TELAWSS3DATASTORAGEBUCKETLIST */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifdef SB_USE_CLASS_TELFILEDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELFILEDATASTORAGEOBJECT_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELFILEDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */

#ifdef SB_USE_CLASS_TELFILEDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELFILEDATASTORAGEOBJECT_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELFILEDATASTORAGEOBJECT */

#ifndef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSTRINGLIST
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT
#  define SB_USE_CLASSES_TELSTRINGLIST_AND_TELWINAZUREDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELWINAZUREDATASTORAGEOBJECT_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT */
#endif

#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT
#  define SB_USE_CLASSES_TELWINAZUREDATASTORAGECONTAINER_AND_TELWINAZUREDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER */

#ifdef SB_USE_CLASS_TELDATASTORAGEOBJECTLIST
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER
#  define SB_USE_CLASSES_TELDATASTORAGEOBJECTLIST_AND_TELWINAZUREDATASTORAGECONTAINER
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER */
#endif /* SB_USE_CLASS_TELDATASTORAGEOBJECTLIST */

#ifndef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSTRINGLIST
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGELISTSTATE
#  define SB_USE_CLASSES_TELSTRINGLIST_AND_TELWINAZUREDATASTORAGELISTSTATE
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGELISTSTATE */
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGELISTSTATE
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELWINAZUREDATASTORAGELISTSTATE_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGELISTSTATE */
#endif

#ifdef SB_USE_CLASS_TELDATASTORAGEOBJECTLIST
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGELISTSTATE
#  define SB_USE_CLASSES_TELDATASTORAGEOBJECTLIST_AND_TELWINAZUREDATASTORAGELISTSTATE
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGELISTSTATE */
#endif /* SB_USE_CLASS_TELDATASTORAGEOBJECTLIST */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELWINAZUREDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELWINAZUREDATASTORAGECONTAINER_AND_TELWINAZUREDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifndef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSTRINGLIST
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELSTRINGLIST_AND_TELWINAZUREDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELWINAZUREDATASTORAGEOBJECT_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT */
#endif
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifndef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSTRINGLIST
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELSTRINGLIST_AND_TELWINAZUREDATASTORAGEOBJECT_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELWINAZUREDATASTORAGEOBJECT_AND_TSTREAM_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT */
#endif
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */

#ifndef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSTRINGLIST
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELSTRINGLIST_AND_TELWINAZUREDATASTORAGEOBJECT_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELWINAZUREDATASTORAGEOBJECT_AND_TSTREAM_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT */
#endif

#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELWINAZUREDATASTORAGEOBJECT_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGEOBJECT_AND_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELWINAZUREDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT */

#ifndef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSTRINGLIST
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER
#  define SB_USE_CLASSES_TELSTRINGLIST_AND_TELWINAZUREDATASTORAGECONTAINER
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER */
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELWINAZUREDATASTORAGECONTAINER_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER */
#endif

#ifdef SB_USE_CLASS_TELWINAZUREACCESSPOLICY
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER
#  define SB_USE_CLASSES_TELWINAZUREACCESSPOLICY_AND_TELWINAZUREDATASTORAGECONTAINER
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER */
#endif /* SB_USE_CLASS_TELWINAZUREACCESSPOLICY */

#ifndef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSTRINGLIST
#ifdef SB_USE_CLASS_TELWINAZUREACCESSPOLICY
#  define SB_USE_CLASSES_TELSTRINGLIST_AND_TELWINAZUREACCESSPOLICY
#endif /* SB_USE_CLASS_TELWINAZUREACCESSPOLICY */
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELWINAZUREACCESSPOLICY
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELWINAZUREACCESSPOLICY_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TELWINAZUREACCESSPOLICY */
#endif

#ifndef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSTRINGLIST
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINERLIST
#  define SB_USE_CLASSES_TELSTRINGLIST_AND_TELWINAZUREDATASTORAGECONTAINERLIST
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINERLIST */
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINERLIST
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELWINAZUREDATASTORAGECONTAINERLIST_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINERLIST */
#endif

#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINERLIST
#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGELISTSTATE
#  define SB_USE_CLASSES_TELWINAZUREDATASTORAGECONTAINERLIST_AND_TELWINAZUREDATASTORAGELISTSTATE
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGELISTSTATE */
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINERLIST */

#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TELWINAZURESINGLEACCESSPOLICY
#  define SB_USE_CLASSES_TELWINAZUREDATASTORAGEOBJECT_AND_TELWINAZURESINGLEACCESSPOLICY
#endif /* SB_USE_CLASS_TELWINAZURESINGLEACCESSPOLICY */
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER
#ifdef SB_USE_CLASS_TELWINAZURESINGLEACCESSPOLICY
#  define SB_USE_CLASSES_TELWINAZUREDATASTORAGECONTAINER_AND_TELWINAZURESINGLEACCESSPOLICY
#endif /* SB_USE_CLASS_TELWINAZURESINGLEACCESSPOLICY */
#endif /* SB_USE_CLASS_TELWINAZUREDATASTORAGECONTAINER */

#ifdef SB_USE_CLASS_TELDATASTORAGEOBJECTLIST
#ifdef SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECT
#  define SB_USE_CLASSES_TELDATASTORAGEOBJECTLIST_AND_TELGOOGLEDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELDATASTORAGEOBJECTLIST */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifdef SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELGOOGLEDATASTORAGEOBJECT_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */

#ifdef SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELGOOGLEDATASTORAGEOBJECT_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECT
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGEOBJECT_AND_TELGOOGLEDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVEDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TELGOOGLEDRIVEFOLDER
#  define SB_USE_CLASSES_TELGOOGLEDRIVEDATASTORAGEOBJECT_AND_TELGOOGLEDRIVEFOLDER
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEFOLDER */
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifdef SB_USE_CLASS_TELGOOGLEDRIVEDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TELGOOGLEDRIVEFOLDER
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELGOOGLEDRIVEDATASTORAGEOBJECT_AND_TELGOOGLEDRIVEFOLDER
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEFOLDER */
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */

#ifdef SB_USE_CLASS_TELGOOGLEDRIVEDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELGOOGLEDRIVEDATASTORAGEOBJECT_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELDATASTORAGEOBJECTLIST
#ifdef SB_USE_CLASS_TELGOOGLEDRIVEFOLDER
#  define SB_USE_CLASSES_TELDATASTORAGEOBJECTLIST_AND_TELGOOGLEDRIVEFOLDER
#endif /* SB_USE_CLASS_TELGOOGLEDRIVEFOLDER */
#endif /* SB_USE_CLASS_TELDATASTORAGEOBJECTLIST */

#ifdef SB_USE_CLASS_TELONEDRIVEDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TELONEDRIVEFOLDER
#  define SB_USE_CLASSES_TELONEDRIVEDATASTORAGEOBJECT_AND_TELONEDRIVEFOLDER
#endif /* SB_USE_CLASS_TELONEDRIVEFOLDER */
#endif /* SB_USE_CLASS_TELONEDRIVEDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELONEDRIVEFILE
#ifdef SB_USE_CLASS_TELONEDRIVEFOLDER
#  define SB_USE_CLASSES_TELONEDRIVEFILE_AND_TELONEDRIVEFOLDER
#endif /* SB_USE_CLASS_TELONEDRIVEFOLDER */
#endif /* SB_USE_CLASS_TELONEDRIVEFILE */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifdef SB_USE_CLASS_TELONEDRIVEFILE
#ifdef SB_USE_CLASS_TELONEDRIVEFOLDER
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELONEDRIVEFILE_AND_TELONEDRIVEFOLDER
#endif /* SB_USE_CLASS_TELONEDRIVEFOLDER */
#endif /* SB_USE_CLASS_TELONEDRIVEFILE */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */

#ifdef SB_USE_CLASS_TELDATASTORAGEOBJECTLIST
#ifdef SB_USE_CLASS_TELONEDRIVEFOLDER
#  define SB_USE_CLASSES_TELDATASTORAGEOBJECTLIST_AND_TELONEDRIVEFOLDER
#endif /* SB_USE_CLASS_TELONEDRIVEFOLDER */
#endif /* SB_USE_CLASS_TELDATASTORAGEOBJECTLIST */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifdef SB_USE_CLASS_TELONEDRIVEFILE
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELONEDRIVEFILE
#endif /* SB_USE_CLASS_TELONEDRIVEFILE */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */

#ifdef SB_USE_CLASS_TELDATASTORAGEOBJECTLIST
#ifdef SB_USE_CLASS_TELDROPBOXDATASTORAGEOBJECT
#  define SB_USE_CLASSES_TELDATASTORAGEOBJECTLIST_AND_TELDROPBOXDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELDROPBOXDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELDATASTORAGEOBJECTLIST */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifdef SB_USE_CLASS_TELDROPBOXDATASTORAGEOBJECT
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELDROPBOXDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELDROPBOXDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifdef SB_USE_CLASS_TELDROPBOXDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELDROPBOXDATASTORAGEOBJECT_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELDROPBOXDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */

#ifdef SB_USE_CLASS_TELDROPBOXDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELDROPBOXDATASTORAGEOBJECT_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELDROPBOXDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER
#ifdef SB_USE_CLASS_TELDROPBOXDATASTORAGEOBJECT
#  define SB_USE_CLASSES_TELCUSTOMDATASTORAGEOBJECT_AND_TELCUSTOMDATASTORAGESECURITYHANDLER_AND_TELDROPBOXDATASTORAGEOBJECT
#endif /* SB_USE_CLASS_TELDROPBOXDATASTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGESECURITYHANDLER */
#endif /* SB_USE_CLASS_TELCUSTOMDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELBOXDATASTORAGEOBJECT
#ifdef SB_USE_CLASS_TELBOXFOLDER
#  define SB_USE_CLASSES_TELBOXDATASTORAGEOBJECT_AND_TELBOXFOLDER
#endif /* SB_USE_CLASS_TELBOXFOLDER */
#endif /* SB_USE_CLASS_TELBOXDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELBOXGROUP
#ifdef SB_USE_CLASS_TELBOXGROUPMEMBERSHIP
#  define SB_USE_CLASSES_TELBOXGROUP_AND_TELBOXGROUPMEMBERSHIP
#endif /* SB_USE_CLASS_TELBOXGROUPMEMBERSHIP */
#endif /* SB_USE_CLASS_TELBOXGROUP */

#ifdef SB_USE_CLASS_TELBOXGROUPMEMBER
#ifdef SB_USE_CLASS_TELBOXUSER
#  define SB_USE_CLASSES_TELBOXGROUPMEMBER_AND_TELBOXUSER
#endif /* SB_USE_CLASS_TELBOXUSER */
#endif /* SB_USE_CLASS_TELBOXGROUPMEMBER */

#ifdef SB_USE_CLASS_TELBOXCOLLABORATION
#ifdef SB_USE_CLASS_TELBOXGROUPINFO
#  define SB_USE_CLASSES_TELBOXCOLLABORATION_AND_TELBOXGROUPINFO
#endif /* SB_USE_CLASS_TELBOXGROUPINFO */
#endif /* SB_USE_CLASS_TELBOXCOLLABORATION */

#ifdef SB_USE_CLASS_TELBOXCOLLABORATION
#ifdef SB_USE_CLASS_TELBOXUSERINFO
#  define SB_USE_CLASSES_TELBOXCOLLABORATION_AND_TELBOXUSERINFO
#endif /* SB_USE_CLASS_TELBOXUSERINFO */
#endif /* SB_USE_CLASS_TELBOXCOLLABORATION */

#ifdef SB_USE_CLASS_TELCARDDAVFILTER
#ifndef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSTRINGLIST
#ifdef SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST
#  define SB_USE_CLASSES_TELCARDDAVFILTER_AND_TELSTRINGLIST_AND_TELWEBDAVPROPERTYINFOLIST
#endif /* SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST */
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELCARDDAVFILTER_AND_TELWEBDAVPROPERTYINFOLIST_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST */
#endif
#endif /* SB_USE_CLASS_TELCARDDAVFILTER */

#ifdef SB_USE_CLASS_TELWEBDAVPROPERTYINFO
#ifdef SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST
#  define SB_USE_CLASSES_TELWEBDAVPROPERTYINFO_AND_TELWEBDAVPROPERTYINFOLIST
#endif /* SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST */
#endif /* SB_USE_CLASS_TELWEBDAVPROPERTYINFO */

#ifndef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSTRINGLIST
#ifdef SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST
#  define SB_USE_CLASSES_TELSTRINGLIST_AND_TELWEBDAVPROPERTYINFOLIST
#endif /* SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST */
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELWEBDAVPROPERTYINFOLIST_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST */
#endif

#ifdef SB_USE_CLASS_TELWEBDAVOBJECTLIST
#ifdef SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT
#  define SB_USE_CLASSES_TELWEBDAVOBJECTLIST_AND_TELWEBDAVSTORAGEOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELWEBDAVOBJECTLIST */

#ifdef SB_USE_CLASS_TELWEBDAVERRORLIST
#ifdef SB_USE_CLASS_TELWEBDAVLOCKLIST
#  define SB_USE_CLASSES_TELWEBDAVERRORLIST_AND_TELWEBDAVLOCKLIST
#endif /* SB_USE_CLASS_TELWEBDAVLOCKLIST */
#endif /* SB_USE_CLASS_TELWEBDAVERRORLIST */

#ifdef SB_USE_CLASS_TELWEBDAVERRORLIST
#ifdef SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT
#  define SB_USE_CLASSES_TELWEBDAVERRORLIST_AND_TELWEBDAVSTORAGEOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELWEBDAVERRORLIST */

#ifdef SB_USE_CLASS_TELWEBDAVLOCKLIST
#ifdef SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST
#  define SB_USE_CLASSES_TELWEBDAVLOCKLIST_AND_TELWEBDAVPROPERTYINFOLIST
#endif /* SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST */
#endif /* SB_USE_CLASS_TELWEBDAVLOCKLIST */

#ifdef SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST
#ifdef SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT
#  define SB_USE_CLASSES_TELWEBDAVPROPERTYINFOLIST_AND_TELWEBDAVSTORAGEOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST */

#ifdef SB_USE_CLASS_TELWEBDAVLOCKLIST
#ifdef SB_USE_CLASS_TELWEBDAVPROPERTYINFO
#  define SB_USE_CLASSES_TELWEBDAVLOCKLIST_AND_TELWEBDAVPROPERTYINFO
#endif /* SB_USE_CLASS_TELWEBDAVPROPERTYINFO */
#endif /* SB_USE_CLASS_TELWEBDAVLOCKLIST */

#ifdef SB_USE_CLASS_TELWEBDAVPROPERTYINFO
#ifdef SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT
#  define SB_USE_CLASSES_TELWEBDAVPROPERTYINFO_AND_TELWEBDAVSTORAGEOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELWEBDAVPROPERTYINFO */

#ifdef SB_USE_CLASS_TELWEBDAVERRORLIST
#ifdef SB_USE_CLASS_TELWEBDAVLOCKLIST
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELWEBDAVERRORLIST_AND_TELWEBDAVLOCKLIST_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELWEBDAVLOCKLIST */
#endif /* SB_USE_CLASS_TELWEBDAVERRORLIST */

#ifdef SB_USE_CLASS_TELWEBDAVERRORLIST
#ifdef SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELWEBDAVERRORLIST_AND_TELWEBDAVSTORAGEOBJECT_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELWEBDAVERRORLIST */

#ifdef SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELWEBDAVSTORAGEOBJECT_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELWEBDAVLOCKLIST
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELWEBDAVLOCKLIST_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELWEBDAVLOCKLIST */

#ifdef SB_USE_CLASS_TELWEBDAVLOCKLIST
#ifdef SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELWEBDAVLOCKLIST_AND_TELWEBDAVSTORAGEOBJECT_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELWEBDAVLOCKLIST */

#ifdef SB_USE_CLASS_TELWEBDAVLOCK
#ifdef SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT
#  define SB_USE_CLASSES_TELWEBDAVLOCK_AND_TELWEBDAVSTORAGEOBJECT
#endif /* SB_USE_CLASS_TELWEBDAVSTORAGEOBJECT */
#endif /* SB_USE_CLASS_TELWEBDAVLOCK */

#ifdef SB_USE_CLASS_TELWEBDAVOBJECTLIST
#ifdef SB_USE_CLASS_TELWEBDAVPROPERTYINFO
#ifdef SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST
#  define SB_USE_CLASSES_TELWEBDAVOBJECTLIST_AND_TELWEBDAVPROPERTYINFO_AND_TELWEBDAVPROPERTYINFOLIST
#endif /* SB_USE_CLASS_TELWEBDAVPROPERTYINFOLIST */
#endif /* SB_USE_CLASS_TELWEBDAVPROPERTYINFO */
#endif /* SB_USE_CLASS_TELWEBDAVOBJECTLIST */

#ifdef SB_USE_CLASS_TELVCARD
#ifdef SB_USE_CLASS_TELWEBDAVERRORLIST
#ifdef SB_USE_CLASS_TELWEBDAVLOCKLIST
#  define SB_USE_CLASSES_TELVCARD_AND_TELWEBDAVERRORLIST_AND_TELWEBDAVLOCKLIST
#endif /* SB_USE_CLASS_TELWEBDAVLOCKLIST */
#endif /* SB_USE_CLASS_TELWEBDAVERRORLIST */
#endif /* SB_USE_CLASS_TELVCARD */

#ifdef SB_USE_CLASS_TELVCARD
#ifdef SB_USE_CLASS_TELWEBDAVLOCKLIST
#  define SB_USE_CLASSES_TELVCARD_AND_TELWEBDAVLOCKLIST
#endif /* SB_USE_CLASS_TELWEBDAVLOCKLIST */
#endif /* SB_USE_CLASS_TELVCARD */

#ifdef SB_USE_CLASS_TELXMLDOMDOCUMENT
#ifdef SB_USE_CLASS_TELXMLDOMNODE
#  define SB_USE_CLASSES_TELXMLDOMDOCUMENT_AND_TELXMLDOMNODE
#endif /* SB_USE_CLASS_TELXMLDOMNODE */
#endif /* SB_USE_CLASS_TELXMLDOMDOCUMENT */

#ifdef SB_USE_CLASS_TELXMLDOMELEMENT
#ifdef SB_USE_CLASS_TELXMLDOMNODE
#  define SB_USE_CLASSES_TELXMLDOMELEMENT_AND_TELXMLDOMNODE
#endif /* SB_USE_CLASS_TELXMLDOMNODE */
#endif /* SB_USE_CLASS_TELXMLDOMELEMENT */

#ifdef SB_USE_CLASS_TELWEBDAVLOCK
#ifdef SB_USE_CLASS_TLIST
#  define SB_USE_CLASSES_TELWEBDAVLOCK_AND_TLIST
#endif /* SB_USE_CLASS_TLIST */
#endif /* SB_USE_CLASS_TELWEBDAVLOCK */

#ifdef SB_USE_CLASS_TELSIMPLEFTPSCLIENT
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELSIMPLEFTPSCLIENT_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELSIMPLEFTPSCLIENT */

#ifdef SB_USE_CLASS_TELMULTIPARTSTREAMACCESS
#ifdef SB_USE_CLASS_TELSIMPLEFTPSCLIENT
#  define SB_USE_CLASSES_TELMULTIPARTSTREAMACCESS_AND_TELSIMPLEFTPSCLIENT
#endif /* SB_USE_CLASS_TELSIMPLEFTPSCLIENT */
#endif /* SB_USE_CLASS_TELMULTIPARTSTREAMACCESS */

#ifdef SB_USE_CLASS_TELSOCKET
#ifdef SB_USE_CLASS_TELWEBSOCKETCLIENT
#  define SB_USE_CLASSES_TELSOCKET_AND_TELWEBSOCKETCLIENT
#endif /* SB_USE_CLASS_TELWEBSOCKETCLIENT */
#endif /* SB_USE_CLASS_TELSOCKET */

#ifdef SB_USE_CLASS_TELOAUTH2REQUEST
#ifdef SB_WINDOWS
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELOAUTH2REQUEST_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#else
#ifdef SB_USE_CLASS_TELSTRINGLIST
#  define SB_USE_CLASSES_TELOAUTH2REQUEST_AND_TELSTRINGLIST
#endif /* SB_USE_CLASS_TELSTRINGLIST */
#endif
#endif /* SB_USE_CLASS_TELOAUTH2REQUEST */

#ifdef SB_USE_CLASS_TELHTTPSERVERREQUESTPARAMS
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELHTTPSERVERREQUESTPARAMS_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELHTTPSERVERREQUESTPARAMS */

#ifdef SB_USE_CLASS_TELHTTPSERVERREQUESTPARAMS
#ifdef SB_USE_CLASS_TELHTTPSERVERRESPONSEPARAMS
#  define SB_USE_CLASSES_TELHTTPSERVERREQUESTPARAMS_AND_TELHTTPSERVERRESPONSEPARAMS
#endif /* SB_USE_CLASS_TELHTTPSERVERRESPONSEPARAMS */
#endif /* SB_USE_CLASS_TELHTTPSERVERREQUESTPARAMS */

#ifdef SB_USE_CLASS_TELHTTPSERVERREQUESTPARAMS
#ifdef SB_USE_CLASS_TELMULTIPARTFORMLIST
#  define SB_USE_CLASSES_TELHTTPSERVERREQUESTPARAMS_AND_TELMULTIPARTFORMLIST
#endif /* SB_USE_CLASS_TELMULTIPARTFORMLIST */
#endif /* SB_USE_CLASS_TELHTTPSERVERREQUESTPARAMS */

#ifdef SB_USE_CLASS_TELHTTPSERVERREQUESTPARAMS
#ifdef SB_USE_CLASS_TELMULTIPARTFORMLIST
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELHTTPSERVERREQUESTPARAMS_AND_TELMULTIPARTFORMLIST_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELMULTIPARTFORMLIST */
#endif /* SB_USE_CLASS_TELHTTPSERVERREQUESTPARAMS */

#ifdef SB_USE_CLASS_TELLDAPRESPONSE
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELLDAPRESPONSE_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TELLDAPRESPONSE */

#ifdef SB_USE_CLASS_TELLDAPRESPONSE
#ifdef SB_USE_CLASS_TELLDAPSSEARCHFILTER
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELLDAPRESPONSE_AND_TELLDAPSSEARCHFILTER_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TELLDAPSSEARCHFILTER */
#endif /* SB_USE_CLASS_TELLDAPRESPONSE */

#ifdef SB_USE_CLASS_TELMESSAGEPART
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELMESSAGEPART_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELMESSAGEPART */

#ifdef SB_USE_CLASS_TELMESSAGE
#ifdef SB_USE_CLASS_TELMESSAGEHEADER
#  define SB_USE_CLASSES_TELMESSAGE_AND_TELMESSAGEHEADER
#endif /* SB_USE_CLASS_TELMESSAGEHEADER */
#endif /* SB_USE_CLASS_TELMESSAGE */

#ifdef SB_USE_CLASS_TELMESSAGEHEADER
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELMESSAGEHEADER_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELMESSAGEHEADER */

#ifdef SB_USE_CLASS_TELCOMPOUNDFILESTORAGE
#ifdef SB_USE_CLASS_TELCOMPOUNDFILESTREAMENTRY
#  define SB_USE_CLASSES_TELCOMPOUNDFILESTORAGE_AND_TELCOMPOUNDFILESTREAMENTRY
#endif /* SB_USE_CLASS_TELCOMPOUNDFILESTREAMENTRY */
#endif /* SB_USE_CLASS_TELCOMPOUNDFILESTORAGE */

#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TELOFFICEBINARYCUSTOMSIGNATUREHANDLER
#  define SB_USE_CLASSES_TELDCASYNCSTATE_AND_TELOFFICEBINARYCUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOFFICEBINARYCUSTOMSIGNATUREHANDLER */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */

#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMSIGNATUREHANDLER
#  define SB_USE_CLASSES_TELDCASYNCSTATE_AND_TELOFFICEOPENXMLCUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMSIGNATUREHANDLER */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */

#ifdef SB_USE_CLASS_TELZIPREADER
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELZIPREADER_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELZIPREADER */

#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TELOPENOFFICECUSTOMSIGNATUREHANDLER
#  define SB_USE_CLASSES_TELDCASYNCSTATE_AND_TELOPENOFFICECUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOPENOFFICECUSTOMSIGNATUREHANDLER */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */

#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TELOFFICECUSTOMSIGNATUREHANDLER
#  define SB_USE_CLASSES_TELDCASYNCSTATE_AND_TELOFFICECUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELOFFICECUSTOMSIGNATUREHANDLER */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */

#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#  define SB_USE_CLASSES_TELDCASYNCSTATE_AND_TELX509CERTIFICATE
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */

#ifdef SB_USE_CLASS_TELCUSTOMTSPCLIENT
#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#  define SB_USE_CLASSES_TELCUSTOMTSPCLIENT_AND_TELX509CERTIFICATE
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */
#endif /* SB_USE_CLASS_TELCUSTOMTSPCLIENT */

#ifdef SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#  define SB_USE_CLASSES_TELCUSTOMCERTSTORAGE_AND_TELDCASYNCSTATE
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */
#endif /* SB_USE_CLASS_TELCUSTOMCERTSTORAGE */

#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TELXMLKEYINFODATA
#  define SB_USE_CLASSES_TELDCASYNCSTATE_AND_TELXMLKEYINFODATA
#endif /* SB_USE_CLASS_TELXMLKEYINFODATA */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */

#ifdef SB_USE_CLASS_TELXMLCUSTOMFORMATTER
#ifdef SB_USE_CLASS_TELXMLDOMDOCUMENT
#ifdef SB_USE_CLASS_TELXMLDOMELEMENT
#  define SB_USE_CLASSES_TELXMLCUSTOMFORMATTER_AND_TELXMLDOMDOCUMENT_AND_TELXMLDOMELEMENT
#endif /* SB_USE_CLASS_TELXMLDOMELEMENT */
#endif /* SB_USE_CLASS_TELXMLDOMDOCUMENT */
#endif /* SB_USE_CLASS_TELXMLCUSTOMFORMATTER */

#ifdef SB_USE_CLASS_TELXMLDOMNODE
#ifdef SB_USE_CLASS_TELXMLDOMNODELIST
#  define SB_USE_CLASSES_TELXMLDOMNODE_AND_TELXMLDOMNODELIST
#endif /* SB_USE_CLASS_TELXMLDOMNODELIST */
#endif /* SB_USE_CLASS_TELXMLDOMNODE */

#ifdef SB_USE_CLASS_TELXMLCUSTOMFORMATTER
#ifdef SB_USE_CLASS_TELXMLDOMDOCUMENT
#ifdef SB_USE_CLASS_TELXMLOBJECTLIST
#  define SB_USE_CLASSES_TELXMLCUSTOMFORMATTER_AND_TELXMLDOMDOCUMENT_AND_TELXMLOBJECTLIST
#endif /* SB_USE_CLASS_TELXMLOBJECTLIST */
#endif /* SB_USE_CLASS_TELXMLDOMDOCUMENT */
#endif /* SB_USE_CLASS_TELXMLCUSTOMFORMATTER */

#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TELPDFSECURITYHANDLER
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELDCASYNCSTATE_AND_TELPDFSECURITYHANDLER_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELPDFSECURITYHANDLER */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */

#ifdef SB_USE_CLASS_TELPDFARRAY
#ifdef SB_USE_CLASS_TELPDFDICTIONARY
#  define SB_USE_CLASSES_TELPDFARRAY_AND_TELPDFDICTIONARY
#endif /* SB_USE_CLASS_TELPDFDICTIONARY */
#endif /* SB_USE_CLASS_TELPDFARRAY */

#ifdef SB_USE_CLASS_TELPDFDICTIONARY
#ifdef SB_USE_CLASS_TELPDFSTRING
#  define SB_USE_CLASSES_TELPDFDICTIONARY_AND_TELPDFSTRING
#endif /* SB_USE_CLASS_TELPDFSTRING */
#endif /* SB_USE_CLASS_TELPDFDICTIONARY */

#ifdef SB_USE_CLASS_TELPDFDICTIONARY
#ifdef SB_USE_CLASS_TELPDFREF
#  define SB_USE_CLASSES_TELPDFDICTIONARY_AND_TELPDFREF
#endif /* SB_USE_CLASS_TELPDFREF */
#endif /* SB_USE_CLASS_TELPDFDICTIONARY */

#ifdef SB_USE_CLASS_TELPDFFILE
#ifdef SB_USE_CLASS_TELPDFSTREAM
#  define SB_USE_CLASSES_TELPDFFILE_AND_TELPDFSTREAM
#endif /* SB_USE_CLASS_TELPDFSTREAM */
#endif /* SB_USE_CLASS_TELPDFFILE */

#ifdef SB_USE_CLASS_TELPDFDICTIONARY
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TELPDFDICTIONARY_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TELPDFDICTIONARY */

#ifdef SB_USE_CLASS_TELPDFPUBLICKEYSECURITYHANDLER
#ifdef SB_USE_CLASS_TELPKCS7MESSAGE
#  define SB_USE_CLASSES_TELPDFPUBLICKEYSECURITYHANDLER_AND_TELPKCS7MESSAGE
#endif /* SB_USE_CLASS_TELPKCS7MESSAGE */
#endif /* SB_USE_CLASS_TELPDFPUBLICKEYSECURITYHANDLER */

#ifdef SB_USE_CLASS_TLIST
#ifdef SB_USE_CLASS_TSTREAM
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TLIST_AND_TSTREAM_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TLIST */

#ifdef SB_USE_CLASS_TELPGPCUSTOMUSER
#ifdef SB_USE_CLASS_TELPGPSIGNATURE
#  define SB_USE_CLASSES_TELPGPCUSTOMUSER_AND_TELPGPSIGNATURE
#endif /* SB_USE_CLASS_TELPGPSIGNATURE */
#endif /* SB_USE_CLASS_TELPGPCUSTOMUSER */

#ifdef SB_USE_CLASS_TELHASHFUNCTION
#ifdef SB_USE_CLASS_TELPGPSIGNATURE
#  define SB_USE_CLASSES_TELHASHFUNCTION_AND_TELPGPSIGNATURE
#endif /* SB_USE_CLASS_TELPGPSIGNATURE */
#endif /* SB_USE_CLASS_TELHASHFUNCTION */

#ifdef SB_USE_CLASS_TELPGPCUSTOMUSER
#ifdef SB_USE_CLASS_TELPGPPUBLICKEY
#ifdef SB_USE_CLASS_TELPGPSIGNATURE
#  define SB_USE_CLASSES_TELPGPCUSTOMUSER_AND_TELPGPPUBLICKEY_AND_TELPGPSIGNATURE
#endif /* SB_USE_CLASS_TELPGPSIGNATURE */
#endif /* SB_USE_CLASS_TELPGPPUBLICKEY */
#endif /* SB_USE_CLASS_TELPGPCUSTOMUSER */

#ifdef SB_USE_CLASS_TELPGPCUSTOMPUBLICKEY
#ifdef SB_USE_CLASS_TELPGPSIGNATURE
#  define SB_USE_CLASSES_TELPGPCUSTOMPUBLICKEY_AND_TELPGPSIGNATURE
#endif /* SB_USE_CLASS_TELPGPSIGNATURE */
#endif /* SB_USE_CLASS_TELPGPCUSTOMPUBLICKEY */

#ifdef SB_USE_CLASS_TLIST
#ifdef SB_USE_CLASS_TSTRINGLIST
#  define SB_USE_CLASSES_TLIST_AND_TSTRINGLIST
#endif /* SB_USE_CLASS_TSTRINGLIST */
#endif /* SB_USE_CLASS_TLIST */

#ifdef SB_USE_CLASS_TELLDAPSKEYSERVERSEARCHFILTER
#ifdef SB_USE_CLASS_TELPGPKEYRING
#  define SB_USE_CLASSES_TELLDAPSKEYSERVERSEARCHFILTER_AND_TELPGPKEYRING
#endif /* SB_USE_CLASS_TELPGPKEYRING */
#endif /* SB_USE_CLASS_TELLDAPSKEYSERVERSEARCHFILTER */

#ifdef SB_USE_CLASS_TELMEMORYCRLSTORAGE
#ifdef SB_USE_CLASS_TLIST
#  define SB_USE_CLASSES_TELMEMORYCRLSTORAGE_AND_TLIST
#endif /* SB_USE_CLASS_TLIST */
#endif /* SB_USE_CLASS_TELMEMORYCRLSTORAGE */

#ifdef SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#ifdef SB_USE_CLASS_TELMEMORYCRLSTORAGE
#ifdef SB_USE_CLASS_TLIST
#  define SB_USE_CLASSES_TELCUSTOMCERTSTORAGE_AND_TELMEMORYCRLSTORAGE_AND_TLIST
#endif /* SB_USE_CLASS_TLIST */
#endif /* SB_USE_CLASS_TELMEMORYCRLSTORAGE */
#endif /* SB_USE_CLASS_TELCUSTOMCERTSTORAGE */

#ifdef SB_USE_CLASS_TELMEMORYCRLSTORAGE
#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#ifdef SB_USE_CLASS_TLIST
#  define SB_USE_CLASSES_TELMEMORYCRLSTORAGE_AND_TELX509CERTIFICATE_AND_TLIST
#endif /* SB_USE_CLASS_TLIST */
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */
#endif /* SB_USE_CLASS_TELMEMORYCRLSTORAGE */

#ifdef SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#  define SB_USE_CLASSES_TELCUSTOMCERTSTORAGE_AND_TELDCASYNCSTATE_AND_TELX509CERTIFICATE
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */
#endif /* SB_USE_CLASS_TELCUSTOMCERTSTORAGE */

#ifdef SB_USE_CLASS_TELPKCS11CONSUMER
#ifdef SB_USE_CLASS_TELPKCS11SESSIONINFO
#  define SB_USE_CLASSES_TELPKCS11CONSUMER_AND_TELPKCS11SESSIONINFO
#endif /* SB_USE_CLASS_TELPKCS11SESSIONINFO */
#endif /* SB_USE_CLASS_TELPKCS11CONSUMER */

#ifdef SB_USE_CLASS_TELPKCS11ATTRIBUTELIST
#ifdef SB_USE_CLASS_TELPKCS11OBJECT
#  define SB_USE_CLASSES_TELPKCS11ATTRIBUTELIST_AND_TELPKCS11OBJECT
#endif /* SB_USE_CLASS_TELPKCS11OBJECT */
#endif /* SB_USE_CLASS_TELPKCS11ATTRIBUTELIST */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#ifdef SB_USE_CLASS_TELPKCS11MODULE
#ifdef SB_USE_CLASS_TELPKCS11SESSIONINFO
#ifdef SB_USE_CLASS_TELPKCS11SLOTINFO
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOPROVIDER_AND_TELPKCS11MODULE_AND_TELPKCS11SESSIONINFO_AND_TELPKCS11SLOTINFO
#endif /* SB_USE_CLASS_TELPKCS11SLOTINFO */
#endif /* SB_USE_CLASS_TELPKCS11SESSIONINFO */
#endif /* SB_USE_CLASS_TELPKCS11MODULE */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER */

#ifdef SB_IOS
#ifdef SB_USE_CLASS_TELPKCS11FUNCTIONSMANAGER
#ifdef SB_USE_CLASS_TELPKCS11MODULE
#  define SB_USE_CLASSES_TELPKCS11FUNCTIONSMANAGER_AND_TELPKCS11MODULE
#endif /* SB_USE_CLASS_TELPKCS11MODULE */
#endif /* SB_USE_CLASS_TELPKCS11FUNCTIONSMANAGER */
#else
#ifdef SB_USE_CLASS_TELPKCS11MODULE
#ifdef SB_USE_CLASS_TELPKCS11NSSPARAMS
#  define SB_USE_CLASSES_TELPKCS11MODULE_AND_TELPKCS11NSSPARAMS
#endif /* SB_USE_CLASS_TELPKCS11NSSPARAMS */
#endif /* SB_USE_CLASS_TELPKCS11MODULE */
#endif

#ifdef SB_IOS
#ifdef SB_USE_CLASS_TELPKCS11FUNCTIONSMANAGER
#ifdef SB_USE_CLASS_TELPKCS11MODULE
#ifdef SB_USE_CLASS_TELPKCS11NSSPARAMS
#  define SB_USE_CLASSES_TELPKCS11FUNCTIONSMANAGER_AND_TELPKCS11MODULE_AND_TELPKCS11NSSPARAMS
#endif /* SB_USE_CLASS_TELPKCS11NSSPARAMS */
#endif /* SB_USE_CLASS_TELPKCS11MODULE */
#endif /* SB_USE_CLASS_TELPKCS11FUNCTIONSMANAGER */
#endif

#ifdef SB_USE_CLASS_TELPKCS11PRIVATEKEYOBJECT
#ifdef SB_USE_CLASS_TELPKCS11PUBLICKEYOBJECT
#ifdef SB_USE_CLASS_TELPKCS11X509CERTIFICATEOBJECT
#  define SB_USE_CLASSES_TELPKCS11PRIVATEKEYOBJECT_AND_TELPKCS11PUBLICKEYOBJECT_AND_TELPKCS11X509CERTIFICATEOBJECT
#endif /* SB_USE_CLASS_TELPKCS11X509CERTIFICATEOBJECT */
#endif /* SB_USE_CLASS_TELPKCS11PUBLICKEYOBJECT */
#endif /* SB_USE_CLASS_TELPKCS11PRIVATEKEYOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11STGCTX
#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#  define SB_USE_CLASSES_TELPKCS11STGCTX_AND_TELX509CERTIFICATE
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */
#endif /* SB_USE_CLASS_TELPKCS11STGCTX */

#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELX509CERTIFICATE_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */

#ifdef SB_USE_CLASS_TELALGORITHMIDENTIFIER
#ifdef SB_USE_CLASS_TELCERTIFICATEREQUEST
#  define SB_USE_CLASSES_TELALGORITHMIDENTIFIER_AND_TELCERTIFICATEREQUEST
#endif /* SB_USE_CLASS_TELCERTIFICATEREQUEST */
#endif /* SB_USE_CLASS_TELALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#ifdef SB_USE_CLASS_TELCUSTOMTSPCLIENT
#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#  define SB_USE_CLASSES_TELCUSTOMCERTSTORAGE_AND_TELCUSTOMTSPCLIENT_AND_TELX509CERTIFICATE
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */
#endif /* SB_USE_CLASS_TELCUSTOMTSPCLIENT */
#endif /* SB_USE_CLASS_TELCUSTOMCERTSTORAGE */

#ifdef SB_USE_CLASS_TELCERTIFICATEREQUEST
#ifdef SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#  define SB_USE_CLASSES_TELCERTIFICATEREQUEST_AND_TELCUSTOMCERTSTORAGE
#endif /* SB_USE_CLASS_TELCUSTOMCERTSTORAGE */
#endif /* SB_USE_CLASS_TELCERTIFICATEREQUEST */

#ifdef SB_USE_CLASS_TELSFTPSERVER
#ifdef SB_USE_CLASS_TELSSHTUNNELCONNECTION
#  define SB_USE_CLASSES_TELSFTPSERVER_AND_TELSSHTUNNELCONNECTION
#endif /* SB_USE_CLASS_TELSSHTUNNELCONNECTION */
#endif /* SB_USE_CLASS_TELSFTPSERVER */

#ifdef SB_USE_CLASS_TELSSHKEY
#ifdef SB_USE_CLASS_TELSSHPUBLICKEYATTRIBUTES
#  define SB_USE_CLASSES_TELSSHKEY_AND_TELSSHPUBLICKEYATTRIBUTES
#endif /* SB_USE_CLASS_TELSSHPUBLICKEYATTRIBUTES */
#endif /* SB_USE_CLASS_TELSSHKEY */

#ifdef SB_USE_CLASS_TELSSHKEY
#ifdef SB_USE_CLASS_TELUSERS
#  define SB_USE_CLASSES_TELSSHKEY_AND_TELUSERS
#endif /* SB_USE_CLASS_TELUSERS */
#endif /* SB_USE_CLASS_TELSSHKEY */

#ifdef SB_USE_CLASS_TELSSHPUBLICKEYSERVER
#ifdef SB_USE_CLASS_TELSSHTUNNELCONNECTION
#  define SB_USE_CLASSES_TELSSHPUBLICKEYSERVER_AND_TELSSHTUNNELCONNECTION
#endif /* SB_USE_CLASS_TELSSHTUNNELCONNECTION */
#endif /* SB_USE_CLASS_TELSSHPUBLICKEYSERVER */

#ifdef SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#ifdef SB_USE_CLASS_TELX509CERTIFICATECHAIN
#  define SB_USE_CLASSES_TELCUSTOMCERTSTORAGE_AND_TELX509CERTIFICATECHAIN
#endif /* SB_USE_CLASS_TELX509CERTIFICATECHAIN */
#endif /* SB_USE_CLASS_TELCUSTOMCERTSTORAGE */

#ifdef SB_USE_CLASS_TELXMLDOMDOCUMENT
#ifdef SB_USE_CLASS_TELXMLDOMDOCUMENTTYPE
#  define SB_USE_CLASSES_TELXMLDOMDOCUMENT_AND_TELXMLDOMDOCUMENTTYPE
#endif /* SB_USE_CLASS_TELXMLDOMDOCUMENTTYPE */
#endif /* SB_USE_CLASS_TELXMLDOMDOCUMENT */

#ifdef SB_USE_CLASS_TELXMLNAMESPACEMAP
#ifdef SB_USE_CLASS_TELXMLNODESET
#  define SB_USE_CLASSES_TELXMLNAMESPACEMAP_AND_TELXMLNODESET
#endif /* SB_USE_CLASS_TELXMLNODESET */
#endif /* SB_USE_CLASS_TELXMLNAMESPACEMAP */

#ifdef SB_USE_CLASS_TELXMLCODEC
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELXMLCODEC_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELXMLCODEC */

#ifdef SB_USE_CLASS_TELXMLCUSTOMELEMENT
#ifdef SB_USE_CLASS_TELXMLDOMDOCUMENT
#ifdef SB_USE_CLASS_TELXMLDOMELEMENT
#  define SB_USE_CLASSES_TELXMLCUSTOMELEMENT_AND_TELXMLDOMDOCUMENT_AND_TELXMLDOMELEMENT
#endif /* SB_USE_CLASS_TELXMLDOMELEMENT */
#endif /* SB_USE_CLASS_TELXMLDOMDOCUMENT */
#endif /* SB_USE_CLASS_TELXMLCUSTOMELEMENT */

#ifdef SB_USE_CLASS_TELXMLCUSTOMELEMENT
#ifdef SB_USE_CLASS_TELXMLDOMDOCUMENT
#ifdef SB_USE_CLASS_TELXMLDOMELEMENT
#ifdef SB_USE_CLASS_TELXMLDOMNODE
#  define SB_USE_CLASSES_TELXMLCUSTOMELEMENT_AND_TELXMLDOMDOCUMENT_AND_TELXMLDOMELEMENT_AND_TELXMLDOMNODE
#endif /* SB_USE_CLASS_TELXMLDOMNODE */
#endif /* SB_USE_CLASS_TELXMLDOMELEMENT */
#endif /* SB_USE_CLASS_TELXMLDOMDOCUMENT */
#endif /* SB_USE_CLASS_TELXMLCUSTOMELEMENT */

#ifdef SB_USE_CLASS_TELXMLDOMDOCUMENT
#ifdef SB_USE_CLASS_TELXMLDOMELEMENT
#  define SB_USE_CLASSES_TELXMLDOMDOCUMENT_AND_TELXMLDOMELEMENT
#endif /* SB_USE_CLASS_TELXMLDOMELEMENT */
#endif /* SB_USE_CLASS_TELXMLDOMDOCUMENT */

#ifdef SB_USE_CLASS_TELXMLDOMNODE
#ifdef SB_USE_CLASS_TELXMLNAMESPACEMAP
#ifdef SB_USE_CLASS_TELXMLNODESET
#ifdef SB_USE_CLASS_TELXMLVARMAP
#  define SB_USE_CLASSES_TELXMLDOMNODE_AND_TELXMLNAMESPACEMAP_AND_TELXMLNODESET_AND_TELXMLVARMAP
#endif /* SB_USE_CLASS_TELXMLVARMAP */
#endif /* SB_USE_CLASS_TELXMLNODESET */
#endif /* SB_USE_CLASS_TELXMLNAMESPACEMAP */
#endif /* SB_USE_CLASS_TELXMLDOMNODE */

#ifdef SB_USE_CLASS_TELNUMBER
#ifdef SB_USE_CLASS_TELXMLDOMNODE
#ifdef SB_USE_CLASS_TLIST
#  define SB_USE_CLASSES_TELNUMBER_AND_TELXMLDOMNODE_AND_TLIST
#endif /* SB_USE_CLASS_TLIST */
#endif /* SB_USE_CLASS_TELXMLDOMNODE */
#endif /* SB_USE_CLASS_TELNUMBER */

#ifdef SB_USE_CLASS_TELBOOLEAN
#ifdef SB_USE_CLASS_TELXMLDOMNODE
#ifdef SB_USE_CLASS_TLIST
#  define SB_USE_CLASSES_TELBOOLEAN_AND_TELXMLDOMNODE_AND_TLIST
#endif /* SB_USE_CLASS_TLIST */
#endif /* SB_USE_CLASS_TELXMLDOMNODE */
#endif /* SB_USE_CLASS_TELBOOLEAN */

#ifdef SB_USE_CLASS_TELSTRING
#ifdef SB_USE_CLASS_TELXMLDOMNODE
#ifdef SB_USE_CLASS_TLIST
#  define SB_USE_CLASSES_TELSTRING_AND_TELXMLDOMNODE_AND_TLIST
#endif /* SB_USE_CLASS_TLIST */
#endif /* SB_USE_CLASS_TELXMLDOMNODE */
#endif /* SB_USE_CLASS_TELSTRING */

#ifdef SB_USE_CLASS_TELBOOLEAN
#ifdef SB_USE_CLASS_TELNUMBER
#ifdef SB_USE_CLASS_TELSTRING
#ifdef SB_USE_CLASS_TELXMLDOMNODE
#ifdef SB_USE_CLASS_TLIST
#  define SB_USE_CLASSES_TELBOOLEAN_AND_TELNUMBER_AND_TELSTRING_AND_TELXMLDOMNODE_AND_TLIST
#endif /* SB_USE_CLASS_TLIST */
#endif /* SB_USE_CLASS_TELXMLDOMNODE */
#endif /* SB_USE_CLASS_TELSTRING */
#endif /* SB_USE_CLASS_TELNUMBER */
#endif /* SB_USE_CLASS_TELBOOLEAN */

#ifdef SB_USE_CLASS_TELXMLDOMDOCUMENT
#ifdef SB_USE_CLASS_TELXMLDOMNODELIST
#  define SB_USE_CLASSES_TELXMLDOMDOCUMENT_AND_TELXMLDOMNODELIST
#endif /* SB_USE_CLASS_TELXMLDOMNODELIST */
#endif /* SB_USE_CLASS_TELXMLDOMDOCUMENT */

#ifdef SB_USE_CLASS_TELCLIENTTSPINFO
#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER
#  define SB_USE_CLASSES_TELCLIENTTSPINFO_AND_TELCUSTOMCRYPTOPROVIDER_AND_TELCUSTOMCRYPTOPROVIDERMANAGER
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER */
#endif /* SB_USE_CLASS_TELCLIENTTSPINFO */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER
#ifdef SB_USE_CLASS_TELCUSTOMTSPCLIENT
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOPROVIDER_AND_TELCUSTOMCRYPTOPROVIDERMANAGER_AND_TELCUSTOMTSPCLIENT
#endif /* SB_USE_CLASS_TELCUSTOMTSPCLIENT */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELCLIENTTSPINFO
#ifdef SB_USE_CLASS_TELXMLCUSTOMFORMATTER
#  define SB_USE_CLASSES_TELCLIENTTSPINFO_AND_TELXMLCUSTOMFORMATTER
#endif /* SB_USE_CLASS_TELXMLCUSTOMFORMATTER */
#endif /* SB_USE_CLASS_TELCLIENTTSPINFO */

#ifdef SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#ifdef SB_USE_CLASS_TELCUSTOMCRLSTORAGE
#ifdef SB_USE_CLASS_TELXMLCUSTOMFORMATTER
#ifdef SB_USE_CLASS_TLIST
#  define SB_USE_CLASSES_TELCUSTOMCERTSTORAGE_AND_TELCUSTOMCRLSTORAGE_AND_TELXMLCUSTOMFORMATTER_AND_TLIST
#endif /* SB_USE_CLASS_TLIST */
#endif /* SB_USE_CLASS_TELXMLCUSTOMFORMATTER */
#endif /* SB_USE_CLASS_TELCUSTOMCRLSTORAGE */
#endif /* SB_USE_CLASS_TELCUSTOMCERTSTORAGE */

#ifdef SB_USE_CLASS_TELXMLCUSTOMFORMATTER
#ifdef SB_USE_CLASS_TELXMLPROCESSOR
#  define SB_USE_CLASSES_TELXMLCUSTOMFORMATTER_AND_TELXMLPROCESSOR
#endif /* SB_USE_CLASS_TELXMLPROCESSOR */
#endif /* SB_USE_CLASS_TELXMLCUSTOMFORMATTER */

#ifdef SB_USE_CLASS_TELCUSTOMTSPCLIENT
#ifdef SB_USE_CLASS_TELXMLCUSTOMFORMATTER
#  define SB_USE_CLASSES_TELCUSTOMTSPCLIENT_AND_TELXMLCUSTOMFORMATTER
#endif /* SB_USE_CLASS_TELXMLCUSTOMFORMATTER */
#endif /* SB_USE_CLASS_TELCUSTOMTSPCLIENT */

#ifdef SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#ifdef SB_USE_CLASS_TELXMLCUSTOMFORMATTER
#  define SB_USE_CLASSES_TELCUSTOMCERTSTORAGE_AND_TELXMLCUSTOMFORMATTER
#endif /* SB_USE_CLASS_TELXMLCUSTOMFORMATTER */
#endif /* SB_USE_CLASS_TELCUSTOMCERTSTORAGE */

#ifdef SB_USE_CLASS_TELCUSTOMCRLSTORAGE
#ifdef SB_USE_CLASS_TLIST
#  define SB_USE_CLASSES_TELCUSTOMCRLSTORAGE_AND_TLIST
#endif /* SB_USE_CLASS_TLIST */
#endif /* SB_USE_CLASS_TELCUSTOMCRLSTORAGE */

#ifdef SB_USE_CLASS_TELCUSTOMCRLSTORAGE
#ifdef SB_USE_CLASS_TELXMLCUSTOMFORMATTER
#ifdef SB_USE_CLASS_TLIST
#  define SB_USE_CLASSES_TELCUSTOMCRLSTORAGE_AND_TELXMLCUSTOMFORMATTER_AND_TLIST
#endif /* SB_USE_CLASS_TLIST */
#endif /* SB_USE_CLASS_TELXMLCUSTOMFORMATTER */
#endif /* SB_USE_CLASS_TELCUSTOMCRLSTORAGE */

#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#ifdef SB_USE_CLASS_TELXMLCUSTOMFORMATTER
#  define SB_USE_CLASSES_TELX509CERTIFICATE_AND_TELXMLCUSTOMFORMATTER
#endif /* SB_USE_CLASS_TELXMLCUSTOMFORMATTER */
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */

#ifdef SB_USE_CLASS_TELXMLCUSTOMFORMATTER
#ifdef SB_USE_CLASS_TELXMLREFERENCELIST
#  define SB_USE_CLASSES_TELXMLCUSTOMFORMATTER_AND_TELXMLREFERENCELIST
#endif /* SB_USE_CLASS_TELXMLREFERENCELIST */
#endif /* SB_USE_CLASS_TELXMLCUSTOMFORMATTER */

#ifdef SB_USE_CLASS_TELXMLCUSTOMFORMATTER
#ifdef SB_USE_CLASS_TELXMLDOMELEMENT
#ifdef SB_USE_CLASS_TELXMLKEYINFO
#ifdef SB_USE_CLASS_TELXMLREFERENCELIST
#  define SB_USE_CLASSES_TELXMLCUSTOMFORMATTER_AND_TELXMLDOMELEMENT_AND_TELXMLKEYINFO_AND_TELXMLREFERENCELIST
#endif /* SB_USE_CLASS_TELXMLREFERENCELIST */
#endif /* SB_USE_CLASS_TELXMLKEYINFO */
#endif /* SB_USE_CLASS_TELXMLDOMELEMENT */
#endif /* SB_USE_CLASS_TELXMLCUSTOMFORMATTER */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER
#ifdef SB_USE_CLASS_TELXMLALGORITHMPARAMETERS
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOPROVIDER_AND_TELCUSTOMCRYPTOPROVIDERMANAGER_AND_TELXMLALGORITHMPARAMETERS
#endif /* SB_USE_CLASS_TELXMLALGORITHMPARAMETERS */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER
#ifdef SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELCUSTOMCRYPTOPROVIDER_AND_TELCUSTOMCRYPTOPROVIDERMANAGER_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDERMANAGER */
#endif /* SB_USE_CLASS_TELCUSTOMCRYPTOPROVIDER */

#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TELXMLDOMDOCUMENT
#  define SB_USE_CLASSES_TELDCASYNCSTATE_AND_TELXMLDOMDOCUMENT
#endif /* SB_USE_CLASS_TELXMLDOMDOCUMENT */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */

#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TELXMLDOMNODE
#  define SB_USE_CLASSES_TELDCASYNCSTATE_AND_TELXMLDOMNODE
#endif /* SB_USE_CLASS_TELXMLDOMNODE */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */

#ifdef SB_USE_CLASS_TELXMLDOMELEMENT
#ifdef SB_USE_CLASS_TELXMLSOAPHEADERBLOCK
#  define SB_USE_CLASSES_TELXMLDOMELEMENT_AND_TELXMLSOAPHEADERBLOCK
#endif /* SB_USE_CLASS_TELXMLSOAPHEADERBLOCK */
#endif /* SB_USE_CLASS_TELXMLDOMELEMENT */

#ifdef SB_USE_CLASS_TELXMLCUSTOMFORMATTER
#ifdef SB_USE_CLASS_TELXMLDOMDOCUMENT
#ifdef SB_USE_CLASS_TELXMLDOMNODE
#  define SB_USE_CLASSES_TELXMLCUSTOMFORMATTER_AND_TELXMLDOMDOCUMENT_AND_TELXMLDOMNODE
#endif /* SB_USE_CLASS_TELXMLDOMNODE */
#endif /* SB_USE_CLASS_TELXMLDOMDOCUMENT */
#endif /* SB_USE_CLASS_TELXMLCUSTOMFORMATTER */

#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TELXMLSOAPCUSTOMSIGNATUREHANDLER
#  define SB_USE_CLASSES_TELDCASYNCSTATE_AND_TELXMLSOAPCUSTOMSIGNATUREHANDLER
#endif /* SB_USE_CLASS_TELXMLSOAPCUSTOMSIGNATUREHANDLER */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */

#ifdef SB_USE_CLASS_TELXMLDOMELEMENT
#ifdef SB_USE_CLASS_TELXMLSOAPMESSAGE
#  define SB_USE_CLASSES_TELXMLDOMELEMENT_AND_TELXMLSOAPMESSAGE
#endif /* SB_USE_CLASS_TELXMLSOAPMESSAGE */
#endif /* SB_USE_CLASS_TELXMLDOMELEMENT */

#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TELXMLDOMELEMENT
#  define SB_USE_CLASSES_TELDCASYNCSTATE_AND_TELXMLDOMELEMENT
#endif /* SB_USE_CLASS_TELXMLDOMELEMENT */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */

#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#ifdef SB_USE_CLASS_TELXMLDOMELEMENT
#  define SB_USE_CLASSES_TELDCASYNCSTATE_AND_TELX509CERTIFICATE_AND_TELXMLDOMELEMENT
#endif /* SB_USE_CLASS_TELXMLDOMELEMENT */
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */

#ifdef SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TELXMLDOMELEMENT
#  define SB_USE_CLASSES_TELCUSTOMCERTSTORAGE_AND_TELDCASYNCSTATE_AND_TELXMLDOMELEMENT
#endif /* SB_USE_CLASS_TELXMLDOMELEMENT */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */
#endif /* SB_USE_CLASS_TELCUSTOMCERTSTORAGE */

#ifdef SB_USE_CLASS_TELDCASYNCSTATE
#ifdef SB_USE_CLASS_TELXMLDOMELEMENT
#ifdef SB_USE_CLASS_TELXMLKEYINFODATA
#  define SB_USE_CLASSES_TELDCASYNCSTATE_AND_TELXMLDOMELEMENT_AND_TELXMLKEYINFODATA
#endif /* SB_USE_CLASS_TELXMLKEYINFODATA */
#endif /* SB_USE_CLASS_TELXMLDOMELEMENT */
#endif /* SB_USE_CLASS_TELDCASYNCSTATE */

#ifdef SB_USE_CLASS_TELX509CERTIFICATE
#ifdef SB_USE_CLASS_TELXMLDOMELEMENT
#  define SB_USE_CLASSES_TELX509CERTIFICATE_AND_TELXMLDOMELEMENT
#endif /* SB_USE_CLASS_TELXMLDOMELEMENT */
#endif /* SB_USE_CLASS_TELX509CERTIFICATE */

#ifdef SB_USE_CLASS_TELCUSTOMCERTSTORAGE
#ifdef SB_USE_CLASS_TELXMLDOMELEMENT
#  define SB_USE_CLASSES_TELCUSTOMCERTSTORAGE_AND_TELXMLDOMELEMENT
#endif /* SB_USE_CLASS_TELXMLDOMELEMENT */
#endif /* SB_USE_CLASS_TELCUSTOMCERTSTORAGE */

#ifdef SB_USE_CLASS_TELXMLDOMELEMENT
#ifdef SB_USE_CLASS_TELXMLKEYINFODATA
#  define SB_USE_CLASSES_TELXMLDOMELEMENT_AND_TELXMLKEYINFODATA
#endif /* SB_USE_CLASS_TELXMLKEYINFODATA */
#endif /* SB_USE_CLASS_TELXMLDOMELEMENT */

#ifdef SB_USE_CLASS_TELZIPARCHIVEDIRECTORYENTRY
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELZIPARCHIVEDIRECTORYENTRY_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELZIPARCHIVEDIRECTORYENTRY */

#ifdef SB_USE_CLASS_TELZIPLOCALFILEHEADER
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELZIPLOCALFILEHEADER_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELZIPLOCALFILEHEADER */

#ifdef SB_USE_CLASS_TELTARARCHIVEDIRECTORYENTRY
#ifdef SB_USE_CLASS_TELUSTARTARHEADER
#  define SB_USE_CLASSES_TELTARARCHIVEDIRECTORYENTRY_AND_TELUSTARTARHEADER
#endif /* SB_USE_CLASS_TELUSTARTARHEADER */
#endif /* SB_USE_CLASS_TELTARARCHIVEDIRECTORYENTRY */

#ifdef SB_USE_CLASS_TELTARARCHIVEDIRECTORYENTRY
#ifdef SB_USE_CLASS_TELUSTARTARHEADER
#ifdef SB_USE_CLASS_TSTREAM
#  define SB_USE_CLASSES_TELTARARCHIVEDIRECTORYENTRY_AND_TELUSTARTARHEADER_AND_TSTREAM
#endif /* SB_USE_CLASS_TSTREAM */
#endif /* SB_USE_CLASS_TELUSTARTARHEADER */
#endif /* SB_USE_CLASS_TELTARARCHIVEDIRECTORYENTRY */

#ifdef SB_USE_CLASS_TELSAMLSTATUSRESPONSETYPE
#ifdef SB_USE_CLASS_TELXMLDOMDOCUMENT
#  define SB_USE_CLASSES_TELSAMLSTATUSRESPONSETYPE_AND_TELXMLDOMDOCUMENT
#endif /* SB_USE_CLASS_TELXMLDOMDOCUMENT */
#endif /* SB_USE_CLASS_TELSAMLSTATUSRESPONSETYPE */

#ifdef SB_USE_CLASS_TELSAMLREQUESTABSTRACTTYPE
#ifdef SB_USE_CLASS_TELSAMLREQUESTRESULT
#  define SB_USE_CLASSES_TELSAMLREQUESTABSTRACTTYPE_AND_TELSAMLREQUESTRESULT
#endif /* SB_USE_CLASS_TELSAMLREQUESTRESULT */
#endif /* SB_USE_CLASS_TELSAMLREQUESTABSTRACTTYPE */

#endif /* __INC_SBDEFS */
